//////////////////////////////////////////////////////////////////////////////////////////////
// This file contains all API variables. The variables are groupped according to the GUI.   //
// These variables can be used either with the tool.exe command line tool or directly       //
// for API  programming.								    //
//											    //
// Syntax:										    //
//											    //
// Variable name	Variable type		Description		Default value	    //
//			     								    //
//////////////////////////////////////////////////////////////////////////////////////////////

Unit apiconst;

Interface

Const
// Function Result Codes
  S_OK = $00;

  E_FAILURE = -$01; // Function failure
  E_LICENSE = -$02; // Insufficient license
  E_PARAMS = -$03; // Size of parameters too short
  E_PATH = -$04;
  E_CONFIG = -$05; // Configuration not found
  E_PASSWORD = -$06; // Password policy
  E_CONFLICT = -$07; // Item already exists
  E_INVALID = -$08; // Item already exists


/////////////
// Domains //
/////////////

	// Domain
	D_Description = $00; 			// String		Domain description
	D_Type = $01;				// Int			Domain Type		
		// 0 -  Standard domain
		// 1 - ETRN/ATRN queue
		// 2 - Domain Alias
		// 3 - Backup domain
		// 4 - Distributed domain
	D_DomainValue = $03; 			// String		Domain Type To value
	D_VerifyType = $21;          		// Int			User verification mode
		// 0 - Default
		// 1 - Issue RCPT
		// 2 - Issue VRFY
	D_PostMaster = $04; 			// String		Default Administrator's alias
 	D_AdminEmail = $05;			// String		Administrator's email		
  	D_UnknownUsersType = $06;	 	// Int			Unknown users action				0
		// 0 - Reject
		// 1 - Forward to address
		// 2 - Delete	
	D_UnknownForwardTo = $07;		// String		Unknown users Forward to Address
 	D_InfoToAdmin = $08;			// Bool			Send information to administrator		0

	// Options
	D_AccountNumber = $09;			// Int			Domain Admin account limit
	D_DiskQuota = $0B;			// Int			Domain disk quota (kB)
	D_DisableLogin = $10;			// Bool			Disable login to this domain			0
	D_UserMailbox = $0C;			// Int			User Mailbox size (kB)
	D_UserMB = $0D;				// Int			User send out data limit (MB/day)
	D_UserNumber = $0E;			// Int			User send out messages limit (#/day)
	D_UserMsg = $0F;			// Int			User max message size (kb)
	D_Expires = $15;              		// Bool			Enable domain expiration			0		
 	D_ExpiresOn = $16;		        // Int			Domain Expires On (Date)
	D_NotifyExpire = $17;         		// Bool			Enable Notify before expiration			0
	D_NotifyBeforeExpires = $18;  		// Int			Notify before expiration (Days)
  	D_DeleteExpired = $19;       		// Bool			Delete Expired domains				0
        D_NumberLimit = $27;                    // Int			Limit of emails sent from domain per day
        D_VolumeLimit = $28;                    // Int			Limit of data sent from domain per day

	//Miscellaneous
	D_Hostname = $23;             		// String               Hostname
        D_IPAddress = $25;                      // String
	D_Folderpath = $24;            		// String               Folder path
	D_AVScan = $0A;				// Bool			Access mode - AV
	D_AntiSpam = $11;			// Bool			Access mode - Antispam
	D_ChallengeResponse = $14;    		// Bool			Access mode - Challenge Response
	D_IM = $13;		                // Bool			Access mode - IM
	D_Calendar = $12; 		        // Bool			Access mode - GW
  	D_SIP = $22; 		                // Bool			Access mode - SIP
        D_SyncML = $29;                         // Bool                 Access mode - SyncML

        D_Backup = $20;                         // String               Structure backup

        D_RulesContentXML = $26;                // String

//////////////
// Accounts //
//////////////

Const
	// Accounts shared
	U_Type = $00;				// Int			Account type
        	// 0 - User
		// 1 - Mailing list
		// 2 - Executable
		// 3 - Notification
		// 4 - Static Route
		// 5 - Catalog
		// 6 - List server
		// 7 - User group

        U_Alias = $03;                         // String	        Account's alias
        U_Name = $02;                          // String		Account's full name/description
        U_Backup = $06;                        // String                Structure backup
        
        U_NonUserAS = $09;                      // Bool                 Non user account antispam access
        U_NonUserQA = $0A;                      // Bool                 Non user account quarantine access 

	// Accounts

		// User
                U_EmailAlias = $4F;             // String               Email alias
                U_PhoneAlias = $55;             // String               Phone alias

		U_Mailbox = $10;                // String		Username
		U_Password = $21;               // String		Password
		U_AuthMode   = $18;             // Int			Authentification mode			0
			// 0 - Standard
			// 1 - NT domain
			// 2 - Active Directory
			// 3 - Any password
		U_AuthModeValue = $22;          // String		Authentification mode value
  		U_Comment = $05;              	// String		User comment
		U_AccountType = $19;            // Int			Mailbox protocol type			0
			// 0 - POP3
			// 1 - IMAP & POP3
			// 2 - IMAP

		U_Admin = $26;                	// Bool			Administrator permissions		0
		U_DomainAdmin = $24;            // Bool			Domain admin permissions		0
		U_AccountDisabled = $11;        // Int			Account state				0
			// 0 - Enabled
			// 1 - Disabled (Login)
			// 2 - Disabled (Login, Receive)
			// 3 - Disabled (Tarpitting)
		U_ForwardTo = $2D;              // String		Forward to address

		// Mailbox
		U_UseRemoteAddress = $2C;       // Bool			Mailbox local/remote			0
			// 0 - Local mailbox
			// 1 - Remote address
		U_MailBoxPath = $25;            // String		Mailbox path
                U_FullMailboxPath = $1C;        // String               Full mailbox path
		U_RemoteAddress = $37;          // String		Remote address
		U_MaxBox = $27;                 // Bool			Enable mailbox size limit		0
		U_MaxBoxSize = $28;             // Int			Mailbox size limit (kB)
		U_MegabyteSendLimit = $39;      // Int			Send out data limit (MB/day)
		U_NumberSendLimit = $3A;        // Int			Send out messages limit (#/day)
 		U_MaxMessageSize = $1B;         // Int			User max message size (kB)
		U_DeleteOlder = $32;            // Bool			Enable Delete messages older than	0
		U_DeleteOlderDays = $33;        // Int			Delete messages older than (Days)
		U_ForwardOlder = $34;           // Bool			Enable Forward messages older than	0
		U_ForwardOlderDays = $35;       // Int			Forward messages older than (Days)
		U_ForwardOlderTo = $36;         // String		Forward messages older then x to address
		U_MailIn = $2F;                 // String		Copy incoming email address
		U_MailOut = $30;                // String		Copy outgoing email address
		U_AlternateEmail = $4D;         // String		Alternate email

		// Options
		U_NULL = $20;                   // Bool			Null account				0
		U_ETRN = $1E;                   // Bool			ETRN/ATRN account			0
		U_XEnvelopeTo = $3C;            // Bool			Add X-Envelope-To header to all messages 0
		U_NoMailList = $3B;    	        // Bool			No mailing lists			0
		U_LocalDomain = $2B;            // Bool			User can send to local domains only 	0
		U_InactiveFor = $41;            // Int			Expires if inactive for (Days)
		U_AccountValid = $12;           // Bool			Enable Expires on			0
		U_AccountValidTill = $13;       // Int			Expires on (Date)
		U_ValidityReport = $16;         // Bool			Enable Notify before exiration		0
		U_ValidityReportDays = $17;     // Int			Notify before expiration (Days)
  		U_DeleteExpire = $1F;         	// Bool			Delete account when expired		0
		U_ValidReport = $31;            // String		Notification file

		// Miscellaneous
		U_SpamFolder = $40;             // Int			Spam folder mode			0
			// 0 - Default
			// 1 - Do not use Spam folder
			// 2 - Use Spam folder
  		U_QuarantineReports = $43;      //Int
		      	// 0 - Disabled
			// 1 - Default
			// 2 - New Items only
			// 3 - All items
		U_SpamAdmin = $3F;              // Bool			Spam administrator			0
 		U_SMTP = $45;       	        // Bool			Access mode - SMTP			1
		U_POP3IMAP = $46;    	        // Bool			Access mode - IMAP & POP3		1
		U_WebMail = $47;     	        // Bool			Access mode - Webmail			1
		U_AVScan = $04;                 // Bool			Access mode - AV			1
		U_AS = $48;          		// Bool			Access mode - AntiSpam			1
  		U_CR = $49;          		// Bool			Obsolete
  		U_Quarantine = $49;   		// Bool			Access mode - Challenge response	1
  		U_IM = $4A;          		// Bool			Access mode - IM			1
  		U_GW = $4B;          		// Bool			Access mode - Groupware			1
		U_SIP = $4E;          		// Bool			Access mode - SIP			1
                U_SyncML = $56;                 // Bool                 Access mode - SyncML                    1

		// Responder
		U_Respond = $2A;              	// Int			Autoresponder mode			0
			// 0 - Do not respond
			// 1 - Respond always
			// 2 - Respond once
			// 3 - Respond once in period
	  	U_RespondPeriod = $42;        	// Int			Responder period (Days)
  		U_RespondWith = $2E;          	// String		Responder file
		U_ReplyFrom = $3D;            	// String		Reply from
  		U_RespondBetweenFrom = $44;     // String		Responder active from (Date)
  		U_RespondBetweenTo = $4C;       // String		Responder active till (Date)
  		U_RespondOnlyIfToMe = $3E;    	// Bool			Reply only if to me			0
                U_ResponderContent = $E0;       // String               Auto responder content

                U_QuarantineSupport = $E1;      // Bool                 Read only variable to check if the user has quarantine enabled
                U_ASSupport = $E2;              // Bool                 Read only variable to check if the user has antispam enabled
                U_SpamFolderSupport = $E3;      // Bool                 Read only variable to check if the user has spam folder enabled
                U_SIPSupport = $105;            // Bool                 Read only variable to check if the user has SIP enabled
                U_AVSupport = $220;             // Bool                 Read only variable to check if the user has antivirus enabled
                U_IMSupport = $221;             // Bool                 Read only variable to check if the user has instant messaging enabled
                U_GWSupport = $222;             // Bool                 Read only variable to check if the user has groupware enabled
                U_SyncMLSupport = $223;         // Bool                 Read only variable to check if the user has syncML enabled


		// B&W list
		U_BlackWhiteFilter = $01;	// Bool			Use B&W list				0
		U_RulesContentXML = $08;               // String                Rules content xml

                U_IMAPMailbox = $1A;            // String               IMAP mailbox settings

                U_PasswordExpired = $102;       // Bool
                U_MailboxQuota = $103;          // Int
                U_MailboxSize = $104;           // Int


	// User Group

		// Group
  		G_ListFile = $73;		// String		List file

                G_Name = $02;                   // String               Folder name
                G_Description = $05;            // String               Description

                G_GroupwareShared = $9D;        // Bool                 Groupware shared
                G_GroupwareMembers = $100;      // Bool                 Groupware members address book
                G_GroupwareMailDelivery = $101; // Bool                 Groupware mail delivery
                G_GroupwareDefaultRights = $9E; // String               Groupware default rights

		// Message
		G_Moderated = $7A;            	// Int			Moderated mode				0
                        // 0 - None
                        // 1 - Client moderated
                        // 2 - Server moderated
  		G_ModeratedPassword = $7B;    	// String		Password
	  	G_AVScan = $04;               	// Bool			Access mode - AntiVirus				1
                G_AS = $09;                      // Bool                Access mode - Antispam
                G_QA = $0A;                      // Bool                Access mode - Quarantine

  		// B&W list
		G_BlackWhiteFilter = $01;  	// Bool			Use B&W list					0

	// Mailing List Accounts

		// Mailing list
  		M_Alias = $03;                	// String		Alias
  		M_Name = $02;		        // String		Description
  		M_OwnerAddress = $70;         	// String		Owner address
  		M_SendAllLists = $77;         	// Int			Members source						0
			// 0 - List file
			// 1 - All current domain users
			// 2 - All system users
			// 3 - All domain administrators
			// 4 - All system administrators
			// 5 - Members from ODBC
  		M_ListFile = $73;      		// String		Path to list file
                M_GroupwareDefaultRights = $9E; // String               Groupware default rights

  		M_ODBC = $95;         		// String		ODBC connection
			// DSN,user,pwd,server,type
                M_SQL = $9C;                    // String               SQL statement

		// Message
  		M_SetSender = $83;            	// Int			Set From or Reply-to headers to sender		0
			// 0 - Off
			// 1 - Set From: to sender
			// 2 - Set Reply-To: to sender
  		M_SetValue = $7F;            	// Int			Set From or Reply-to headers to value		0
			// 0 - Off
			// 1 - Set From: to value
			// 2 - Set Reply-To: to value
  		M_ValueMode = $84;            	// Bool			Order of "header value" mode
			// 0 - From: header set to value
			// 1 - Reply To: header set to value
		M_HeaderValue = $80;          	// String		From or Reply-to headers value
			// FromValue|ReplyToValue
  		M_SeparateTo = $8D;           	// Bool			Set Recipients to To: header			1
  		M_AddToSubject = $85;         	// String		Add to Subject value
  		M_AddToHeader = $98;         	// String		Add headers value
  		M_ListSender = $8C;           	// Int			Originator					2
			// 0 - Blank
			// 1 - Sender
			// 2 - Owner
  		M_HeaderFile = $78;           	// String		Header file
  		M_FooterFile = $79;           	// String		Footer file

		// Security
  		M_MembersOnly = $82;          	// Bool			Only members can post new messages		0
		M_Moderated = $7A;            	// Int			Moderated  mode				0
                        // 0 - None
                        // 1 - Client moderated
                        // 2 - Server moderated
  		M_ModeratedPassword = $7B;    	// String		Moderated password
  		M_AllowSubscribers = $96;       // String		Allow subscribers file
  		M_DefaultRights = $9B;        	// Int			Default rights					0
			// 0 - Receive & post
			// 3 bits - 1st (Receive), 2nd (Post), 3rd (Digest)					
  		M_MaxList = $7D;              	// Bool			Enable Maximum message size			0
	 	M_MaxListSize = $7E;          	// Int			Maximim message size value (kB)			
  		M_DenyEXPNList = $7C;         	// Bool			Deny EXPN					0
  		M_AVScan = $04;               	// Bool			Access mode - Antivirus				1
                M_AS = $09;                      // Bool                Access mode - Antispam
                M_QA = $0A;                      // Bool                Access mode - Quarantine

		// Other
  		M_SendToSender = $75;         	// Bool			Send copy to Sender				1
  		M_CopyToOwner = $71;          	// Bool			Forward copy to owner				0
  		M_DigestConfirmed = $72;      	// Bool			Digest mailing list				0
		M_ListSubject = $8B;            // Bool			Process mailing list variables			0
		M_Personalized = $92;         	// Bool			Personalized mailing list 			0
		M_RemoveDead = $90;           	// Bool			Remove dead email addresses			0
  		M_ListBatch = $91;            	// Int			Max # of messages sent out in 1 minute
  		M_NotifyJoin = $8F;           	// Bool			Notify owner - Join				0
  		M_NotifyLeave = $99;           	// Bool			Notify owner - Leave				0
  		M_SubListFile = $76;          	// String		Join file
  		M_LeaveFile = $97;         	// String		Leave file

		// B&W list
	  	M_BlackWhiteFilter = $01;     	// Bool			Use B&W list					0

                M_MaxMembers = $9F;             // Int                  Max members
                M_LDAPSync = $106;              // Bool                 LDAP sync

	// List server

		// List server
  		L_Alias = $03;                	// String		Alias
  		L_Name = $02;		        // String		Description
  		L_OwnerAddress = $70;         	// String		Owner address

  		L_SendAllLists = $77;         	// Int			Members source						0
			// 0 - List file
			// 1 - All domain mailing lists

  		L_ListFile = $73;      		// String		Path to list file
  		L_DigestConfirmed = $72;      	// Int			Subscription					0
			// 0 - No confirmation
			// 1 - User confirmation
			// 2 - Owner confirmation
		L_ListSubject = $8B;            // Bool			Commands in subject				1
  		M_JoinR = $86;                	// Bool			Join right					1
  		M_LeaveR = $87;               	// Bool			Leave right					1
		M_ListsR = $88;               	// Bool			Lists right					1
		M_WhichR = $89;              	// Bool			Which right					1
		M_ReviewR = $8A;              	// Bool			Review right					1
		M_VacationR = $9A;            	// Bool			Vacation right					1
		M_WLR = $93;         		// Bool			Whitelist right					1
		M_BLR = $94;         		// Bool			Blacklist right					1

		M_DeliverExternally = $88;    	// Bool			Deliver externally				1

		// Options
		L_Moderated = $7A;            	// Bool			Moderated list server				0
  		L_ModeratedPassword = $7B;    	// String		Moderated password
  		M_HelpFile = $81;             	// String		List server help file
  		L_ListSender = $8C;           	// Int			Originator					2
			// 0 - Blank
			// 1 - Sender
			// 2 - Owner
  		L_MaxList = $7D;              	// Bool			Suppress command responses			0
  		L_AVScan = $04;               	// Bool			Access mode - Antivirus				1
                L_AS = $09;                      // Bool                Access mode - Antispam
                L_QA = $0A;                      // Bool                Access mode - Quarantine

		// B&W list
	  	L_BlackWhiteFilter = $01;     	// Bool			Use B&W list					0

		// Other
  		M_ListServer = $74;           	// Bool			List server vs mailing list			1

	// Executable Accounts

		// Executable
  		E_Alias = $03;                	// String		Alias
  		E_Name = $02;		        // String		Description
  		E_Application = $50;            // String		Application
  		E_ExecType = $53;             	// Int			Application type				0
			// 0 - Executable
			// 1 - StdCall library
			// 2 - Cdeecl library
			// 3 - URL
  		E_Parameters = $51;           	// String		Application parameters
  		E_ExecPass = $54;             	// String		Password
  		E_ExecForwardCopy = $52;      	// String		Forward to address
  		E_AVScan = $04;               	// Bool			Access mode - Antivirus				1
                E_AS = $09;                      // Bool                Access mode - Antispam
                E_QA = $0A;                      // Bool                Access mode - Quarantine

		// B&W list
	  	E_BlackWhiteFilter = $01;     	// Bool			Use B&W list					0

	// Remote Accounts

		//Remoteaccount
                RA_Enabled = $225;           	// Bool			Enabled					
		RA_Name = $E0;                	// String		Name
  		RA_Server = $E2;              	// String		Server
  		RA_IMAP = $F5;                	// Bool			Server type					0
			// 0 - POP3
			// 1 - IMAP
  		RA_UserName = $E3;            	// String		Username
  		RA_Password = $EA;            	// String		Password
  		RA_APOP = $F2;                	// Bool			Logging using APOP				0
  		RA_TLSSSL = $F7;              	// Int			TLS/SSL						0
			// 0 - Detect TLS/SSL
			// 1 - Direct TLS/SSL
			// 2 - Disable TLS/SSL
  		RA_ForwardTo = $E1;           	// String		Forward to address
  		RA_Schedule = $F6;            	// Schedule		Remote account schedule
		
		// Options
                RA_NotifyAdmin = $F9;           // Bool                 Notify administrator of session problems 
  		RA_Dedupe = $EF;              	// Bool			Dedupe collected emails				0
  		RA_LeaveMessagesOnServer = $F3; // Bool			Leave messages on server			0
  		RA_DeleteOlder = $F0;         	// Bool			Delete messages older than (Days)
  		RA_DeleteCount = $F1;         	// Int			Delete if more than (Messages)
  		RA_ExtraForward = $E5;        	// String		Forward extra copy to address
  		RA_ConvertDomains = $ED;      	// Bool			Convert domain names				0
	  	RA_Routing = $EE;             	// Bool			Email address routing				0

		// Domain POP
  		RA_DomainPOP = $E4;           	// Bool			Domain POP					0
  		RA_NoReceived = $E7;          	// Bool			Do not processed Received: header		0
  		RA_ReceiveAll = $EC;          	// Bool			Stop parsing if Received: yields a local address 0
  		RA_XEnvelopeTo = $E8;         	// Bool			Parse these headers				0
  		RA_NoNames = $E9;             	// Bool			Real name address matching			0
  		RA_MatchEmail = $E6;          	// String		If email:
		
                RA_DomainString = $EB;          // String               Domain it belongs to
                RA_LeaveMessageFile = $F4;      // String               Path to file to keep uids
                RA_Backup = $F8;                // String               Structure backup
                RA_RulesContentXML = $FA;       // String               Rules xml

	// Static Route Accounts

		// Static route
  		R_Alias = $03;                	// String		Alias
  		R_Name = $02;		        // String		Description
  		R_Activity = $C0;             	// Int			Action						0
			// 0 - Forward to address
			// 1 - Forward to domain
			// 2 - Forward to host
			// 3 - Delete
			// 4 - Deliver to this domain
  		R_ExternalDomain = $C5;       	// Bool			Forward
  		R_ActivityValue = $C1;        	// String		Value
  		R_SaveTo = $C6;               	// String		Forward to address
		R_ExternalFilter = $C3;       	// Int			Filter						0
			// 0 - Filter
			// 1 - External
			// 2 - All
  		R_FilterFile = $C2;           	// String		Filter file
  		R_ExternalFilterFile = $C4;   	// String		External filter file
		R_ExternalFilterType = $C7;   	// Int			External filter type				0
			// 0 - StdCall library
			// 1 - Cdecl library
			// 2 - Executable
			// 3 - URL


	// Notification Accounts

		// Notification
  		N_Alias = $03;                	// String		Alias
  		N_Name = $02;		        // String		Description
  		N_NotifyTo = $A0;          	// String		Notify to:
  		N_IMNotification = $AE;       	// Bool			IM notification
  		N_Size = $A2;                 	// Int			Max message size (Bytes)			128
  		N_Count = $AC;             	// Int			Split to multiple messages (Messages)		1
  		N_FilterType = $B3;             // Int			Filter						0
			// 0 - All
			// 1 - None
			// 2 - Filter
  		N_Send = $A8;                 	// Bool			Send						0
  		N_FilterFile = $AD;        	// String		Filter file path

		// Other
  		N_IntoSubject = $A1;       	// Bool			Insert information into subject			1
  		N_SendTo = $A3;               	// Bool			Insert To: header				0
  		N_SendFrom = $A4;             	// Bool			Insert From: header				0
  		N_SendSubject = $A5;          	// Bool			Insert Subject					1
		N_SendDateTime = $A7;         	// Bool			Insert Date/Time				0
  		N_SendBody = $A6;             	// Bool			Insert Body					1
  		N_From = $B2;              	// String		From:
  		N_Subject = $AF;           	// String		Subject
  		N_Body = $B0;              	// String		Body
  		N_File = $B1;              	// String		Text file
  		N_ForwardCopy = $A9;       	// String		Forward to:
  		N_Sender = $AB;            	// Int			Originator					0
			// 0 - Empty
			// 1 - Sender
			// 2 - Owner
  		N_AVScan = $04;               	// Bool			Access mode - Antivirus				1
                N_AS = $09;                      // Bool                Access mode - Antispam
                N_QA = $0A;                      // Bool                Access mode - Quarantine

		// B&W list
	  	N_BlackWhiteFilter = $01;     	// Bool			Use B&W list					0


	// Catalog Accounts 

		// Catalog
  		T_Alias = $03;                	// String		Alias
  		T_Name = $02;		        // String		Description
  		T_CatalogPass = $D0;          	// String		Password
		T_CatalogSubject = $D1;       	// Bool			Commands in subject				1
  		T_CatalogFile = $D5;          	// String		Catalog file

		// Other
  		T_CatalogGet = $D2;           	// Bool			Get right					1
  		T_CatalogDir = $D3;           	// Bool			Dir right					1
  		T_CatalogSendTo = $D6;        	// Bool			SendTo right					1
  		T_CatalogSender = $D4;        	// Int			Originator					2
			// 0 - Empty
			// 1 - Sender
			// 2 - Owner
  		T_AVScan = $04;               	// Bool			Access mode - Antivirus				1
                T_AS = $09;                      // Bool                Access mode - Antispam
                T_QA = $0A;                      // Bool                Access mode - Quarantine

		// B&W list
	  	T_BlackWhiteFilter = $01;     	// Bool			Use B&W list					0
	
///////////////////
// Configuration //
///////////////////

// Version & License

	C_Version = $1000;      				// String	Server version
        C_Date = $1004;                                  // String              Server release date
        C_Backup = $1001;                                       // String
        C_OS     = $1002;                                       // Bool		Server OS versuin
		// 0 - Windows
		// 1 - Linux

        C_TimeZone = $1003;                                     // Int          Time zone in seconds

	C_SuiteType = $15;           				// Int		Mail server license type
		// 1 - Pro
		// 2 - Standard
		// 3 - Lite

	C_InstallPath = $10A;                      		// String	Mail server installation path
        C_ConfigPath = $AA;		                        // String	Path to Config folder
        C_WebPath = $200;                                       // String
        C_SpamPath = $202;                                      // String
        C_CalendarPath = $203;                                  // String
        C_PathServiceID = $201;                                 // String

	C_GUI_RequireAuth = $D0;                            	// Bool		Require authentification to access Admin console
	C_GUI_SafeConfirm = $40;               			// Bool		Use Safe confirmation

	C_License_XMLFile = $AB;              			// String	XML license
	C_License_XMLFileFull = $255;              		// String	XML license including expired and demo

	C_License = $A9;                  		        // String	Server license (read/export and add new license)
        C_Reference = $131;                                     // String       Server refefence key
        C_OnlineLicense = $169;                                 // String       Retrieve online license using orderid

        C_SettingsTime = $243;                                  // Int          Unix timestamp of settings creation
        C_EvalExpirationTime = $244;                            // Int          Unix timestamp of evaluation expiration

// Accounts

	// Global Settings
		
		// Accounts
		C_Accounts_Global_Accounts_UserStat = $74;      // Bool		Enable User statistics			1
		C_Accounts_Global_Accounts_UseDefaults = $4D;	// Bool		Use Account defaults			0
                C_Accounts_Global_Accounts_DisableCache = $1A4; // Bool		Disables account caching		0
                C_Accounts_Global_Accounts_AccountCache = $1A8; // Int          Number of cached items
                C_Accounts_Global_Accounts_DomainCache = $1A9; // Int           Number of cached items
                C_Accounts_Global_Accounts_DirectoryCacheExpire = $1B7; // Int  Directory cache expiration in seconds
                C_Accounts_Global_Accounts_DirectoryCacheDisable = $1B8;// Int  (dctDirect, dctNone, dctWave)
                C_Accounts_Global_Accounts_MaintenanceLog = $1BD; // Bool       Maintenance log

		// Domains
		C_Accounts_Global_Domains_UseDiskQuota = $3F;   // Bool		Use Domain disk quota			0
		C_Accounts_Global_Domains_UseUserLimits = $A0;  // Bool		Use Domain user limits			0
		C_Accounts_Global_Domains_UseDomainLimits = $1EC;  // Bool		Use Domain limits			0
		C_Accounts_Global_Domains_UseExpiration = $F2;  // Bool		Use Domain expiration			0
		C_Accounts_Global_Domains_OverrideGlobal = $C3; // Bool		Override global limits			0
		C_Accounts_Global_Domains_Literals = $B3;       // Bool		Enable Domain literals			0
		C_Accounts_Global_Domains_DomainKeys = $13D;   	// Bool		Enable DomainKeys support		0
		C_Accounts_Global_Domains_Hostname = $196; 	// Bool		Use domain hostnames for outgoing msgs  0
		C_Accounts_Global_Domains_IPAddress = $197; 	// Bool		Use domain IP address for outgoing msgs 0
		C_Accounts_Global_Domains_WelcomeMsgs = $45;	// Bool		Use Welcome messages			0
		C_Accounts_Global_Domains_WarnMailboxUsage = $D3; // Int	Warn when mailbox size exceeds (%)
                C_Accounts_Global_Domains_WarnDomainSize = $167; //Int          Warn when domain size exceeds (%)

                C_Accounts_Global_ActiveDirectorySyncInterval = $1D7; // Int    Minutes interval

                // LDAP
		C_Accounts_Global_LDAP_Synchronize = $D6;        // Bool	LDAP user synchronization               0
                C_Accounts_Global_LDAP_Host = $1CD;             // String
                C_Accounts_Global_LDAP_Base = $1CE;             // String
                C_Accounts_Global_LDAP_User = $1CF;             // String
                C_Accounts_Global_LDAP_Pass = $1D0;             // String

                // Console
                C_Accounts_Global_Console_ShowAccounts = $145;  // Int		Number of shown accounts in a domain	1000
                C_Accounts_Global_Console_AccountsPosition = $144; // Int	Database account display start position	0
                C_Accounts_Global_Console_DomainDescription = $3A; // Int	Domain list display mode
			// 0 - Domain
			// 1 - Description + Domain
			// 2 - Domain + Description


	// Policies

		// Login Policy
		C_Accounts_Policies_Login_Enable = $F3;		// Bool		Enable Login policy			0
		C_Accounts_Policies_Login_Attempts = $F4;       // Int		Number of failed logins
		C_Accounts_Policies_Login_BlockPeriod = $F5;	// Int		Block user login for (Min)
		C_Accounts_Policies_Login_LoginSettings = $73;  // Bool		Login settings mode			0
			// 0 - login with username
			// 1 - login with full email address
                C_Accounts_Policies_Login_Block = $1F4;         // Bool
			// 0 - Do not block but delay authentication
			// 1 - Block account for specified time
		C_Accounts_Policies_Login_ConvertChars = $79;   // Bool		Convert chars %/ to @ in username	0

                C_Accounts_Policies_Login_IPRestriction = $134; // Bool         Enables account IP restriction

                C_Accounts_Policies_Login_RevealPasswords = $1E8; // Bool

                C_Accounts_Policies_Login_DisableDomainIPLogin = $1F8; // Bool


                C_Accounts_Policies_SuperUser = $1EA;             // Bool
                C_Accounts_Policies_SuperUserPassword = $1EB;     // String

                C_Accounts_Policies_Login_AuthWISIDDisable = $215; // Bool

		// Password policy
		C_Accounts_Policies_Pass_Enable = $9B; 		// Bool		Enable Password policy			0
		C_Accounts_Policies_Pass_MinLength = $9C;    	// Int		Min password length
		C_Accounts_Policies_Pass_Digits = $9D;          // Int		Number of numeric chars in password
		C_Accounts_Policies_Pass_NonAlphaNum = $F7;	// Int		Number of non alphanumeric characters
		C_Accounts_Policies_Pass_UserAlias = $B7;       // Bool		Check password against username/alias	0
		C_Accounts_Policies_Pass_Expiration = $FA;      // Bool		Enable password expiration		0
		C_Accounts_Policies_Pass_ExpireAfter = $FB;	// Int		Expire after (Days)
		C_Accounts_Policies_Pass_Notification = $240;   // Bool		Enable Notification of expiration		0
		C_Accounts_Policies_Pass_NotifyBefore = $241;	// Int		Notify before (Days)
		C_Accounts_Policies_Pass_DenyExport = $F8;      // Bool		Passwords cannot be read or exported	0
		C_Accounts_Policies_Pass_AllowAdminPass = $F9;  // Bool		Allow Admin's password to be exported	0
                C_Accounts_Policies_Pass_Encrypt = $CD;         // Bool		Password database encryption		0
                C_Accounts_Policies_Pass_Alpha = $1E9;          // Int          Number of alpha characters


// System

	// Services

		C_System_Services_Firewall = $5B;          	// Bool		Restrict access to all services		0
		C_System_Services_BindIPAddress = $27;  	// String	IP addresses to bind services to

		// SMTP service
	   	C_System_Services_SMTP_Port = $1B;  		// Int		SMTP service port			25
		C_System_Services_SMTP_SSLPort = $3B;           // Int		SMTP service SSL port			465
		C_System_Services_SMTP_AltPort = $13;		// Int		SMTP service alternative port		366
 		C_System_Services_SMTP_Traffic = $103;          // Bool		Enable SMTP traffic logs 		1
		C_System_Services_SMTP_IPList = $5D;            // String	List of Denied/Granted IPs
		C_System_Services_SMTP_AccessMode = $5C;	// Bool		Service access mode			0
			// 0 - Deny
			// 1 - Grant
                C_System_Services_SMTP_Startup = $251;          // Int          (ssAutomatic, ssManual)
 		C_System_Services_SMTP_ThreadCache = $51;       // Int		SMTP service Thread cache		40
		C_System_Services_SMTP_MonitorData = $14F;      // Int          Monitor increased traffic
		C_System_Services_SMTP_MonitorConn = $150;      // Int          Monitor number of increased connections
		C_System_Services_SMTP_MaxInConn = $112;  	// Int		Max number of Incoming connections	256
		C_System_Services_SMTP_MaxOutConn = $50;        // Int		Max number of Outgoing connections	256
		C_System_Services_SMTP_Bandwidth = $11F;        // Int		Max transfer bandwidth (kB/s)		0

		// POP3 service
		C_System_Services_POP3_Port = $19; 	  	// Int		POP3 service port			110
		C_System_Services_POP3_SSLPort = $1A;		// Int		POP3 service SSL port			995
		C_System_Services_POP3_Traffic = $104;          // Bool		Enable SMTP traffic logs		1
		C_System_Services_POP3_IPList = $5F;            // String	List of Denied/Granted IPs
		C_System_Services_POP3_Accessmode = $5E;        // Bool		Service access mode			0
			// 0 - Deny
			// 1 - Grant
                C_System_Services_POP3_Startup = $252;          // Int          (ssAutomatic, ssManual)
		C_System_Services_POP3_ThreadCache = $52;       // Int		POP3 service thread cache		40
		C_System_Services_POP3_MaxInConn = $113;        // Int		Max number of Incoming connections	256
		C_System_Services_POP3_MaxOutConn = $4F;        // Int		Max number of Outgoing connections	1
		C_System_Services_POP3_Bandwidth = $120;        // Int		Max transfer bandwidth (kb/s)		0
		C_System_Services_POP3_MonitorData = $151;      // Int          Monitor increased traffic
		C_System_Services_POP3_MonitorConn = $152;      // Int          Monitor number of increased connections

		// IMAP service
		C_System_Services_IMAP_Port = $1F;            	// Int		IMAP service port			143
 		C_System_Services_IMAP_SSLPort = $1C; 		// Int		IMAP service SSL port			993
		C_System_Services_IMAP_Traffic = $105;          // Bool		Enable IMAP traffic logs		1
		C_System_Services_IMAP_ThreadCache = $12B;      // Int		IMAP service thread cache		40
		C_System_Services_IMAP_MaxInConn = $114;        // Int		Max number of Incoming connections	256
		C_System_Services_IMAP_MaxOutConn = $12C;       // Int		Max number of Outgoing connections	1
		C_System_Services_IMAP_Bandwidth = $121;        // Int		Max transfer bandwidth (kB/s)		0
		C_System_Services_IMAP_IPList = $127;           // String	List of Denied/Granted IPs
		C_System_Services_IMAP_Accessmode = $128;       // Bool		Service access mode			0
		C_System_Services_IMAP_MonitorData = $153;      // Int          Monitor increased traffic
		C_System_Services_IMAP_MonitorConn = $154;      // Int          Monitor number of increased connections

                C_System_Services_IMAP_FileNameFlags = $1C7;    // Bool

		// IM service
		C_System_Services_IM_Port = $E1;                // Int		IM service port				5222
		C_System_Services_IM_SSLPort = $E2;		// Int		IM service SSL port			5223
		C_System_Services_IM_AltPort = $BD;             // Int		IM service alternative port		5269
		C_System_Services_IM_Traffic = $106;            // Bool		Enable IM traffic logs			1
		C_System_Services_IM_IPList = $100;             // String	List of Granted?Denied IPs
		C_System_Services_IM_AccessMode = $FF;          // Bool		Service access mode			0
			// 0 - Deny
			// 1 - Grant
                C_System_Services_IM_Startup = $253;          // Int          (ssAutomatic, ssManual)
		C_System_Services_IM_ThreadCache = $DE;		// Int		Service thread cache			40
		C_System_Services_IM_MaxInConn = $118;          // Int		Max number of Incoming connections	256
		C_System_Services_IM_Bandwidth = $125;          // Int		Max transfer bandwidth (kB/s)		0
		C_System_Services_IM_MonitorData = $155;        // Int          Monitor increased traffic
		C_System_Services_IM_MonitorConn = $156;        // Int          Monitor number of increased connections

		// Groupware service
		C_System_Services_GW_Port = $B8;                // Int		GW service port				5229
		C_System_Services_GW_Traffic = $107;            // Bool		Enable GW traffic logs			1
		C_System_Services_GW_IPList = $102;           	// String	List of Denied/Granted IPs
		C_System_Services_GW_AccessMode = $101;         // Bool		Service access mode			0
			// 0 - Deny
			// 1 - Grant
                C_System_Services_GW_Startup = $254;          // Int          (ssAutomatic, ssManual)
		C_System_Services_GW_ThreadCache = $12A;	// Int		GW service Thread cache                 40
		C_System_Services_GW_MaxInConn = $119;		// Int		Max number of Incoming connections	256
		C_System_Services_GW_Bandwidth = $126;          // Int		Max transfer bandwidth (kB/s)		0
		C_System_Services_GW_MonitorData = $157;        // Int          Monitor increased traffic
		C_System_Services_GW_MonitorConn = $158;        // Int          Monitor number of increased connections

		C_System_Services_SyncML_AccessMode = $1ED;         // Bool		Service access mode			0
                C_System_Services_SyncML_AccessGroup = $1EF;                      // String

		// Control service
		C_System_Services_Control_Port = $1E;         	// Int		Control service port			32000
		C_System_Services_Control_SSLPort = $20;      	// Int		Control service SSL port		32001
		C_System_Services_Control_Traffic = $108;       // Bool		Enable Control traffic logs		1
		C_System_Services_Control_IPList = $63;         // String	List of Denied/Granted IPs
		C_System_Services_Control_AccessMode = $62;     // Bool		Service access mode			0
			// 0 - Deny
			// 1 - Grant
                C_System_Services_Control_Startup = $256;          // Int          (ssAutomatic, ssManual)
		C_System_Services_Control_ThreadCache = $53;    // Int		Control service Thread cache		40
		C_System_Services_Control_MaxInConn = $115;     // Int		Max number of Incoming connections	256
		C_System_Services_Control_Bandwidth = $122;     // Int		Max transfer bandwidth (kB/s)		0
		C_System_Services_Control_MonitorData = $159;   // Int          Monitor increased traffic
		C_System_Services_Control_MonitorConn = $15A;   // Int          Monitor number of increased connections

		// FTP service
		C_System_Services_FTP_Port = $10C;              // Int		FTP service port			21
		C_System_Services_FTP_SSLPort = $10D;           // Int		FTP service SSL port			990
		C_System_Services_FTP_Traffic = $11A;      	// Bool		Enable FTP traffic logs			1
		C_System_Services_FTP_IPList = $11B;            // String	List of Granted/Denied IPs
		C_System_Services_FTP_AccessMode = $11C;	// Bool		Service access mode			0
			// 0 - Deny
			// 1 - Grant
		C_System_Services_FTP_ThreadCache = $11D;       // Int		Service thread cache			40
		C_System_Services_FTP_MaxInConn = $116;		// Int		Max number of Incoming connections	256
		C_System_Services_FTP_MaxOutConn = $11E;	// Int		Max number of Outgoing connections	256
		C_System_Services_FTP_Bandwidth = $123;         // Int		Max transfer bandwidth (kB/s)		0
		C_System_Services_FTP_MonitorData = $15B;      // Int          Monitor increased traffic
		C_System_Services_FTP_MonitorConn = $15C;      // Int          Monitor number of increased connections

		// LDAP service
		C_System_Services_LDAP_Enable = $6D;  		// Bool		Enable LDAP service 			0
		C_System_Services_LDAP_Port = $12;              // Int		LDAP service port 			389
		C_System_Services_LDAP_SSLPort = $11;           // Int		LDAP service SSL port 			636
		C_System_Services_LDAP_MaxInConn = $117;        // Int		Max number of Incoming connections 	256
		C_System_Services_LDAP_Bandwidth = $124;        // Int		Max transfer bandwidth (kB/s)		0


	// Logging

		// General
                C_System_Logging_General_AppendFiles = $19A;    // Bool		Append logs to files					1	
		C_System_Logging_General_DeleteOlder = $34;     // Int		Delete logs after (Days)		7
		C_System_Logging_General_Archive = $1DD;        // Bool
		C_System_Logging_General_ArchiveTo = $1DE;      // String
		C_System_Logging_General_LogCache = $67;	// Int		Logging cache (B)			0
                C_System_Logging_General_LogRotation = $12D;    // Int          Size of the log file (kB)               0
		C_System_Logging_General_SystemLogFunction = $7B; // Bool	Send logs to system log function	0
                C_System_Logging_Syslog_Active = $19B;          // Bool		Send logs to server			0
                C_System_Logging_Syslog_Server = $19C;          // String	Syslog server name
		C_System_Logging_General_EnableODBCLog = $6C;	// Bool		Enable ODBC logging
		C_System_Logging_General_ODBCLogConn = $6B;	// String		ODBC logging connection
                C_System_Logging_General_LogTimeFormat = $1B9;  // Int          Log time format
                        // 0 - sltfTime
                        // 1 - sltfScientific
                        // 2 - sltfRFC822

                C_System_Sessions_DisableHistory = $1BF;        // Bool         Disable session history

		// Services
		C_System_Log_Services_SMTP = $64;		// Int		SMTP service logging level
			// 0 - None
			// 1 - Debug
			// 2 - Summary
			// 3 - Debug & Summary
		C_System_Log_Services_POP3 = $69;		// Int		POP3 service logging level
			// 0 - None
			// 1 - Debug
			// 2 - Summary
			// 3 - Debug & Summary
		C_System_Log_Services_IMAP = $10F;		// Int		IMAP service logging level
			// 0 - None
			// 1 - Debug
			// 2 - Summary
			// 3 - Debug & Summary
		C_System_Log_Services_IM = $E0;                	// Int		IM service logging level
			// 0 - None
			// 1 - Debug
			// 2 - Summary
			// 3 - Debug & Summary
		C_System_Log_Services_GW = $B1;                	// Int		GW service logging level
			// 0 - None
			// 1 - Debug
			// 2 - Summary
			// 3 - Debug & Summary
		C_System_Log_Services_Control = $6E;	        // Int		Control service logging level
			// 0 - None
			// 1 - Debug
			// 2 - Summary
			// 3 - Debug & Summary
		C_System_Log_Services_FTP = $10E;		// Int		FTP service logging level
			// 0 - None
			// 1 - Debug
			// 2 - Summary
			// 3 - Debug & Summary
		C_System_Log_Services_LDAP = $110;		// Int		LDAP service logging level
			// 0 - None
			// 1 - Debug
			// 2 - Summary
			// 3 - Debug & Summary
		C_System_Log_Services_AV = $97;			// Int		AV logging level
			// 0 - None
			// 1 - Debug
			// 2 - Summary
        		// 3 - Debug & Summary
                C_System_Log_Services_AS = $15F;                // Int          AS logging level
			// 0 - None
			// 1 - Debug
			// 2 - Summary
			// 3 - Debug & Summary
                C_System_Log_Services_SIP = $18A;               // Int          SIP logging level
			// 0 - None
			// 1 - Debug
			// 2 - Summary
			// 3 - Debug & Summary
		C_System_Log_Services_SMS = $210;              	// Int		SMS service logging level
			// 0 - None
			// 1 - Debug
			// 2 - Summary
			// 3 - Debug & Summary
		C_System_Log_Services_SyncMLPush = $213;              	// Int		SMS service logging level
			// 0 - None
			// 1 - Debug
			// 2 - Summary
			// 3 - Debug & Summary


                C_System_Log_MailQueue = $1E4;  // Bool                      Debug logging - internal usage only

	// Tools
		// Auto backup
		C_System_Tools_AutoBackup_Enable = $6F;  	// Bool		Enable Auto backup			0
                C_System_Tools_AutoBackup_BackupTo = $140;      // String	Path to backup file
                C_System_Tools_AutoBackup_Password = $1D2;      // String       Password
                C_System_Tools_AutoBackup_Schedule = $141;      // Schedule	Auto backup Schedule
                C_System_Tools_AutoBackup_DeleteAfter = $142;   // Int		Delete backup file after (Days)
		C_System_Tools_IncludeMailDir = $FE;            // Bool		Include mail folder settings to backup  0
		C_System_Tools_ExcludeLicense = $CC;            // Bool		Do not include license to backup file	0
                C_System_Tools_Backup_Emails = $1AA;            // Bool         Backup emails
                C_System_Tools_Backup_SkipLarger = $1AB;        // Int          Skip emails larger (MB)
                C_System_Tools_Backup_SkipOlder = $1AC;         // Int          Skip emails older (Days)
                C_System_Tools_Backup_Dirs = $1AD;              // String       Additional directories to backup
                C_System_Tools_Backup_Logs = $1B2;              // Bool         Backup logs

		// Mail archive
		C_System_Tools_AutoArchive_Enable = $99;	// Bool		Enable Auto archive			0
		C_System_Tools_AutoArchive_Path = $9A;		// String	Auto archive path
		C_System_Tools_AutoArchive_DoNotSpam = $224;	// Bool 	Do not archive spam messages
		C_System_Tools_AutoArchive_DeleteOlder = $BA;   // Int		Delete archive older than (Days)
		C_System_Tools_AutoArchive_Outgoing = $143;     // (ammIncoming, ammBoth, ammOutgoing)
		C_System_Tools_AutoArchive_Backup_Active = $1AE;   // Bool 	Backup archive
                C_System_Tools_AutoArchive_Backup_DeleteOlder = $1B0; // Int    Delete old archive backups
                C_System_Tools_AutoArchive_Backup_File = $1B1; // String        Archive backup file
                C_System_Tools_AutoArchive_Backup_Password = $1D1; // String    Password
                C_System_Tools_AutoArchive_Backup_Domains = $1B6; // Bool       Archive specified domains

		// Atomic clock sync
		C_System_Tools_AtomicClockSync_Enable = $96;	// Bool		Enable Atomic clock sync

		// Watchdog
		C_System_Tools_WatchDog_SMTP = $2E;             // Bool		Enable Watchdog for SMTP		0
		C_System_Tools_WatchDog_POP3 = $2F;      	// Bool		Enable Watchdog for POP3		0
		C_System_Tools_WatchDog_IM = $CF;            	// Bool		Enable Watchdog for IM			0
		C_System_Tools_Watchdog_GW = $AE;	        // Bool		Enable Watchdog for GW			0
		C_System_Tools_Watchdog_Control = $214;	        // Bool		Enable Watchdog for Control		0
		C_System_Tools_Watchdog_Int = $31;              // Int		Watchdog Interval

		// System Monitor
		C_System_Tools_Monitor_Enable = $35; 		// Bool		Enable System monitor			0
		C_System_Tools_Monitor_ReportAddress = $7C;	// String	Disk monitor report address
		C_System_Tools_Monitor_FreeMem = $F1;           // Int		Alert if free memory drops below (kB)	0
 		C_System_Tools_Monitor_DiskSize = $55;          // Int		Alert if free disk space drops below (MB) 0
		C_System_Tools_Monitor_CPUUsagePerc = $EF;      // Int		CPU utilization threshold (%)		0
		C_System_Tools_Monitor_CPUUsagePeriod = $F0;	// Int		Alert if CPU usage exceeds threshold for (Min) 0

		// Remote Servers Watchdog
		C_System_Tools_RemoteServer_Enable = $160;      // Bool		Enable Remote server watchdog		0
		C_System_Tools_RemoteServer_MoreThan = $161;    // Int		Server is down if unreachable for (Min)	0
		C_System_Tools_RemoteServer_Email = $162;       // String	Report Email address
 		C_System_Tools_RemoteServer_Schedule = $163;    // Schedule	Remote Server Watchdog Schedule
		C_System_Tools_RemoteServer_NotifyAgain = $164; // Bool		Notify when server is back online	0


		// TCP/IP tunnel
		C_System_Tools_Tunnel_Enable = $CA;   		// Bool		Enable TCP/IP tunnel			0

                // Migration Tool

		//General
	        C_System_Tools_Migration_Active = $16D;         // Bool		Enable Migration			0
        	C_System_Tools_Migration_Server = $16E;         // String	Migration source host
                C_System_Tools_Migration_MigrateService = $175; // Int		Migration service
			// 0 - Both
			// 1 - POP3
			// 2 - IMAP
                C_System_Tools_Migration_InfoAccount = $16F;    // String	Migration account
	        C_System_Tools_Migration_LogFile = $170;        // String	Path to log file
        	C_System_Tools_Migration_MessageProcessType = $172; // Int	Access mode				0
			// 0 - Standard
			// 1 - Extended alias resolving
			// 2 - Username
                C_System_Tools_Migration_NoXEnvelopeTo = $171;  // Bool		Do not use X-Envelope-To header		0
                C_System_Tools_Migration_NoReceived = $173;     // Bool		Do not process received header		0
                C_System_Tools_Migration_MultiDomain = $174;    // Bool		Multidomain migration			0
                C_System_Tools_Migration_PasswordsOnly = $270;  // Bool		Multidomain migration			0

		// Statistics
                C_System_Tools_Migration_Stat_Start = $17C;     // Int		Unix time of start
                C_System_Tools_Migration_Stat_TotalUsers = $17A;// Int		Total number of migrated mailboxes
                C_System_Tools_Migration_Stat_Users = $177;     // Int		Number of migrated mailboxes
                C_System_Tools_Migration_Stat_Aliases = $179;   // Int		Number of migrated aliases
                C_System_Tools_Migration_Stat_Messages = $178;  // Int		Number of messages migrated
                C_System_Tools_Migration_Stat_Last = $17D;      // Int		Unix time of last migrated mailbox
                C_System_Tools_Migration_Stat_Errors = $17B;    // Int		Number of migration errors

	// Storage

		// Accounts
		C_System_Storage_Accounts_StorageMode = $75;	// Int (stProfessional, stFileSystem, stODBC)		1
			// Accounts storage mode
			// 0 - Professional file system
			// 1 - Standard file system
			// 2 - ODBC
		C_System_Storage_Accounts_ProModeCache = $E4;	// Int		Professional file system memory cache	10
		C_System_Storage_Accounts_ODBCConnString = $61;	// String	ODBC connection string
		C_System_Storage_Accounts_ODBCMultithread = $B0;// Bool		Use Multithreaded ODBC			0
                C_System_Storage_Accounts_ODBCMaxThreads = $1E3; // Int


		// Directories
		C_System_Storage_Dir_MailPath = $17;		// String	Path to mail folder			
		C_System_Storage_Dir_TempPath = $16;		// String	Path to temp folder
		C_System_Storage_Dir_LogPath = $18; 		// String	Path to log folder

                C_System_Storage_Mailbox_UseSorting = $12F;     // Bool         Enables mailbox path alphabetical sorting
                C_System_Storage_Mailbox_PrefixLen = $130;      // Int          Number of characters from alias to prefix

		// Load Balancing
		C_System_Storage_LB_ServerID = $D2;      	// String	Server ID
		C_System_Storage_LB_AutoCheckConfig = $129;     // Bool 	Periodically check if settings have been change and auto reload 0

                // Default charset for direct mysql client library - as of v5 the default is latin1 so this needs to be changed to utf8
                C_System_MySQLDefaultCharset = $216;            // String
                C_System_SQLLogPath = $220;                     // String       Full path to file where SQL queries will be saved
                C_System_SQLLogType = $221;                     // Int          Type of SQL logging
		// 0 - Do not log SQL queries
		// 1 - Log all SQL Queries
		// 2 - Log only Failed SQL Queries

	// Internet Connection
	C_System_Conn_Type = $7E;                  		// Int		Connection mode
		// 0 - Network connection
		// 1 - Dial-up
		// 2 - Dial-up on demand router
	C_System_Conn_UpName = $7F;                  		// String	Connection name
	C_System_Conn_UpUsername = $80;   	    		// String	Username
	C_System_Conn_UpPassword = $81; 	                // String	Password
	C_System_Conn_UpHangUpAfter = $82; 			// Int		Hang up after (sec)
	C_System_Conn_UpOlderthan = $21;		        // Int		COnnect if msg waits for more than (Min)
	C_System_Conn_DialOnDemandExceed = $68;                 // Int		Connect if number of msgs exceeds
	C_System_Conn_DialOnDemandHeader = $70;                 // Bool		Connect if message with this header
	
	C_System_Conn_Schedule = $95;          			// Schedule	Connection schedule
	C_System_Conn_GlobalSchedule = $176;          	    	// Schedule	Global schedule

	// Advanced

		// Extensions
		C_System_Adv_Ext_DisableSSLTLS = $AF;           // Bool		Disable SSL/TLS				1
		C_System_Adv_Ext_EnableIPv6 = $B4; 		// Bool		Enable IPv6 Protocol			0
		C_System_Adv_Ext_ChangePassServer = $CB;	// Bool		Enable Change password server		0
		C_System_Adv_Ext_DaytimeServer = $C8; 		// Bool		Enable Daytime server			0
                C_System_Adv_Ext_DayTimePort = $13B;            // Int          Daytime port
		C_System_Adv_Ext_DisableMultiCPU = $4C;         // Bool		Disable Multiple CPU			1
                C_System_Adv_Ext_SNMPServer = $139;             // Bool         Enable SNMP server
                C_System_Adv_Ext_SNMPPort = $13C;               // Int          SNMP port
                C_System_Adv_Ext_SocksServer = $218;            // Bool         Enable Sokcs server
                C_System_Adv_Ext_SocksPort = $219;              // Int          Socks port

                C_System_Adv_Ext_SSLServerMethod = $1F5;        // (Default, smSSLv2_method, smSSLv23_method, smSSLv3_method, smTLSv1_method)
                C_System_Adv_Ext_SSLClientMethod = $1F6;        // (Default, smSSLv2_method, smSSLv23_method, smSSLv3_method, smTLSv1_method)

		// Protocols
		C_System_Adv_Protocols_SessionTimeOut = $0C;    // Int		Session timeout				300
		C_System_Adv_Protocols_ResponseDelay = $0D;     // Int		Protocol response delay			0
		C_System_Adv_Protocols_MaxBadCommands = $4E; 	// Int		Max number of bad commands		8	
		C_System_Adv_Protocols_BackLog = $54;           // Int		Listen back logs			5
		C_System_Adv_Protocols_DNSTimeout = $48;        // Int		DNS Timeout				5
		C_System_Adv_Protocols_DNSCache = $E6;          // Bool		Use DNS smart cache			1
		C_System_Adv_Protocols_DNSRetry = $12E;         // Int		DNS retries                             1
		C_System_Adv_Protocols_DNSCacheLimit = $132;    // Int		DNS cache items limit                   128
                C_System_Adv_Protocols_IMAPTimeout = $1F0;      // Int          IMAP timeout

                // Notification
                C_System_Adv_Notification_Active = $1F1;        // Bool         Notification messages active
                C_System_Adv_Notification_Host = $1F2;          // String       Notification messages host

// Mail service

	// SMTP service

		// General
		C_Mail_SMTP_General_HostName = $0B;     	// String	Mailserver hostname
		C_Mail_SMTP_General_DeliveryMode = $29;         // Bool		SMTP service delivery mode		1
			// 0 - Use SMTP relay server
			// 1 - Use DNS lookup
		C_Mail_SMTP_General_RelayMailServer = $26;	// String	SMTP relay server
		C_Mail_SMTP_General_DNSServer = $28;            // String	DNS servers
		
		// Delivery
		C_Mail_SMTP_Delivery_UseTLSSSL = $87;           // Bool		Use TLS/SSL				0
		C_Mail_SMTP_Delivery_RetrySMTP = $89;           // Bool		Retry with SMTP when ESMTP failed
		C_Mail_SMTP_Delivery_LimitMsgSize = $56;	// Bool		Enable Max message size			0
		C_Mail_SMTP_Delivery_MaxMsgSize = $57;          // Int		Max message size (B)
		C_Mail_SMTP_Delivery_MXReconnectFailure = $C7;  // Bool		Deliver message via relay server when direct delivery fails
		C_Mail_SMTP_Delivery_HideIP = $78;		// Bool		Hide IP from received header
                C_Mail_SMTP_Delivery_RDNSLookup = $1C2;         // Bool
		C_Mail_SMTP_Delivery_UndelivAfter = $93;        // Int		Undeliverable after (Minutes)		0
		C_Mail_SMTP_Delivery_UndelivWarning = $92;      // Int		Undeliverable warning (Minutes)		0
		C_Mail_SMTP_Delivery_DaemonAlias = $49;		// String	Mailer Daemon report alias 		MAILER-DAEMON
		C_Mail_SMTP_Delivery_DaemonName = $4A;	        // String 	Mailer Daemon report name		Mail Delivery Subsystem
		C_Mail_SMTP_Delivery_BadMail = $6A;   		// String	Bad mail address	
		C_Mail_SMTP_Delivery_DoNoTruncate = $109;       // Bool		Do not truncate mailer daemon's msgs	0
		C_Mail_SMTP_Delivery_InfoToAdmin = $8F;         // Bool		Send info to admin			0
                C_Mail_SMTP_Delivery_UseIncomingQueue = $1C9;   // Bool         Use incoming mail queue
                C_Mail_SMTP_Delivery_IncomingQueueSize = $1CA;  // Int          Size of the queue (# threads)
                C_Mail_SMTP_Delivery_MDAInternal = $1E6;  // Bool               Use MDA queue for internal delivery     0
                C_Mail_SMTP_Delivery_ReturnPath = $1F7;  // Bool                Add return-path

		// Header/Footer
		C_Mail_SMTP_HeaderFooter_Enable = $3C;		// Bool		Enable Header/Footer			0

		// Other
		C_Mail_SMTP_Other_Dedupe = $C2;    		// Bool		Dedupe email messages			0
		C_Mail_SMTP_Other_SearchInLocalDomains = $58;   // Bool		Search for alias in other local domains	0
		C_Mail_SMTP_Other_HeaderFunctions = $59;        // Bool		Activate message header functions	0
		C_Mail_SMTP_Other_MaxHopCount = $90;            // Int		Max SMTP hop count			20
		C_Mail_SMTP_Other_MaxRecipients = $39;   	// Int		Max SMTP server recipients		32768
                C_Mail_SMTP_Other_MaxMTARecipients = $1A5;      // Int		Max SMTP client recipients		100
		C_Mail_SMTP_Other_LocalDelivery = $FC;          // Bool		Enable remote delivery from local server 0
		C_Mail_SMTP_Other_ExternalDelivery = $C6;       // Bool		Deliver all messages externally		0
		C_Mail_SMTP_Other_NoRetryQueue = $BE;		// Bool		Do not queue messages		 	0
		C_Mail_SMTP_Other_BounceBackMode = $199;	// Int		Bounce back mode 
		C_Mail_SMTP_Other_SMTPPipelining = $D4;         // Bool		Enable SMTP pipelining          	0
                C_Mail_SMTP_Other_SPFSRS = $13E;                // Bool		Enable SRS				0
                C_Mail_SMTP_Other_SPFSRSKey = $13F;             // String	SRS secret key

                C_Mail_SMTP_Other_MailboxSeparator = $16C;      // String	Mailbox separator / extension separator (eg: alias:extension@domain)

	// Security

		// Anti Relaying
		C_Mail_Security_Relay_RelayMode = $83;          // Bool		Relay mode
			// 0 - Open relay
			// 1 - Close relay
		C_Mail_Security_Relay_IPList = $84;             // String	List of relayed IP addresses
		C_Mail_Security_Relay_POPSMTP = $8D;    	// Bool		Enable POP before SMTP
		C_Mail_Security_Relay_POPSMTPInt = $8C;		// Int		POP before SMTP interval (Min)
		C_Mail_Security_Relay_POPSMTPGlobal = $1D4;    	// Bool		Enable POP before SMTP global mode
		C_Mail_Security_Relay_RejectLocalUnauth = $B6;  // Bool		Reject if orig's domain is local&unauth	0

		// Protection
		C_Mail_Security_Protection_DNSBL = $3E;     	// Bool		Enable DNSBL				0
		C_Mail_Security_Protection_CloseDNSBLConn = $BF;// Bool		Close connection for DNSBL sessions	0
		C_Mail_Security_Protection_RejectrDNS = $30;    // Bool		Reject if sender's IP has no rDNS	0
		C_Mail_Security_Protection_RejectMX = $8B;      // Bool		Reject if orig's domain has no MX rec	0
		C_Mail_Security_Protection_SMTPWait = $14C;     // Int		Wait before processing a new conn 	0
		C_Mail_Security_Protection_LocalDomain = $91;   // Bool		Relay only if orig's domain's local	0
		C_Mail_Security_Protection_DomainIPShield = $A1;// Bool		Use Domain IP shielding			0
		C_Mail_Security_Protection_RejectSMTPAuthSender = $1C8; // Bool	Reject if SMTP AUTH different from sender
		C_Mail_Security_Protection_HELOEHLO = $36;      // Bool		Require HELO/EHLO			0
                C_Mail_Security_Protection_IgnoreBlankHeloHost = $16B; // Bool	Igonore Blank Helo Host

		// Tarpitting
		C_Mail_Security_Tarpit_Enable = $88;      	// Bool		Enable tarpitting			0
		C_Mail_Security_Tarpit_Count = $25;     	// Int		Number of attempts
		C_Mail_Security_Tarpit_Period = $1D;	 	// Int		Tarpitting interval
		C_Mail_Security_Tarpit_RelayTarpit = $B2;       // Bool		Tarpit relay rejected IPs		0
		C_Mail_Security_Tarpit_BlockIP = $C1;           // Bool		Block IPs that establish more than BlockIPValue connections within a minute	0
		C_Mail_Security_Tarpit_BlockIPValue = $C0;      // Int		Number of limitted of connections	
                C_Mail_DoNot_Tarpit_IPs = $133;                 // Bool         Do not tarpit IP addresses		0
                C_Mail_Security_Tarpit_CloseConnection = $14D;  // Bool		Close tarpitted connections		0
                C_Mail_Security_Tarpit_CrossSession = $14E;     // Bool		Cross session processing		0
                C_Mail_Security_Tarpit_Msg_Enabled = $1BA;     // Bool		Tarpit message size
                C_Mail_Security_Tarpit_Msg_Value = $1BB;     // Int		Tarpit message size value
                C_Mail_Security_Tarpit_Spam = $1C0;     // Bool  		Tarpit spam
                C_Mail_Security_Tarpit_SpamScore = $1C1;     // Int  		Tarpit spam score (* 100)
                C_Mail_Security_Tarpit_DNSBL = $1C3;     // Bool  		Tarpit DNSBL
                C_Mail_Security_Tarpit_RSET = $1C5;      // Bool                Tarpit RSET
                C_Mail_Security_Tarpit_RSETCount = $1C6; // Int                 Tarpit RSET count

		// Protocols
		C_Mail_Security_Protocols_DenyESMTP = $2A;      // Bool		Deny ESMTP protocol			0
		C_Mail_Security_Protocols_AllowSMTPAuth = $76;	// Bool		Allow SMTP Auth				1
  		C_Mail_Security_Protocols_DenyVRFY = $2B;       // Bool		Deny VRFY command			0
		C_Mail_Security_Protocols_DenyEXPN = $2C;       // Bool		Deny EXPN command			0
		C_Mail_Security_Protocols_DenyTelnet = $2D;  	// Bool		Deny Telnet access			0

	// Filtering
	
		// Content Filters
		C_Mail_Filter_Content_Enable = $77;    		// Bool		Enable Content filters			0

		// B&W lists
		C_Mail_Filter_BW_Enable = $8E;                  // Bool		Enable B&W lists			0
                C_Mail_Filter_RulesContentXML = $1E5;           // String

                C_Mail_Filter_MaxThreads = $13A;                // Int          Number of filter threads                0

	// ETRN download
        C_Mail_ETRN_Active = $245;                              // Bool
        C_Mail_ETRN_Schedule = $17E;                            // Schedule	ETRN Schedule

// AS
	// General
	C_AS_General_Enable = $FD;   				// Bool		Enable Spam Engine			1
	C_AS_General_ProcessingMode = $BC;                      // Int		AS access mode			bit 0
		// 0 - All messages
		// 1 - All except selected
		// 3 - Group
		// 5 - Selected domains only
		// 9 - Selected accounts only
        C_AS_General_ProcessingGroup = $19D;                    // String	Access mode group


        C_AS_Info_UpdateDate = $146;                            // String	Update date
        C_AS_Info_UpdateVersion = $147;                         // String	Update version
        C_AS_Info_EngineVersion = $148;                         // String	Engine version
        C_AS_Info_UpdateSize = $1DF;                         // Int
        C_AS_Info_BayesWords = $1E0;                         // Int
        C_AS_Info_BayesSpamMessages = $1E1;                         // Int
        C_AS_Info_BayesGenuineMessages = $1E2;                         // Int

	// Challenge Response
	C_AS_Challenge_ProcessingMode = $B5;       		// Int		CR access mode				bit 0
		// 0 - All messages
		// 1 - All except selected
		// 3 - Group
		// 5 - Selected domains only
		// 9 - Selected accounts only

        C_AS_Challenge_ProcessingGroup = $19E;                  // String	Access mode group

        C_AS_Challenge_ReportsSchedule = $1AF;                  // Schedule

        C_AS_Challenge_ConnectionString = $230;                 // String       Anti spam DB ConnectionString

// AV

	// General
	C_AV_General_IntegratedAV = $3D;        		// Bool		Enable Integrated AV scanner		1
	C_AV_General_ProcessingMode = $E7;                      // Int 		AV access mode - bit based		bit 0
		// 0 - All messages
		// 1 - All except selected 
		// 3 - Group
		// 5 - Selected domains only
		// 9 - Selected accounts only

        C_AV_General_ProcessingGroup = $19F;                    // String	Access mode group

        C_AV_General_UpdateType = $168;                         // Int		Update Schedule
		// 0 - Disabled
		// 1 - Once at
		// 2 - Every x hours
	C_AV_General_UpdateNotWeekdays = $E9;                   // Int		List of days when server does not check for update
		// bit 1 - Monday ... bit 7 - Sunday
	C_AV_General_UpdateTime = $EB;                          // Int		Update time
		// hours - upper byte
		// minutes - lower byte
	C_AV_General_EveryHour = $C9;                           // Int		Check for update every (Hours)
	C_AV_General_ActiveUpdate = $EA;             		// Bool		Enable Active Update			0
	C_AV_General_ActiveAddress = $EC;              		// String	Active update email trigger
        C_AV_General_MirrorURL = $250;                          // String	Custom mirror URL

        C_AV_Info_UpdateDate = $149;                            // String	Update date
        C_AV_Info_UpdateSize = $14A;                            // Int		Update size
        C_AV_Info_UpdateVersion = $14B;                         // String	Update version

	// Action
	C_AV_Action_ScanAllParts = $0F;        			// Int		Scan All message parts
	C_AV_Action_Mode = $0E;            			// Int		AV Action mode				1
		// 1 - Reject
		// 2 - Remove infected attachments
		// 3 - Delete
	C_AV_Action_CleanInfected = $9E;	       		// Bool		Clean infected messages if possible	0
	C_AV_Action_InfoToAdmin = $47;                  	// Bool		Notification to Admin			0
	C_AV_Action_InfoToRecipient = $4B;			// Bool		Notification to Recipient		0
	C_AV_Action_InfoToSender = $60;				// Bool		Notification to Sender			0
	C_AV_Action_UseQuarantine = $33;                  	// Bool		Quarantine infected messages		0
	C_AV_Action_QuarantineAddress = $7D;                	// String	Quarantine address/path
	C_AV_Action_QuarantineMode = $D9;                       // Bool		Virus Quarantine mode			0
		// 0 - Quarantine whole infected messages
		// 1 - Quarantine only infected attachments

	// Filters
	C_AV_Filters_BlockFiles = $10B;            		// Bool		Block files with following extensions	0

	// Misc
	C_AV_Misc_RejectPassProtected = $AC;			// Bool		Reject password protected files		0
	C_AV_Misc_ApplyAsLast = $BB;              		// Bool		Apply antivirus as the last filter	0
	C_AV_Misc_Outgoing = $1A3;            		        // Bool		Apply antivirus to outgoing messages
	C_AV_Misc_DisableExternalAV = $9F;                  	// Bool		Disable External AV			1

	C_AV_MaxThreads = $111;                          	// Int		Max number of concurrent threads	0
        C_AV_MaxFile = $1D3;                                    // Int          Max message size

        C_AV_Avast = $135;                                      // Int		Avast Antivirus usage			0
		// 0 - Default
		// 1 - Enabled
		// 2 - Disabled
        C_AV_Symantec = $136;                                   // Int		Symantec Antivirus usage		1	0
		// 0 - Default
		// 1 - Enabled
		// 2 - Disabled
        C_AV_AVG = $137;                                        // Int		AVG Antivirus usage			1
		// 0 - Default
		// 1 - Enabled
		// 2 - Disabled
        C_AV_Kaspersky = $138;                                  // Int		Kaspersky Antivirus usage		1
		// 0 - Default
		// 1 - Enabled
		// 2 - Disabled


// Web Service

        C_WebService_AppMaxThreads = $166;        	        // Int          Number of web service application threads

// SMS Service
        C_SMSService_Active = $1FE;                             // Bool
        C_SMSService_RequireAuth = $211;                        // Bool

// Web Service

        C_FTPService_Active = $1A6;        	                // Bool         Activate FTP service

// GW

	// General
	C_GW_General_Disable = $B9;                             // Bool		Disable GW service			0
	C_GW_ProcessingMode = $EE;     				// Int		GW service access mode			bit 0
		// 0 - All messages
		// 1 - All except selected
		// 3 - Group
		// 5 - Selected domains only
		// 9 - Selected accounts only
        C_GW_ProcessingGroup = $1A0;                      	// String

        C_GW_SuperUser = $1CB;                                  // String
        C_GW_SuperPass = $1CC;                                  // String
        C_GW_ConnectionString = $235;                           // String       Connection string to GW database


// IM

	// General
	C_IM_General_Disable = $D5;                            	// Bool		Disable IM service			0
	C_IM_General_Redirectunknown = $D7;         		// Bool		Redirect unknown domain to local domain	0
	C_IM_General_Anonymous = $DA;  				// Bool		Enable Anonymousserver to server communication 0
	C_IM_General_FileTransfer = $D1;                  	// Bool		Enable Server file transfer		0
	C_IM_General_AccountRegistration = $DB;        		// Bool		Enable Account registration		0
	C_IM_General_ServerOSReport = $DC;		        // Bool		Enable Server OS report			0
	C_IM_ProcessingMode = $ED;                		// Int		IM access mode - bit based		bit 0
		// 0 - All messages
		// 1 - All except selected
		// 3 - Group
		// 5 - Selected domains only
		// 9 - Selected accounts only
        C_IM_ProcessingGroup = $1A2;                      	// String
        C_IM_EmailTransportNode = $1E7;                      	// String
        C_IM_SocksServerIP = $21A;                      	// String

	// Archiving
	C_IM_Archive_Enable = $C5;				// Bool		Enable IM archive
	C_IM_Archive_DeleteAfter = $C4;                         // Int		Delete IM archive after (Days)

        // Presence History
        C_IM_Presence_History = $1F9;                           // Bool
        C_IM_Presence_HistoryDelete = $1FA;                     // Int

// SyncML
        C_SyncML_Push_Active = $1FB;                            // Bool
        C_SyncML_Push_Port = $1FC;                              // Int
        C_SyncML_URL = $242;                                    // String


// SIP service
                C_System_Services_SIP_Enable = $17F;            // Bool
                C_System_Services_SIP_Port = $180;              // Int
                C_System_Services_SIP_DebugFile = $189;         // String
                C_System_Services_SIP_NoRecordRoute = $181;     // Bool
                C_System_Services_SIP_LocalNet = $182;          // String
                C_System_Services_SIP_RemoteAccessHost = $183;  // String
                C_System_Services_SIP_LocalAccessHost = $184;  // String
                C_System_Services_SIP_OtherProxy = $185;  // String
                C_System_Services_SIP_UseOtherProxy = $186;  // Bool
                C_System_Services_SIP_DisableAnonymousAccess = $187;  // Bool
                C_System_Services_SIP_DisableRegistrar = $188;  // Bool
                C_System_Services_SIP_DisableSymmetricResponseRouting = $198;  // Bool
                C_System_Services_SIP_Calls = $192;  // Bool
                C_System_Services_SIP_CallsFile = $193;  // String
                C_System_Services_SIP_UserCalls = $1D5;  // Bool
                C_System_Services_SIP_AwayPrefix = $1D8;  // String
                C_System_Services_SIP_ResetPrefix = $1D9;  // String
                C_System_Services_SIP_RedialPrefix = $1DA;  // String
                C_System_Services_SIP_ENUM = $1DC; // Bool
                C_System_Services_SIP_SDPProxy = $18C;  // Bool
                C_System_Services_SIP_SDPRemoteAccessHost = $18D;  // String
                C_System_Services_SIP_Mode = $18E;  // Int
                C_System_Services_SIP_RTPProxy = $18F;  // Int
                C_System_Services_SIP_RTPStart = $190;  // Int
                C_System_Services_SIP_RTPMax = $191;  // Int
                C_System_Services_SIP_MaxCalls = $194;  // Int
                C_System_Services_SIP_DNSEnabled = $195; // Bool
                C_System_Services_SIP_AccessGroup = $1A1;                      // String
                C_System_Services_SIP_SSLPort = $1B3;                      // Int
                C_System_Services_SIP_List = $1B4;                      // String
                C_System_Services_SIP_Grant = $1B5;                      // Bool
                C_System_Services_SIP_DisableRTPProxy = $1C4;           // Bool
                C_System_Services_SIP_ContactExpires = $1FD;            // Int


// Schedule 

  S_ForceDial = $00;           					// Bool
  S_WeekDays_Mo = $02;           				// Bool
  S_WeekDays_Tu = $03;           				// Bool
  S_WeekDays_We = $04;           				// Bool
  S_WeekDays_Th = $05;           				// Bool
  S_WeekDays_Fr = $06;           				// Bool
  S_WeekDays_Sa = $07;           				// Bool
  S_WeekDays_Su = $08;           				// Bool
  S_ScheduleType = $09;          				// (stEvery, stOnce)
  S_ScheduleWhen = $260;          				// (stWeekdays, stDaysInMonth,stDisabled)
  S_DaysInMonth = $261;          				// String
  S_OnceAt = $0A;                				// Int
  S_Every = $0B;                 				// Int
  S_WholeDay = $0C;              				// Bool
  S_BetweenFrom = $0D;           				// Int
  S_BetweenTo = $0E;             				// Int

  S_Backup = $0F;                				// String

// Statistics

  ST_Time = $00;                    			        // Int  	Unix time
  ST_ServerOut = $01;                   			// Int 		kB
  ST_ServerIn = $02;                    			// Int 		kB
  ST_ClientOut = $03;                   			// Int 		kB
  ST_ClientIn = $04;                    			// Int 		kB
  ST_Server = $05;                      			// Int
  ST_ServerPeak = $06;                      			// Int
  ST_Client = $07;                      			// Int
  ST_ClientPeak = $08;                      			// Int
  ST_ServerConns = $0B;                      			// Int
  ST_PeakWorkingSetSize = $17;               			// Int
  ST_PageFileUsage = $18;               			// Int
  ST_WorkingSetSize = $19;               			// Int
  ST_RunningTime = $1A;                    			// Int

  ST_SMTP_MessageOut = $0C;                      		// Int
  ST_SMTP_MessageIn = $0D;                     			// Int
  ST_SMTP_MessageFailed = $0E;                      		// Int
  ST_SMTP_FailedGL = $0F;                      			// Int
  ST_SMTP_FailedVirus = $10;                      		// Int
  ST_SMTP_FailedCF = $11;                      			// Int
  ST_SMTP_FailedStaticFilter = $12;                      	// Int
  ST_SMTP_FailedFilter = $13;                      		// Int
  ST_SMTP_FailedRBL = $14;                      		// Int
  ST_SMTP_FailedTarpit = $15;                      		// Int
  ST_SMTP_FailedSpam = $16;                      		// Int
  ST_SMTP_FailedSpamQuarantine = $1B;                      		// Int
  ST_SMTP_FailedSpamRefused = $1C;                      		// Int

  ST_SIP_PacketsIn = $0C;                      		// Int
  ST_SIP_PacketsOut = $0D;                     			// Int
  ST_SIP_RTPPacketsIn = $0E;                      		// Int
  ST_SIP_RTPPacketsOut = $0F;                      			// Int

// Validation
  V_Account_PassPolicy = 'passpolicy';

Implementation
// Last Used ID: $270
End.
