// Result Codes 
  #define S__API_OK 0x000

  #define E_FAILURE -0x001
  #define E_LICENSE -0x002
  #define E_PARAMS -0x003
  #define E_PATH -0x004
  #define E_CONFIG -0x005

// Domain 
  #define D_Description 0x000
  #define D_Type 0x001
  #define D_DomainValue 0x003
  #define D_PostMaster 0x004
  #define D_AdminForward 0x005
  #define D_UnknownUsersForward 0x006
  #define D_UnknownForwardTo 0x007
  #define D_InfoToAdmin 0x008
  #define D_AccountNumber 0x009

// Account 
  #define U_Type 0x000
  #define U_AntiSpamIndex 0x001
  #define U_Name 0x002
  #define U_Alias 0x003

  #define U_Mailbox 0x010
  #define U_AccountDisabled 0x011
  #define U_AccountValid 0x012
  #define U_AccountValidTill 0x013
  #define U_AllowRemote 0x015
  #define U_ValidityReport 0x016
  #define U_ValidityReportDays 0x017
  #define U_NTPassword 0x018
  #define U_IMAP 0x019
  #define U_IMAPMailbox 0x01A
  #define U_MaxMessageSize 0x01B
  #define U_DontShowMessages 0x01C
  #define U_AnyPassword 0x01D
  #define U_ETRN 0x01E
  #define U_DeleteExpire 0x01F
  #define U_NULL 0x020
  #define U_Password 0x021
  #define U_NTPasswordValue 0x022
  #define U_DomainAdminIndex 0x023
  #define U_DomainAdmin 0x024
  #define U_MailBoxPath 0x025
  #define U_Admin 0x026
  #define U_MaxBox 0x027
  #define U_MaxBoxSize 0x028
  #define U_ForceFrom 0x029
  #define U_Respond 0x02A
  #define U_OnlyLocalDomain 0x02B
  #define U_UseRemoteAddress 0x02C
  #define U_ForwardTo 0x02D
  #define U_RespondWith 0x02E
  #define U_MailIn 0x02F
  #define U_MailOut 0x030
  #define U_ValidReport 0x031
  #define U_DeleteOlder 0x032
  #define U_DeleteOlderDays 0x033
  #define U_ForwardOlder 0x034
  #define U_ForwardOlderDays 0x035
  #define U_ForwardOlderTo 0x036
  #define U_RemoteAddress 0x037
  #define U_ForceFromAddress 0x038
  #define U_MegabyteSendLimit 0x039
  #define U_NumberSendLimit 0x03A
  #define U_NoMailList 0x03B

  #define U_E_Application 0x050
  #define U_E_Parameters 0x051
  #define U_E_ExecForwardCopy 0x052

  #define M_OwnerAddress 0x070
  #define M_CopyToOwner 0x071
  #define M_DigestConfirmed 0x072
  #define M_MailingListFile 0x073
  #define M_ListServer 0x074
  #define M_SendToSender 0x075
  #define M_SubListFile 0x076
  #define M_SendAllLists 0x077
  #define M_HeaderFile 0x078
  #define M_FooterFile 0x079
  #define M_Moderated 0x07A
  #define M_ModeratedPassword 0x07B
  #define M_DenyEXPNList 0x07C
  #define M_MaxList 0x07D
  #define M_MaxListSize 0x07E
  #define M_SetFromTo 0x07F
  #define M_SetFromToValue 0x080
  #define M_HelpFile 0x081
  #define M_MembersOnly 0x082
  #define M_ReplyTo 0x083
  #define M_SwitchFields 0x084
  #define M_AddToSubject 0x085
  #define M_JoinR 0x086
  #define M_LeaveR 0x087
  #define M_ListsR 0x088
  #define M_WhichR 0x089
  #define M_ReviewR 0x08A
  #define M_ListSubject 0x08B
  #define M_ListSender 0x08C
  #define M_SeparateTo 0x08D
  #define M_ServerModerated 0x08E

  #define S_MailAddress 0x0A0
  #define S_SMSIntoSubject 0x0A1
  #define S_Size 0x0A2
  #define S_SendTo 0x0A3
  #define S_SendFrom 0x0A4
  #define S_SendSubject 0x0A5
  #define S_SendBody 0x0A6
  #define S_SendDateTime 0x0A7
  #define S_Send 0x0A8
  #define S_SMSForwardCopy 0x0A9
  #define S_SkipAttach 0x0AA
  #define S_SMSSender 0x0AB
  #define S_SMSCount 0x0AC
  #define S_SMSFilterFile 0x0AD

  #define R_Activity 0x0C0
  #define R_ActivityValue 0x0C1
  #define R_FilterFile 0x0C2
  #define R_ExternalFilter 0x0C3
  #define R_ExternalFilterFile 0x0C4
  #define R_ExternalDomain 0x0C5
  #define R_SaveTo 0x0C6
  #define R_ExternalFilterType 0x0C7

// Config
  #define C_XHostName 0x000
  #define C_XDNS 0x001
  #define C_XRelay 0x002
  #define C_XLicense 0x003
  #define C_XTempPath 0x004
  #define C_XMailPath 0x005
  #define C_XLogPath 0x006

  #define C_Name 0x00B
  #define C_SessionTimeOut 0x00C
  #define C_ResponseDelay 0x00D
  #define C_VirusType 0x00E
  #define C_VirusAllParts 0x00F
  #define C_VirusPlugIn 0x010
  #define C_LDAPSSLPort 0x011
  #define C_LDAPPort 0x012
  #define C_SMTPPortMore 0x013
  #define C_NoUIDLPrefix 0x014
  #define C_ServerType 0x015
  #define C_TempPath 0x016
  #define C_MailPath 0x017
  #define C_LogPath 0x018
  #define C_Config_Ports_POP3 0x019
  #define C_Config_Ports_POP3SSL 0x01A
  #define C_Config_Ports_SMTP 0x01B
  #define C_Config_Ports_IMAPSSL 0x01C
  #define C_Config_Ports_TarpittingPeriod 0x01D
  #define C_Config_Ports_Control 0x01E
  #define C_Config_Ports_IMAP 0x01F
  #define C_Config_Ports_ControlSSL 0x020
  #define C_Config_Ports_MinOlder 0x021
  #define C_Config_AutoStart_POP3 0x022
  #define C_Config_AutoStart_SMTP 0x023
  #define C_Config_AutoStart_Control 0x024
  #define C_Config_AutoStart_TarpittingCount 0x025
  #define C_Config_System_RelayMailServer 0x026
  #define C_Config_System_BindIP 0x027
  #define C_Config_System_DNSServer 0x028
  #define C_Config_System_UseDNS 0x029
  #define C_Config_System_DenyESMTP 0x02A
  #define C_Config_System_DenyVRFY 0x02B
  #define C_Config_System_DenyEXPN 0x02C
  #define C_Config_System_DenyTelnet 0x02D
  #define C_Config_System_WatchDogSMTP 0x02E
  #define C_Config_System_WatchDogPOP3 0x02F
  #define C_Config_System_RejectrDNS 0x030
  #define C_Config_System_WatchDogInterval 0x031
  #define C_Config_System_VirusScan 0x032
  #define C_Config_System_UseQuarantine 0x033
  #define C_Config_System_DeleteOlder 0x034
  #define C_Config_System_DiskMonitorActive 0x035
  #define C_Config_System_GreetingRequired 0x036
  #define C_Config_System_DenyWeb 0x037
  #define C_Config_System_MaxConnections 0x038
  #define C_Config_System_MaxRecipients 0x039
  #define C_Config_System_DomainListing 0x03A
  #define C_Config_System_SMTPSSL 0x03B
  #define C_Config_System_HeaderFooter 0x03C
  #define C_Config_System_SMTPScan 0x03D
  #define C_Config_System_RBL 0x03E
  #define C_Config_System_DiskQuota 0x03F
  #define C_Config_System_SafeConfirm 0x040
  #define C_Config_System_NoDomainAdminMailbox 0x041
  #define C_Config_System_NoShowControl 0x042
  #define C_Config_System_NoShowSMTP 0x043
  #define C_Config_System_NoShowPOP3 0x044
  #define C_Config_System_UseWelcome 0x045
  #define C_Config_System_UseBindIP 0x046
  #define C_Config_System_VirusInfoAdmin 0x047
  #define C_Config_System_DNSTimeout 0x048
  #define C_Config_System_DaemonAlias 0x049
  #define C_Config_System_DaemonName 0x04A
  #define C_Config_System_VirusInfoRecipient 0x04B
  #define C_Config_System_DisableCPU 0x04C
  #define C_Config_System_UseDefaults 0x04D
  #define C_Config_System_MaxBadCommands 0x04E
  #define C_Config_System_POP3Max 0x04F
  #define C_Config_System_SMTPMax 0x050
  #define C_Config_System_SMTPCache 0x051
  #define C_Config_System_POP3Cache 0x052
  #define C_Config_System_ControlCache 0x053
  #define C_Config_System_BackLog 0x054
  #define C_Config_System_DiskMonitorSize 0x055
  #define C_Config_Exchange_MaxData 0x056
  #define C_Config_Exchange_MaxDataSize 0x057
  #define C_Config_Exchange_SearchForAliasInDomains 0x058
  #define C_Config_Exchange_HeaderFunctions 0x059
  #define C_Config_Exchange_NoAutoResponderFor 0x05A
  #define C_Config_Firewall_Active 0x05B
  #define C_Config_Firewall_SMTP_Grant 0x05C
  #define C_Config_Firewall_SMTP_List 0x05D
  #define C_Config_Firewall_POP3_Grant 0x05E
  #define C_Config_Firewall_POP3_List 0x05F
  #define C_Config_Firewall_ODBC_VirusInfoSender 0x060
  #define C_Config_Firewall_ODBC_ConnectionString 0x061
  #define C_Config_Firewall_Control_Grant 0x062
  #define C_Config_Firewall_Control_List 0x063
  #define C_Config_EventLog_SMTP 0x064
  #define C_Config_EventLog_More_OutgoingPacketDelay 0x065
  #define C_Config_EventLog_More_IncomingPacketDelay 0x066
  #define C_Config_EventLog_More_LoggingCache 0x067
  #define C_Config_EventLog_More_DialOnDemandExceed 0x068
  #define C_Config_EventLog_POP3 0x069
  #define C_Config_EventLog_BadMailAddr 0x06A
  #define C_Config_EventLog_ODBCLoggingConnection 0x06B
  #define C_Config_EventLog_ODBCLogging 0x06C
  #define C_Config_EventLog_LDAPActive 0x06D
  #define C_Config_EventLog_Control 0x06E
  #define C_Config_EventLog_BackupActive 0x06F
  #define C_Config_EventLog_DialOnDemandHeader 0x070
  #define C_Config_EventLog_DialOnDemand 0x071
  #define C_Config_EventLog_WebAdminSecure 0x072
  #define C_Config_EventLog_EmailLogin 0x073
  #define C_Config_EventLog_UserStat 0x074
  #define C_Config_EventLog_DBSetting 0x075
  #define C_Config_EventLog_AllowSMTPAuth 0x076
  #define C_Config_EventLog_ContentFilter 0x077
  #define C_Config_EventLog_HideIP 0x078
  #define C_Config_EventLog_ConvertAuth 0x079
  #define C_Config_EventLog_DisableMailFile 0x07A
  #define C_Config_EventLog_OutputDebug 0x07B
  #define C_Config_DiskMonitor_ReportAddress 0x07C
  #define C_Config_DiskMonitor_QuarantineAddress 0x07D
  #define C_Config_Connect_DialUp 0x07E
  #define C_Config_Connect_EntryName 0x07F
  #define C_Config_Connect_Username 0x080
  #define C_Config_Connect_Password 0x081
  #define C_Config_Connect_HangUpAfter 0x082
  #define C_Config_Delivery_UseDoNotRelay 0x083
  #define C_Config_Delivery_AllowRelayTo 0x084
  #define C_Config_Delivery_UseETRN 0x085
  #define C_Config_Delivery_ETRNCount 0x086
  #define C_Config_Delivery_UseTLSSSL 0x087
  #define C_Config_Delivery_Tarpitting 0x088
  #define C_Config_Delivery_UseSMTP 0x089
  #define C_Config_Delivery_LongDomain 0x08A
  #define C_Config_Delivery_RejectMX 0x08B
  #define C_Config_Delivery_POP3SMTPValue 0x08C
  #define C_Config_Delivery_POP3SMTPRelay 0x08D
  #define C_Config_Delivery_GlobalFilter 0x08E
  #define C_Config_Delivery_UndelivAdmin 0x08F
  #define C_Config_Delivery_MaxHopCount 0x090
  #define C_Config_Delivery_RelayLocal 0x091
  #define C_Config_Delivery_UndeliverableWarning 0x092
  #define C_Config_Delivery_UndeliverableAfter 0x093
  #define C_Config_ETRNConfig 0x094
  #define C_Config_ConnectSchedule 0x095
  #define C_Config_AtomicClockSync 0x096
  #define C_Config_AVLogging 0x097
  #define C_Config_AVDeleteOlder 0x098
  #define C_Config_AutoArchive 0x099
  #define C_Config_ArchivePath 0x09A

// Global External 

typedef DWORD (__stdcall *Init_type) (PCHAR Directory);

typedef void (__stdcall *Done_type) (void);

typedef void (__stdcall *UpdateConfiguration_type) (void);

typedef DWORD (__stdcall *GetConfigSetting_type) (DWORD Setting, PCHAR Buffer, DWORD Size);

typedef DWORD (__stdcall *SetConfigSetting_type) (DWORD Setting, PCHAR Buffer, DWORD Size);

typedef DWORD (__stdcall *BackupConfig_type) (PCHAR FileName);

typedef DWORD (__stdcall *RestoreConfig_type) (PCHAR FileName);

// Domain External

typedef DWORD (__stdcall *GetDomainCount_type) (void);

typedef DWORD (__stdcall *GetDomainList_type) (PCHAR List, DWORD Size);

typedef DWORD (__stdcall *GetDomainName_type) (DWORD Index, PCHAR Name, DWORD Size);

typedef DWORD (__stdcall *GetDomainIndex_type) (PCHAR Name);


typedef DWORD (__stdcall *LoadDomain_type) (DWORD Index, PCHAR Buffer, DWORD Size);

typedef DWORD (__stdcall *SaveDomain_type) (DWORD Index, PCHAR Buffer, DWORD Size);

typedef DWORD (__stdcall *AddDomain_type) (PCHAR Name, PCHAR Buffer, DWORD Size);

typedef DWORD (__stdcall *RenameDomain_type) (PCHAR NameOld, PCHAR NameNew);

typedef DWORD (__stdcall *DeleteDomain_type) (DWORD Index);

typedef DWORD (__stdcall *GetDomainSetting_type) (PCHAR Buffer, DWORD Size, DWORD Setting, PCHAR FResult, DWORD ResultSize);

typedef DWORD (__stdcall *SetDomainSetting_type) (PCHAR Buffer, DWORD Size, DWORD Setting, PCHAR Value, DWORD ValueSize);

typedef DWORD (__stdcall *GetDomainIP_type) (DWORD Index, PCHAR Buffer, DWORD Size);

typedef DWORD (__stdcall *SetDomainIP_type) (DWORD Index, PCHAR Buffer, DWORD Size);

// User External

typedef DWORD (__stdcall *GetUserCount_type) (PCHAR Domain);

typedef DWORD (__stdcall *GetUserList_type) (PCHAR Domain, PCHAR List, DWORD Size);

typedef DWORD (__stdcall *GetUserIndex_type) (PCHAR Domain, PCHAR Alias);

typedef DWORD (__stdcall *LoadUser_type) (PCHAR Domain, DWORD Index, PCHAR Buffer, DWORD Size);

typedef DWORD (__stdcall *SaveUser_type) (PCHAR Domain, DWORD Index, PCHAR Buffer, DWORD Size);

typedef DWORD (__stdcall *AddUser_type) (PCHAR Domain, PCHAR Buffer, DWORD Size);

typedef DWORD (__stdcall *DeleteUser_type) (PCHAR Domain, DWORD Index);
 
typedef DWORD (__stdcall *GetUserSetting_type) (PCHAR Buffer, DWORD Size, DWORD Setting, PCHAR FResult, DWORD ResultSize);

typedef DWORD (__stdcall *SetUserSetting_type) (PCHAR Buffer, DWORD Size, DWORD Setting, PCHAR FResult, DWORD ResultSize);

typedef DWORD (__stdcall *AuthenticateUser_type) (PCHAR Mailbox, PCHAR Password, PCHAR IP, DWORD *DomainIndex, PCHAR FResult, DWORD ResultSize);

typedef DWORD (__stdcall *APIInitUsers_type) (DWORD *Handle, PCHAR Domain);

typedef DWORD (__stdcall *APINextUser_type) (DWORD Handle, PCHAR Buffer, DWORD Size);

typedef void (__stdcall *APIDoneUsers_type) (DWORD Handle);
