<?php
require_once 'cmtreenode.php';
require_once 'inc/clsparsexml.php';
require_once 'function.php';

/* 
	Menu tree class
  	used to handle all things around menu 
*/
class cMTree
{
	var $Root; //Top of the tree
	var $Imode;
	var $CurrentPath;
	
	/* 	
		Method : cMTree
	   	DEscription: constructor for this class
	*/
	function cMTree($mode = 'basic')
	{
		$this->Root = new cMTreeNode(NULL,'ROOT',$mode);
		$this->Imode = $mode;
		$this->MTLoad();
	}
	/* 	
		Method : MTAddNode()
	   	DEscription: Adds a new node to $node and saves its $val
	*/
	function MTAddNode(&$node,$val,$key)
	{
		$node->Childs[$key] = new cMTreeNode($val,$key);
    $node->Childs[$key]->Location = $node->Location.$node->mtnId;
	}
	/* 	
		Method : MTLoad
	   	DEscription: Loads a tree from file
	*/
	function MTLoad()
	{
		$parser = new ParseXML();
		//Load XML depending on interface mode
		$file = 'xml/interface/'.$this->Imode.'.xml';
		
		if (!file_exists($file)){
				$file = 'xml/interface/basic.xml';
				$this->Imode = 'basic';
		}
		if ($_SESSION["ACCOUNT"] == 'DOMAINADMIN'){
		 	$file = 'xml/interface/domainadmin.xml';
			$this->Imode = 'domainadmin';
		}

		$_SESSION['imode'] = $this->Imode;
		$MXML = @$parser->GetXMLTree($file);
		if ($MXML['MENU'][0]['PARAM'])
		foreach ($MXML['MENU'][0]['PARAM'] as $Mkey => $Mval){
      $this->MTAddNode($this->Root,$Mval,$Mval['ATTRIBUTES']['ID']);
			$this->MTHandleXMLNode($this->Root->Childs[$Mval['ATTRIBUTES']['ID']],$Mval);

    }
	}
	/* 	
		Method : MTPrint
	   	DEscription: Prints the menu
	*/
	function MTPrint($id,&$idval)
	{
		$mtNodeCount = 0;
		foreach($this->Root->Childs as $node_key => $node_val){
			$node_val->MTNPrint($node_val->mtnID,@$node_val->pData["FOLDER"],$mtNodeCount,$inarray);			
			if ($node_val->pData['ID']==$id) $idval = 'sLI'.$inarray[$mtNodeCount]['root'];
		}
		$_ret =$inarray;
		return $_ret;
	}

	/* 	
		Method : MTHasndleXML node
	   	DEscription: Construct the tree from XML,recursive - steps through all 
		              child nodes
	*/
	function MTHandleXMLNode(&$node,$xml)
	{
		if (isset($xml['PARAM'][0]))
			foreach($xml['PARAM'] as $node_key => $node_val){
				if ($node_val["ATTRIBUTES"]["ID"]=='SPAMQUEUE' && $_SESSION['ACCOUNT']=='DOMAINADMIN' && !isuserright("Q")) continue;

        $this->MTAddNode($node,$node_val,$node_val['ATTRIBUTES']['ID']);
				$this->MTHandleXMLNode($node->Childs[$node_val['ATTRIBUTES']['ID']],$node_val);			
			}
	}
	/* 	
		Method : MTGetNode
	   	DEscription: Finds the node with specified $nodeid.Search begin on $rootnode. 
	*/
	function MTGetNode($nodeid,$rootnode)
	{
		foreach ($rootnode->Childs as $key => $val){
			if ($val->pData['ID'] == $nodeid) {
				$ret = $val;
				$this->CurrentPath=$nodeid.$this->CurrentPath;
				break;
			}
			if (isset($val->Childs))
				 $ret = $this->MTGetNode($nodeid,$val);
				 if (@$ret) {
          break;
        }
		}
		if (@$ret && $rootnode->pData['ID']!="") $this->CurrentPath=$rootnode->pData['ID'].'/'.$this->CurrentPath; 
    return @$ret;
	}
	/* 	
		Method : MTPrintMenu
	   	DEscription: 
	*/
	function MTPrintMenu($node)
	{
		global $alang,$skin_dir;
		$ret='';
    if (isset($node->Childs))
		foreach ($node->Childs as $key => $val)
			{	
				if (@$val->pData["DISABLE"]!=$_SESSION["ACCOUNT"]){
					if ($val->pData['FILE']=='mainframe.html') $href='mainframe.html?treenode='.$val->pData['ID'];
					else $href='mainframe.html?file='.$val->pData['FILE'];
					if ($val->pData['ID']=='DOMAINS') $href.='&dac=1';
					$ret.='<div class="odkaz"><a onclick="setLastNode(\''.$this->CurrentPath.'/'.$val->pData['ID'].'\');setInfoValue(\''.$skin_dir.'/images/tree/'.$val->pData['ICON'].'\',\''.$alang[$val->pData['LABEL']].'\');" href="'.$href.'"><center><img src="'.$skin_dir.'/images/tree/'.$val->pData['ICON'].'" /><div>'.$alang[$val->pData['LABEL']].'</div></center></a></div>';
          
        }
			}
		return $ret;
	}
}
?>
