<?
/*
Function gets file name for current log identified by service and date
*/
function getfilename($service,$date)
{
	checksession();
	global $api;
	/*
		Get Logpath dir from API 
	*/
  $api = createobject("api");
  $logdir = 	$api->GetProperty("C_System_Storage_Dir_LogPath");
  
  $serverid = $api->GetProperty("C_PathServiceID");
	/* 
	   Date format correction
	*/
	$date=str_replace('/','',$date); 
	if ($date=='') $date = date("Y/m/d",time());
	/*
	    prefix distribution depending on Service name{log type}
	*/
	$whole = false;
	switch (strtolower($service)){
		case 'smtp':
			$tempfile ="s";
		break;
		case 'av':
			$tempfile ="antivirus/";
		break;
		case 'as':
			$tempfile ="antispam/";
		break;
		case 'sreport':
			$tempfile ="reports/";
		break;
		case 'main':
			$tempfile ="maintenance/";
		break;
		case 'webmail':
			$tempfile ="webmail/";
		break;
		case 'sip':
			$tempfile ="sip/";
		break;
		case 'syncml':
		  $tempfile = "syncml/";
		break;
		case 'syncmlpush':
		  $tempfile = "syncmlpush/";
		break;
		case 'sms':
		  $tempfile = "sms/";
		break;
		case 'caldav':
		  $tempfile = "webdav/";
		break;
		case 'gw':
			$tempfile ="g";
		break;
		case 'control':
			$tempfile ="c";
		break;
		case 'ftp':
			$tempfile ="f";
		break;
		case 'pop3':
			$tempfile ="p";
		break;
		case 'im':
			$tempfile ="i";
		break;
		case 'imap':
			$tempfile ="m";
		break;
		case 'error':
			$tempfile ="e"; 
		break;
		case 'phperror':
		  $tempfile = 'phperror';
		  $whole = true;
		break;
		case 'caldav':
		  $tempfile = "webdav/";
		break;

		//I does not know naming convention for theese log files
		case 'ima':
			$tempfile ="im/";
		break;
		case 'imp':
			$tempfile ="im-presence/";
		break;
		case 'ldap':
		  $logdir = 	$_SESSION['INSTALLPATH'];
			$tempfile = "ldap/var/slapd";
			$whole = true;
		break;
    }	
    
  if($whole)
    return $logdir.$tempfile;
  
	return $logdir.$tempfile.$serverid.$date;
}
/*
Function returns content of the logfile depending on service and date
*/
function getlogs($service,$date,$from,$to,$stripdate)
{
	global $api;
	$skip = false;
	checksession();
	$ret='';
	$i = 0;
	$tempfile = getfilename($service,$date);
	$rotate = $api->GetProperty("C_System_Logging_General_LogRotation");
	if ($rotate!=0) {
	 $end = false;
    while (!$end)
      {
      $index =($i++);
      if ($index<10) $index="0".$index;
      if ($index==0) $index="00";
      $tempf=$tempfile.'-'.$index.".log";
      if (file_exists($tempf)){
  	  $lines = @file($tempf);
  	   if ($lines) foreach ($lines as $v)
          $ret.=processline($v,$from,$to,$stripdate,$service,$skip);
      }else $end = true;
    }
  }else{
    $tempfile.=".log";
  	$lines = @file($tempfile);

  	if ($lines)	foreach ($lines as $v)
        $ret.=processline($v,$from,$to,$stripdate,$service,$skip);
  } 	
	return nl2br(htmlspecialchars($ret));
	
}
function  processline($line,$from,$to,$stripdate,$service,&$skip = false)
{
	
	switch(strtolower($service)){
		case 'syncml':
			if(preg_match("#([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})#i",$line,$regs)){
				$repstr = $regs[1].'-'.$regs[2].'-'.$regs[3].' '.$regs[4].':'.$regs[5].':'.$regs[6];
				$sec = $regs[4]*3600+$regs[5]*60+$regs[6];
			}else{
				if($skip) return;
				else return $line;
			}
		break;
		case 'webmail':
			if(preg_match('#(REQUEST|RESPONSE).([0-9]{2}):([0-9]{2}):([0-9]{2})\.([0-9]{0,})#i',$line,$regs)){
				$repstr = $regs[2].':'.$regs[3].':'.$regs[4].'.'.$regs[5];
				$sec = $regs[2]*3600+$regs[3]*60+$regs[4];
			}
		break;
		default:
			if(preg_match('#^([a-zA-Z]{0,})(.*)\[([a-zA-Z0-9]{0,})\] ([0-9]{2}):([0-9]{2}):([0-9]{2}) (.*)#i',$line,$regs)){
				//Default logs
				$repstr = $regs[1].$regs[2].'['.$regs[3].'] '.$regs[4].':'.$regs[5].':'.$regs[6];
				$sec = $regs[4]*3600+$regs[5]*60+$regs[6];
			}
		break;
	}

  		//Strip date
      if ($stripdate) $line = str_replace($repstr,"",$line);
  		//From to time 
  		$from_arr = explode(":",$from);
      $to_arr = explode(":",$to);
      $from = $from_arr[0]*3600+$from_arr[1]*60;
      $to = $to_arr[0]*3600+$to_arr[1]*60;

  		if (($sec<=$to) && ($sec>=$from)){
  		  $ret.= iconv('','UTF-8',$line);
  			$skip = false;
			}else{
				$skip = true;
			}
  		return $ret;
}
?>
