<?PHP
	require_once( "api.php" );
	require_once( "domain.php" );
	require_once( "account.php" );
 	require_once( 'clsparsexml.php' );
 	require_once( 'presentation.php' );
	require_once( "class.phpmailer.php" );
 	require_once( 'mailparse.php' );
 	require_once ('system.php');
	
	$api = new MerakAPI;
	$mailpath  = $api->GetProperty( "C_System_Storage_Dir_MailPath" );
	
	if ( isset( $debug ) )
	{
		echo "Debug mode ON<br>";
		if ( !$debug ) $debug = 1;
	}
	else 	$debug = 0;
  function unix2calendardate($stamp)
  {
    $jd = getdate($stamp);

    $on = GregorianToJD($jd["mon"], $jd["mday"], $jd["year"]);

    return $on;
  }
  function unix2calendartime($stamp)
  {
    $jd = getdate($stamp);

    $at = ($jd["hours"] * 60 + $jd["minutes"])*60 + $jd["seconds"];
    return $at;
  }
  function calendar2unix($date,$time)
  {
    global $api;
    $timezone = $api->GetProperty("C_TimeZone");

		$timechange = (date("O")!=0)?($timezone):0;
    $stamp = jdtounix($date) + $time - $timechange;
    return $stamp;
  }

  function getserverpath()
  {
    $result=get_cfg_var('icewarp_server_path');
    if(!$result){
      $result=dirname($_SERVER['SCRIPT_FILENAME']);
      $result=substr($result,0,strrpos($result,'html'));
    }
    return $result;
  }	
  
  function parseinifile($filename){
    $lines = file($filename);
    foreach($lines as $line){
      $data = explode("=",$line,2);
      $aResult[$data[0]] = trim($data[1]);
    }
    return $aResult;    
  }
	/* ---------------------------------------------------------------------------------------
	 Concatenates two paths (or a path with a filename) to a single one and adds a slash 
	 	if necessary.
		 --------------------------------------------------------------------------------------- */
	function ConcatPath( $path, $file )
	{
		$count = 0;
		
		if ( strlen($path) && ($path[strlen($path)-1] == '\\' || $path[strlen($path)-1] == '/') ) 
			$count++;
		if ( strlen($file) && ($file[0] == '\\' || $file[0] == '/') ) 
			$count++;
		
		switch ($count) {
			case 0: return $path."/".$file;
			case 1: return $path.$file;
			case 2: return $path.substr($file,1);
		}
	}


	/* ---------------------------------------------------------------------------------------
	 Takes a 'sender' or 'recipient' string and strips out data outside of <> brackets.
	 If there are not <> brackets, the entire trimmed string is returned.
		 --------------------------------------------------------------------------------------- */
	function GetAddressOnly( $address )
	{
		$indL = strpos( $address, "<" );
		$indR = strpos( $address, ">" );
		if ( $indL === FALSE || $indR === FALSE ) return trim($address);
		return trim(substr($address,$indL+1,$indR-$indL-1));
	}


	/* ---------------------------------------------------------------------------------------
	 Enumerates all server accounts and sends a summary message to all of them
	   thus leting them know about the content of their challenge queue (=quarantine).
		 --------------------------------------------------------------------------------------- */
	function CreateChallengeMsgs( $limit, $language )
	{
		global $api;
		global $mailpath;
		global $debug;

		if ( !isset($limit) || !$limit ) $limit = 100;
		
		// obtain the server address (hostname) from spam.dat file

	  $spampath = $api->GetProperty( "C_SpamPath" );
	  $timezone = $api->GetProperty("c_timezone");
/*	  if(!$spampath) 
      $spampath = ConcatPath($api->GetProperty( "C_InstallPath" ),'spam/');*/
      
	  $spamdat = parseinifile(ConcatPath($spampath,'spam.dat'));


		$link = ConcatPath( $spamdat["SpamChallengeURL"], "challengeaction.html" );
		$logging = $spamdat["SpamReportLogs"];

		$senderenvelope = $spamdat["SpamReportMailSender"];
		$sender = $spamdat["SpamReportMailFrom"];
		//$senderenvelope = strtr( $spamdat["SpamReportMailSender"], "<>", "  " );
		//$sender = strtr( $spamdat["SpamReportMailFrom"], "<>", "  " );
		$GlobFilterMode = $spamdat["SpamQReportsMode"]; // 1 = all items, 0 = new items only
		$QReportsEnabled = $spamdat["SpamQReports"]; 
		$FReportsEnabled = $spamdat["SpamFReports"]; 
		$SMTPport = $api->GetProperty( "C_System_Services_SMTP_Port" );
		$SMTPserver = $api->GetProperty( "C_System_Services_BindIPAddress" );
		$SMTPserver = explode( ";", $SMTPserver );
		$SMTPserver = $SMTPserver[0];
		if ( !$SMTPserver ) $SMTPserver = "127.0.0.1";
		

		ini_set( "sendmail_from", $senderenvelope );
		ini_set( "SMTP", $SMTPserver );
		ini_set( "smtp_port", $SMTPport );
		
		
		
		// parse the language .xml file to $lang variables
		if ( !$language ) $language = "en";
		$langpath = "lang/".securepath($language)."/";
		$xmlparser = &new ParseXML;
		$langxml = $xmlparser->GetXMLTree( $langpath."lang.xml" );

		foreach ( $langxml['CHALLENGE'][0]['LIST'][0]['ITEM'] as $val )
			$lang[$val["ATTRIBUTES"]["ID"]] = $val["ATTRIBUTES"]["VALUE"];

		// process each domain and each user
		$error = 0;
		$account = new MerakAccount();

		$domcount = $api->GetDomainCount();
		for ( $i = 0; $i < $domcount; $i++ )
		{
    		$domainname = $api->GetDomain( $i );
			if ( $debug ) echo "<hr><h2>Processing domain '$domainname'</h2>";

			if ( !$account->FindInitQuery( $domainname, "" ) )
				{ $error = 2; /*echo "Unable to perform Find command<br>";*/ }
		
			while ( $account->FindNext() )
			{
				$email = $account->EmailAddress;
				if ( $debug ) echo "<h3>processing account '$email'</h3>";
				
				// only user accounts will be processed
				if ( $account->GetProperty( "U_Type" ) ) 
				{
					if ( $debug ) echo "account skipped due to unsupported account type<br>";
					continue;
				}
				CheckReportingState($account,$MakeQReport,$MakeFReport,$filtermode);

				if ( $debug && !$MakeQReport ) echo "Quarantine reports disabled for this account.<br>";
				if ( $debug && !$MakeFReport ) echo "Spam folder reports disabled for this account.<br>";
								
        if($MakeQReport || $MakeFReport){
  				//$mailboxpath = $account->GetProperty( "U_MailBoxPath" );
          $mailboxpath = $account->GetProperty( "U_FullMailBoxPath" );
  
          $fname = $mailboxpath;
  				// obtain the 'last report date' so we will report only new items
  			//	@mkdir( $mailpath );
  			//	$fname = ConcatPath( $mailpath, $mailboxpath );
  			//	@mkdir( $fname );
  				$fname = ConcatPath( $fname, "~spam" );
  			//	@mkdir( $fname );
  				$fname2 = $fname . "/spamreport.dat";
  				$fname3 = $fname . "/spamauth.dat";
  				$fname .= "/~quarantine";
  			//	@mkdir( $fname );
  				$fname .= "/quarantine.dat";
  				
  				// obtain the date for quarantine reports
  				if ( @file_exists( $fname ) )
  				{
  					$udate = fileatime( $fname );
						$offset = $timezone;
						$udate += $offset;
						$udate -= date("O")*36;
  					if($debug){
							dmp(date("Y/m/d H:i:s",$udate));
						}
						$date = unix2calendardate($udate);
						$time = unix2calendartime($udate);
					}
  				else $date = $time = 0; // distant past - all items will be listed as new
  				
  				// obtain the date for spam folder reports
  				if ( @file_exists( $fname2 ) )
  				{
  					$udate = fileatime( $fname2 );
  					
						$offset = $timezone;
						$udate += $offset;
						$udate -= date("O")*36;
  					if($debug){
							dmp(date("Y/m/d H:i:s",$udate));
						}
						$date2 = unix2calendardate($udate);
						$time2 = unix2calendartime($udate);

  				}
  				else $date2 = $time2 = 0; // distant past - all items will be listed as new
        }
        
				// set the 'last report date' to current date
				if ( $MakeQReport ) @touch( $fname );
				if ( $MakeFReport ) @touch( $fname2 );
				
				// mode set to "all items"
				if ( $filtermode ) { $date = $time = $date2 = $time2 = 0; }

				// get the basic user's list
				unset( $newlist );

				
				// if the user is spamadmin, he will obtain an extra list for every account he manages
				if ( $account->GetProperty( "U_SpamAdmin" ) )
				{
					if ( $debug ) echo "user is a spam administrator for following mailboxes:<br>";

					// parse the spamadmin.dat file
					//$fname = ConcatPath( $mailpath, $account->GetProperty( "U_MailBoxPath" ) );
					$fname = $account->GetProperty( "U_FullMailBoxPath" );
					$fname = ConcatPath( $fname, "spamadmin.dat" );
					
					GetSpamAdminLists($newlist,$fname,$MakeQReport,$MakeFReport,$date,$time,$date2,$time2,1000000);

					$spamAdminActive = true;
				}else{
					$spamAdminActive = false;
				}
				
				if ( $MakeQReport ) $newlist = GetQuarantineList( $newlist, $email, $date, $time, $limit );
				if ( $MakeFReport && !$spamAdminActive ){ 
					$newlist = GetSpamList( $newlist, $email, $date2, $time2 );
				}
				// send the message
				if($newlist){
					
					if(!file_exists($fname3)){
						$uid = eregi_replace("e","z",uniqid('',true));
						@file_put_contents($fname3,$uid);
					}else{
						$uid = file_get_contents($fname3);
					}
				
					$res = SendChallengeListToUser( $email, $newlist, $link, $sender, $senderenvelope, $language, $logging, $spamdat, $uid );
				}
				if ( $res ) { $error = 1; echo LangStr2( $lang, 'delivery_problem' ).": '$email'<br>"; }
			}
					
			$account->FindDone();
		}

    	return 0;	
	}
	
	function GetSpamAdminLists(&$newlist,$fname,$MakeQReport,$MakeFReport,$date,$time,$date2,$time2,$limit,$minstamp = false,$maxstamp = false)
	{
		if ( @file_exists( $fname ) )
		{
			$SA_acclist = file( $fname );
			if ( count( $SA_acclist ) )
			foreach ( $SA_acclist as $val ) {

				if ( $MakeQReport ) $newlist = GetQuarantineList( $newlist, trim($val), $date, $time, 1000000,$minstamp ,$maxstamp );

				if ( $MakeFReport ) {
					if ( strpos( $val, "@" ) === FALSE ) { // it's probably a domain -> process each its account
						//TODO: maybe a group can also appear in this list
						$adminsDomain = new MerakDomain();
						if ( $adminsDomain->Open( $val ) < 0 ) {
							echo "Could not open domain '$val'<br>"; 
							continue;
						}
						
						$domAcc = new MerakAccount();
						if ( $domAcc->FindInitQuery(trim($val), "") )
  						{
      						while ( $domAcc->FindNext() ) {
      							
        						if ( $domAcc->GetProperty( "U_Type" ) == 0 ){ 
											$newlist = GetSpamList( $newlist, $domAcc->EmailAddress, $date2, $time2, $minstamp, $maxstamp );
										}
									}
      						$domAcc->FindDone();
							}
					}
					else { // it's just a user account - process it the common way
					
						$newlist = GetSpamList( $newlist, $val, $date2, $time2, $minstamp, $maxstamp );
					}
				}
			}
		}
	}
	
	
	
	
	/* ---------------------------------------------------------------------------------------
	 Finds up to 'limit' quarantined items stored in CR database for specified account or domain.
	 All the items are added as a single compound object into specified array 'list'.
	 Date parameter must contain the last date (in JD format) when the checkout was performed.
	   Only newer (or the same date) items will be listed.
	 Time parameter is a count of seconds from the day start and is used to more precise time
	   calculation in the difference listing.
		 --------------------------------------------------------------------------------------- */
	function GetQuarantineList( $list, $account, $date, $time, $limit ,$fromstamp = false,$tostamp = false)
	{
		global $api;
		global $debug;
		
		$account = trim(strtolower($account));

		// first we have to decide whether the $account property specifies a single account or
		//   whole domain (for spamadmins a whole domain can be listed, which needs different query)
		$isdomain = strpos( $account, "@" ) === FALSE;
		$column = $isdomain ? "SndDomain" : "SndOwner ";

 		//Get list  interval(from -> to)
    if($fromstamp){
          $query = " WHERE $column = '$account'";
          
          $fromCreatedOn = unix2calendardate($fromstamp);
          $fromCreatedAt = unix2calendartime($fromstamp);

          $toCreatedOn = unix2calendardate($tostamp);
          $toCreatedAt = unix2calendartime($tostamp);
          
          $query .= " AND ((( SndCreatedOn = $fromCreatedOn AND SndCreatedAt >= $fromCreatedAt) OR sndCreatedOn > $fromCreatedOn) AND ( ( sndCreatedOn=$toCreatedOn AND sndCreatedAt <= $toCreatedAt ) OR sndCreatedOn< $toCreatedOn) )";
		
    //Get list (from -> all)
    } else {
      // obtain the Quarantine list, but process only pending items that belong to our user / domain
      $query  = " WHERE SndAuthorized = '2' AND $column = '$account'";
      $query .= " AND ( SndCreatedOn > $date OR ( SndCreatedOn = $date AND SndCreatedAt >= $time ) )"; 
		
    }
    $query .= " ORDER BY SndCreatedOn DESC, SndCreatedAt DESC"; 

		$list_flat = $api->QuarantineList( "", $query, $limit );
		if ( $debug ) { echo "<pre>$account (quarantine): "; print_r($list_flat); echo"</pre>"; }
		// search the existing list for this account - if there is a record for this account, it is extended
		//  instead of creating a new one; otherwise a new one is added at the end of the list
		$ind = count( $list );
		$accIndex = 0;
		if ( $ind ) 
		foreach ( $list as $listitem ) {
			if ( $listitem["account"] == $account ) {
				$ind = $accIndex;
				break;
			}
			$accIndex++;
		}
		
		// parse the result; the returned string is in following format:
		//   [SENDER;DATE;FOLDERNAME;STATUS;RECIPIENT;TIME;SENDERDOMAIN;SUBJECT;newline]*
		//  where DATE is in Julian format and TIME contains count of seconds from the midnight
		$array = explode( "\n", trim($list_flat) );

		// process each DB entry
		if ( count( $array ) )
		foreach ( $array as $subarray )
		{
			$line = explode( ";", $subarray );
			if ( count( $line ) < 8 ) continue; // ignore incomplete items
		
			$newItem = array();
			$newItem["sender"] = trim( $line[0] );
			$newItem["date"] = trim( $line[1] );
			$newItem["folder"] = trim( $line[2] );
			$newItem["status"] = trim( $line[3] );
			$newItem["recipient"] = trim( $line[4] );
			$newItem["time"] = trim( $line[5] );
			$newItem["domain"] = trim( $line[6] );
			$newItem["subject"] = trim( $line[7] ); 
			$newItem["defined"] = 1;
			$newItem["type"] = 1;

			$list[$ind]["items"][] = $newItem;
			$list[$ind]["itemscount"] = $list[$ind]["itemscount"] + 1;
		}
		
		// add special tags but to properly defined items only
		if ( count($array) >= 1 )
		{
			$list[$ind]["isdomain"] = $isdomain;
			$list[$ind]["account"] = $account;
		}
		
		//if ( $debug ) { echo "<pre>"; print_r($list); echo"</pre>"; }


		return $list;
	}




	/* ---------------------------------------------------------------------------------------
	 Searches user's spam folder for all (spam) messages. All the items are added as a single 
	   compound object into specified array 'list'.
	 Date parameter must contain the last date (in JD format) when the checkout was performed.
	   Only newer (or the same date) items will be listed.
	 Time parameter is a count of seconds from the day start and is used to more precise time
	   calculation in the difference listing.
		 --------------------------------------------------------------------------------------- */
	function GetSpamList( $list, $account, $date, $time ,$fromstamp = false,$tostamp = false)
	{
		global $api;
		global $debug;
		global $mailpath;

		$account = trim(strtolower($account));
		$timezone = $api->GetProperty("C_TimeZone");

		// obtain the account API object and some needed properties
		$accobj = new MerakAccount();
		if ( $accobj->Open( $account ) < 0 ) return $list;
		//$mailboxpath = $accobj->GetProperty( "U_MailBoxPath" );
		$imapacc = $accobj->GetProperty( "U_AccountType" ) == 0 ? 0 : 1;
		$extension = $imapacc ? ".imap" : ".tmp";

		// compose the mailbox path
		//$fname = ConcatPath( $mailpath, $mailboxpath );
		$fname = $accobj->GetProperty( "U_FullMailBoxPath" );
    $fname = ConcatPath( $fname, "~spam" );

		if ( ($dirlist = @scandir($fname)) === FALSE ) return $list; // no item added if the spam folder doesn't exist

		// search the existing list for this account - if there is a record for this account, it is extended
		//  instead of creating a new one; otherwise a new one is added at the end of the list
		$ind = count( $list );
		$accIndex = 0;
		if ( $ind )
		foreach ( $list as $listitem ) {
			if ( $listitem["account"] == $account ) {
				$ind = $accIndex;
				break;
			}
			$accIndex++;
		}

		if ( $debug ) echo "<pre>$account (spam folder): ";
		// walk thru the directory	
		$defined = 0;

		if ( count( $dirlist ) )
		foreach ( $dirlist as $fileitem ) {

			if ( $fileitem == "." || $fileitem == ".." ) continue;
			if ( strpos( $fileitem, $extension ) === FALSE ) continue;

			$msgpath = ConcatPath( $fname, $fileitem );
			@$message = file_get_contents( $msgpath );
			@$message = substr($message,0,strpos($message,"\r\n\r\n"));
			
			try{
				$parser = new MailParse( false,false,false,false,'1',$message );
				$messageParts = $parser->parse();
			}catch(Exc $e){
				$messageParts = array();
			}
			$offset = 0;
			// parse the date & time
			$unixDateTime = filemtime( $msgpath ); // beware! time 1175722511 results in wrong computation; I don't know why!
			//echo "$unixDateTime";
			$offset += $timezone;
			$offset -= date( "O" ) * 36;
			$unixDateTime += $offset;
			
			$msgDate = unix2calendardate($unixDateTime);
			$msgTime = unix2calendartime($unixDateTime);
			
			/*$msgDate = intval( unixtojd( $unixDateTime ) );
			$msgTime = $unixDateTime - jdtounix( $msgDate );*/

			if(isset($fromstamp) && $fromstamp!==false){
        $date = unix2calendardate($fromstamp);
        $time = unix2calendartime($fromstamp);
        
        $todate = unix2calendardate($tostamp);
        $totime = unix2calendartime($tostamp);
        
      }

			if($debug){
				dmp("Message time:".date("Y/m/d H:i:s",$unixDateTime)."<br/>");
				dmp("Min time:".date("Y/m/d H:i:s",$fromstamp)."<br/>");
				dmp("Max time:".date("Y/m/d H:i:s",$tostamp)."<br/>");
				dmp("=====<br/>");
			}
			
			
			//echo "Date: $date, Time: $time, MsgDate: $msgDate, MsgTime: $msgTime<br>";
			if ( $msgDate < $date || $msgDate == $date && $msgTime < $time ) continue;
				
			if($fromstamp && ( $msgDate > $todate || $msgDate == $todate && $msgTime > $totime )) continue;
		
			$newItem = array();
			$newItem["sender"] = GetAddressOnly( $messageParts["headers"]["from"] );
			$newItem["date"] = $msgDate;
			$newItem["folder"] = $fileitem;
			$newItem["status"] = 2;
			$newItem["recipient"] = $account;//GetAddressOnly( $messageParts["headers"]["to"] );
			$newItem["time"] = $msgTime;
			$newItem["domain"] = "";
			$newItem["subject"] = $messageParts["headers"]["subject"];
			$newItem["defined"] = 1;
			$newItem["type"] = 2;
			
			if ( $debug ) {
				echo $newItem["sender"].";".$newItem["date"].";".$newItem["folder"].";".$newItem["status"].";".
					$newItem["recipient"].";".$newItem["time"].";".$newItem["domain"].";".$newItem["subject"]."\n";		
			}

			$list[$ind]["items"][] = $newItem;
			$list[$ind]["itemscount"] = $list[$ind]["itemscount"] + 1;
			$defined = 1;
		}
		if ( $debug ) echo "</pre>";
		
		if ( $debug >= 2 ) { echo "<pre>Directory listing:"; print_r($dirlist); echo"</pre>"; }

		// add special tags but to properly defined items only
		if ( $defined ) {
			$list[$ind]["isdomain"] = 0;
			$list[$ind]["account"] = $account;
		}

		return $list;
	}




	/* ---------------------------------------------------------------------------------------
		This function adds leading zeros to a number which has lesser count of digits than 
			specified count.
	   --------------------------------------------------------------------------------------- */
	function ExtendByZeros( $number, $count )
	{
		$len = $count - strlen( $number ); 
		for ( $i = $len; $i > 0; $i-- ) $number = "0" . $number;
		
		return $number;
	}
	
	
	
	/* ---------------------------------------------------------------------------------------
		SortCompare function takes two list items and compares them on the base of their date
			and time. This is used as a comparison function when sorting messages/spam records.
	   --------------------------------------------------------------------------------------- */
	function SortCompare( $item1, $item2 )
	{
		if ( !isset($item1["date"]) || $item1["date"] == 0 ) return 1;
		if ( !isset($item1["time"]) ) return 1;
		if ( !isset($item2["date"]) || $item2["date"] == 0 ) return -1;
		if ( !isset($item2["time"]) ) return -1;
		if ( $item1["date"] > $item2["date"] ) return -1;
		if ( $item1["date"] < $item2["date"] ) return 1;
		if ( $item1["time"] > $item2["time"] ) return -1;
		if ( $item1["time"] < $item2["time"] ) return 1;
		
		return 0;
	}
	
	
	
	/* ---------------------------------------------------------------------------------------
		 Followind function generates and sends an HTML formatted message containning a table
			where each line represents one challenge queue (=quarantine) item and several
		  action hyperlinks offering a control over the item
		 Use link parameter to define URL target for all the action hyperlinks.
		 Use language parameter to specify chosen language that will be used for the message.
		 Sender parameter can be used to specify the message sender.
		 If logging parameter is set, then a log entry is created on successful report.
		 
	   --------------------------------------------------------------------------------------- */
	function SendChallengeListToUser( $account, $list, $link, $sender, $senderenvelope, $language, $logging, $spamdat, $uid )
	{
	
	  
    global $debug;    
		global $api;

		if ( !$list ) return 0;  

		if ( $debug >= 2 ) { echo "<pre>"; print_r($list); echo"</pre>"; }

		// process the input list of quarantine items
		$SFcount = $Qcount = 0;
		$bl_ind = 0;
		$anyReport = 0;


		if ( count( $list ) )
		foreach ( $list as $block )
		{
			if ( !count($block) ) continue;
			$ind = 0;
			
						
			//if ( !$val["defined"] ) break; // ignore incomplete items
			// this is necessary here to properly check domain atribute - i really do NOT code in PHP, don't understand the strange array processing
			if ( $block[isdomain] )$skindata["blocks"]["num"][$bl_ind]["isdomain"] = 1;
			$skindata["blocks"]["num"][$bl_ind]["account"] = $block[account]; 

			if ( count( $block[items] ) ) {
				// sort messages by date and time in descending order
				usort( $block[items], "SortCompare" );
		    
		    $skindata["blocks"]["num"][$bl_ind]["maxstamp"] = 0;
		    $skindata["blocks"]["num"][$bl_ind]["minstamp"] = 10000000000000;
		    
				foreach ( $block[items] as $val ) 
				{

          $stamp = calendar2unix($val["date"],$val["time"]);
          
          if($stamp > $skindata["blocks"]["num"][$bl_ind]["maxstamp"]) 
            $skindata["blocks"]["num"][$bl_ind]["maxstamp"] = $stamp;
          
          if($stamp < $skindata["blocks"]["num"][$bl_ind]["minstamp"]) 
            $skindata["blocks"]["num"][$bl_ind]["minstamp"] = $stamp;
				    
				  $skindata["blocks"]["num"][$bl_ind]["receipient"] = $val["recipient"];
				    
				//	$skindata["blocks"]["num"][$bl_ind]["allids"] .= $val["folder"] . ";";
				//	$skindata["blocks"]["num"][$bl_ind]["alltos"] .= $val["recipient"] . ";";
				//	$skindata["blocks"]["num"][$bl_ind]["allfroms"] .= $val["sender"] . ";";
					if ( $val["type"] == 2 ) {
						$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["spamfolder"] = 1;
						$SFcount++;
					}
					else $Qcount++;
					$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["from"] = strval($val["sender"]);
					$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["fromshort"] = strval(substr( $val["sender"], -50 ));
					$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["to"] = strval($val["recipient"]);
					$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["subject"] = strval($val["subject"]);
					$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["subjectshort"] = strval(substr( $val["subject"], 0, 50 ));
					$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["id"] = $val["folder"];
					$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["date"] = jdtogregorian( $val["date"] );
					$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["time"] = $val["time"];
					$prehour = intval( $val["time"] / 3600 ) % 12;
					if ( !$prehour ) $prehour = 12;
					$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["hours"] = ExtendByZeros( $prehour, 2 );
					if ( intval( $val["time"] / 3600 ) < 12 ) 
						$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["am"] = "am";
					else 
						$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["am"] = "pm";
					$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["minutes"] = 
						ExtendByZeros( intval( ( $val["time"] - intval($val["time"] / 3600) * 3600 ) / 60 ), 2 );
					$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["seconds"] = intval( $val["time"] % 60 );
					$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["domain"] = $val["domain"];
					$skindata["blocks"]["num"][$bl_ind]["items"]["num"][$ind]["status"] = $val["status"];
					$ind++;
					$anyReport = 1;
				}
			}
			if ( !$ind ) continue; // there are no items to bother with
			$bl_ind++;
		}
		if ( !$anyReport ) {
			if ( $debug ) echo "No item to report. Account skipped.<br>";
			return 0;
		}

		if ( $debug >= 2 ) { echo "<pre>";print_r($skindata);echo"</pre>"; }
		
		// parse the language .xml file to $lang variables
		if ( !$language ) $language = "en";
		$langpath = "lang/".securepath($language)."/";
		$xmlparser = &new ParseXML;
		$langxml = $xmlparser->GetXMLTree( $langpath."lang.xml" );

		foreach ( $langxml['CHALLENGE'][0]['LIST'][0]['ITEM'] as $val )
			$lang[$val["ATTRIBUTES"]["ID"]] = $val["ATTRIBUTES"]["VALUE"];

		$skindata["title"] = LangStr2( $lang, 'title' );
		$skindata["intro"] = LangStr2( $lang, 'intro' );
		$skindata["outro"] = LangStr2( $lang, 'outro' );
		$skindata["sender"] = LangStr2( $lang, 'sender' );
		$skindata["subject"] = LangStr2( $lang, 'subject' );
		$skindata["recipient"] = LangStr2( $lang, 'recipient' );
		$skindata["date"] = LangStr2( $lang, 'date' );
		$skindata["time"] = LangStr2( $lang, 'time' );
		$skindata["actions"] = LangStr2( $lang, 'actions' );
		$skindata["delete"] = LangStr2( $lang, 'delete' );
		$skindata["authorize"] = LangStr2( $lang, 'authorize' );
		$skindata["accept"] = LangStr2( $lang, 'accept' );
		$skindata["blacklist"] = LangStr2( $lang, 'blacklist' );
		$skindata["view"] = LangStr2( $lang, 'view' );
		$skindata["deleteall"] = LangStr2( $lang, 'deleteall' );
		$skindata["authorizeall"] = LangStr2( $lang, 'authorizeall' );
		$skindata["acceptall"] = LangStr2( $lang, 'acceptall' );
		$skindata["blacklistall"] = LangStr2( $lang, 'blacklistall' );
		$skindata["deliveruntouched"] = LangStr2( $lang, 'deliveruntouched' );
		$skindata["blacklistuntouched"] = LangStr2( $lang, 'blacklistuntouched' );
		$skindata["domain"] = LangStr2( $lang, 'domain' );
		$skindata["account"] = LangStr2( $lang, 'account' );
		$skindata["location"] = LangStr2( $lang, 'location' );
		$skindata["submit"] = LangStr2( $lang, 'submit' );
		$skindata["type_quarantine"] = LangStr2( $lang, 'type_quarantine' );
		$skindata["type_spam"] = LangStr2( $lang, 'type_spam' );
		$skindata["uid"] = $uid;
		$skindata['owner'] = $account;
		
		$RecDomain = explode( "@", $account );
		$RecDomain = $RecDomain[1];
		$link = str_ireplace( "%%recipient_domain%%", $RecDomain, $link );
		$sender = str_ireplace( "%%recipient_domain%%", $RecDomain, $sender );
		$senderenvelope = str_ireplace( "%%recipient_domain%%", $RecDomain, $senderenvelope );

		$skindata["URL"] = $link;
		$skindata["language"] = $language;

			
		// determine the mail server address
		$mailServer = "127.0.0.1";
		$port = $api->GetProperty( "C_System_Services_SMTP_Port" );
		$globServer = $api->GetProperty( "C_System_Services_BindIPAddress" );
		if ( $globServer != "" ) $mailServer = $globServer;
		$fname = ConcatPath( $api->GetProperty( "C_ConfigPath" ), "servicebind.dat" );
		if ( @file_exists( $fname ) ) {
			$binding = @file_get_contents( $fname );
			$binds = explode( "\n", trim($binding) );
			if ( count($binds) ) {
				foreach ( $binds as $val ) {
					$items = explode( ";", $val );
					if ( $items[0] == "SMTP" ) {
						echo $items[1];
						if ( $items[1] != "" ) $mailServer = $items[1];
						if ( $items[2] != "" ) $port = $items[2];						
						break;
					}
				}    
			}
		}


		// compose the message
		$message = template( "skins/default/list.tpl", $skindata );

		$mail = new phpmailer();

		$mail->From     = $sender;
		$mail->FromName = '';
		$aReplyTo  = reset(Mailparse::parseAddresses($senderenvelope));
		
		$mail->Sender = $aReplyTo['address'];
		
		$mail->charSet = "UTF-8";
		$mail->Host     = $mailServer; 
		$mail->Port		= $port;
		$mail->Mailer   = "smtp";
		$mail->ContentType = "text/html";
		//$mail->Sender = $senderenvelope;
		if(!$mail->Subject){
			$mail->Subject = $lang["msgsubject"];
		}

		$mail->Body    = $message;
		$mail->AddAddress( $account );
		
		try {
    		if( !$mail->Send(false,false,'UTF-8') ) throw new Exception( "Unable to send spam report." );

    		// log the result if logging allowed
    		if ( $logging ) {
	    		$fname = $api->GetProperty( "C_System_Storage_Dir_LogPath" );
				@mkdir( $fname );
				$fname = ConcatPath( $fname, "reports" );
				@mkdir( $fname );
				$fname = $fname . "/" . date( "Ymd" ) . ".log";
				
				if ( @file_exists( $fname ) ) $exist = 1;
				else $exist = 0;
				
				if ( $file = @fopen($fname,"a+") ) {
					
          //Removed first line of theg
          if ( !$exist ) fprintf( $file, "Time\t\tQuarantine items\tSpam folder items\tSpam admin\tRecipient\n" );
          
					$APIAcc = new MerakAccount();
					$APIAcc->Open( $account );
					if ( $APIAcc->GetProperty( "U_SpamAdmin" ) ) $sadmin = "1";
					else $sadmin = "0";
					$time = date( "H:i:s" );

          fprintf( $file, "%s\t%s\t\t\t%s\t\t\t%s\t\t%s\n", $time, $Qcount, $SFcount, strval($sadmin), strval($account) );
					fclose( $file );
				}
			}
		} catch ( Exception $e ) {
    		return 1;
		}

		return 0;
	}
	


	/* ---------------------------------------------------------------------------------------
		ObtainUsedCharset function takes a message as a parameter and finds a 'Content-type' 
		header in it. If it is present, this returns the charset value stored in the header.
		If it is not present, this function returns "utf-8".
		 --------------------------------------------------------------------------------------- */
	function ObtainUsedCharset( $msg )
	{                  
		$lines = explode( "\n", $msg );
		if ( count($lines) )
		{
			
			foreach ( $lines as $line ) {
				$parts = explode( ":", $line );
				if ( count($parts) < 2 ) continue;
				$parts[0] = strtolower( trim($parts[0]) );
				$parts[1] = strtolower( trim($parts[1]) );
				if ( $parts[0] != "content-type" ) continue;
				$result = explode( "charset=", $parts[1] );
				if ( count( $result ) < 2 ) continue;
				return  str_replace( array('"',"'"," ","\n","\r","\t"," "), "", $result[1] );
      }
		}
		return "utf-8";
	}



	/* ---------------------------------------------------------------------------------------
		PerformChallengeAction function performs specified function upon chosen item.
	  	The item is identified by its unique ID (which is identical to folder name) and the 
	  	recipient's address. The action is specified as a single value from predefined set:
	     1: Authorize sender
	     2: Deliver message
	     3: Delete message
	     4: Black list sender
	     5: Show message
	     6: Deliver if SndAuthorized == 2 (silent delivery)
	     7: Black list if SndAuthorized == 2 (silent blacklist)
	  	Language can be also specified which will be used when printing the result.
	  	
	  	Returns zero if the action was conditioned and wasn't performed due to the condition result.
	  	Returns 1 if the action was properly performed.
	  	Returns -1 if the action could not be performed for some reason.
	 --------------------------------------------------------------------------------------- */
	function PerformChallengeAction( $id, $recipient, $action, $language)
	{
		global $api;

		// parse the language .xml file to $lang variables
		if ( !$language ) $language = "en";
		$langpath = "lang/".securepath($language)."/";
		$xmlparser = &new ParseXML;
		$langxml = $xmlparser->GetXMLTree( $langpath."lang.xml" );

		foreach ( $langxml['CHALLENGE'][0]['QACTIONS'][0] as $key => $val )
		{
			if ( $key == 'VALUE' ) continue;

			foreach ( $val[0]['ITEM'] as $value )
				$lang[$key][$value["ATTRIBUTES"]["ID"]] = $value["ATTRIBUTES"]["VALUE"];
		}
		
		
		// preinit output data
		$skindata["sender"] = " ";
		$skindata["title"] = LangStr2( $lang["FAIL"], "title" );
		$skindata["failure"] = LangStr2( $lang["FAIL"], "wrongid" );
		
		// check whether the ID is valid
		if ( !$id ) { 
			$skindata["error_happened"] = 1;
			echo template( "skins/default/actiononly.tpl", $skindata );
			return -1;
		}


 		// check whether the specified entry exists
		$list = $api->QuarantineList( "", " WHERE SndFolder = '$id' AND SndOwner = '$recipient'", 1 );
		$array = explode( ";", $list );
		if ( $action > 5 ) { // action on untouched items only - ignore errors
			if ( $array[3] != 2 ) return 0; // success, but no action
		}
		if ( strchr($list,";") == FALSE ) {
			$skindata["error_happened"] = 1;
			echo template( "skins/default/actiononly.tpl", $skindata );
			return -1;
		}
		

		// choose texts accordingly to the action which is being performed (index variable)
		//   and perform the action
		switch ( $action )
		{
			case 1: $index = "AUTHORIZE";
					/*$list = $api->QuarantineList( "", " WHERE SndAuthorized = '2' AND SndOwner = '$recipient'", 1 );
					if ( !$api->QuarantineSet( $recipient, $array[0], 1 ) ) $skindata["error_happened"] = 1; 
					*/
					
					if ( !$api->QuarantineAuthorize( $id ) ) $skindata["error_happened"] = 1;
					break;

			case 2: 
			case 6: $index = "DELIVER"; // DELIVER = AUTHORIZE + DELETE
					$list = $api->QuarantineList( "", " WHERE SndAuthorized = '2' AND SndOwner = '$recipient'", 1 );
					if ( !$api->QuarantineAuthorize( $id ) ) $skindata["error_happened"] = 1;
					if ( !$api->QuarantineDelete( $recipient, $array[0], $id ) ) $skindata["error_happened"] = 1;
					break;

			case 3: $index = "DELETE";
					$list = $api->QuarantineList( "", " WHERE SndAuthorized = '2' AND SndOwner = '$recipient'", 1 );
					if ( !$api->QuarantineDelete( $recipient, $array[0], $id ) ) $skindata["error_happened"] = 1; 
					break;

			case 4: 
			case 7: $index = "BLACKLIST";
					$list = $api->QuarantineList( "", " WHERE SndAuthorized = '2' AND SndOwner = '$recipient'", 1 );
					if ( !$api->QuarantineSet( $recipient, $array[0], 0 ) ) $skindata["error_happened"] = 1; 
					break;

			case 5: $index = "VIEW";
					$msgText = GetPlainMessage( $recipient, $id ); 
					$charset = strtoupper( ObtainUsedCharset( $msgText ) );
					if (strpos($charset,";")!==false)
            $charset = substr($charset,0,strpos($charset,";"));
					$skindata["message"] = htmlspecialchars(iconv( $charset, "UTF-8", $msgText ));
					if ( $skindata["message"] ) $skindata["view"] = 1;
					else $skindata["message"] = $msgText;
					if ( !$skindata["message"] ) $skindata["error_happened"] = 1;
					break;

			default: $index = "FAIL";
					$skindata["error_happened"] = 1;
					break;
		}
		
		// fill the template data accordingly to chosen action
		$skindata["sender"] = $array[0];
		$skindata["title"] = LangStr2( $lang[$index], "title" );
		$skindata["success"] = LangStr2( $lang[$index], "success" );
		$skindata["failure"] = LangStr2( $lang[$index], "failure" );
		
		// and finally generate the result
		echo template( "skins/default/actiononly.tpl", $skindata );

		if ( $skindata["error_happened"] ) return -1;
		return 1;
	}



	/* ---------------------------------------------------------------------------------------
		PerformSpamAction function performs specified function upon chosen item.
	 	The item is identified by its unique ID (which is identical to base file name) and the 
	  	recipient's address. The action is specified as a single value from predefined set:
	     1: Authorize sender
	     2: Deliver message
	     3: Delete message
	     4: Black list sender
	     5: Show message
	     6: Deliver if exists (silent delivery)
	     7: Black list if file exists (silent blacklist)
	  	Language can be also specified which will be used when printing the result.
	  
	  	Returns zero if the action was conditioned and wasn't performed due to the condition result.
	  	Returns 1 if the action was properly performed.
	  	Returns -1 if the action could not be performed for some reason.
	 --------------------------------------------------------------------------------------- */
	function PerformSpamAction( $id, $recipient, $sender, $action, $language )
	{
		global $api;
		global $mailpath;

		// parse the language .xml file to $lang variables
		if ( !$language ) $language = "en";
		$langpath = "lang/".securepath($language)."/";
		$xmlparser = &new ParseXML;
		$langxml = $xmlparser->GetXMLTree( $langpath."lang.xml" );

		foreach ( $langxml['CHALLENGE'][0]['ACTIONS'][0] as $key => $val )
		{
			if ( $key == 'VALUE' ) continue;

			foreach ( $val[0]['ITEM'] as $value )
				$lang[$key][$value["ATTRIBUTES"]["ID"]] = $value["ATTRIBUTES"]["VALUE"];
		}
		
		
		// obtain the full message file path
		$id = basename( $id );
		// obtain the account API object and some needed properties
		$accobj = new MerakAccount();
		$accobj->Open( $recipient );
		$imapacc = $accobj->GetProperty( "U_AccountType" ) == 0 ? 0 : 1;
		//$mailboxpath = $accobj->GetProperty( "U_MailBoxPath" );

		//$mailboxpath = ConcatPath( $mailpath, $mailboxpath );
		$mailboxpath = $accobj->GetProperty( "U_FullMailBoxPath" );
		$fname = ConcatPath( $mailboxpath, "~spam" );
		$fname .= "/".$id;
		$bwfname = $mailboxpath."filter.dat";
		$inboxPath = $imapacc ? ConcatPath( $mailboxpath, "inbox/" ) : $mailboxpath;
		$newFName = $inboxPath . $id;
		
		// choose texts accordingly to the action which is being performed (index variable)
		//   and perform the action
		if(!isset($sender)){
			if($debug){
				echo "Can't parse sender for item".$id."\r\n";
			}
		}
		switch ( $action )
		{
			case 1: $index = "AUTHORIZE"; // AUTHORIZE = DELIVER + WhiteList sender
					// deliver
					if ( @rename( $fname, $newFName ) === FALSE ) $skindata["error_happened"] = 1;
					// whitelist
				    // update existing or create new record in challenge.mdb
    				$list = $api->QuarantineList( '', " WHERE SndOwner = '".$recipient."' AND SndEmail='".$sender."'", 0 );
					if ( !$list ) $result = $api->QuarantineAdd( $recipient, $sender, 1 );
					else $result = $api->QuarantineSet( $recipient, $sender, 1 );
					if ( !$result ) $skindata["error_happened"] = 1;
					//if ( !($bwfile = @fopen($bwfname,"at")) ) $skindata["error_happened"] = 1;
					//else { fprintf( $bwfile, "1:%s\n", $sender ); fclose( $bwfile ); }
					break;

			case 6: // SILENT DELIVERY
					// if the file does not exist, it was probably already processed and we doesn't care;
					// if it exists - perform standard delivery
					if ( !file_exists( $fname ) ) return 0;
			case 2: $index = "DELIVER"; // DELIVER = move to inbox
					// move the file
					if ( @rename( $fname, $newFName ) === FALSE ) $skindata["error_happened"] = 1;
					break;

			case 3: $index = "DELETE"; // DELETE = delete message
					// delete the file
					if ( @unlink( $fname ) === FALSE ) $skindata["error_happened"] = 1;
					break;

			case 7: // SILENT BLACKLIST
					// if the file does not exist, it was probably already processed and we doesn't care;
					// if it exists - perform standard delivery
					if ( !file_exists( $fname ) ) return 0;
			case 4: $index = "BLACKLIST"; // BLACKLIST = DELETE + BlackList sender
					// delete
					if ( @unlink( $fname ) === FALSE ) $skindata["error_happened"] = 1;
					// blacklist
				    // update existing or create new record in challenge.mdb
    				$list = $api->QuarantineList( '', " WHERE SndOwner = '".$recipient."' AND SndEmail='".$sender."'", 0 );
					if ( !$list ) $result = $api->QuarantineAdd( $recipient, $sender, 0 );
					else $result = $api->QuarantineSet( $recipient, $sender, 0 );
					if ( !$result ) $skindata["error_happened"] = 1;
					//if ( !($bwfile = @fopen($bwfname,"at")) ) $skindata["error_happened"] = 1;
					//else { fprintf( $bwfile, "0:%s\n", $sender ); fclose( $bwfile ); }
					break;

			case 5: $index = "VIEW";

					$msgText = @file_get_contents( $fname );
					$charset = strtoupper( ObtainUsedCharset( $msgText ) );
					if (strpos($charset,";")!==false)
            $charset = substr($charset,0,strpos($charset,";"));
					$skindata["message"] = htmlspecialchars(iconv( $charset, "UTF-8", $msgText ));
					if ( $skindata["message"] ) $skindata["view"] = 1;
					else $skindata["message"] = $msgText;
					if ( !$skindata["message"] ) $skindata["error_happened"] = 1;
					break;

			default: $index = "FAIL";
					$skindata["error_happened"] = 1;
					break;
		}
		
		// fill the template data accordingly to chosen action
		$skindata["sender"] = $sender;
		$skindata["title"] = LangStr2( $lang[$index], "title" );
		$skindata["success"] = LangStr2( $lang[$index], "success" );
		$skindata["failure"] = LangStr2( $lang[$index], "failure" );
		
		// and finally generate the result
		echo template( "skins/default/actiononly.tpl", $skindata );
		
		if ( $skindata["error_happened"] ) return -1;
		return 1;
	}



	/* ---------------------------------------------------------------------------------------
		PerformMultipleChallengeAction function performs specified action upon multiple chosen
		items. These items are identified by their unique IDs (which are identical to folder names)
		and the recipients' addresses. The action is specified as a single value from predefined set:
	     11: Authorize senders
	     12: Deliver messages
	     13: Delete messages
	     14: Black list senders
	     16: Deliver the rest (untouched, i.e. SndAuthorized == 2)
	     17: Black list the rest
	 	Language can be also specified which will be used when printing the result.
	 --------------------------------------------------------------------------------------- */
	function PerformMultipleChallengeAction( $recipient, $minstamp, $maxstamp, $action, $language, $uid, $mode, $owner )
	{	

		if($mode==1){
			$recipient = $owner;
		}
		//Account properties
		$account = new MerakAccount();
		$account->Open($recipient);
		$mailboxPath = $account->getProperty('u_fullmailboxpath');
		
		CheckReportingState($account,$MakeQReport,$MakeFReport,$filtermode);
		
		$date = unix2calendardate($minstamp);
		$time = unix2calendartime($minstamp);
		$date2 = unix2calendardate($maxstamp);
		$time2 = unix2calendartime($maxstamp);
		


		//Spam admin - get all possible recipients
		if($mode == 1){
			GetSpamAdminLists($slist,$mailboxPath.'spamadmin.dat',0,1,$date,$time,$date,$time,1000000,$minstamp,$maxstamp);
			GetSpamAdminLists($qlist,$mailboxPath.'spamadmin.dat',1,0,$date,$time,$date,$time,1000000,$minstamp,$maxstamp);
		}else{
			$qlist = GetQuarantineList($list,$recipient,false,false,0,$minstamp,$maxstamp);
  		$slist = GetSpamList($list,$recipient,false,false,$minstamp,$maxstamp);
		}
		

		global $api;

    if($qlist[0]['items']) foreach($qlist[0]['items'] as $qitem){
      $id_list[] = $qitem['folder'];
      $sender_list[] = $qitem['sender'];
      $rcp_list[] = $qitem['recipient'];
    }
    
    if($slist[0]['items']) foreach($slist[0]['items'] as $sitem){
      $id_list[] = $sitem['folder'];
      $sender_list[] = $sitem['sender'];
      $rcp_list[] = $sitem['recipient'];
    }


		$ind = -1;
		if ( count( $id_list ) ) {
			$processed = 0;
			foreach ( $id_list as $val ) {
				$ind++;
				if ( $val == "" ) continue;
				if ( strpos( $val, "." ) === FALSE ) {
					if ( PerformChallengeAction( $val, $rcp_list[$ind], $action % 10, $language ) )
						$processed++;
				}
				else {
					if ( PerformSpamAction( $val, $rcp_list[$ind], $sender_list[$ind], $action % 10, $language ) )
						$processed++;
				}
			}
			if ( !$processed ) echo "No item found.";
		}
		else echo "No item found.";
		
	}

	function CheckReportingState($account,&$MakeQReport,&$MakeFReport,&$filtermode){
		global $api;
		$spampath = $api->GetProperty( "C_SpamPath" );
		$spamdat = parseinifile(ConcatPath($spampath,'spam.dat'));
		// use global setting by default (which reports are enabled / disabled) ...
		$MakeQReport = $spamdat["SpamQReports"]; 
		$MakeFReport = $spamdat["SpamFReports"]; 
		$filtermode = $spamdat["SpamQReportsMode"];

		//Skip the accounts with disabled spam folder
		$spamMode = $account->GetProperty("U_SpamFolder");
    
    if( $spamMode!=2 ){
      //Default - get from spam.dat
      if($spamMode==0){
          //Disabled spam folder - in spam.dat
          if($spamdat['UseSpamFolder']==0){
            $MakeFReport = 0;
          }
      } else{
        //Disabled spam folder - API
        $MakeFReport = 0;          
		  }
    }	

		// ... but overwrite the global setting if the account has this service turned off, or reports disabled
		if ( !$account->GetProperty( "U_QuarantineSupport" ) ) $MakeQReport = 0;
		if ( !$account->GetProperty( "U_SpamfolderSupport" ) ) $MakeFReport = 0;
		switch ( $account->GetProperty( "U_QuarantineReports" ) ) {
			case 0: // disabled
				$MakeQReport = 0;
				$MakeFReport = 0;
				break;
			case 1: break; // default (global setting used)
			case 2: // new messages only
				$filtermode = 0;
				break;
			case 3: // all messages (time/date independent)
				$filtermode = 1;
				break;
		}
	}

	/* ---------------------------------------------------------------------------------------
		GetPlainMessage() function returns specified message content in plain text. The message
		  is specified by its parent quarantine folder and username. This function atomatically
		  reads the mail folder path from user's configuration. 
	 --------------------------------------------------------------------------------------- */
	function GetPlainMessage( $account, $folder )
	{
		global $api;

		$domainname = explode( "@", $account );
	  	$domain = $api->OpenDomain( $domainname[1] );
	  	$acc = @$domain->OpenAccount( $account );
	  	
	  	// was the account properly opened?
	  	if ( !$acc ) 
	  	{ /* account wasn't properly opened, maybe a backup domain? */
		  	// if the domain is a backup domain, it's ok when the account could not be opened
		  	//  in such case all the quarantine mail is stored in mail_path (in the root directory)
		  	if ( $domain->GetProperty( "D_Type" ) == 3 )
	  		{
					// compose the full file path by obtaining Merak configuration and user config
					$path = ConcatPath( $api->GetProperty( "C_System_Storage_Dir_MailPath" ), "/$domainname[1]/" );
					$path .= "~spam/~quarantine/$folder/";

	  		}
	  		else 
	  		{
	  			// Account could not be opened, but it's a standard domain, which is not usual ! -> throw error
	  			//TODO: return some error msg
	  			return 0;
	  		}
		}
	  	else 
	  	{
			// compose the full file path by obtaining Merak configuration and user config
			
			$path = $acc->GetProperty( "U_FullMailBoxPath" );//ConcatPath( $api->GetProperty( "C_System_Storage_Dir_MailPath" ), $acc->GetProperty( "U_MailBoxPath" ) );
			$path = ConcatPath( $path, "~spam/~quarantine/" );
			$path .= $folder."/";
  		}
		
    			
		// obtain a name of some file containing a message (.tmp extension)
		$filename = glob( $path."*.tmp" );
		return @file_get_contents( $filename[0] );
	}
	

?>
