<?
/**
 *  @brief : Security class
 *		 : this class offers solution for defence against naughty users
 */
class Security{
	  /**
		* @brief: Constructor
				: check if any GET or POST variables are set
		*/
	  public function __construct(){
		 global $aError;
		 
		 if (@count($_POST) || @count($_GET))
			throw new DebugException($aErrors["'no get post"]);
	  }
	  /**
		* @brief: checks if there are no double-dots in tested paths
		 @params: $path - STRING to be checked as path
		*/
	  public static function checkpath($path,$low = false){
		 if (!ereg("\.\.",$path)) return true;
		 return false;
	  }
	  /**
		* @brief: checks temp file
		 @params: $path - STRING to be checked as temp file
		*/
	  public static function checktemp($path){
		 if(!$path || ereg("\.\.",$path) || !eregi("^[a-z]\:[/\\]",$path) || !file_exists($path)) return false;

		 // get file properties
		 $size = filesize($path);
		 $time = filemtime($path);

		 if ($tmpdir = ini_get('upload_tmp_dir'))
			$regex = "^".str_replace("\\","/",$tmpdir);
		 else
			$regex = "[/\\]temp";

		 //file test
		 if(!$size || time()>$time+3600 || !eregi($regex."[/\\]([a-z0-9_ \-])+\.tmp$",$path)) return false;
		 return true;
	  }
	  /**
		* @brief: Checks if the email is in the correct form
		* @param:$email - STRING to be tested as e-mail	  
		*/
	  public static function checkemail($email,$low = false){
		 if (eregi("^[a-z0-9_\.\-]+\@[a-z0-9_\.\-]+\.[a-z]{2,3}$",$email)) return true;
		 return false;
	  }
	  /**
		*  cypher, work version only!!
		*/
	  public static function cipher($data){
		 return base64_encode($data);
	  }
	  /**
		*  decypher function, work version only!!
		*/
	  public static function decipher($data){
		 return base64_encode($data);
	  }
}


?>
