<?php

require_once 'inc/encode.php';

class Tools
{
	/*************************************** Public **************************************/
	public static function validateTemp($path)
	{
		// TODO
		return true;
	}
	
	public static function isIE()
	{
		$agent = $_SERVER['HTTP_USER_AGENT'];

		if (strpos($agent,'MSIE') !== false && strpos($agent,'Opera') === false)
			return true;
		else
			return false;
	}
	
	public static function sendFileHeaders($fileName, $length, $contentType)
	{

		if (Tools::isIE()){
		
		  //IE BUG : explorer can not handle localized file names 
		  // longer than 21 charactes - cut out the rest of filename
	/*	  if(($fnLength = iconv_strlen($fileName,'utf-8'))>21){

		    $dot = iconv_strrpos($fileName,'.','utf-8');
        $ext = iconv_substr($fileName,$dot,$fnLength,'utf-8');
        $fileName = iconv_substr($fileName,0,21,'utf-8').$ext;

      }*/
    	$fileName = rawurlencode($fileName);
    }
    
		header('Pragma: ');		// leave blank to avoid IE errors
		header('Cache-Control: '); // leave blank to avoid IE errors
		header('Content-Type: ' . $contentType);
		header('Content-Disposition: attachment; filename="' . $fileName . '"');

    if($length)	header('Content-Length: ' . $length);		
	}
	
	
	public static function removeHTML($message)
	{
		// Convert CRLF
		$message = ereg_replace("(\n)|(\r\n)","",$message);
		$message = eregi_replace("<li[^>]*>","\r\n - ",$message);
		$message = eregi_replace("<td[^>]*>"," ",$message);
		$message = eregi_replace("<(p|br|hr|tr)[^>]*>","\r\n",$message);
		
    //Remove style tag + its value
    $message = preg_replace('#<(style)[^>]*>([^<]{0,})*<#i',"$2<",$message);
	  $message = preg_replace('#</(style)[^>]*>#i',"",$message);
	  
		// Strip all HTML and PHP Tags
		$message = strip_tags($message);
		// Replace all entities
		$message = eregi_replace("&nbsp;", " ", $message);
		$message = eregi_replace("&amp;", "&", $message);
		$message = eregi_replace("&quot;", "\"", $message);
		$message = eregi_replace("&apos;", "'", $message);
		$message = eregi_replace("&lt;", "<", $message);
		$message = eregi_replace("&gt;", ">", $message);
		
		return $message;
	}
	
	public static function dotConvert($value)
	{
		if ($value) if ($value[0] == ".") $value = "." . $value;
		return str_replace("\n.", "\n.." , $value);
	}
	
	public static function cr2crlf($string)
	{
		$string = str_replace("\x0D", "", $string);
		return str_replace("\x0A", "\x0D\x0A", $string);
	}
	
	/*************************************** Private **************************************/

	public static function isabovechar($string)
	{
		for ($i = 0; $i < strlen($string); $i++)
			if (ord($string[$i]) > 127) return true;
			
		return false;
	}
	
	public static function fillstr($str, $size, $char)
	{
		if (strlen($str) > $size) return substr($str, 0, $size);
		
		$value = $str;
		for ($i = strlen($str); $i < $size; $i++) {
			$value = $char . $value;
		}
		
		return $value;
	}
		 /**
	  @brief Converts parsed item array into xml string.
	  @param $item parsed item array.
	  @param $filter GW array result.
	  */
		public static function makeXMLTags($item,$tags = '*')
		{
		$return = '';
		$tags = strtolower($tags);
		$tags = explode(",",$tags);

    if (is_array($item)) foreach ($item as $tag => $value){
				$tag = strtolower($tag);

				//If there are selected tags and current tag is not in there
				if ($tags[0]!='*' && in_array($tag,$tags)==0) continue;
	
				if (isset($value) && $value !== '') $return.='<'.$tag.'>'.htmlspecialchars(trim($value)).'</'.$tag.'>';
				else		$return.='<'.$tag.'/>';
			}
			return $return;
		}
	  
		/**
	  @brief Converts xml into into array
	  @param $oXMLNode node element.
	  @param $filter folder result.
	  */
		public static function makeArrayFromXML($oXMLNode,$bBlankTags = false)
		{
		  $itm = array();
			 if ($oXMLNode->hasChildNodes())
			  foreach ($oXMLNode->childNodes as $node)
				  if ($node->nodeValue !== '' || $bBlankTags)
						$itm[strtolower($node->nodeName)] = $node->nodeValue;
		 

		  return $itm;
		}
		
		public static function makeTreeFromXML($oXMLNode)
		{
		  $itm = array();
		  
      if ($oXMLNode && $oXMLNode->hasAttributes())
        foreach($oXMLNode->attributes as $attr)
          $itm['@attributes'][$attr->name] = encodeHTML($attr->value);
      
    		  
      $oldname ='';
      if ($oXMLNode->hasChildNodes()) 
        foreach($oXMLNode->childNodes as $node)
        {
          //Count items with the same name
          if ($oldname != $node->nodeName) 
            $nCount = 0;  

          $oldname = $node->nodeName;

          if ($node->nodeName=='#text')
            $itm['@value'] = encodeHTML($node->nodeValue);
          else {
           if ($uid = $node->getAttribute('uid'))
              $itm['@childnodes'][strtolower($node->nodeName)][$uid] = 
                self::makeTreeFromXML($node);
           else
              $itm['@childnodes'][strtolower($node->nodeName)][$nCount++] = 
              self::makeTreeFromXML($node);
          }
        }
      return $itm;    
		}
		
		/**
		 @brief Converts UTF-8 with invalid chars to proper UTF-8.
		 @param UTF-8
		 @return Filtered UTF-8 string
		*/
public static function utf8_bad_replace($str, $replace = '') {
       $UTF8_BAD =
        '([\x00-\x7F]'.                          # ASCII (including control chars)
        '|[\xC2-\xDF][\x80-\xBF]'.               # non-overlong 2-byte
        '|\xE0[\xA0-\xBF][\x80-\xBF]'.           # excluding overlongs
        '|[\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}'.    # straight 3-byte
        '|\xED[\x80-\x9F][\x80-\xBF]'.           # excluding surrogates
        '|\xF0[\x90-\xBF][\x80-\xBF]{2}'.        # planes 1-3
        '|[\xF1-\xF3][\x80-\xBF]{3}'.            # planes 4-15
        '|\xF4[\x80-\x8F][\x80-\xBF]{2}'.        # plane 16
        '|(.{1}))';                              # invalid byte
       ob_start();
       while (preg_match('/'.$UTF8_BAD.'/S', $str, $matches)) {
           if ( !isset($matches[2])) {
               echo $matches[0];
           } else {
               echo $replace;
           }
           $str = substr($str,strlen($matches[0]));
       }
       $result = ob_get_contents();
       ob_end_clean();
       return $result;
   }

		/**
		 @brief Converts string representin an XML document into simple XML containing parsed JS array string.
		 @param $XMLString XML string.
		 @return Simple XML containing parsed JS array string.
		*/
		public static function str2JSArray(&$XMLString) {
			$array = array();
			$xml = @simplexml_load_string($XMLString);

			//If load of XML failed, try to remove bad characters 
			//and possibly convert string to UTF-8s
      if (!is_object($xml))
        $xml = self::fixXML($XMLString);


			$rootName = strtoupper(@dom_import_simplexml($xml)->nodeName);
		
			self::makeJSArray($xml, $array[$rootName][0]);

      if ($array[$rootName][0])
			 $result =  json_encode($array);

		  else $result =  false;

		  return $result;
    }

    public static function fixXML($XMLString)
    {
    
        for($i=0;$i<32;$i++)
	        $binary.=chr($i);
	      
          
        $XMLString =strtr($XMLString,$binary,"          \n  \r                   ");
        $xml = @simplexml_load_string($XMLString); 
        
        if (!is_object($xml)){
          if (!is_object($xml)) $xml = @simplexml_load_string(self::utf8_bad_replace($XMLString));     
          
        }
  
      return $xml;
    }
    
		/**
		 @brief Converts Simple XML object into array that is used within JS on client.
		 @param $parent Simple XML node being processed.
		 @param[in,out] $output JS-like array.
		*/
		private static function makeJSArray(&$parent, &$output) {
			
			$hasChild = false;
			if ($parent)
			foreach ($parent->children() as $name => $child) {
				$output2 = &$output[strtoupper($name)][];
				self::makeJSArray($child, $output2);
				$hasChild = true;
			}
			
			if (($value = /*trim(*/(string)$parent)/*)*/!='')
          $output['VALUE'] = $value;
      else{
			 if (!$hasChild){
        $output = array();
        }
      }
			if ($parent)
      foreach ($parent->attributes() as $attName => $attValue) {
        $output['ATTRIBUTES'][strtoupper($attName)] = (string)$attValue;
        }
		}
		
		public static function makeXMLStringFromTree($aArray,$sTagName = 'documentElement')
		{ 
		  //Init
		  $sStart = $sEnd = $sValue = $sReturn = $sAttributes = '';

      //Transform attributes
      if (isset($aArray['@attributes'])){
        foreach($aArray['@attributes'] as $attname => $attvalue)
          $sAttributes.=' '.$attname.'="'.$attvalue.'"';
      }
      
      //Process childnodes
      if (isset($aArray['@childnodes'])){
        foreach($aArray['@childnodes'] as $chName => $chValue)
          foreach($chValue as $chVal)
            $sValue.= Tools::makeXMLStringFromTree($chVal,$chName);
      }
      //Set value 
      if (isset($aArray['@value']))
        $sValue .= $aArray['@value'];
    
    
      //No pair-tag
      if (!isset($aArray['@value']) && !isset($aArray['@childnodes']))
        $sReturn = '<'.$sTagName.$sAttributes.'/>';
      else 
        $sReturn = '<'.$sTagName.$sAttributes.'>'.$sValue.'</'.$sTagName.'>';    
      
      return $sReturn;
    }
    	  
		public static function binary2decimal($num)
		{
			$dec = 0;
			for ($i=0;$i<sizeof($num);$i++){
	  		$dec+=pow(2,$i)*$num[$i];
	  	}
	  	return $dec;
		}

		public static function decimal2binary($num,$length = 7)
		{
			$i = 0;
			while ($num!=0){
	  		$binary[$i++] = $num%2;
	  		if (($num - $num%2)!=0) $num = ($num - $num%2)/2;
	  		else					$num = 0;
	  	}
	  	while (count(@$binary)!=$length)
	  		$binary[$i++] = 0;
	  	return $binary;
		}	
		
    public static function securePath($path) 
    { 
      if (ereg("(\.\.)|(:)", $path) || $path[0]=="/" || $path[0]=="\\") $path=false;
      return $path;   
    }

    
  public static function createURL($array) {
		if(!is_array($array)) return '';
		$result = '';
		$first = true;
		foreach($array as $k => $v) {
			if ($first)
				$first = false;
			else
				$result .= '&';
			
			$result .= $k. "=" . encodeURL($v);
		}
		return $result;
	}

	public static function parseURL($line){
		if (!$line) return array();
		
		$result = array();
		$fields = explode("&", $line);

		// Get all lines array
		foreach ($fields as $item){
			$pos = strpos($item, '=');
			if ($pos === false)
				continue;
			$key = substr($item, 0, $pos);
			$value = substr($item, $pos+1);
			$result[$key] = decodeURL($value);
		}

		return $result;
	}
    
    //This function is an altenative to the standard
    //explode funct. but it unsets the last element in array
    //(for strings with separator at the end)
    public static function explode_j($sep,$string)
    {
      $return = explode($sep,$string);
      unset($return[count($return)-1]);
      return $return;
    }
    
    public static function parseFullPath($fullPath,$class)
    {
      switch($class)
      {
        // Parse "folder/item"
        case 'file':    
          $lastSlash = strrpos($fullPath,"/");
                    
          $attData['item'] = substr($fullPath,$lastSlash+1);
          $attData['folder'] = substr($fullPath,0,$lastSlash);                                                         
          break;
        case 'exportcsv':    
      /*    $firstSlash = strpos($fullPath,"/");
                    
          $attData['folder'] = substr($fullPath,$firstSlash+1);
          $attData['account'] = substr($fullPath,0,$firstSlash);                                                         
          break;       */   
        //Parse "account/folder/item"
        case 'itemlink':
        case 'allattachments':
        case 'item':
          $lastSlash = strrpos($fullPath,"/");
          $firstSlash = strpos($fullPath,"/");
                    
          $attData['item'] = substr($fullPath,$lastSlash+1);
          $attData['account'] = substr($fullPath,0,$firstSlash);
          $attData['folder'] = substr($fullPath,$firstSlash+1,$lastSlash-$firstSlash-1);
        
          break;
          
        //Parse "account/folder/item/part"
        case 'attachment':
        case 'gwattachment':
          $lastSlash = strrpos($fullPath,"/");
          $preLastSlash = strrpos(substr($fullPath,0,$lastSlash),"/");
          $firstSlash = strpos($fullPath,"/");
                    
          $attData['part'] = substr($fullPath,$lastSlash+1);
          $attData['item'] = substr($fullPath,$preLastSlash+1,$lastSlash-$preLastSlash-1);
          $attData['account'] = substr($fullPath,0,$firstSlash);
          $attData['folder'] = substr($fullPath,$firstSlash+1,$preLastSlash-$firstSlash-1);
                        
          break;
        //Parse ""
        case 'url':
        //Not implemented yet
        break;
        case 'groupware':
          $attData['account'] = $fullPath;          
        break;
        case 'captcha':
          $attData['uid'] = $fullPath;
        break;
        default:
          throw new Exc('attacment_class_unknown',$class);        
        break;

      }
      return $attData;
    }

public static function cleanHTML($string,&$base) {
	
  
  if (get_magic_quotes_gpc())
		$string = stripslashes($string);

  

	for($i=0;$i<32;$i++)
		$binary.=chr($i);
	$string =strtr($string,$binary,"          \n  \r                   ");


	$string = str_replace(array("&amp;","&lt;","&gt;"),array("&amp;amp;","&amp;lt;","&amp;gt;",),$string);

	// fix &entitiy\n;
	$string = preg_replace('#(&\#*\w+)[\x00-\x20]+;#',"$1;",$string);
	$string = preg_replace('#(&\#x*)([0-9A-F]+);*#i',"$1$2;",$string);
	$string = html_entity_decode($string, ENT_COMPAT, "UTF-8");

	// remove any attribute starting with "on" or xmlns
	$string = preg_replace('#(<[^>^!]+[\x00-\x20\"\'])(on|xmlns)[^>]*>#iU',"$1>",$string);


	// remove javascript: and vbscript: protocol
	$string = preg_replace('#([a-z]*)[\x00-\x20]{0,10}=[\x00-\x20]{0,10}([\`\'\"]{0,10})[\x00-\x20]{0,10}(javascript|vbscript)[\x00-\x20]{0,10}:#iU','$1=$2noscript...',$string);

	//<span style="width: expression(alert('Ping!'));"></span>
	// only works in ie...

//FIX by Pavel : this does not clear mail when style="" found and i think its a better for removing expression and behaviuor
$string = preg_replace('#(<[^>]+) style=([^:]{0,}).(\s*).(expression|behaviour).([^\>]{0,})#i',"$1",$string);
//	$string = preg_replace('#(<[^>]+)style[\x00-\x20]{0,10}=[\x00-\x20]{0,10}([\`\'\"]*).*expression[\x00-\x20]{0,10}\([^>]*>#iU',"$1>",$string);
//	$string = preg_replace('#(<[^>]+)style[\x00-\x20]{0,10}=[\x00-\x20]{0,10}([\`\'\"]*).*behaviour[\x00-\x20]{0,10}\([^>]*#iU',"$1>",$string);

	//remove namespaced elements (we do not need them...)
	$string = preg_replace('#</*\w+:\w[^>]*>#i',"",$string);

	//remove really unwanted tags and its content
	do {
		$oldstring = $string;
		//Remove only tag
		$string = preg_replace('#</*(meta|xml|blink|link|embed|object|iframe|frame|frameset|ilayer|layer|bgsound)[^>]*>#i',"",$string);

		//Remove oncluding tag value
		$string = preg_replace('#<(applet|script)[^>]*>([^<]{0,})*<#i',"$2<",$string);
		$string = preg_replace('#</(applet|script)[^>]*>#i',"",$string);
	}

	while ($oldstring != $string);

	//Check for <base>$baseURL</base> element

	if(preg_match('#<(base)([^>]*)>([^<]{0,})#i',$string,$matches)){
		if(preg_match('#(href|url|name)="(.*)"#i',$matches[2],$matches2))
			$base = trim($matches2[2]);
		else
			$base = trim($matches[3]);

		//$string = preg_replace('#<base[^>].*>([^<]{0,}).*<#i',"<",$string);
		//$string = preg_replace('#</base[^>]*>#i',"",$string);
	}
	return $string;
}

public static function convertLFtoCRLF($string)
{
  $string = str_replace("\r","",$string);
  return str_replace("\n","\r\n",$string); 
}

public static function textLinksToHTML($string)
{
  $match = array();
  $offset = 0;
  $replace = array();
//'/(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/'

  while(preg_match('/([a-z0-9]+):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/',$string,$match,PREG_OFFSET_CAPTURE,$offset) && $i++<100){
    $rplc = array();

    $offset = $match[0][1];
    $text = $match[0][0];

    $text = strtr($text,',\'"\\)(][','       ');
    if (($pos = strpos($text,' '))!==false)
      $text = substr($text,0,$pos);
      
    $text = ereg_replace('[\.;\\\]+$','',$text);
    $link = '<a target="_blank" href="'.$text.'">'.$text.'</a>';
    
   $string = substr_replace($string,$link,$offset,strlen($text));
   $offset += strlen($link);
  }

  return $string;
}

public function htmlspecialchars_array($array)
{
  if ($array) foreach($array as $key => $val){
    if (is_array($val)) $return[$key] = Tools::htmlspecialchars_array($val);
    else $return[$key] = htmlspecialchars($val);
  }
  else return $value;
  return $return;
}

public function text2html($text, $links=false)
{
  // Special chars
  $result = htmlspecialchars($text);

  // Links to html
  if ($links) $result = Tools::textLinksToHTML($result);

  // Now we can convert CRLF to <br> and preserve spacing
  return str_replace('  ', ' &nbsp;', nl2br($result));
}

public function unhtmlspecialchars($string)
{
    $trans_tbl = get_html_translation_table (HTML_SPECIALCHARS);
    $trans_tbl = array_flip ($trans_tbl);
    return strtr ($string, $trans_tbl);
}

public function getServerPath()
{
  $result=get_cfg_var('icewarp_server_path');
  if(!$result){
    $result=dirname($_SERVER['SCRIPT_FILENAME']);
    $result=substr($result,0,strrpos($result,'html'));
  }
  return $result;
}	

public static function randomFilename() {
		$filename = eregi_replace("e","z",uniqid('',true));
		if($_SESSION['user']){
			
			$dir = User::getDir() . '~upload/';
			if(!is_dir($dir))
			System::mkdir_r($dir);
		}else{
			$api = new MerakAPI();
			$dir = $api->getProperty("C_System_Storage_Dir_TempPath");
			unset($api);
		}
		return $dir . $filename . '.tmp';
}


public function checkFolderName($sName){

  //Do not allow 
  if(!$sName) return false;
  
  // Do not allow \ / : * ? " < > |
  if(preg_match("([\:\*\?\"\<\>\|])",$sName,$matches))
  {  

    return false;
  } 
  return true; 
}

public function checkIgnore(&$charset){
  if(strpos($charset,"//IGNORE")!==false){
    $charset = str_replace("//IGNORE","",$charset);
    return true;
  }  
  return false;
}

public function my_iconv($inCharset,$outCharset,$inputString)
{
  $bIgnoreIn = Tools::checkIgnore($inCharset);
  $bIgnoreOut = Tools::checkIgnore($outCharset);
  
  if(!$inCharset)
    $inCharset = $_SESSION['DEFAULTCHARSET'];

  switch(strtolower($inCharset)){
    case 'gb2312':
   // case 'us-ascii':
      $inCharset = 'gbk';
    break;
    case 'unicode':
      $inCharset = 'ucs-2le';
    break;
    case 'ks_c_5601-1987':
      $inCharset = 'euc-kr';
    break;
  }  


  return iconv($inCharset.($bIgnoreIn?"//IGNORE":""),$outCharset.($bIgnoreOut?"//IGNORE":""),$inputString);
}


  public function checkFolderMove($sOldName,$sNewName)
  {
      $sParent = substr($sName,0,strrpos($sName,'/'));
      
      $aOldNames = explode('/',$sOldName);
      $aNewNames = explode('/',$sNewName);
    
      if((count($aNewNames)>count($aOldNames)) 
      && (strpos($sNewName,$sOldName)!==false)){
        throw new Exc('folder_move_to_subfolder',$sOldName.'=>'.$sNewName);
      }
      
      if($sParent==$sOldName){
        throw new Exc('folder_move_to_self',$sOldName);
      }
}
	static public function overrideContentType($fileName,&$contentType)
	{
		$extStart = strpos($fileName,'.');
		$ext = substr($fileName,$extStart+1);
		switch($ext){
			case 'eml':
				$contentType ='message/rfc822';
				break;
			default:
			break;
		}
	}
}

?>
