<?
  /**
   * getgroups()  ziska seznam skupin
   *
   * @param integer $id
   * @param boolean $private Urcuje jestli se jedna o privatni skupiny nebo globalni
   * @return pole skupin
   **/
  function getgroups($id, $private = true,$dbswitch=1) // 0 DB Off; 1DB on;2DB only
  {
    getusersession($id, $user, $config);
    $groups = array();

    if($dbswitch)
    {
      global $groupsessid,$otherconfig;
      if($groupsessid && !$otherconfig["DISABLESERVERADDRESS"] && $otherconfig["FULLMERAK"])
      {
         $result= parsecalendarresult(calendarfunctioncall("GetContactDetailList",$groupsessid,'(ITMCLASS=\'L\''.($private?'':' AND ITMSHARETYPE=\'U\'').')','ITMTITLE,LCTEMAIL1,LCTDESCRIPTION'));
         if (is_array($result)) {
            foreach ($result as $v) {
               $descript = trim(ereg_replace("\(.+\)$","",$v["LCTDESCRIPTION"]));
               if (ereg("[\;\, ]",$descript)) $descript='"'.$descript.'"';
               $dbitem[$v['ITM_ID'].';'.$v['ITMTITLE']].= $descript.' <'.$v['LCTEMAIL1'].'>; ';
            }
            if (is_array($dbitem)){
               foreach ($dbitem as $k=> $v) {
                  $dbitem2["NAME"] = substr($k,strpos($k,";")+1);
                  $dbitem2["LIST"] = substr(trim($v),0,-1);
                  $dbitem2["ISGROUP"]= 2;
                  $dbitem2["DBID"]= substr($k,0,strpos($k,";"));
                  $groups[]=$dbitem2;
               }
            }
         }
      }
    }

    if($dbswitch!=2)
    {
       if ($private)
        $path = usersdir . $user . groupsfile;
       else
        $path = getvirtualhostpath(configgroupsitem);

       if (!(@$file = fopen($path, "rb"))) return $groups;
       while (!(feof($file)))
       {
         $line = fgets($file, 65536);

         if (!(trim($line) == ""))
         {
           $xitem = explode(delimiterchar, $line);

           $item["NAME"] = rawurldecode($xitem[0]);
           $item["LIST"] = rawurldecode($xitem[1]);
           $item["ISGROUP"]= 1;
           $item["DELETED"] = false;

           $groups[] = $item;
         }
       }
       fclose($file);
    }

    return $groups;
  }

  /**
   * @param  : $groups
   * @param  : $groupname jmeno skupiny
   * @return : $index
   **/
  function getgroup($groups, $groupname)
  {
    $index = 0;

    for ($i = 0; $i < count($groups); $i++)
    {
      if (!strcasecmp($groups[$i]["NAME"], $groupname))
      {
        $index = $i + 1;
        break;
      }
    }

    return $index;
  }

  /**
   * getgrouplist()  nate poloky v grupe;
   *
   * @param integer $id cislo
   * @param $groupname nazev
   * @return $list,$groupDBID
   **/
  function getgrouplist($id, $groupname,$private=true)
  {
    global $groupDBID;
    $groups = getgroups($id,$private);

    $list = "";
    for ($i = 0; $i < count($groups); $i++)
    {
      if (!strcasecmp($groups[$i]["NAME"], $groupname))
      {
        $item = trim($groups[$i]["LIST"]);
        $item = str_replace("\x0A", ";", $item);
        $item = str_replace("\x0D", "", $item);
        $item = str_replace(";;", ";", $item);
        $list = $item;
        $groupDBID=$groups[$i]["DBID"];
        break;
      }
    }

    return $list;
  }

  /**
   * cutgrouplist()  ozne grupu na 3poloky x 3dky + ...;
   *
   * @param integer $id cislo
   * @param $groupname nazev
   * @return $list
   **/
  function cutgrouplist($groupname,$list)
  {
    global $id,$sort,$selectsort,$listnumber,$showlite,$category,$showgroups,$global;
    $arr=explode (";", $list,10);

    if(is_array($arr))
    {
        for ($i=0;$i<count($arr);$i++)
        {
          if($i==9){$xlist.='<a href="groupitem.html?id='.$id.'&groupname='.rawurlencode($groupname).'&selectsort='.rawurlencode($selectsort).'&listnumber='.rawurlencode($listnumber).'&showlite='.rawurlencode($showlite).'&global='.rawurlencode($global).'" CLASS="listrowlink"><b>...</b></a>'; break;}
          if(!($i%3) && $i>0) $xlist.= "<br>";
          $xlist.=htmlspecialchars($arr[$i])."; ";
        }
        $xlist=substr(trim($xlist),0,-1);
    }
    else
        $xlist=$list;

    return $xlist;
  }

  /**
   * ukladani skupin
   *
   * @param integer $id
   * @param $groups
   * @param boolean $private
   * @return true pokud se podarilo
   **/
  function savegroups($id, &$groups, $private = true)
  {
    global $sessid,$groupsessid;
    
    getusersession($id, $user, $config);
    if ($private) $path = usersdir . $user . groupsfile; else $path = getvirtualhostpath(configgroupsitem);

    if (!(@$file = fopen($path, "wb"))) return false;
    foreach($groups as $key => $val){

      //Plain text Groups
      if (!$val["DELETED"] && !$val["DBID"])
        fputs($file, rawurlencode($val["NAME"]) . delimiterchar . rawurlencode($val["LIST"]) . delimiterchar . "\r\n");
      elseif($val["DELETED"])
        unset($groups[$key]);
      //GW groups
      else{
        $datain[ITMCLASS]="L";
        $datain[ITMTITLE]=$val['NAME'];

        $cid = calendarfunctioncall("AddContactInfo",$groupsessid,createcalendarparameters($datain),$val["DBID"]);
        if($cid)
        {
                 calendarfunctioncall("DeleteContactLocations",$groupsessid,$cid);
                 $Garr = explode(";",$val['LIST']);
		 $counter=0;

                 if(is_array($Garr) && count($Garr))
                 {
                   unset($datain,$arr);
                   foreach($Garr as $gv)
                   {
                     $gv = ereg_replace("[\"\']",'',trim($gv));
                     if(!$gv) continue;

                     if(eregi("<([a-z0-9@\-\.\_\~-]+)",$gv,$arr)){
                        $datain['LCTEMAIL1'] = $arr[1];
                        $datain['LCTDESCRIPTION'] = trim(substr($gv,0,strpos($gv,"<")));
                     }
                     elseif (eregi("([a-z0-9\-\.\_\~\-]+@[a-z0-9\-\.\_\~\-]+)",$gv,$arr)){
                         $datain['LCTEMAIL1']=$arr[1];
                         $gv = ereg_replace("[<>]",'',$gv);
                         $datain['LCTDESCRIPTION']= trim(substr($gv,0,strpos($gv,$arr[1])));
                     }
                     else{
                         $gv = trim(ereg_replace("[<>]",' ',$gv));
                         if(!$gv) continue;
                         
                         $sppos = strpos($gv," ");
                         if($sppos) $gv = substr($gv,0,$sppos);
                         $datain['LCTEMAIL1'] = $gv;
                         $datain['LCTDESCRIPTION'] = '';
                     }
                     if (!$counter) $datain['LCTTYPE']='O'; else $datain['LCTTYPE']='L';
		     $counter++;
                     calendarfunctioncall("AddContactLocation",$groupsessid,$cid,createcalendarparameters($datain));
                   }
                 }
	    // Finalize
            calendarfunctioncall("AddContactInfo",$groupsessid,'',$cid);
        }
      }
    }
    @fclose($file);

    return true;
  }

  /**
   * groupcompare() fce na sorotvani podle abecedy
   *
   * @param $a
   * @param $b
   * @return neco
   **/
  function groupcompare($a, $b)
  {
    $index = "NAME";
    if (strtolower($a[$index]) > strtolower($b[$index])) $value = 1;
    elseif (strtolower($a[$index]) < strtolower($b[$index])) $value = -1;
    else $value = 0;

    return $value;
  }

    /**
    * sortgroups()  funkce na sortovani k razeni pole pouziva fci groupcompare()
    *
    * @param $groups
    * @return  nic ;) akorat pretridi pole
    **/
    function sortgroups(&$groups)
    {
      usort($groups, "groupcompare");
    }

    /**
    * isgroup()  kontrola skupiny
    *
    * @param $groupname
    * @return  vraci true pokud je to skupina
    **/
    function isgroup($groupname)
    {
         $result = false;
         if (substr($groupname, 0, 1) == "[") if (substr($groupname, strlen($groupname) - 1, 1) == "]") $result = true;

         return $result;
    }
?>