<?
  define(certfile, "cert.dat");

  function getrecipientcertificate($user, $email)
  {
    require_once("function.address.php");

    $key = getaddressitemcertificate($email);
    return $key;
  }

  function getusercertificate($user)
  {
    $filename = usersdir . $user . "/" . certfile;
     if (@$file = fopen($filename, "rb"))
     {
       while (!(feof($file)))
       {
          $line = trim(fgets($file, 16384));

          if ($line)
          {
            $items = explode(delimiterchar, $line);
            $array[CERTIFICATE] = rawurldecode($items[0]);
            $array[PASSPHRASE] = base64_decode(rawurldecode($items[1]));
          }
       }
       fclose($file);
    }

    return $array;
  }

  function setusercertificate($user, $array)
  {
     $filename = usersdir . $user . "/" . certfile;
     if (@$file = fopen($filename, "wb"))
     {
       fputs($file,
        rawurlencode(trim($array[CERTIFICATE])) . delimiterchar .
        rawurlencode(base64_encode(trim($array[PASSPHRASE]))) . "\r\n");

       fclose($file);
    }
  }

  function convertmessagetoplainfile($user, $message)
  {
    $filename = usersdir . $user . "/" . getfilename();
    $message = str_replace("\x0D\x0A.", "\x0D\x0A", $message);

    if (@$file = fopen($filename, "wb"))
    {
      fwrite($file, $message, strlen($message));
      fclose($file);
    }

    return $filename;
  }

  function getfileheaderitemarray($fileitem, &$arraylist, $header)
  {
    $field = getfileheaderitem($fileitem, $header . ":");
    if ($field)
    {
      $arraylist[$header] = trim($field);
    }
  }

  function crtocrlf($string)
  {
    $string = str_replace("\x0D", "", $string);
    $string = str_replace("\x0A", "\x0D\x0A", $string);
    return $string;
  }

  function getopensslheaderarray($fileitem)
  {
    getfileheaderitemarray($fileitem, $array, "Subject");
    getfileheaderitemarray($fileitem, $array, "From");
    getfileheaderitemarray($fileitem, $array, "Reply-To") ;
    getfileheaderitemarray($fileitem, $array, "To")  ;
    getfileheaderitemarray($fileitem, $array, "Return-Receipt")  ;
    getfileheaderitemarray($fileitem, $array, "Message-ID")  ;
    getfileheaderitemarray($fileitem, $array, "X-Priority")  ;
    getfileheaderitemarray($fileitem, $array, "X-Originating-IP")  ;
    getfileheaderitemarray($fileitem, $array, "X-Mailer")  ;

    return $array;
  }

  function smimeprocessmessage($user, &$message, $recipient, $encrypt, $sign)
  {
    $plainfile = convertmessagetoplainfile($user, $message);

    $headerarray = getopensslheaderarray($plainfile);

    // Sign with the sender's private key
    if ($sign)
    {
      $encodedfile = usersdir . $user . "/" . getfilename();
      $cert = getusercertificate($user);

      $key = $cert[CERTIFICATE];
      $passphrase = $cert[PASSPHRASE];
      if ($passphrase) $fcert = array($key, $passphrase); else $fcert = $key;

      if ($key) if (@openssl_pkcs7_sign($plainfile, $encodedfile, $key, $fcert, $headerarray))
      {
        @unlink($plainfile);
        $plainfile = $encodedfile;
      } else @unlink($encodedfile);
    }

    // Encrypt with the recipients public key
    if ($encrypt)
    {
      $encodedfile = usersdir . $user . "/" . getfilename();
      $key = getrecipientcertificate($user, getemail($recipient[0], "", true));

      if ($key) if (@openssl_pkcs7_encrypt($plainfile, $encodedfile, $key, $headerarray))
      {
        @unlink($plainfile);
        $plainfile = $encodedfile;
      } else @unlink($encodedfile);
    }

    // Load file back
    $message = file_get_contents($plainfile);
    $message = crtocrlf($message);
    $message = dotconvert($message);

    // Delete file
    @unlink($plainfile);
  }

  function smimedecodemessage($user, &$certmsg)
  {
    // Save To File
    $encodedfile = usersdir . $user . "/" . getfilename();
    $plainfile = usersdir . $user . "/" . getfilename();
    if (@$nfile = fopen($encodedfile, "wb"))
    {
      fwrite($nfile, $certmsg, strlen($certmsg));
      fclose($nfile);
    }

    // Get Private Key
    $cert = getusercertificate($user);

    $key = $cert[CERTIFICATE];
    $passphrase = $cert[PASSPHRASE];
    if ($passphrase) $fcert = array($key, $passphrase); else $fcert = $key;

    // Decrypt
    if (@openssl_pkcs7_decrypt($encodedfile, $plainfile, $key, $fcert)) {}
    @unlink($encodedfile);

    return $plainfile;
  }

  function getcertificateinfo($key, $user = "")
  {
    $result = "";

    // Get user's certificate
    if ($user)
    {
      $cert = getusercertificate($user);
      $key = $cert[CERTIFICATE];
    }

    if ($key)
    {
       // Get key info
      @$array = openssl_x509_parse($key);

      // Parse cert array
      if (is_array($array))
      {
        $result .= $array["name"] . "\r\n\r\n";

        $result .= $array["subject"]["CN"] . "\r\n";
        $result .= $array["subject"]["emailAddress"] . "\r\n\r\n";

        $result .= $array["issuer"]["C"] . "\r\n";
        $result .= $array["issuer"]["ST"] . "\r\n";
        $result .= $array["issuer"]["L"] . "\r\n";
        $result .= $array["issuer"]["O"] . "\r\n";
        $result .= $array["issuer"]["OU"] . "\r\n";
        $result .= $array["issuer"]["CN"] . "\r\n";
        $result .= $array["issuer"]["emailAddress"] . "\r\n\r\n";

        $result .= $array["validFrom"] . "\r\n";
        $result .= $array["validTo"] . "\r\n\r\n";
      }
    }

    return trim($result);
  }
?>