<?php
  /**
   * Attachment manager
   * Date: 19.12.2005
   */
  class upAttachment {

     var $sUSessId = '';
     var $pUppath  = '';
     var $iFileId  = 0;
     var $sExt     = '.wuf'; // WebmailUploadFile :o)
     var $pIndex   = 'index.wui';

     function upAttachment($sUSessId=''){
        global $user;

        // create path
        $this->pUppath = usersdir . $user .'/'. uploadfolder.'/';

        // create session
        if (!$sUSessId || !$this->validateusession($sUSessId))
           $this->createUSessId();
        else
           $this->sUSessId = $sUSessId;

        // create session dir
        mkdirtree($this->pUppath.$this->sUSessId);
     }

     /**
      * Validate UploadSession name
      */
     function validateusession($sUSessId){
        return ereg("^[a-z0-9]+$",strtolower($sUSessId));
     }

     /**
      * return unique HASH string (32 chars)
      */
     function uniqhash(){
		$id = md5(uniqid(chr(rand(65,90)).time()));
		$id = str_ireplace('e','o',$id);
		return $id;
     }

     /**
      * find missing sUSessId (dirname) in pUppath
      */
     function createUSessId(){
        while(1){
           $usessid = $this->uniqhash();
           if (!is_dir($this->pUppath.$usessid)) break;
        }
        $this->sUSessId = $usessid;
     }

     function getFileId(){
        $id = 0;
        if (@$handle = opendir($this->pUppath.$this->sUSessId)) {
           while (false !== ($file = readdir($handle))) {
                 if ($file != "." && $file != ".." && strpos($file,$this->sExt,1)) $id++;
           }
        }
        @closedir($handle);
        return $this->iFileId = $id;
     }

     /**
      * create hash from $name and $content-type
      * $ext is for message fw
      */
     function nameEncode($name,$type,$ext=''){

          $index = $this->readindex();

          if(!($this->iFileId = count($index))) $this->iFileId = 0;

          $hash = $this->iFileId.$this->uniqhash().$this->sExt;   // $this->getFileId()

          $index[$this->iFileId]['name'] = trim($name);

          if ($ext)
             $index[$this->iFileId]['ext'] = $ext;
		  elseif (strtolower(trim($type))=="message/rfc822")
             $type = "text/plain";

          $index[$this->iFileId]['type'] = trim($type);


          $this->writeindex($index);

        return $hash;
     }

     /**
      * create $name and $content-type from hash
      */
     function nameDecode($hash){
        //strip sExt
        $name = substr($hash,0,-strlen($this->sExt));
        //strip hash
        $id   = substr($name,0,-32);

        return $id;
     }

     function getAttachments(){

        $index = $this->readindex();
        if (!count($index)) return array();

        $path = $this->pUppath.$this->sUSessId;
        if (@$handle = opendir($path)) {
           while (false !== ($file = readdir($handle))) {
              if ($file == "." || $file == ".." || !strpos($file,$this->sExt,1)) continue;
              $files[] = $file;
           }
           @closedir($handle);
        }
        else return array();

        foreach ($files as $file){
           unset($item);
           $id   = $this->nameDecode($file);
           $item = $index[$id];
           $item['id']   = $id;
           $item['size'] = @filesize("$path/$file");
           $item['path'] = "$path/$file";

           // FW message is always on 1st postion
           if ($item['type']=='message/rfc822' && $items)
              array_unshift($items,$item);
           else
              $items[]=$item;
        }

        return $items;
     }

     function removeSession($sUSessId=''){
        $sUSessId = $sUSessId?$sUSessId:$this->sUSessId;
        if ($this->validateusession($sUSessId))
           deltree(uploadfolder.'/'.$sUSessId,1);
     }


     function readindex(){
        $path = $this->pUppath.$this->sUSessId.'/'.$this->pIndex;

        if (!file_exists($path)) return array();

        clearstatcache();

        if ($handle = fopen ($path, "rb")) {
           $contents = base64_decode(fread ($handle, filesize ($path)));
           fclose($handle);
           $out = unserialize($contents);
        }

        return $out?$out:array();
     }

     function writeindex($array){
        if(!is_array($array)) return false;

        $path = $this->pUppath.$this->sUSessId.'/'.$this->pIndex;

        if ($handle = fopen ($path, "wb")) {
           if (($in = serialize($array))) fwrite ($handle, base64_encode($in));
           fclose($handle);
        }
     }
  }


  function extractAttFromFile($file,$attachments,$sUSessId=null){

     $oAttach = new upAttachment($sUSessId);
     $fpath = $oAttach->pUppath.$oAttach->sUSessId.'/';


     foreach ($attachments as $attach) {
        rewind($file);
        if (($fitem = getattachment($file, $attach['INDEX'], true))) {

           $name = $oAttach->nameEncode($attach["NAME"],$attach["CONTENTTYPE"]);

           if ($name) {
              $handle = fopen ($fpath.$name, "wb");
              fwrite ($handle,$fitem);
              fclose ($handle);
           }
        }
     }

     return $oAttach->sUSessId;
  }

  function contentIcon($type){
     $fcontent1 = substr($type,0,strpos($type,"/"));
     $fcontent2 = substr($type,strpos($type,"/")+1);

     $ico = 'iconone';

     switch (strtolower($fcontent1)) {
            case 'image' :
                          switch ($fcontent2) {
                             case 'jpg': $ico = 'icojpg'; break;
                             case 'png': $ico = 'icopng'; break;
                             case 'gif': $ico = 'icogif'; break;
                             default   : $ico = 'icoimg';
                          }
                          break;
            case 'message' :
                          $ico = 'icomsg'; break;
            case 'application' :
                          switch ($fcontent2) {
                             case 'vnd.ms-excel': $ico = 'icoxls'; break;
                             case 'msword': $ico = 'icodoc'; break;
                             case 'vnd.visio': $ico = 'icovsd'; break;
                             case 'vnd.ms-powerpoint': $ico = 'icoppt'; break;
                             case 'x-javascript': $ico = 'icojs'; break;
                             case 'pdf': $ico = 'icopdf'; break;
                             case 'zip': $ico = 'icozip'; break;
                             case 'rar': $ico = 'icozip'; break;
                             case 'arj': $ico = 'icozip'; break;
                          }
                          break;
            case 'text' :
                          switch ($fcontent2) {
                             case 'plain': $ico = 'icotext'; break;
                             case 'htm'  : $ico = 'icohtml'; break;
                             case 'html' : $ico = 'icohtml'; break;
                          }
     }
     return $ico;
  }

/*******************************************************************************/

  // return certificate from mail
  function readcertificatefromsign($folder,$messageid)
  {
    global $user;
    if(!$user || !$folder || !$messageid || !($filename = getfolderpath($user, $folder, $messageid))) return false;
    $tmpfile = usersdir . $user. certificatetmp;

    if(!openssl_pkcs7_verify ($filename,PKCS7_NOVERIFY,$tmpfile)) return false;
    $handle = fopen ($tmpfile, "rb");
    $certificate = fread ($handle, filesize ($tmpfile));
    @fclose ($handle);
    @unlink($tmpfile);

    return $certificate;
  }

  // ADD CERTIFICATE TO CONTACT LIST
  function addcertificatefromsign($folder,$messageid,$from)
  {
     global $id,$user,$config,$otherconfig,$groupsessid;

     $from=getclearmail($from);
     if(!$from) return false;

     //GET full local addresses
     $addresses =getaddresses($id, 1,0,2);
     //GET short DB addresses
     if(!$otherconfig[DISABLESERVERADDRESS] && $otherconfig["FULLMERAK"])
     {
       if(file_exists("inc/function.calendar.php"))
         require_once("inc/function.calendar.php");
       else
         require_once("../inc/function.calendar.php");

       $sessid=logtocalendar($user,$config['EMAIL'],$config['PASS'],$xglob);
       $addresses = array_merge($addresses,getaddresses($id, 1,1,1));  //short DB
     }

     foreach($addresses as $key => $value)
     {
        if(is_array($value['EMAIL']))
        {
          foreach($value['EMAIL'] as $key2 => $value2)
          {
             if(!strcasecmp($value2,$from) && $value2)
             {
               $isin=$key;
               break;
             }
          }
        }
        elseif((!strcasecmp($value['EMAIL'],$from) && $value['EMAIL']) || (!strcasecmp($value['EMAIL2'],$from) && $value['EMAIL2']) || (!strcasecmp($value['EMAIL3'],$from) && $value['EMAIL3']))
        {
          $isin=$key;
          break;
        }
     }

     if(!isset($isin)) return false;

     $addresscertificate=readcertificatefromsign($folder,$messageid);

     if(strlen($addresses[$isin]['ID'])==12)
     {
       if(calendarfunctioncall("getContactCertificate",$groupsessid,$val['ID'])) return true;
       calendarfunctioncall("SetContactCertificate",$groupsessid,$addresses[$isin]['ID'],$addresscertificate);
     }
     else
     {
       if($addresses[$isin]['CERTIFICATE']) return true;
       $addresses[$isin]['CERTIFICATE']=$addresscertificate;
       saveaddresses($id,$addresses, 1);
     }

  return true;
  }


  function attachmentencode($attachment)
  {
    $attachment = strtr($attachment, "/\\", "__");
    return rawurlencode($attachment);
  }

        function displaymessage($file, $background, $messageid, $folder, $id, $header)
        {
          global $kb, $viewpage_messagetable,$showlite,$lang;
          $index = 0;
          $attachments = array();
          $back = '';

          if ($header == 1)
                  $back .= displaymessageheader($file, $background, $messageid, $folder, $id, $index, $attachments);
          elseif ($header == 2)
          {
                  $back .= displaymessageheadertags($file, $background, $messageid, $folder, $id, $index, $attachments);
                  $back .= eregi_replace('<a ','<a onclick="openerfix(this);return false;" ',displaymessagebody($file, $background, $messageid, $folder, $id, $index, $attachments));

                  if (count($attachments) > 0){
                     $back .= '<br><table><tr><td colspan="2"><hr size="1"><td></tr><tr><td>'.$lang['MSG_ATTACHMENT'].'</td><td>'.$lang[MSG_HEADER_LENGTH].'</td></tr>';
                     for ($i = 0; $i < count($attachments); $i++){
                             $attachments[$i]["NAME"]=ereg_replace("[:\\/]+","_",$attachments[$i]["NAME"]);
                             @eregi("(.+)\.(.+)$",$attachments[$i]["NAME"],$mirr);
                             if($mirr[2]) {
                               if(strlen($mirr[1])>32) $mirr[1]=substr($mirr[1],0,31)."..";
                               $attname = $mirr[1].'.'.$mirr[2];
                             }
                             else
                               $attname=$attachments[$i]["NAME"];

                             $back .= '<tr><td>'.$attachments[$i]["NAME"].'</td><td>'.((round(($attachments[$i]["SIZE"] * 100) / 1024)) / 100) . ' ' . $kb .'</td></tr>';
                     }
                     $back .= '</table>';
                  }
          }
          else
          {
              $back .= eregi_replace('<a ','<a onclick="openerfix(this);return false;" ',displaymessagebody($file, $background, $messageid, $folder, $id, $index, $attachments));

              if (count($attachments) > 0)
              {
                  global $viewpage_attachmenttable,$otheruser,$lang,$showlite;

                    $back .= '
                      <DIV >
                                <TABLE width="100%">
                                        <TR>
                                          <TD >
                                         <HR>';


                        for ($i = 0; $i < count($attachments); $i++)
                        {
                          $attachments[$i]["NAME"]=ereg_replace("[\\/]+","_",$attachments[$i]["NAME"]);
                          
                          
                          
                          @eregi("(.+)\.(.+)$",$attachments[$i]["NAME"],$mirr);
                          if($mirr[2]) {
                            if(strlen($mirr[1])>32) $mirr[1]=substr($mirr[1],0,31)."..";
                            $attname = $mirr[1].'.'.$mirr[2];
                          }
                          else
                            $attname=$attachments[$i]["NAME"];

                          $attname = str_replace("\r","",$attname);
                          $attname = str_replace("\n","",$attname);



                          if($otheruser["OLDSTYLEATTACH"] || !$showlite)
                          {
                             $back .= '
                                    <TABLE>
                                           <TR >
                                                   <TD>
                                                           <TABLE CELLSPACING="0" CELLPADDING="0" BORDER="0">
                                                           <TR>
                                                                   <TD ><A HREF="attachment.html?id=' . $id . '&name='. attachmentencode($attachments[$i]["NAME"]) .'&messageid=' . rawurlencode($messageid) . '&index=' . $attachments[$i]['INDEX'] . '&folder=' . rawurlencode($folder) .'"><IMG SRC="images/attach.gif" WIDTH="16" HEIGHT="21" BORDER="0"></A></TD>
                                                                   <TD ><IMG SRC="images/space.gif" WIDTH="3" HEIGHT="21"></TD>
                                                                   <TD ><A HREF="attachment.html?id=' . $id . '&name='. attachmentencode($attachments[$i]["NAME"]) .'&messageid=' . rawurlencode($messageid) . '&index=' . $attachments[$i]['INDEX'] . '&folder=' . rawurlencode($folder) .'" CLASS="link">'.$attname.'</A></TD>
                                                           </TR>
                                                           </TABLE>
                                                   </TD>
                                                   <TD CLASS="standardtext" >
                                                           <B>Content-Type: </B>'. $attachments[$i]["CONTENTTYPE"].' name="'. $attname.'"<BR>
                                                           <B>Content-Transfer-Encodings: </B>'. $attachments[$i]["ENCODING"].'<BR>
                                                           <B>'.$lang[MSG_HEADER_LENGTH].': </B>'.((round(($attachments[$i]["SIZE"] * 100) / 1024)) / 100) . ' ' . $kb .'
                                                   </TD>
                                           </TR>
                                    </TABLE>';
                          }
                          else
                          $jsattarr[]='["attachment.html?id='.$id.'&name='. attachmentencode($attachments[$i]["NAME"]) .'&messageid='.rawurlencode($messageid).'&index='.$attachments[$i]['INDEX'].'&folder='.rawurlencode($folder)."\",\r\n\"<b>$attname</b> (".((round(($attachments[$i]["SIZE"] * 100) / 1024)) / 100) . ' ' . $kb .')","","attach","",1]';

                          if($otheruser['SHOWATTIMAGES'] && eregi("image/",$attachments[$i]["CONTENTTYPE"]))
                          {
                             $picarray[$attachments[$i]["INDEX"]]["NAME"]=$attachments[$i]["NAME"];
                             $picarray[$attachments[$i]["INDEX"]]["SIZE"]=$attachments[$i]["SIZE"];
                          }
                        }

                        if(!$otheruser["OLDSTYLEATTACH"] && $showlite){
$back .='
<script language="javascript">
parent.CMenuData.view_attach=[
["'.$lang[MSG_MESSAGEATTACH].'","menu-header"],
'.join(",\r\n",$jsattarr).',["-"],
["","<input type=\"checkbox\" onclick=\"parent.fview.document.main.showattimages.checked=this.checked;WM_ContentMenu1[\'view_attach\'].popupMenuClose(); parent.fview.SendForm(\'main\');\" '.($otheruser['SHOWATTIMAGES']?'checked':'').'>'.$lang['MSG_SHOWATTPIC'].'","","cmform",4]
];
document.getElementById("attimg").style.display="inline";
</script>';
                        }



                       $back .= '</TD></TR></TABLE></DIV>
                          <DIV>
                            <input type="checkbox" name="showattimages" value="1" onclick="SendForm(\'main\');" '.($otheruser['SHOWATTIMAGES']?'checked':'').'><b>'.$lang['MSG_SHOWATTPIC'].'</b></DIV>
                       ';

                       if($otheruser['SHOWATTIMAGES'] && is_array($picarray))
                       {
                          $back .= '
                          <style>
                           #viewattpicdiv{
                             padding-bottom: 10px;
                             margin-bottom: 10px;
                           }
                           .vpicture{
                             float: left;
                             margin-top: 10px;
                             margin-right: 5px;
                             visibility: hidden;
                           }
                           .vpictureshow,.vpicturecontrol,.vpictureshow img{
                             border-width: 1px;
                             border-color: #808080;
                             border-style: solid;
                           }
                           .vpictureshow,.vpicturecontrol{
                             float: left;
                             clear: both;
                             background-color: #F2F2F2;
                           }
                           .vpictureshow,.vpicturecontrol .vp_name,.vpicturecontrol .vp_control{
                             padding-left: 3px;
                             padding-right: 3px;
                             padding-top: 3px;
                             padding-bottom: 3px;
                           }
                           .vpicturecontrol{
                             border-bottom-width: 0;
                           }
                             .vpicturecontrol .vp_name,.vpicturecontrol .vp_control
                             {
                               float: left;
                               padding-left: 6px;
                               padding-right: 6px;
                             }
                             .vpicturecontrol .vp_name{
                               font-weight: bold;
                               padding-right: 10px;
                               background-color: #808080;
                               color: white;
                             }
                             .vpicturecontrol .vp_size{
                               color: #808080;
                             }
                               .vpicturecontrol .vp_size,.vpicturecontrol .vp_size span{
                                 cursor: default ! important;
                               }
                             .vpicturecontrol .vp_control span{
                               cursor: pointer;
                             }
                             .vpicturecontrol span[onclick]{
                               cursor: pointer;
                             }
                          </style>

                          <script language="javascript">
                             var original = new Array();

                             function picresize(imgid,rtype)
                             {
                               if(!original[imgid])
                               {
                                 var xy = new Array();
                                 xy["x"]=document.images["shimg_"+imgid].width;
                                 xy["y"]=document.images["shimg_"+imgid].height;
                                 xy["xo"]=document.images["shimg_"+imgid].width;
                                 xy["yo"]=document.images["shimg_"+imgid].height;
                                 original[imgid]=xy;
                               }

                               if(rtype=="start"){
                                 if(original[imgid]["x"]>349)
                                   rtype=(Math.ceil(100/(original[imgid]["x"]/35))*10);
                                 else
                                 {
                                   document.getElementById("vpid_"+imgid).style.visibility="visible";
                                   return;
                                 }
                               }

                               if(rtype=="-")
                               {
                                 if((original[imgid]["xo"] - Math.round(original[imgid]["x"]/10))<350 && original[imgid]["x"]>349)
                                   return;
                                 else if(original[imgid]["x"]<350 && (original[imgid]["xo"] - Math.round(original[imgid]["x"]/10))< original[imgid]["x"])
                                   return;

                                 document.images["shimg_"+imgid].style.width = original[imgid]["xo"] = original[imgid]["xo"] - Math.round(original[imgid]["x"]/10);
                                 document.images["shimg_"+imgid].style.height = original[imgid]["yo"] = original[imgid]["yo"] - Math.round(original[imgid]["y"]/10);
                                 document.getElementById("vptxt_"+imgid).innerHTML = document.getElementById("vptxt_"+imgid).innerHTML - 10;
                                 return;
                               }
                               else
                               if(rtype=="+")
                               {
                                 document.images["shimg_"+imgid].style.width = original[imgid]["xo"] = original[imgid]["xo"] + Math.round(original[imgid]["x"]/10);
                                 document.images["shimg_"+imgid].style.height = original[imgid]["yo"] = original[imgid]["yo"] + Math.round(original[imgid]["y"]/10);
                                 document.getElementById("vptxt_"+imgid).innerHTML = (document.getElementById("vptxt_"+imgid).innerHTML*1) + 10;
                                 return;
                               }
                               else
                               {
                                 document.images["shimg_"+imgid].style.width = original[imgid]["xo"] = Math.round(original[imgid]["x"]*(rtype/100));
                                 document.images["shimg_"+imgid].style.height = original[imgid]["yo"] = Math.round(original[imgid]["y"]*(rtype/100));
                                 document.getElementById("vptxt_"+imgid).innerHTML = rtype;
                               }
                               document.getElementById("vpid_"+imgid).style.visibility="visible";
                             }
                          </script>
                          <hr>
                          <div id="viewattpicdiv" '.($showlite==2?'style="position: absolute;"':'').'>';
                          foreach($picarray as $k => $v)
                          {
                            $back .= '<div class="vpicture" id="vpid_'.$k.'">
                            <div class="vpicturecontrol"><div class="vp_name">'.htmlspecialchars($v['NAME']).'</div><div class="vp_control">[<span onclick="picresize(\''.$k.'\',\'-\');">-</span>] <span class="vp_size"><span id="vptxt_'.$k.'">100</span>%</span> [<span onclick="picresize(\''.$k.'\',\'+\');">+</span>] [<span onclick="picresize(\''.$k.'\',\'150\');">150%</span>] [<span onclick="picresize(\''.$k.'\',\'100\');">100%</span>] [<span onclick="picresize(\''.$k.'\',\'50\');">50%</span>]</div></div>
                            <div class="vpictureshow"><img name="shimg_'.$k.'" src="attachment.html?name='.attachmentencode($v['NAME']).'&id='.$id.'&messageid='.rawurlencode($messageid).'&index='.$k.'&folder='.rawurlencode($folder).'" alt="'.htmlspecialchars($v['NAME']).'" onload="picresize(\''.$k.'\',\'start\');"></div>
                            </div>';
                          }
                          if($showlite!=2) $back .= '</div><div style="clear: both;">&nbsp;</div>';
                       }
              }
          }
          fclose($file);
          return $back;
        }













  $mimepartresult = "";
  $replytype = "";
  $replydone = "";

  function getmimepart($file, $boundary, &$index, $type, &$param, $first = false, $rfc822 = false, $background = "", $messageid = "", $folder = "", $id = "", $boundaryend = "",$tovarx = "")
  {
    global $otherconfig, $mimepartresult, $replytype, $replydone,$tovar,$output;

    if ($tovarx){
       $tovar = 1;
       $output = null;
    }

    $dotcheck = false;
    $multipartalternative = false;
    $fprint = true;


    if (strpos($type, calternative))
    {
      $multipartalternative = true;
      $type = substr($type, 0, strpos($type, calternative));
    }
    if (($otherconfig["FULLMERAK"]) && (directmerak)) $dotcheck = true;

    if ($boundary  || ($index == 0) || $rfc822) { if ($boundary) $boundary = "--" . $boundary; $state = false; } else $state = "TEXT";
    $fdone = false;
    $noattach = false;

    $result = "";
    $fmime = false;

    while (!feof($file))
    {
      $line = fgets($file, 1024);

      if ($dotcheck && $line[0] == ".")
      {
        if (strlen(trim($line)) > 1) $line = substr($line, 1, strlen($line) - 1); else $line = fgets($file, 1024);
        if (feof($file)) continue;
      }

      if ($fmime) if (feof($file)) break;
      $fmime = false;

      if (!$state)
      {
        if ((strtolower(trim($line)) == strtolower($boundary)) || ($index == 0) || ($rfc822))
        {
          $contenttype = "";
          $charset = "";
          $encoding = "";
          $name = "";
          $xboundary = "";

          while (getheaderline($file, $header, $line)) getmimetypes($header, $line, $contenttype, $charset, $encoding, $name, $xboundary, $contentid);

		  $contenttype = strtolower($contenttype);
          if($contenttype == "message/rfc822") $name = "";

          $index++;

          if ($xboundary)
          {
            $ftype = $type;
            if ($contenttype == "multipart/alternative") $ftype = $ftype . calternative;
            $mimepartresult .= getmimepart($file, $xboundary, $index, $ftype, $param, false, false, $background, $messageid, $folder, $id);
            $state="ATTACHMENT";
            $fmime = true;
          }
          else
          {
            if (strtolower($encoding) == "7bit") $encoding = "";

            if ($name)
            {
              if ($contenttype == "application/x-pkcs7-mime")
              {
                include("function.pkcs7mime.php");

                $state = false;
                continue;
              }
              else
                $state = "BOUNDARY";
            }
            else
            if (($contenttype == "text/plain") || (!($contenttype)) || (substr($contenttype, 0, 8) == "message/"))
            {
              if ($contenttype == "message/rfc822")
              {
                if ($type == "MESSAGE")
                {
                  $mimepartresult .= textdelimiter . displaymessageheadertags($file, $background, $messageid, $folder, $id, $index, $param);
                }

                $ftell = ftell($file);
                $contenttype = "";
                $charset = "";
                $encoding = "";
                $xboundary = "";
                $contentid = "";
                $name = "";
                while (getheaderline($file, $header, $line)) getmimetypes($header, $line, $contenttype, $charset, $encoding, $name, $xboundary, $contentid);

                fseek($file, $ftell);
                $contenttype = strtolower($contenttype);
                if($contenttype == "message/rfc822") $name = "";

                $ftype = $type;
                if ($contenttype == "multipart/alternative") $ftype = $ftype . calternative;
                getmimepart($file, $xboundary, $index, $ftype, $param, false, true, $background, $messageid, $folder, $id, $boundary);

                $state = false;

                continue;
              }
              else
                $state = "TEXT";
            }
            else
            if ($contenttype == "text/html") $state = "HTML";
            else
            if (strpos("." . $contenttype, "text")) $state = "TEXT";
            else
              $state = "BOUNDARY";

           if ($type == "REPLY" && $replydone) break;


            switch ($state)
            {
              case "TEXT":
              case "HTML":
              {
                if ($type == "MESSAGE")
                {
                  if ($multipartalternative)
                    if ($state == "HTML")
                    {
                      $fprint = true;
                      $displayed = true;
                    }
                    else
                      $fprint = false;

                  if ($index > 2) if (!($first)) if ($fprint && (!($multipartalternative))) $mimepartresult .= textdelimiter;
                }
                break;
              }
              case "BOUNDARY":
              {
                if (($type == "MESSAGE") || ($type == "REPLY"))
                {
                  if (!$name) $name = unknown;
                  /*
                  if (!(strpos($name, "."))){
                    echo $name .= ".";
                     if ($slpos = strpos($contenttype,"/"))
                        $name .= substr($contenttype,$slpos+1);
                  }
                  */

				  $attachment["INDEX"] = $index;
                  $attachment["NAME"] = $name;
                  $attachment["CONTENTTYPE"] = $contenttype;
                  $attachment["ENCODING"] = $encoding;
                  $attachment["SIZE"] = 0;

                  if ($type == "REPLY")
                  {
                    global $replyattachments;
                    $replyattachments[] = $attachment;
                  }
                  else
                    $param[] = $attachment;
                }
                else
                if ($type == "ATTACHMENT")
                {
                  $xproceedboundary = false;
                  if ($contentid) if ($param == $contentid) $xproceedboundary = true;

                  if ($index == $param || $xproceedboundary)
                  {
                    if (!$name) $name = unknown;
                    /*
                    if (!(strpos($name, "."))){
                       $name .= ".";
                       if ($slpos = strpos($contenttype,"/"))
                          $name .= substr($contenttype,$slpos+1);
                    }
                    */
                    $name=ereg_replace("[:\\/]+","_",$name);

                    if(!$tovar) {

                      // Opera doesnt accept octet-stream
                      $bname  = basename($name);
                      $bname  = str_replace("\n","",$bname);
                      $bname  = str_replace("\r","",$bname);

					if (strpos($_SERVER['HTTP_USER_AGENT'],"MSIE")>0 && strpos(strtolower($_SERVER['HTTP_USER_AGENT']),"opera")===false)
						$bname = urlencode($bname);

                      header("Content-Type: ".($contenttype=='application/octet-stream'?'application/x-download':$contenttype)."; charset=utf-8");
                      header('Content-Disposition: attachment; filename="' . $bname . '"');
/*
                      if (strpos($bname,"\r")===true || strpos($bname,"\n")===true){
                          $bname  = str_replace("\r\n","\n",$bname);
                          $bname  = str_replace("\r","\n",$bname);
                          $bnames = explode("\n",$bname);
                          foreach($bnames as $k => $val){
                             if (!$k)
                                header('Content-Disposition: attachment; filename="' . basename($name) . '"');
                          }
                      }
                      else
                          header('Content-Disposition: attachment; filename="' . basename($name) . '"');
*/
                    }
                    $fdone = true;
                  }
                }
                break;
              }
            }
          }
        }
      }
      else
      {

        if ($boundaryend) if (strstr(strtolower(trim($line)), strtolower($boundaryend))) if (strtolower(trim($line)) == strtolower($boundaryend) . "--") break;
        if ($boundary) if (strstr(strtolower(trim($line)), strtolower($boundary)))
        {
          if (strtolower(trim($line)) == strtolower($boundary) . "--") break;
          if ($fdone) if ($type == "ATTACHMENT") break;
          $state = $false;
          fseek($file, ftell($file) - strlen($line));
          continue;
        }

        $fuuattach = false;
        if ($type == "ATTACHMENT")
        {
          if (strpos("." . $param, cindex) == 1) $fuuattach = true;
          if (!$fuuattach && !$fdone) continue;
        }
        else if ($state == "BOUNDARY")
        {
          $xsize = strlen($line) - 2;
          $xsize = round(($xsize / 4) * 3);
          if ($type == "MESSAGE")
          {
            if (!($noattach)) $param[count($param) - 1]["SIZE"] += $xsize;
          }
          else
          if ($type == "REPLY")
          {
            if (!$noattach) $replyattachments[count($replyattachments) - 1]["SIZE"] += $xsize;
          }
          continue;
        }

        if ($encoding)
        {
          if (strtolower($encoding) == strtolower("base64")) $line = base64_decode($line);
          else
          if (strtolower($encoding) == strtolower("quoted-printable"))
                                        {
            $crlf = true;
            $line = rtrim($line);
            if (strlen($line) > 0)
            {
              if ($line[strlen($line) - 1] == "=") { $line = substr($line, 0, strlen($line) - 1); $crlf = false; }
              $line = convertquoted($line, false);
            }
            if ($crlf) $line = $line . "\r\n";
                                  }
        }
        else
        // Uuencode checking
        if (strpos(strtolower($line), cbegin)===0 && ereg("^".cbegin."{1}[0-9]{3}[ ]{1}",strtolower($line)))
        {
          $line = trim(str_replace("  ", " ", $line));
          list($f1, $flen, $xline) = explode(" ", $line, 3);
          if (!(intval($flen))) $xline = "";
          if ($xline)
          {
            $name = $xline;
            if (!(strpos($name, "."))) $name .= ".";
            $fdouuattach = false;

            if (!$fuuattach)
            {
              $attachment["INDEX"] = cindex . $name;
              $attachment["NAME"] = $name;
              $attachment["CONTENTTYPE"] = "";
              $attachment["ENCODING"] = "";
              $attachment["SIZE"] = 0;
            }
            else
            if ($param == cindex . $name)
            {
              $fdouuattach = true;
              if(!$tovar)
              {
                header("Content-Type: application/octet-stream");
                header("Content-Disposition: attachment; filename=\"" . basename($name) . "\"");
              }
            }

            while (!feof($file))
            {
              $line = ltrim(fgets($file, 1024));
              if (strtolower(trim($line)) == cend) break;

              if ($fuuattach)
              {
                if ($fdouuattach)
                {
                  $line = uudecode($line);
                  if($tovar) $output.=$line; else echo $line;
                }
              }
              else
                $attachment["SIZE"] += round(strlen($line) * 3 / 4);
            }

            
            if (!($fuuattach))
            {
              if ($type == "REPLY")
              {
                global $replyattachments;
                $replyattachments[] = $attachment;
              }
              else{
                if(!is_array($param)) unset($param);
                $param[] = $attachment;
              }
            }

            continue;
          }
        }


        if ($fuuattach) continue;

        if ($type != "ATTACHMENT") $line=charsetconvert($line,$charset,mycharset); //&& strcasecmp(mycharset,"us-ascii")

        if ($type == "REPLY")
        {
          if ($state == "TEXT" || ($state == "HTML" && $replytype == $state))
          {
            $mimepartresult .= $line;
            $replydone = $state;
          }
          continue;
        }
        else
        if ($type == "MESSAGE")
        {
          if ($state == "TEXT")
            $line = nl2br(sp2nbsp(formatmessage(htmlspecialchars($line))));
          elseif ($state == "HTML")
          {
            // Reset BASE HREF
            if (!(($xpos = strpos(strtolower($line), basehref)) === false)) $line[$xpos + 1] = "!";
            if (!(($xpos = strpos(strtolower($line), "<t:set")) === false)) $line[$xpos + 1] = "!";
            // Remove Script
            $line= eregi_replace("<script",'<div style="display:none;" ',$line);
            $line= eregi_replace("</script","</div",$line);
            // Remove Object
            $line= eregi_replace("<object",'<div style="display:none;" ',$line);
            $line= eregi_replace("</object","</div",$line);

            if ($cidp = strpos(strtolower($line), cidtext))
              if (($line[$cidp - 1] == "\"") || ($line[$cidp - 1] == "=")) $line = getcidstring($file, $encoding, $line, $folder, $messageid, $id);
          }
        }

        if ($fprint)
        {
          if ($type == "ATTACHMENT"){ if($tovar) $output.=$line; else echo $line; }else $mimepartresult .= $line;
        }
        else if ($multipartalternative && !$displayed) if ($type == "MESSAGE") $textmimepartresult .= $line;
      }
    }
    if ($multipartalternative && !$fprint && !$displayed) if ($type == "MESSAGE") $mimepartresult .= $textmimepartresult;

    if ($tovar) return $output;
  }


  function getmessagetext($file, $messageid, $folder, $id, &$index, &$attachments, $boundary, $background)
  {
    global $mimepartresult;
    $mimepartresult = "";

    getmimepart($file, $boundary, $index, "MESSAGE", $attachments, true, false, $background, $messageid, $folder, $id);

    if (strpos($mimepartresult, "\x00")) $mimepartresult = str_replace("\x00", "", $mimepartresult);

    return $mimepartresult;
  }

  function getattachment($file, $findex, $tovar=false)
  {
    global $output; $output=null;

    $index = 0;
    $output = getmimepart($file, "", $index, "ATTACHMENT", $findex, $x, $x, $x, $x, $x, $x, $x, $tovar);
    if($tovar) return $output;
  }

  function getreplytext($file, $replyline, $html = false)
  {
    global $mimepartresult, $replyattachments, $kb, $replytype, $replydone,$htmlpresent;

    $replyattachments = array();

    //GET TEXT PART
    if ($html) $replytype = "HTML"; else $replytype = "";
    unset($background, $messageid, $folder, $id, $attachments);
    rewind($file);
    $index = 0;
    getmimepart($file, "", $index, "REPLY", $replyline);

    if (strpos($mimepartresult, "\x00")) $mimepartresult = str_replace("\x00", "", $mimepartresult);
    $mimeparttext=$mimepartresult;

    //GET HTML PART
    if ($html) $replytype = "HTML"; else $replytype = "";
    unset($background, $messageid, $folder, $id, $attachments);
    rewind($file);
    $index = 0;
    global $display_contenttype;
    $mimeparthtml = displaymessageitem($file, $background, $messageid, $folder, $id, $index, $replyattachments);

    if ($display_contenttype=="text/plain")
       unset($mimeparthtml);
    elseif($mimeparthtml)
       $htmlpresent = true;

    //select source type
    if($html)
    {
       if(trim($mimeparthtml)=="" && trim($mimeparttext)!=="")
         $mimebody = nl2br($mimeparttext);
       else{

        /* if (($pos = strpos($mimeparthtml,"<body")))
            $mimeparthtml = substr($mimeparthtml,$pos);

         if (($pos = strpos($mimeparthtml,"</body")))
            $mimeparthtml = substr($mimeparthtml,0,$pos).'</body>';

         $mimeparthtml = preg_replace("/(\<style)(.*?)(style>)/si", "", $mimeparthtml);
         */

         $mimeparthtml = preg_replace("/(\<script)(.*?)(script>)/si", "", $mimeparthtml);
         $mimebody = $mimeparthtml;
       }
    }
    else
    {
       if (trim($mimeparttext)=="" && trim($mimeparthtml)!=="")
          $mimebody = $replyline.removehtml($mimeparthtml);
       else
          $mimebody = $replyline.$mimeparttext;

         $mimebody = str_replace("\r\n","\n",$mimebody);
         $mimebody = str_replace("\r","\n",$mimebody);
         $mimebody = str_replace("\n","\r\n$replyline",$mimebody);
    }

    //print
/*
    if ($html)
      $result = '<BR><BLOCKQUOTE dir=ltr style="PADDING-RIGHT: 0px; PADDING-LEFT: 5px; MARGIN-LEFT: 5px; BORDER-LEFT: #000000 2px solid; MARGIN-RIGHT: 0px">' . $mimebody . '</BLOCKQUOTE>';
    else
*/

/*
    if (count($replyattachments))
    {
      $result .= $replyline . "----------------------------------------------------\r\n";
      for ($i = 0; $i < count($replyattachments); $i++)
      {
        $result .= $replyline . "     Name: " . $replyattachments[$i]["NAME"] . "\r\n";
        $result .= $replyline . "     Type: " . $replyattachments[$i]["CONTENTTYPE"] . "\r\n";
        $result .= $replyline . " Encoding: " . $replyattachments[$i]["ENCODING"] . "\r\n";
        $result .= $replyline . "   Length: " . ((round(($replyattachments[$i]["SIZE"] * 100) / 1024)) / 100) . " " . $kb . "\r\n";

        if ($i <> (count($replyattachments) - 1)) $result .= $replyline . "\r\n";
      }
    }
*/
    return $mimebody;
  }


        function displaymessageitem($file, $background, $messageid, $folder, $id, &$index, &$attachments)
        {
                global $display_contenttype;
                getusersession($id, $user, $config);

                $tell = ftell($file);

                $contenttype = "";
                $charset = "";
                $encoding = "";
                $name = "";
                while (getheaderline($file, $header, $line)){
                  getmimetypes($header, $line, $contenttype, $charset, $encoding, $name, $boundary, $contentid);
                }
                fseek($file, $tell);
                $display_contenttype = $contenttype;
				return getmessagetext($file, $messageid, $folder, $id, $index, $attachments, $boundary, $background);
        }

        function addFieldDiv($text){
            if(strlen(strip_tags($text))>250)
              return '<div class="scrollfield">'.$text.'</div>';
            else
              return $text;
        }

        function displaymessageheader($file, $background, $messageid, $folder, $id, &$index, &$attachments)
        {
          global $viewpage_headerlist, $showfullheaders,$otherconfig,$showlite,$lang,$skin_dir;

                getusersession($id, $user, $config);

                $colors = split("," , $background);
                $oddrow_color = $colors[0];
                $evenrow_color = $colors[1];

                $tell = ftell($file);

                $contenttype = "";
                $charset = "";
                $encoding = "";
                $name = "";

                $findex = 0;

                if($showlite==2)
                {
                  $shx='target="_parent"';
                }

              $back ='';

              if( $showfullheaders)
              {
                $back='<tr><td colspan="2">
                <div style="padding-right:50px; float: right;overflow: visible">
                <div style="position: absolute;white-space: nowrap;">
                '.(!$otheruser["OLDSTYLEATTACH"] && $showlite?'<IMG SRC="images/attach2.gif" id="attimg" style="cursor:pointer;display: none;" oncontextmenu="return false;" onmousedown="if(!window || !window.event || window.event.button==\'2\') return false;initCmenu(\'view_attach\',this,2);return false;">':'').'
                <IMG SRC="images/certificate.gif" id="certimg" style="display: none;">
                </div>
                </div>
                <td></tr>';
              }

                while (getheaderline($file, $header, $line))
                {
                        if (strpos($line, "\x00")) $line = trim(str_replace("\x00", "", $line));

                        getmimetypes($header, $line, $contenttype, $charset, $encoding, $name, $boundary, $contentid);

                        if ($showfullheaders || (strtolower($header) == "subject:") || (strtolower($header) == "date:") || (strtolower($header) == "from:") || (strtolower($header) == "to:") || (strtolower($header) == "cc:") || (strtolower($header) == "bcc:"))
                        {
                                if ((strtolower($header) == "from:") || (strtolower($header) == "to:") || (strtolower($header) == "reply-to:") || (strtolower($header) == "cc:") || (strtolower($header) == "bcc:") || (strtolower($header) == "in-reply-to:"))
                                        $line = getmail($line, $id,strtolower($header),$otherconfig["FULLMERAK"],$signed);
                                else {
                                        $line = htmlspecialchars($line);
                                        if (strtolower($header) == "subject:") $line = formatmessage($line);
                                }

                                if ($findex%2==0) $bgcolor = $oddrow_color; else $bgcolor = $evenrow_color;

                                if(!$showfullheaders)
                                     $headerArr[strtolower($header)] = $line;
                                else
                                     $back .='
                                     <TR BGCOLOR="'. $bgcolor.'">
                                             <TD NOWRAP CLASS="standardtext" ALIGN="right" valign="top" width="0%" nowrap><B>'. $header .'</B></TD>
                                             <TD VALIGN="top" CLASS="standardtext" ALIGN="left" width="100%">'. $line.'</TD>
                                     </TR>';

                                $findex++;
                        }
                        elseif (!$headerArr['date'] && strtolower($header) == "received:"){

							 $line = trim(substr($line,strpos($line,';')+1));

                             if (strpos($line, ":")>-1)
                                $headerArr['date:'] = $line;
						}
                        
                        if($contenttype=="multipart/signed" && !$addcer)  $addcer=1;
                }


                if(is_array($headerArr))
                {
                                     $back .='
                                     <TR valign="top">
                                        <TD width="0%"  nowrap><B>'. $lang['HEADER_FROM'] .' :</B></TD>
                                        <TD width="100%">
                                          <TABLE cellpadding="0" cellspacing="0">
                                             <TR CLASS="standardtext" valign="top">
                                             <TD width="100%">'. $headerArr['from:'].'</TD>
                                             <TD width="0%" nowrap><B>&nbsp;'. $lang['HEADER_DATE'] .' :</B>&nbsp;</TD>
                                             <TD width="0%" nowrap>'. $headerArr['date:'].'</TD>
                                             </TR>
                                          </TABLE>
                                        </TD>
                                     </TR>
                                     <TR CLASS="standardtext" valign="top">
                                        <TD nowrap><b>'. $lang['HEADER_TO'] .' :</b></TD>
                                        <TD>
                                          <TABLE cellpadding="0" cellspacing="0" width=100%>
                                             <TR CLASS="standardtext" valign="top">
                                             <TD width="100%">'. addFieldDiv($headerArr['to:']).'</TD>
                                             <TD width="0%" nowrap>

                '.(!$otheruser["OLDSTYLEATTACH"] && $showlite?'<IMG SRC="images/attach2.gif" id="attimg" style="cursor:pointer;display: none;" oncontextmenu="return false;" onmousedown="if(!window || !window.event || window.event.button==\'2\') return false;initCmenu(\'view_attach\',this,2);return false;">':'').'
                <IMG SRC="images/certificate.gif" id="certimg" style="display: none;">

                                             </TD>
                                             </TR>
                                          </TABLE>
                                        </TD>
                                     </TR>'.($headerArr['cc:']?'
                                     <TR CLASS="standardtext" valign="top">
                                        <TD nowrap><b>'. $lang['HEADER_CC'] .' :</b></TD>
                                        <TD>'.addFieldDiv($headerArr['cc:']).'</TD>
                                     </TR>':'').($headerArr['bcc:']?'
                                     <TR CLASS="standardtext" valign="top">
                                        <TD nowrap><b>'. $lang['HEADER_BCC'] .' :</b></TD>
                                        <TD>'.addFieldDiv($headerArr['bcc:']).'</TD>
                                     </TR>':'').'
                                     <TR CLASS="standardtext" valign="top">
                                        <TD nowrap><b>'. $lang['HEADER_SUBJECT'] .' :</b></TD>
                                        <TD>'.wordwrap($headerArr['subject:'], 150 ," ",1).'</TD>
                                     </TR>';
                }

                if($addcer)
                   $back.='<script language="javascript">document.getElementById("certimg").style.display="inline";</script>';


                fseek($file, $tell);
        return $back;
        }


        function displaymessageheadertags($file, $background, $messageid, $folder, $id, $index, &$attachments)
        {
        global $viewpage_headerlist;
        $back ='';
        $back .= '
              <DIV >
              <TABLE>
              <TR><TD>
              <table>
                                    '. displaymessageheader($file, $background, $messageid, $folder, $id, $index, $attachments).'
              </TABLE>
              </TD></TR>
              </TABLE>
              </DIV>';
        return $back;
        }

        function displaymessagebody($file, $background, $messageid, $folder, $id, $index, &$attachments)
        {
                global $viewpage_messagetable;
        $back = '
        <DIV>
                <TABLE width="100%">
                <TR >
                  <TD  VALIGN="top" CLASS="standardtext">
                  '.cleanHTML(displaymessageitem($file, $background, $messageid, $folder, $id, $index, $attachments)).'
                  </TD>
                </TR>
        </TABLE>
        </DIV>
        ';

        return $back;
        }

  function getmimetypes($header, $line, &$contenttype, &$charset, &$encoding, &$name, &$boundary, &$contentid)
  {
    if ((strtolower($header) == strtolower("Content-Type:")) || (strtolower($header) == strtolower("Content-Disposition:")))
    {

      if ($x = getheaderitem($line, boundarystr))
      {
       $boundary = strtolower($x);
      }
      else
      if ($x = getheaderitem($line, namestr)){
		$name = getheader($x);
      }
      else
      if ($x = getheaderitem($line, filenamestr))
        $name = getheader($x);
      else
      if ($x = getheaderitem($line, charsetstr))
        $charset = strtolower($x);

      if (strtolower($header) == strtolower("Content-Type:"))
      {
        $x = strtr($line, ",;\"", "   ");
        list($contenttype) = explode(" ", trim($x) . " ");
      }
    }
    else
    if (strtolower($header) == strtolower("Content-Transfer-Encoding:"))
    {
      $encoding = trim($line);
    }
    else
    if (strtolower($header) == strtolower("Content-ID:"))
    {
      $contentid = trim($line);
      $contentid = substr($contentid, 1, strlen($contentid) - 2);
    }
  }

  function formatmessage($message)
  {
    if (strpos(strtolower($message), "http://")>-1) $message = replaceurl($message, "http://");
    if (strpos(strtolower($message), "https://")>-1) $message = replaceurl($message, "https://");
    if (strpos(strtolower($message), "ftp://")>-1) $message = replaceurl($message, "ftp://");
    if (strpos(strtolower($message), "mailto:")>-1) $message = replaceurl($message, "mailto:");

    return $message;
  }

  // changed 09.08.05
  function getheaderitem($header, $item)
  {
    $item = strtolower($item);
    $x = strpos(strtolower($header), $item);
    if (!($x)) return false;
/*
    $value = substr($header, $x,  strlen($header) - $x);
    $value = substr($value, strlen($item), strlen($value) - strlen($item));
*/
    $value = substr($header, $x+strlen($item));
    $value = strtr($value, ";", "\"") . "\"";
    if ($value[0] == "\"") $value = substr($value, 1);
    $value = trim(substr($value, 0, strpos($value, "\"")));

    return $value;
  }

  function sp2nbsp($value)
  {
    for ($i = 0; $i < strlen($value); $i++) if ($i > 0) if (($value[$i] == " ") && (($value[$i - 1] == " ") || ($value[$i - 1] == "\x00"))) $value[$i] = "\x00";
    return str_replace("\x00", "&nbsp;", $value);
  }

?>