<?php
  // Checks if user authorized
  //
  // $flags is an array of flags
  //        [ADMIN] - user must be administrator
  //
  // returns true if authenticated

  function http_authenticate($flags) {

    $result = false;

    // Start php session
    session_start();

    // Check authorization
    $result = $_SESSION['authorized'];

    // Check headers
    if (!$result)
    {
      // Check auth header
      if ($_SERVER['HTTP_AUTHORIZATION'])
      {
        // Explode
        list($scheme, $text) = explode(' ', $_SERVER['HTTP_AUTHORIZATION']);
  
        // Get username and password
        $text = base64_decode($text);
        list($username, $password) = explode(':', $text);

        // Check account api
        require('api/account.php');
        $account = new MerakAccount();

        // Authenticate via api
        $result = $account->AuthenticateUser($username, $password, $SERVER_NAME);

        // User authenticated
        if ($result) {
             
          // Check if admin
          if ($flags[ADMIN]) $result = $account->GetProperty('u_admin');
        }
      }
    }
  
    // Set session
    $_SESSION['authorized'] = $result;

    // Send http authorization request
    if (!$result)
    {
      header('Status: 401 Access Denied');
      header('Authorization: Basic');
      header('WWW-Authenticate: Basic realm="API RPC"');
 
      exit();    
    }    

    return $result;
  }
?>