<?php

  // Handles the call request parsed by rpc_request() function
  //
  // $call is an array with multiple calls, methods and params
  //
  // returns an array with results for each call for rpc_result() function
  //

  function handle_api_call(&$call) {

    // Method format "classinstance->methodname"   
    if (ereg('(^.*)(\.|->)([[:alnum:]_]+)', $call[METHOD], $regs)) {

      // Instance and method
      $instance = $regs[1];
      $method = $regs[3];

    // Instance not specified
    } else {

      // Method
      $method = $call[METHOD];

      // Instance     
      $instance = 0;
    }   

    // Call API function
    $result[METHOD] = $call[METHOD];
    if (!count($call[PARAMS])) 
      $result[PARAMS][] = icewarp_controlapiobjectcall((string)$instance, (string)$method); 
    else
      $result[PARAMS][] = icewarp_controlapiobjectcall((string)$instance, (string)$method, (string)$call[PARAMS][0], (string)$call[PARAMS][1], (string)$call[PARAMS][2], (string)$call[PARAMS][3], (string)$call[PARAMS][4]);

    // Return
    return $result;  
  }
?>
