<?php
//Zkladn tda pro komunikaci s Merak GroupWare a ukldn pomocnch dat v prosted libovoln SQL databze
//Base clase for communication with Merak GroupWare and for storing service data in any SQL database

include_once 'api.php';
include_once 'account.php';
include_once 'gw.php';
include_once 'database.php';
include_once 'mail.php';
include_once 'backup.php';

//************************************************************

define('catSyncML',10);
$item_types=array('C'=>'Contacts','E'=>'Events','F'=>'Files','J'=>'Journals','M'=>'Mails','N'=>'Notes','T'=>'Tasks');
$datastore_formats=array('C'=>array('pref'=>'text/vcard','sif'=>'sif/contact','vob'=>'text/x-vcard'),
                         'E'=>array('pref'=>'text/calendar','sif'=>'sif/calendar','vob'=>'text/x-vcalendar'),
                         'F'=>array('pref'=>'application/*','sif'=>'application/*','vob'=>'application/*'),
                         'J'=>array('pref'=>'text/x-vjournal','sif'=>'sif/journal','vob'=>'text/x-vjournal'),
                         'M'=>array('pref'=>'text/message','sif'=>'application/vnd.omads-email+xml','vob'=>'text/message'),
                         'N'=>array('pref'=>'text/plain','sif'=>'sif/note','vob'=>'text/plain'),
                         'T'=>array('pref'=>'text/calendar','sif'=>'sif/task','vob'=>'text/x-vcalendar'));
                         
$format_versions=array('text/x-vcard'=>'2.1',
											 'text/vcard'=>'3.0',
											 'text/x-vcalendar'=>'1.0',
											 'text/calendar'=>'2.0');                         
                         
$folder_aliases=array('calendar'=>'Events');

//************************************************************

class datastore
{
	var $_password;
	var $_api;
	var $_gw;
  var $_gsid;
  var $_fsid;
  var $_imap;
  var $_backup;
  var $_sync_data;
  var $_db;
  
  var $_registered;
  var $_push;
  var $_notif;
  var $_device_id;
  var $_object_folder;
  var $_object_type;
  var $_object_format;
  var $_saved_format;
  var $_backup_format;
  var $_htmlspecialchars;
  var $_slow_sync;
	var $_special_sync;
	var $_max_place;
	var $_max_object;
	var $_free_place;
  var $_all_items;
  var $_more_data;

  var $_local_next_anchor;
  var $_remote_next_anchor;

//************************************************************

  function datastore()
  {
    $this->_gw=new MerakGWAPI();
		$this->_imap=new IMAP();
		$this->_backup=new Backup();
    $this->_fsid=array();
    $this->_registered=false;
    $this->_remote_next_anchor=array();
    $this->_object_format=array();
    $this->_saved_format=array();
    $this->_more_data=array();
  }

  function __destruct()
  {
		unset($this->_api);
		unset($this->_db);
	}

//******************************************************************
// Pomocn funkce pro komunikaci s API and GroupWare
// Supplementary functions for communications with API and GroupWare
//******************************************************************

	function connect_api()
	{
		$this->_api=new MerakAPI();
	}

  function parse_result_line($text,$first,$second)
  {
    if(!$text)
      return array();
    $lines=explode("\r\n",$text);

    $fields=explode('&',strtoupper(trim($lines[0])));
    foreach($fields as $key=>$field)
      if ($field==$first)
        $id=$key;
      else
        if ($field==$second)
          $counter=$key;

    unset($lines[0]);

    foreach($lines as $line)
    {
      $line=trim($line);
      if (!$line)
        continue;
      $part=explode('&',$line);

      $result[rawurldecode($part[$id])]=$part[$counter];
		}
    return $result;
  }

//************************************************************

  function login($username,$password,$scheme='',$challenge='')
  {
		global $folder_aliases;

		$account=new MerakAccount();

		//Je povolena sluba SyncML?
		//Is SyncML service enabled?
		if ($account->Open($username) && $account->ValidateUser(catSyncML))
		{
			$this->_gw->user=$username;
    	$this->_gw->pass=$password;
    	$this->_gw->authscheme=$scheme;
    	$this->_gw->authchallenge=$challenge;

			//Oven uivatele pomoc GroupWare
			//User's authentication via GroupWare
    	if ($this->_gw->Login())
    	{
				$this->_gsid=$this->_gw->OpenGroup('*');
      	$this->_folders=$this->parse_result_line($this->_gw->FunctionCall('GetFolderList',$this->_gsid),'FDR_ID','FDRTYPE');

				if (!$this->_api->GetProperty('C_Accounts_Policies_Login_LoginSettings'))
					$username=$account->GetProperty('U_Mailbox');

				if ($scheme=='SYNCML-MD5')
        	$password=$account->GetProperty('U_Password');

				$password=(($password!='*')?$password:'');
				$this->_password=$password;
				
				//Oven uivatele pro IMAP
				//User's authentication for IMAP (account must be POP3/IMAP or IMAP type)
				if ($password && $account->GetProperty('U_AccountType') && $this->_imap->open($_SERVER['SERVER_NAME'],143,$username,$password))
				{
					$mailboxes=$this->_imap->get_mailboxes();
				
					foreach($mailboxes as $mailbox)
						if (!$this->_folders[str_replace('/','\\',$mailbox)])
				    	$this->_folders[$mailbox]='M';
				}
				
			  //een case-insensitivity jmen folder a zmnnost \ a /
				//Case-insensitive folder names solution and interchangeability \ a /
				foreach($this->_folders as $key=>$value)
				  $this->_translate_folders[strtolower(str_replace('\\','/',$key))]=$key;

				//een alias jmen folder
				//Folder's names aliases solution
				foreach($folder_aliases as $key=>$value)
					if (!$this->_translate_folders[$key])
					  $this->_translate_folders[$key]=$value;

				return true;
    	}
		}
    return false;
  }

//************************************************************

  function logout()
  {
    $this->_gw->LogOut();
  }

//************************************************************

  function next_nonce_get($username,$source_uri)
  {
		//Mme next nonce pro zazen v pomocn tabulce?
    //Have we device's next nonce in support table?
    $nonce=$this->_db->query('SELECT next_nonce FROM support WHERE user_id=? AND uri=?',
                             	array($username,$source_uri));
    if ($nonce)
    {
      $this->_db->query('DELETE FROM support WHERE user_id=? AND uri=?',
                         array($username,$source_uri));
      return $nonce[0]['next_nonce'];
		}
	}

//************************************************************

	function next_nonce_set($username,$source_uri,$next_nonce)
	{
		//Vloen next nonce do pomocn tabulky
    //Insert next nonce into support table
    $this->_db->query('INSERT INTO support (user_id,uri,next_nonce) VALUES (?,?,?)',
                       array($username,$source_uri,$next_nonce));
	}

//************************************************************
// Pomocn funkce pro komunikaci s SQLite
// Supplementary functions for communications with SQLite
//************************************************************

  function syncml_tables_exist() 
  {
    $tables=$this->_db->query("SELECT name FROM sqlite_master WHERE type='table' AND (name='devices' OR name='support' OR name='folders' OR name='formats' OR name='backups' OR name='maps' OR name='syncs')");

		if (count($tables)!=7)
    {
      $this->_db->query('DROP TABLE devices');
      $this->_db->query('DROP TABLE support');
      $this->_db->query('DROP TABLE folders');
			$this->_db->query('DROP TABLE formats');
			$this->_db->query('DROP TABLE backups');
      $this->_db->query('DROP TABLE maps');
      $this->_db->query('DROP TABLE syncs');

      return false;
		}
    else
      return true;
  }

//************************************************************

  function syncml_tables_create() 
  {
    $this->_db->query('CREATE TABLE devices(device_id INTEGER NOT NULL PRIMARY KEY,
                                    user_id CHAR(128) DEFAULT NULL,
                                    uri CHAR(128) DEFAULT NULL)');

		$this->_db->query('CREATE TABLE support(user_id CHAR(128) DEFAULT NULL,
                                    uri CHAR(128) DEFAULT NULL,
																		next_nonce CHAR(64) DEFAULT NULL)');
																		
		$this->_db->query('CREATE TABLE folders(device_id INTEGER DEFAULT NULL,
                                    object_folder CHAR(128) DEFAULT NULL,
																		object_type CHAR(1) DEFAULT NULL)');

    $this->_db->query('CREATE TABLE formats(device_id INTEGER DEFAULT NULL,
                                    object_type CHAR(1) DEFAULT NULL,
                                    object_format CHAR(64) DEFAULT NULL,
																		format_version CHAR(4) DEFAULT NULL,
																		format_filter CHAR(64) DEFAULT NULL,
																		object_encode CHAR(4) DEFAULT NULL)');
                                       
    $this->_db->query('CREATE TABLE backups(device_id INTEGER DEFAULT NULL,
                                    object_folder CHAR(128) DEFAULT NULL,
                                    object_format CHAR(64) DEFAULT NULL,
																		format_version CHAR(4) DEFAULT NULL,
																		object_encode CHAR(4) DEFAULT NULL)');

		$this->_db->query('CREATE TABLE maps(local_id CHAR(64) DEFAULT NULL,
                                    remote_id CHAR(64) DEFAULT NULL,
                                    device_id INTEGER DEFAULT NULL,
                                    object_folder CHAR(128) DEFAULT NULL,
                                    local_last_sequence INTEGER DEFAULT NULL)');

    $this->_db->query('CREATE TABLE syncs(device_id INTEGER DEFAULT NULL,
                                    object_folder CHAR(128) DEFAULT NULL,
                                    local_last_anchor CHAR(32) DEFAULT NULL,
                                    remote_last_anchor CHAR(32) DEFAULT NULL)');
  }

//************************************************************

  function connect_db()
  {
 		$this->_db=new database();

		if (!$this->syncml_tables_exist())
      $this->syncml_tables_create();
	}

//********************************************************************
// Pomocn funkce mnc a testujc stav objektu Datastore
// Supplementary functions for changing and testing Datastore's status
//********************************************************************

  function set_datastore_type($folder_name,$imap_reopen=false)
  {
    global $datastore_formats;

    //prava jmna databze pro nkter zazen
    //Database name modification for some devices
    if (substr($folder_name,0,2)=='./')
      $folder_name=substr($folder_name,2);

		//Odstrann filtr Synthesis
		//Remove Synthesis filters
		if ($pos=strpos($folder_name,'?'))
		  $folder_name=substr($folder_name,0,$pos);
		  
		//een case-insensitivity jmen folder
		//Case-insensitive folder names solution
		$lc_folder_name=strtolower($folder_name);
		
		if ($lc_folder_name=='mail' || $lc_folder_name=='mails')

      //Zdroj Mail(s) pesmrujeme na Inbox
			//Resource Mail(s) redirection to Inbox
			$folder_name='INBOX';
		else
			if (!$this->_folders[$folder_name])
			{
        //een case-insensitivity jmen folder a zmnnost \ a /
				//Case-insensitive folder names solution and interchangeability \ a /
				$lc_folder_name=str_replace('\\','/',$lc_folder_name);
				$folder_name=$this->_translate_folders[$lc_folder_name];

        if (!$folder_name)
		  		return;
			}

    $this->_object_folder=$folder_name;
    $this->_object_type=$this->_folders[$folder_name];

		//Znovu oteven pstupu do IMAPu
		//Reopen access to IMAP
		if ($this->_object_type=='M' && $imap_reopen)
		  $this->_imap->reopen();

    return $this->_object_type;
  }

//************************************************************

  function set_datastore_format($format,$version='')
  {
		if (!$format)
		  return;

		if ($this->_object_type=='F')
      if ($format!='application/*')
      {
				if ($format!=$this->_backup_format[$this->_object_folder]['format'])
				{
					$this->_backup_format[$this->_object_folder]['format']=$format;

      		if ($version)
						$this->_backup_format[$this->_object_folder]['version']=$version;

      		$backup=$this->_db->query('SELECT object_format FROM backups WHERE device_id=? AND object_folder=?',
        		                     		 array($this->_device_id,$this->_object_folder));
					if ($backup)
					{
						if ($version)
      				$this->_db->query('UPDATE backups SET object_format=?,format_version=? WHERE device_id=? AND object_folder=?',
        	  	  	             	 array($format,$version,$this->_device_id,$this->_object_folder));
						else
      				$this->_db->query('UPDATE backups SET object_format=? WHERE device_id=? AND object_folder=?',
              	  	      	   	 array($format,$this->_device_id,$this->_object_folder));
					}
					else
			  		$this->_db->query('INSERT INTO backups (device_id,object_folder,object_format,format_version) VALUES (?,?,?,?)',
        			                 array($this->_device_id,$this->_object_folder,$format,($version?$version:NULL)));
				}
				return;
			}
			else
			  if ($this->_backup_format[$this->_object_folder])
			  {
				  $this->_db->query('DELETE FROM backups WHERE device_id=? AND object_folder=?',
          		          	 	 array($this->_device_id,$this->_object_folder));
					unset($this->_backup_format[$this->_object_folder]);
				}

		if ($format!=$this->_saved_format[$this->_object_type])
    {
      $this->_object_format[$this->_object_type]['format']=$format;
      $this->_saved_format[$this->_object_type]=$format;
      
      if ($version)
      {
				$this->_object_format[$this->_object_type]['version']=$version;
				$this->_db->query('UPDATE formats SET object_format=?,format_version=? WHERE device_id=? AND object_type=?',
       		                 array($format,$version,$this->_device_id,$this->_object_type));
			}
			else
      	$this->_db->query('UPDATE formats SET object_format=? WHERE device_id=? AND object_type=?',
         	            	   array($format,$this->_device_id,$this->_object_type));
    }
  }

//************************************************************

  function get_datastore_format()
  {
		if ($this->_object_type=='F')
		{
			$backup_format=$this->_backup_format[$this->_object_folder]['format'];
			
			if ($backup_format)
				return $backup_format;
		}

		return $this->_object_format[$this->_object_type]['format'];
  }

//************************************************************

	function get_saved_format()
  {
		if ($this->_object_type=='F')
		{
			$backup_format=$this->_backup_format[$this->_object_folder]['format'];

			if ($backup_format)
				return $backup_format;
		}

		return $this->_saved_format[$this->_object_type];
  }

//************************************************************

  function get_format_version()
  {
  	global $format_versions;
  	
		if ($this->_object_type=='F')
    {
			$backup_version=$this->_backup_format[$this->_object_folder]['version'];

			if ($backup_version)
				return $backup_version;
		}
		
		if ($this->_object_format[$this->_object_type]['version'])
			return $this->_object_format[$this->_object_type]['version'];
		else
			return '1.0';	
  }

//************************************************************

  function set_datastore_filter($filter)
  {
		if (!$filter)
		  return;

		if ($filter!=$this->_object_format[$this->_object_type]['filter'])
    {
      $this->_object_format[$this->_object_type]['filter']=$filter;
      
      $this->_db->query('UPDATE formats SET format_filter=? WHERE device_id=? AND object_type=?',
         	            	 array($filter,$this->_device_id,$this->_object_type));
    }
  }

//************************************************************

	function set_datastore_encode($encode)
	{
		if (!$encode)
			return;

		if (($this->_object_type=='F') && ($this->_object_format!='application/*'))
    {
			if ($this->_backup_format[$this->_object_folder]['format'] && ($encode!=$this->_backup_format[$this->_object_folder]['encode']))
			{
				$this->_backup_format[$this->_object_folder]['encode']=$encode;

      	$this->_db->query('UPDATE backups SET object_encode=? WHERE device_id=? AND object_folder=?',
              	  	      	 array($encode,$this->_device_id,$this->_object_folder));
			}
			return;
		}
			
		if ($encode!=$this->_object_format[$this->_object_type]['encode'])
    {
      $this->_object_format[$this->_object_type]['encode']=$encode;

      $this->_db->query('UPDATE formats SET object_encode=? WHERE device_id=? AND object_type=?',
         	            	 array($encode,$this->_device_id,$this->_object_type));
		}
	}

//************************************************************

	function get_datastore_encode()
	{
    if ($this->_object_type=='F')
		{
			$backup_encode=$this->_backup_format[$this->_object_folder]['encode'];

			if ($backup_encode)
				return $backup_encode;
		}

		return $this->_object_format[$this->_object_type]['encode'];
	}

//************************************************************

	function set_htmlspecialchars()
	{
		if (!$this->get_datastore_encode())
			if ((strpos($this->_object_format[$this->_object_type]['format'],'sif')===false) && (strpos($this->_object_format[$this->_object_type]['format'],'application')===false))
				$this->_htmlspecialchars=true;
			else
    		$this->_htmlspecialchars=false;
	}

//************************************************************

  function set_slow_sync($bool)
  {
    $this->_slow_sync=$bool;
  }

//************************************************************

	function set_special_sync($bool)
	{
		$this->_special_sync=$bool;
	}

//************************************************************

	function set_filters($filters)
	{
		$this->_filters=$filters;
	}

//************************************************************

  function set_max_place($max_place)
  {
    $this->_max_place=$max_place;
		$this->_free_place=$max_place;
  }

//************************************************************

  function set_max_object($max_object)
  {
    $this->_max_object=$max_object;
  }

//************************************************************

  function get_free_place()
  {
		return $this->_free_place;
	}

//************************************************************

  function set_all_items()
  {
    $this->_all_items=true;
  }

//************************************************************

  function get_all_items()
  {
    return $this->_all_items;
  }

//***************************************************************
// Funkce pro inicializaci synchronizace (pkaz Alert)
// Functions for synchronization's initialization (command Alert)
//***************************************************************

  function device_registration($username,$source_uri,$params)
  {
    global $datastore_formats;
    global $format_versions;
    
    if ($this->_registered)
      return;
		
		$this->_push=urlencode((strlen($params['PUSH'])==strlen(trim($params['PUSH'])))?$params['PUSH']:('+'.trim($params['PUSH'])));
    $this->_notif=($this->_push?'ID='.$this->_push:'IGNORE=1');

		$this->_backup->set_backup_sync($params['BACKUP']);

		//Mme zazen v tabulce zazen?
    //Have we device in devices table?
    $device=$this->_db->query('SELECT device_id FROM devices WHERE user_id=? AND uri=?',
                           		 array($username,$source_uri));
		if ($device)
    {
			$this->_device_id=$device[0]['device_id'];

			//Zmnila se struktura ji pouvanch folder?
			//Did already used folders structure change?
			$folders=$this->_db->query('SELECT object_folder,object_type FROM folders WHERE device_id=?',
                 					        array($this->_device_id));

			foreach($folders as $folder)
				if ($this->_folders[$folder['object_folder']]!=$folder['object_type'])
				{
					$this->_db->query('DELETE FROM folders WHERE device_id=? AND object_folder=?',
         		           		 	 array($this->_device_id,$folder['object_folder']));
          $this->_db->query('DELETE FROM backups WHERE device_id=? AND object_folder=?',
         		           		 	 array($this->_device_id,$folder['object_folder']));
          $this->_db->query('DELETE FROM maps WHERE device_id=? AND object_folder=?',
         		           		 	 array($this->_device_id,$folder['object_folder']));
          $this->_db->query('DELETE FROM syncs WHERE device_id=? AND object_folder=?',
         		           		 	 array($this->_device_id,$folder['object_folder']));
				}

      if ($params['FORMAT'])
      {
				//Vymazn vech uloench formt zazen z tabulky formt
				//Delete all saved device's formats from formats table
        $this->_db->query('UPDATE formats SET object_format=NULL format_version=NULL format_filter=NULL object_encode=NULL WHERE device_id=?',
                         	 array($this->_device_id));

				//Vymazn vech uloench formt zloh z tabulky zloh
      	//Delete all saved backup's formats from backups table
      	$this->_db->query('DELETE FROM backups WHERE device_id=?',
          		          	 array($this->_device_id));
			}
			else
			{
        //Nastaven formtu pro kad typ objektu
        //Set format for every object's type
        $formats=$this->_db->query('SELECT object_type,object_format,format_version,format_filter,object_encode FROM formats WHERE device_id=?',
                             	      array($this->_device_id));
				foreach($formats as $format)
				{
        	$this->_saved_format[$format['object_type']]=$format['object_format'];
					$this->_object_format[$format['object_type']]=array('version'=>$format['format_version'],'filter'=>$format['format_filter'],'encode'=>$format['object_encode']);
				}

				//Nastaven formtu pro kad folder typu File pouit pro Backup synchronizaci
				//Set format for every File type folder used for Backup synchronization
				$backups=$this->_db->query('SELECT object_folder,object_format,format_version,object_encode FROM backups WHERE device_id=?',
                             	      array($this->_device_id));
        foreach($backups as $backup)
					$this->_backup_format[$backup['object_folder']]=array('format'=>$backup['object_format'],'version'=>$backup['format_version'],'encode'=>$backup['object_encode']);
			}
		}
    else
    {
      //Vytvoen novho zazen v tabulce zazen
      //Create new device in devices table
      $this->_db->query('INSERT INTO devices (user_id,uri) VALUES (?,?)',
                         array($username,$source_uri));
      $this->_device_id=$this->_db->lastInsertId();
        
      //Vytvoen przdnho formtu pro kad typ objektu v tabulce formt
      //Create empty format for every object's type in formats table
      foreach($datastore_formats as $key=>$value)
        $this->_db->query('INSERT INTO formats (device_id,object_type,object_format,format_version,format_filter,object_encode) VALUES (?,?,NULL,NULL,NULL,NULL)',
                           array($this->_device_id,$key));
		}
			
		if (($params['FORMAT']!='sif') && ($params['FORMAT']!='sif'))
			$params['FORMAT']='pref';

		//Nastaven vech formt
		//Set all formats
		foreach($datastore_formats as $key=>$value)
		{
			if ($this->_saved_format[$key])
			  $this->_object_format[$key]['format']=$this->_saved_format[$key];
			else
			  $this->_object_format[$key]['format']=$value[$params['FORMAT']];

			if (!$this->_object_format[$key]['version'])
				$this->_object_format[$key]['version']=$format_versions[$this->_object_format[$key]['format']];
		}
		
    $this->_registered=true;
  }

//************************************************************

  function get_anchors(&$local_last_anchor,&$remote_last_anchor,&$local_next_anchor,$remote_next_anchor)
  {
		//Mme zznam v synchronizan tabulce?
    //Have we entry in sync table?
    $sync=$this->_db->query('SELECT local_last_anchor,remote_last_anchor FROM syncs WHERE device_id=? AND object_folder=?',
                             array($this->_device_id,$this->_object_folder));
		if ($sync)
    {
      $local_last_anchor=$sync[0]['local_last_anchor'];
      $remote_last_anchor=$sync[0]['remote_last_anchor'];
    }
    else
      //Potebujeme pomalou synchronizaci
      //We need slow synchronization
      $local_last_anchor=$remote_last_anchor='00000000T000000Z';
      
    //Vytvoen datov a asov znaky
    //Create date&time stamp
    if (!$this->_local_next_anchor)
      $this->_local_next_anchor=date('Ymd\THis\Z',time());
		$local_next_anchor=$this->_local_next_anchor;
		
    $this->_remote_next_anchor[$this->_object_folder]=$remote_next_anchor;
  }

//************************************************************

	function push_response($alerts)
	{
		if (!count($alerts))
			return;

		if (!$this->_api->GetProperty('C_SyncML_Push_Active'))
			return;

		foreach($alerts as $folder=>$value)
		{
		  //prava jmna databze pro nkter zazen
    	//Database name modification for some devices
    	if (substr($folder,0,2)=='./')
      	$folder=substr($folder,2);
      	
      $folder=(($pos=strpos($folder,'?'))?substr($folder,0,$pos):$folder);

			$folders.=$folder.';';
		}

    $this->_api->SyncPush($this->_gw->user,$folders,'ID='.$this->_push,'remove');
	}
	
//************************************************************
// Funkce pro vlastn synchronizaci (pkaz Sync)
// Functions for self synchronization (command Sync)
//************************************************************

  function start_sync($folder_name)
  {
    //Nastaven typu synchronizovanch dat
    //Set synchronization's data type
    $this->set_datastore_type($folder_name,true);

		//Vloen novho folderu do tabulky folder
		//Insert new folder into folders table
		$folder=$this->_db->query('SELECT object_type FROM folders WHERE device_id=? AND object_folder=?',
                 					     array($this->_device_id,$this->_object_folder));
		if (!$folder)
			$this->_db->query('INSERT INTO folders (device_id,object_folder,object_type) VALUES (?,?,?)',
        	             	 array($this->_device_id,$this->_object_folder,$this->_object_type));
		
    if ($this->_slow_sync || $this->_special_sync)

			//Vymazn vech poloek z mapovac tabulky
      //Delete all items from maps table
      $this->_db->query('DELETE FROM maps WHERE device_id=? AND object_folder=?',
                         array($this->_device_id,$this->_object_folder));

		if ($this->_object_type=='M')
		{
			//Zskn identififikac dat z IMAP
    	//Acquire identification's data from IMAP
    	if ($this->_slow_sync || $this->_refresh_sync)
				$this->_sync_data[$this->_object_folder]=$this->_imap->get_items($this->_object_folder);
			else
        $this->_sync_data[$this->_object_folder]=$this->_imap->get_items_id($this->_object_folder);

			$list=($this->_sync_data[$this->_object_folder]!==false)?true:false;
		}
		else
		{
    	//Zskn identififikac dat z GroupWare
    	//Acquire identification's data from GroupWare
    	$this->_fsid[$this->_object_folder]=$this->_gw->OpenFolder($this->_gsid,$this->_object_folder);
    	switch($this->_object_type)
    	{
      	case 'C':
        	$list=$this->_gw->FunctionCall('GetContactList',$this->_fsid[$this->_object_folder],'','Itm_EditCounter');
        	$prefix='ITM';
        	break;
        	
      	case 'E':
      	case 'F':
      	case 'J':
      	case 'N':
      	case 'T':
        	$list=$this->_gw->FunctionCall('GetEventList',$this->_fsid[$this->_object_folder],"EvnClass='".$this->_object_type."'",'Evn_EditCounter');
        	$prefix='EVN';
    	}
    	
    	$this->_sync_data[$this->_object_folder]=$this->parse_result_line($list,$prefix.'_ID',$prefix.'_EDITCOUNTER');
		}

		//M smysl pokraovat v synchronizaci?
		//Is reasonable to continue in synchronization?
    if ($list)
      return true;
    else 
      return false;
  }

//************************************************************

	function item_decode($item)
	{
    switch($this->get_datastore_encode())
		{
			case 'b64':
				$item=base64_decode($item);
				break;
				
			case 'des;b64':
        $item=$this->_api->CryptData('SYNCML-DES',$this->_password,$item,false);
		}

		return $item;
	}

//************************************************************

	function add_email($remote_id,$item,$verify,$flags_only=false) 
	{
    //Dekdovn nov poloky
    //New item decode
    switch($this->_object_format['M']['format'])
		{
			case 'text/message':
				$email=$this->_imap->decode_plain($item,$remote_id);
				$email['mask']=32;
				break;

			case 'application/vnd.omads-email+xml':
    	  $email=$this->_imap->decode_syncml($item);
    	  $email['mask']=107;
    	  break;

			case 'text/x-vMessage':
			  $email=$this->_imap->decode_sms($item);
			  $email['mask']=32;
			  break;
			  
    	default:
    	  return false;
		}
		
		if (!$flags_only)
		
			//Vloen nov poloky do IMAP
    	//Add new item to IMAP
			$email['local_id']=$this->_imap->add_message($this->_object_folder,$email['mail'],$verify);

		return $email;
	}

//************************************************************

  function client_add($remote_id,$item) 
  {
		//Mme poloku v mapovac tabulce?
    //Have we item in maps table?
    $select=$this->_db->query('SELECT local_id FROM maps WHERE device_id=? AND object_folder=? AND remote_id=?',
          				             array($this->_device_id,$this->_object_folder,$remote_id));
    if ($select)
    
      //Poloka ji existuje
      //Item exists already
      return 418;

		$item=$this->item_decode($item);

    if ($this->_slow_sync || $this->_special_sync)
      $verify=';VERIFY';

		$format=$this->_object_format[$this->_object_type]['format'];
		$filter=$this->_object_format[$this->_object_type]['filter'];
		$notif=($this->_special_sync?'IGNORE=1':$this->_notif);

		//Vloen nov poloky do IMAP i GroupWare
    //Add new item to IMAP or to GroupWare
    switch($this->_object_type)
    {
			case 'M':
			  $email=$this->add_email($remote_id,$item,$verify);
				$local_id=$email['local_id'];
				break;
			  
			case 'C':
        $local_id=$this->_gw->FunctionCall('AddvCard',$this->_fsid[$this->_object_folder],$item,'',$format.$verify.($filter?(';FILTER='.$filter):'').';NOTIF='.$notif);
        break;
        	
      case 'F':
        $item=$this->_backup->item_encode($item,$this->_backup_format[$this->_object_folder]['format']);

			case 'E':
      case 'J':
      case 'N':
      case 'T':
				$local_id=$this->_gw->FunctionCall('AddvCalendar',$this->_fsid[$this->_object_folder],$item,'',$format.$verify.($filter?(';FILTER='.$filter):'').';NOTIF='.$notif);
    }

		if (!$local_id)

			//Poloka nebyla do IMAP i GroupWare vloena
    	//Item wasn't inserted to IMAP or to GroupWare
    	return 500;

		$data=&$this->_sync_data[$this->_object_folder][$local_id];
			
		//Nesynchronizujeme typem pomal pouze klientsk?
		//We don't use slow client only sync type?
		if (!$this->_special_sync)
		{
			//Aktualizujeme poloku v IMAPu nebo v GroupWare?
		  //Do we add item into IMAP or into GroupWare?
			if ($this->_object_type=='M')
        if (isset($data))
				{
					//Aktualizujeme flagy pouze v ppad normln synchronizace
					//Update flags only if we are in normal-sync mode
        	if (!$this->_slow_sync)
        		$data['flags']=$data['flags']&(~$email['mask'])|$email['flags'];
        	$last=$data['flags'];
				}
				else
				{
					$last=$data['flags']=$email['flags'];
					$this->_imap->set_flags($this->_object_folder,$local_id,$email['flags'],$email['mask']);
				}
			else
				if (isset($data))
      	{
					//Inkrementujeme poitadlo pouze v ppad normln synchronizace
					//Increment counter only if we are in normal-sync mode
        	if (!$this->_slow_sync)
          	$data++;
        	$last=$data;
      	}
      	else
        	$last=$data=0;

      //Vloen nov poloky do mapovac tabulky
      //Insert new item to map table
      $this->_db->query('INSERT INTO maps (device_id,object_folder,local_id,remote_id,local_last_sequence) VALUES (?,?,?,?,?)',
        	             	 array($this->_device_id,$this->_object_folder,$local_id,$remote_id,$last));
		}
		else

			//Existovala prav vloen poloka na serveru?
			//Did exist just added item on the server?
			if (isset($data))

				//Vloen nov poloky do mapovac tabulky
      	//Insert new item to map table
      	$this->_db->query('INSERT INTO maps (device_id,object_folder,local_id,remote_id,local_last_sequence) VALUES (?,?,?,?,?)',
        		             	 array($this->_device_id,$this->_object_folder,$local_id,$remote_id,($this->_object_type=='M')?$data['flags']:$data));
			else

				//Vymazn prv pidan poloky
				//Delete just added item
        switch($this->_object_type)
      	{
					case 'M':
				  	$this->_imap->delete_message($this->_object_folder,$local_id);
				  	break;

					case 'C':
          	$this->_gw->FunctionCall('DeleteContact',$this->_fsid[$this->_object_folder],$local_id,0,'NOTIF='.$notif);
          	break;

        	case 'E':
          case 'F':
					case 'J':
        	case 'N':
        	case 'T':
          	$this->_gw->FunctionCall('DeleteEvent',$this->_fsid[$this->_object_folder],$local_id,0,'NOTIF='.$notif);
      	}
			
    //Poloka byla spn vloena do IMAP i GroupWare
    //Item was added successfully to IMAP or to GroupWare
    return 201;
	}

//************************************************************

  function client_delete($remote_id) 
  {
    //Mme poloku v mapovac tabulce?
    //Have we item in maps table?
    $select=$this->_db->query('SELECT local_id FROM maps WHERE device_id=? AND object_folder=? AND remote_id=?',
                             	 array($this->_device_id,$this->_object_folder,$remote_id));
    if ($select)
    {
      //Vymazn poloky
      //Delete item
      $local_id=$select[0]['local_id'];

      switch($this->_object_type)
      {
				case 'M':
				  $result=$this->_imap->delete_message($this->_object_folder,$local_id);
				  break;
				  
				case 'C':
          $result=$this->_gw->FunctionCall('DeleteContact',$this->_fsid[$this->_object_folder],$local_id,0,'NOTIF='.$this->_notif);
          break;
          
        case 'E':
        case 'F':
        case 'J':
        case 'N':
        case 'T':
          $result=$this->_gw->FunctionCall('DeleteEvent',$this->_fsid[$this->_object_folder],$local_id,0,'NOTIF='.$this->_notif);
      }
      
      //Vymazn reference na vymazanou poloku z mapovac tabulky
      //Delete item's reference from maps table
      $this->_db->query('DELETE FROM maps WHERE device_id=? AND object_folder=? AND local_id=?',
                     		 array($this->_device_id,$this->_object_folder,$local_id));
      if ($result)

				//Poloka byla spn vymazna
        //Item was deleted successfuly
        return 200;
    }
    
    //Poloka neexistuje
    //Item doesn't exist
    return 218;
  }

//************************************************************

  function client_replace($remote_id,$item) 
  {
    //Mme poloku v mapovac tabulce?
    //Have we item in maps table?
    $select=$this->_db->query('SELECT local_id,local_last_sequence FROM maps WHERE device_id=? AND object_folder=? AND remote_id=?',
          				             array($this->_device_id,$this->_object_folder,$remote_id));
    if ($select)
    {
      $item=$this->item_decode($item);
      
			$local_id=$select[0]['local_id'];
      $last=$select[0]['local_last_sequence'];

      //Aktualizujeme poloku v IMAPu nebo v GroupWare?
		  //Do we update item in IMAP or in GroupWare?
      if ($this->_object_type=='M')
			{
        //Existuje aktualizovan poloka v IMAPu?
      	//Does item exist in IMAP?
      	$data=&$this->_sync_data[$this->_object_folder][$local_id];
				if ($data)
				{
					//Pouze dekdujeme flagy mailu
					//Decode mail flags only
					$email=$this->add_email($remote_id,$item,'',true);

					if (!$email)

						//Neznm formt
						//Unknown format
					  return 500;

					//Zmnily se flagy poloky v Meraku?
					//Did item's flags change in Merak?
					if (($data['flags']&$email['mask'])!=$email['flags'])
						$result=$this->_imap->set_flags($this->_object_folder,$local_id,$email['flags'],$email['mask']);
					else
					  $result=true;

          if ($result)
					{
						//Zmnily se flagy poloky v mapovac tabulce?
						//Did item's flags change in maps table?
						if (($last&$email['mask'])!=$email['flags'])
            {
              //Aktualizace flag jako local_last_sequence v mapovac tabulce
        			//Update flags as a local_last_sequence in maps table
							$flags=$data['flags']=$data['flags']&(~$email['mask'])|$email['flags'];
							$this->_db->query('UPDATE maps SET local_last_sequence=? WHERE device_id=? AND object_folder=? AND local_id=?',
          			          		   array($flags,$this->_device_id,$this->_object_folder,$local_id));
						}

						//Poloka byla spn aktualizovna
        		//Item was updated successfully
        		return 200;
					}
					else

						//Chyba v IMAPu
						//Error in IMAP
						return 500;
				}
			}
			else
			{
        //Aktualizace poloky v GroupWare
	      //Update item in GroupWare
	      $format=$this->_object_format[$this->_object_type]['format'];
	      $filter=$this->_object_format[$this->_object_type]['filter'];
	      
				switch($this->_object_type)
      	{
        	case 'C':
            $result=$this->_gw->FunctionCall('GetContactList',$this->_fsid[$this->_object_folder],"ITM_ID='".$local_id."'");
            $this->_gw->FunctionCall('AddvCard',$this->_fsid[$this->_object_folder],$item,$local_id,$format.($filter?(';FILTER='.$filter):'').';NOTIF='.$this->_notif);
          	$prefix='ITM';
          	break;
          	
        	case 'F':
        		$item=$this->_backup->item_encode($item,$this->_backup_format[$this->_object_folder]['format']);

          case 'E':
					case 'J':
        	case 'N':
        	case 'T':
          	$result=$this->_gw->FunctionCall('GetEventList',$this->_fsid[$this->_object_folder],"EVN_ID='".$local_id."'");
          	$this->_gw->FunctionCall('AddvCalendar',$this->_fsid[$this->_object_folder],$item,$local_id,$format.($filter?(';FILTER='.$filter):'').';NOTIF='.$this->_notif);
          	$prefix='EVN';
      	}

		  	//Existuje aktualizovan poloka v GroupWare?
      	//Does item exist in GroupWare?
      	if (count($this->parse_result_line($result,$prefix.'_ID',$prefix.'_EDITCOUNTER')))
      	{
        	//Aktualizace local_last_sequence v mapovac tabulce
        	//Update local_last_sequence in maps table
        	$this->_db->query('UPDATE maps SET local_last_sequence=? WHERE device_id=? AND object_folder=? AND local_id=?',
          	                 array(++$this->_sync_data[$this->_object_folder][$local_id],$this->_device_id,$this->_object_folder,$local_id));

        	//Poloka byla spn aktualizovna
        	//Item was updated successfully
        	return 200;
      	}
			}

			//Vymazn reference na neexistujc poloku z mapovac tabulky
      //Delete reference to non-exist item from maps table
      $this->_db->query('DELETE FROM maps WHERE device_id=? AND object_folder=? AND local_id=?',
       	          		   array($this->_device_id,$this->_object_folder,$local_id));
		}
		
    //Poloku se pokusme pidat
    //We try to add item
    return $this->client_add($remote_id,$item);
  }

//************************************************************

	function item_encode($item)
	{
		switch($this->get_datastore_encode())
		{
			case 'b64':
				$item=base64_encode($item);
				break;

			case 'des;b64':
        $item=$this->_api->CryptData('SYNCML-DES',$this->_password,$item,true);
			//	break;
				
			//default:
			//	if ($this->_htmlspecialchars)
			//		$item=htmlspecialchars($item);
		}

		return $item;
	}
	
//************************************************************

	function get_mask() 
	{
    switch($this->_object_format['M']['format'])
		{
			case 'text/message':
				$mask=32;
				break;

			case 'application/vnd.omads-email+xml':
			default:
			  $mask=107;
		}
		return $mask;
	}

//************************************************************

	function get_email($local_id)
  {
		$data=$this->_sync_data[$this->_object_folder][$local_id];

		//Nepouvme asov filtr nebo mme mail v odpovdajcm ase?
		//Don't we use time filter or we have mail in corresponding time?
		if (!$this->_filters['record'] || ($data['date']>$this->_filters['record']))
		{
			$header=$this->_imap->get_header($this->_object_folder,$local_id);
			if ($header!==false)
			{
				//Analza filtr poloek a velikosti
				//Field and size filter analyze
				if ($this->_filters['size'] && ($data['size']>$this->_filters['size']))
					$field='body';
				else
					$field=$this->_filters['field']?$this->_filters['field']:'all';

				//prava mailu podle filtr poloek a velikosti
				//Mail modification accordind to field and size filters
				switch($field)
				{
					case 'header':
						$body='';
						break;

					case 'body':
						$email=$this->_imap->extract_attach($this->_object_folder,$local_id);
						if ($email['header'])
							$header=$email['header'];
						$body=$email['body'];

						if ($body!==false && $this->_filters['size'])
							$body=substr($body,0,$this->_filters['size']);
						break;

					case 'all':
						$body=$this->_imap->get_body($this->_object_folder,$local_id);
				}
				
				if ($body!==false)
				
          //Zakdovn nov poloky
    			//New item encode
					switch($this->_object_format['M']['format'])
					{
						case 'text/message':
							$item=$this->_imap->encode_plain($this->_object_folder,$data['flags'],$header.$body);
							break;

						case 'application/vnd.omads-email+xml':
						default:
						  $item=$this->_imap->encode_syncml($data['flags'],$header.$body);
					}
			}
		}
		
		return $item;
	}

//************************************************************

  function server_add() 
  {
    $result=array();
    
    //Provdme istc synchronizaci?
    //Do we execute reset synchronization?
    if ($this->_special_sync)
      return $result;

		//Mme njak data, kter poslme po stech?
    //Have we any chunked data?
    if ($this->_more_data['guid'])
		{
			$local_id=$this->_more_data['guid'];
			$item=$this->_more_data['item'];
			$format=$this->_more_data['format'];
			$item_length=strlen($item);

			//Poslme posledn st?
			//Do we send last chunk?
			if ($item_length<=$this->_free_place)
			{
        $result[]=array('guid'=>$local_id,'item'=>$item,'format'=>$format);
        $this->_more_data=array();
				$this->_free_place-=$item_length;
			}
			else
			{
			  $result[]=array('guid'=>$local_id,'item'=>substr($item,0,$this->_free_place),'format'=>$format,'moredata'=>true);
        $this->_more_data['item']=substr($item,$this->_free_place);
        $this->_free_place=0;
        $this->_all_items=false;
        return $result;
			}
		}
		
		$format=$this->_object_format[$this->_object_type]['format'];
		$version=$this->_object_format[$this->_object_type]['version'];
    $filter=$this->_object_format[$this->_object_type]['filter'];
		
		//Hledme ta data v GroupWare, kter nemme v mapovac tabulce
    //Find data we have in GroupWare, but we haven't in maps table
    $maps=$this->_db->query('SELECT local_id,remote_id,local_last_sequence FROM maps WHERE device_id=? AND object_folder=?',
                             array($this->_device_id,$this->_object_folder));
    
		//Syncovali jsme, ale nedostali jsme zpatky remote_id
		foreach($maps as $map)
			if ($map['remote_id'])
      	$map_data[$map['local_id']]=2;
      else
      {
      	$data=$this->_sync_data[$this->_object_folder][$map['local_id']];
      	$last=$map['local_last_sequence'];
      	if (isset($data)&&($this->_object_type=='M'?($data['flags']&($mask=$this->get_mask()))!=($last&$mask):$data>$last))
					$map_data[$map['local_id']]=1;
				else
					$map_data[$map['local_id']]=2;	
			}
			
    foreach($this->_sync_data[$this->_object_folder] as $local_id=>$data)
      if ($map_data[$local_id]<=1)
      {
        if (!$this->_free_place)
        {
          //Neposlme vechny zmnn poloky
          //We don't send all updated items
          $this->_all_items=false;
          break;
				}
				
				switch($this->_object_type)
        {
					case 'M':
						$item=$this->get_email($local_id);
						break;
						  
					case 'C':
            $item=$this->_gw->FunctionCall('GetvCard',$this->_fsid[$this->_object_folder],$local_id,$format.($version?(';VERSION='.$version):'').($filter?(';FILTER='.$filter):''));
            break;
            	
          case 'E':
          case 'F':
          case 'J':
          case 'N':
          case 'T':
            $item=$this->_gw->FunctionCall('GetvCalendar',$this->_fsid[$this->_object_folder],$local_id,$format.($version?(';VERSION='.$version):'').($filter?(';FILTER='.$filter):''));

            if ($this->_object_type=='F')
          	{
							$item_object=$this->_backup->item_decode($item,$this->_backup_format[$this->_object_folder]['format']);
							$item=$item_object['item'];
							$forced_format=$item_object['format'];
						}
				}
				
				$item=$this->item_encode($item);
				
        if ($item && (($item_length=strlen($item))<=$this->_max_object))
        {
					//Nevejde se nm poloka do stvajc zprvy, ale vejde se nm do dal?
					//Have we item, which doesn't fit in current message, but fits in next message?
					if (($item_length>$this->_free_place) && ($item_length<=$this->_max_place))
					{
            //Neposlme vechny pidan poloky
            //We don't send all added items
            $this->_all_items=false;
            break;
					}

					if ($map_data[$local_id]==1)
          	//Aktualizace local_last_sequence v mapovac tabulce
          	//Update local_last_sequence in maps table
          	$this->_db->query('UPDATE maps SET local_last_sequence=? WHERE device_id=? AND object_folder=? AND local_id=?',
         		          		   	 array(($this->_object_type=='M')?$data['flags']:$data,$this->_device_id,$this->_object_folder,$local_id));
					else
						//Vloen nov poloky do mapovac tabulky
          	//Insert new item into maps table
          	$this->_db->query('INSERT INTO maps (device_id,object_folder,local_id,remote_id,local_last_sequence) VALUES (?,?,?,NULL,?)',
            	          		   array($this->_device_id,$this->_object_folder,$local_id,($this->_object_type=='M')?$data['flags']:$data));
						
					//Vejde se nm cel poloka do stvajc zprvy?
					//Dooes whole item fit in current message?
					if ($item_length<=$this->_free_place)
					{
					  //Poslme celou poloku
						//We send whole item
						$result[]=array('guid'=>$local_id,'item'=>$item,'format'=>$forced_format);
						$this->_free_place-=$item_length;
					}
					else
					{
					  //Poslme prvn st poloky
						//We send first chunk of item
						$result[]=array('guid'=>$local_id,'item'=>substr($item,0,$this->_free_place),'format'=>$forced_format,'size'=>$item_length,'moredata'=>true);
            $this->_more_data=array('guid'=>$local_id,'item'=>substr($item,$this->_free_place),'format'=>$forced_format);
            $this->_free_place=0;
            $this->_all_items=false;
            break;
					}
				}
      }
      
    return $result;
  }

//************************************************************

  function server_delete() 
  {
    $result=array();

    //Provdme pomalou ani obnovovac synchronizaci?
    //Do we execute slow nor refresh synchronization?
    if ($this->_slow_sync)
      return $result;

    //Hledme ta data, kter mme v mapovac tabulce, ale ji nejsou v Meraku
    //Find data we have in maps table, but we haven't in Merak already
    $maps=$this->_db->query('SELECT local_id,remote_id FROM maps WHERE device_id=? AND object_folder=?',
                             array($this->_device_id,$this->_object_folder));
		foreach($maps as $map)
      if (!isset($this->_sync_data[$this->_object_folder][$map['local_id']]))
        if ($this->_free_place)
        {
          if ($map['remote_id'])
          {
						$result[]=$map['remote_id'];
          	$this->_free_place--;
          }	

          //Vymazn ji v Meraku vymazan poloky z mapovac tabulky
          //Delete item from maps table, which was deleted from Merak already
          $this->_db->query('DELETE FROM maps WHERE device_id=? AND object_folder=? AND local_id=?',
                       		   array($this->_device_id,$this->_object_folder,$map['local_id']));
        }
        else
        {
          //Neposlme vechny vymazan poloky
          //We don't send all deleted items
          $this->_all_items=false;
          break;
        }
    
    return $result;
  }
  
//************************************************************
  
  function server_refresh_delete() 
  {
    //Hledme ta data v Meraku, kter nemme v mapovac tabulce
    //Find data we have in Meraku, but we haven't in maps table
		$maps=$this->_db->query('SELECT local_id FROM maps WHERE device_id=? AND object_folder=?',
                             array($this->_device_id,$this->_object_folder));
    foreach($maps as $map)
      $map_data[$map['local_id']]=true;

		foreach($this->_sync_data[$this->_object_folder] as $local_id=>$value)
      if (!$map_data[$local_id])
      
        //Vymazn poloky z Meraku
      	//Delete item from Merak
      	switch($this->_object_type)
      	{
          case 'M':
				  	$this->_imap->delete_message($this->_object_folder,$local_id);
				  	break;
				  	
					case 'C':
          	$this->_gw->FunctionCall('DeleteContact',$this->_fsid[$this->_object_folder],$local_id);
          	break;
          	
        	case 'E':
          case 'F':
					case 'J':
        	case 'N':
        	case 'T':
          	$this->_gw->FunctionCall('DeleteEvent',$this->_fsid[$this->_object_folder],$local_id);
      	}
	}

//************************************************************

  function server_replace() 
  {
    $result=array();

    //Provdme pomalou ani obnovovac synchronizaci?
    //Do we execute slow nor refresh synchronization?
    if ($this->_slow_sync)
			return $result;
			
		//Mme njak data, kter poslme po stech?
    //Have we any chunked data?
		if ($this->_more_data['luid'])
		{
			$remote_id=$this->_more_data['luid'];
			$item=$this->_more_data['item'];
			$format=$this->_more_data['format'];
			$item_length=strlen($item);
			  
			//Poslme posledn st?
			//Do we send last chunk?
			if ($item_length<=$this->_free_place)
			{
        $result[]=array('luid'=>$remote_id,'item'=>$item,'format'=>$format);
        $this->_more_data=array();
				$this->_free_place-=$item_length;
			}
			else
			{
        $result[]=array('luid'=>$remote_id,'item'=>substr($item,0,$this->_free_place),'format'=>$format,'moredata'=>true);
        $this->_more_data['item']=substr($item,$this->_free_place);
        $this->_free_place=0;
        $this->_all_items=false;

				return $result;
			}
		}
			
		$format=$this->_object_format[$this->_object_type]['format'];
		$version=$this->_object_format[$this->_object_type]['version'];
		$filter=$this->_object_format[$this->_object_type]['filter'];
			
		//Hledme ta data, jejich local_last_sequence v GroupWare je vt ne v mapovac tabulce
    //Find data have GroupWare's local_last_sequence bigger than in maps table
    $maps=$this->_db->query('SELECT local_id,remote_id,local_last_sequence FROM maps WHERE device_id=? AND object_folder=?',
     	                       array($this->_device_id,$this->_object_folder));
    foreach($maps as $map)
		{
			$local_id=$map['local_id'];
			$remote_id=$map['remote_id'];
      $last=$map['local_last_sequence'];
      $data=$this->_sync_data[$this->_object_folder][$local_id];
          
			if ($this->_object_type=='M'?($data['flags']&($mask=$this->get_mask()))!=($last&$mask):$data>$last)
      {
				if (!$this->_free_place)
        {
          //Neposlme vechny zmnn poloky
          //We don't send all updated items
          $this->_all_items=false;
          break;
				}
					
				switch($this->_object_type)
        {
					case 'M':
						$item=$this->get_email($local_id);
						break;
						  
					case 'C':
            $item=$this->_gw->FunctionCall('GetvCard',$this->_fsid[$this->_object_folder],$local_id,$format.($version?(';VERSION='.$version):'').($filter?(';FILTER='.$filter):''));
            break;

					case 'E':
					case 'F':
          case 'J':
          case 'N':
          case 'T':
            $item=$this->_gw->FunctionCall('GetvCalendar',$this->_fsid[$this->_object_folder],$local_id,$format.($version?(';VERSION='.$version):'').($filter?(';FILTER='.$filter):''));

						if ($this->_object_type=='F')
          	{
							$item_object=$this->_backup->item_decode($item,$this->_backup_format[$this->_object_folder]['format']);
							$item=$item_object['item'];
							$forced_format=$item_object['format'];
						}
				}
					
				$item=$this->item_encode($item);
          
        if ($item && (($item_length=strlen($item))<=$this->_max_object))
        {
					//Nevejde se nm poloka do stvajc zprvy, ale vejde se nm do dal?
					//Have we item, which doesn't fit in current message, but fits in next message?
					if (($item_length>$this->_free_place) && ($item_length<=$this->_max_place))
					{
            //Neposlme vechny zmnn poloky
            //We don't send all updated items
            $this->_all_items=false;
            break;
					}

          //Aktualizace local_last_sequence v mapovac tabulce
          //Update local_last_sequence in maps table
          $this->_db->query('UPDATE maps SET local_last_sequence=? WHERE device_id=? AND object_folder=? AND local_id=?',
         		          		   array(($this->_object_type=='M')?$data['flags']:$data,$this->_device_id,$this->_object_folder,$local_id));

          //Vejde se nm cel poloka do stvajc zprvy?
					//Dooes whole item fit in current message?
					if ($item_length<=$this->_free_place)
					{
            //Poslme celou poloku
						//We send whole item
						$result[]=array('luid'=>$remote_id,'item'=>$item,'format'=>$forced_format);
						$this->_free_place-=$item_length;
					}
					else
					{
            //Poslme prvn st poloky
						//We send first chunk of item
						$result[]=array('luid'=>$remote_id,'item'=>substr($item,0,$this->_free_place),'format'=>$forced_format,'size'=>$item_length,'moredata'=>true);
            $this->_more_data=array('luid'=>$remote_id,'item'=>substr($item,$this->_free_place),'format'=>$forced_format);
            $this->_free_place=0;
            $this->_all_items=false;
            break;
					}
        }
			}
		}
    
    return $result;
  }

//************************************************************

  function end_sync() 
  {
    //Bylo zazen ji synchronizovno?
    //Did device synchronize?
    $sync=$this->_db->query('SELECT local_last_anchor FROM syncs WHERE device_id=? AND object_folder=?',
                             array($this->_device_id,$this->_object_folder));
		if ($sync)
    
		  //Aktualizace odkaz v synchronizan tabulce
      //Update synchronization's anchors in syncs table
      $this->_db->query('UPDATE syncs SET local_last_anchor=?,remote_last_anchor=? WHERE device_id=? AND object_folder=?',
                         array($this->_local_next_anchor,$this->_remote_next_anchor[$this->_object_folder],$this->_device_id,$this->_object_folder));
		else
		
      //Vloen novch odkaz do synchronizan tabulky
      //Insert new anchors into syncs table
      $this->_db->query('INSERT INTO syncs (device_id,object_folder,local_last_anchor,remote_last_anchor) VALUES (?,?,?,?)',
                         array($this->_device_id,$this->_object_folder,$this->_local_next_anchor,$this->_remote_next_anchor[$this->_object_folder]));
	}

//************************************************************
// Funkce pro mapovn dat klienta (pkaz Map)
// Client's data mapping function (command Map)
//************************************************************

  function map_data_update($local_id,$remote_id) 
  {
		//Aktualizace remote_id v mapovac tabulce
    //Update remote_id in maps table
    $this->_db->query('UPDATE maps SET remote_id=? WHERE device_id=? AND object_folder=? AND local_id=?',
                		   array($remote_id,$this->_device_id,$this->_object_folder,$local_id));
  }
}
?>
