<?php
class Info
{
	var $_text;
	var $_summary;
	var $_partial;
	var $_errors;
	var $_folder;
	var $_source;

	function add_text($text)
	{
		$this->_text.=$text."\r\n";
	}
	
	function get_text()
	{
		return $this->_text;
	}
	
	function clear_text()
	{
		$this->_text='';
	}
	
	function add_delimiter($delimiter,$count)
	{
		for($p=1;$p<=$count;$p++)
		  $text.=$delimiter;
		  
		$this->add_text($text);
	}
	
	function set_info($folder,$source)
	{
		$this->_folder=$folder;
		$this->_source=$source;
		if (!$this->_summary[$this->_folder][$this->_source])
			$this->_summary[$this->_folder][$this->_source]=array();
		$this->_partial=array();
		$this->_errors=array();
	}
	
	function item_add($result)
	{
		$add=&$this->_summary[$this->_folder][$this->_source]['add'];
    if ($result!=213)
			$add['sent']++;
		$partial=&$this->_partial['add'];
		$partial['sent']++;
		
		switch($result)
		{
			case 200:
			case 201:
				$add['added']++;
				$partial['added']++;
				break;
				
			case 213:
				$partial['chunked']++;
				break;
				
			case 418:
			  $add['have']++;
			  $partial['have']++;
			  break;
			
			case 415:  
			case 424:
			case 500:
			  $add['error']++;
			  $partial['error']++;
		}
	}

  function item_delete($result)
	{
		$delete=&$this->_summary[$this->_folder][$this->_source]['delete'];
		$delete['sent']++;
    $partial=&$this->_partial['delete'];
    $partial['sent']++;
    
		switch($result)
		{
			case 200:
				$delete['deleted']++;
				$partial['deleted']++;
				break;

			case 218:
			  $delete['havenot']++;
        $partial['havenot']++;
		}
	}
	
	function item_replace($result)
	{
		$replace=&$this->_summary[$this->_folder][$this->_source]['replace'];
		if ($result!=213)
			$replace['sent']++;
    $partial=&$this->_partial['replace'];
    $partial['sent']++;
    
		switch($result)
		{
			
			case 200:
				$replace['replaced']++;
				$partial['replaced']++;
				break;

      case 201:
			  $replace['added']++;
			  $partial['added']++;
				break;
				
			case 213:
				$partial['chunked']++;
				break;
				
			case 424:
			case 500:
			  $replace['error']++;
			  $partial['error']++;
		}
	}

	function client_partial_summary()
	{
    $actions=array('add','delete','replace');
    foreach($actions as $action)
		{
			$partial=&$this->_partial[$action];
			
			switch($action)
			{
			  case 'add':
					$this->add_text(sprintf('- ADD     Sent:% 4d  Added:   % 4d  We have:    % 4d  Chunked:% 4d  Error:% 4d',$partial['sent'],$partial['added'],$partial['have'],$partial['chunked'],$partial['error']));
					break;

				case 'delete':
					$this->add_text(sprintf('- DELETE  Sent:% 4d  Deleted: % 4d  We have not:% 4d',$partial['sent'],$partial['deleted'],$partial['havenot']));
					break;

				case 'replace':
					$this->add_text(sprintf('- REPLACE Sent:% 4d  Replaced:% 4d  Added:      % 4d  Chunked:% 4d  Error:% 4d',$partial['sent'],$partial['replaced'],$partial['added'],$partial['chunked'],$partial['error']));
			}
		}

		$this->get_errors();
	}
	
	function final_summary()
	{
		if (!count($this->_summary))
		  return;
		  
		$this->add_delimiter('-',70);
    $this->add_text('SYNCHRONIZATION SUMMARY:');

		foreach($this->_summary as $sync=>$part_sync)
		{
      $this->add_delimiter('-',70);
			$this->add_text('SYNC for '.((substr($sync,0,2)=='./')?substr($sync,2):$sync));
      
      $sources=array('Client','Server');
      foreach($sources as $source)
      {
        $this->add_text($source."'s part:");
        
        $actions=array('add','delete','replace');
        foreach($actions as $action)
	  		{
					$partial=&$part_sync[strtolower($source)][$action];

					switch($action)
					{
			  		case 'add':
							$this->add_text(sprintf('- ADD     Sent:% 4d  Added:   % 4d  We have:    % 4d  Error:% 4d',$partial['sent'],$partial['added'],$partial['have'],$partial['error']));
							break;

						case 'delete':
							$this->add_text(sprintf('- DELETE  Sent:% 4d  Deleted: % 4d  We have not:% 4d',$partial['sent'],$partial['deleted'],$partial['havenot']));
							break;

						case 'replace':
							$this->add_text(sprintf('- REPLACE Sent:% 4d  Replaced:% 4d  Added:      % 4d  Error:% 4d',$partial['sent'],$partial['replaced'],$partial['added'],$partial['error']));
					}
				}
			}
		}
	}
	
	function add_error($id,$data='')
	{
    if ($data)
			$this->_errors[]=array('id'=>$id,'data'=>$data);
		else
			$this->_errors[]=array('id'=>$id,'data'=>' Size of large object mismatch!!!');
	}
	
	function get_errors()
	{
		foreach($this->_errors as $error)
		{
		  $this->add_delimiter('-',70);
			$this->add_text('- ERROR: ItemId: '.$error['id'].' Data:');
			$this->add_text($error['data']);
		}
	}
}
?>
