<?php
/*
Usage

$gw = new MerakGWAPI();
$gw->user = 'admin@merakdemo.com';
$gw->pass = 'pass';
$gw->Login();
$gid = $gw->OpenGroup("*");
$fid = $gw->OpenFolder($gid, "Contacts");
$data = $gw->FunctionCall("geteventlist", $fid, "EvnClass='E'");

*/

class MerakGWAPI {

   // PUBLIC
   var $user,$pass, $authchallenge, $authscheme;
   var $sessid;
   var $groupsessid;
   var $grouplist;

   var $sException;

   // Function call
   function FunctionCall($funcname, $param1 = "", $param2 = "", $param3 = "", $param4 = ""){
      @$result = icewarp_calendarfunctioncall($funcname, $param1, $param2, $param3, $param4);
      
      return $result;
   }

   function CreateParamLine($array){
      if(!is_array($array)) return '';
      foreach($array as $k => $v) $result .= $k. "=" . rawurlencode($v) ."&";
      return $result;
   }

   function ParseParamLine($line){
      if (!$line) return array();

      $lines = explode("\r\n", $line);

      // Get field array list
      $fields = explode("&", strtoupper(trim($lines[0])));
      unset($lines[0]);

      // Get all lines array
      foreach ($lines as $row){
        $row = trim($row);
        if (!$row) continue;
        $arow = explode("&", $row);

        foreach ($fields as $k => $field){
           if($field) $item[$field] = rawurldecode($arow[$k]);
        }
        $result[] = $item;
      }

      return $result;
   }

   // Session functions
   function Login(){
      global $SERVER_NAME;

      if($this->IsConnected()) return true;

      if (!$this->user) {
         $this->sException = 'No user';
         return false;
      }
      if (!$this->pass) {
         $this->sException = 'No pass';
         return false;
      }

      // Set plain authentication if not set
      if (!$this->authscheme) {
        $this->authscheme = 'PLAIN';
        $this->authchallenge = 'none';
      }

      // Authenticate
      return $this->sessid = $this->FunctionCall("authenticate", $this->user, $this->pass, $SERVER_NAME, $this->authscheme . "|" . $this->authchallenge);
   }

   function Logout(){
      $this->FunctionCall("logoutuser", $this->sessid);

      $this->sessid = null;
      $this->grouplist = null;
   }

   function IsConnected(){
      if ($this->sessid && $this->FunctionCall("userloggedon", $this->sessid)) return true;
      return false;
   }

   // Groups
   function OpenGroup($groupid="*"){
      if (!$groupid) $groupid = $this->grouplist[0]["GRP_ID"];
      return $this->FunctionCall("opengroup", $this->sessid,$groupid);
   }

   function CloseGroup($groupsessid){
      return $this->FunctionCall("closegroup", $groupsessid);
   }

   function OpenFolder($groupsessid, $folder){
      return $this->FunctionCall("openfolder", $groupsessid, $folder);
   }

   function CloseFolder($groupsessid){
      return $this->CloseGroup($groupsessid);
   }

   function GetFolders($groupsessid){
      return $this->ParseParamLine($this->FunctionCall("getfolderlist", $groupsessid));
   }

   function GetGroups($groupview=""){
      if (!$this->sessid){
         $this->sException = 'Call login first';
         return false;
      }

      if(is_array($this->grouplist)) return $this->grouplist;

      return $this->grouplist = $this->ParseParamLine($this->FunctionCall("getgrouplist", $this->sessid,$groupview));
   }

   function GetGroupSessid($groupid=""){
      return $this->OpenGroup($groupid);
   }

   function GetGroupRights($groupsessid){
      return $this->FunctionCall("GetGroupAccessRights",$groupsessid);
   }


   // Date and time
   function Unixdate2Str($date)
   {
     $arr = getdate($date);
     return $this->Date2Str($arr["year"], $arr["mon"], $arr["mday"]);
   }
   function Date2Str($year, $month, $day) {
      return gregoriantojd($month, $day, $year);
   }
   function Datestr2Date($date, &$year, &$month, &$day) {
      $result = jdtogregorian(intval($date));
      ereg("([0-9]{1,2})/([0-9]{1,2})/([0-9]{4})", $result, $regs);
      $month = $regs[1];
      $day = $regs[2];
      $year = $regs[3];
   }
   function Time2Str($hour, $min) {
      return $hour * 60 + $min;
   }
   function Timestr2Time($time, &$hour, &$min) {
      $hour = floor($time / 60);
      $min = $time % 60;
   }
}

?>