////////////////////////////////////////////////////
//      EVENT HANDLERS CROSS BROWSER EMULATION
////////////////////////////////////////////////////
/*
window.onerror = function(msg, url, linenumber){
try{
	- otevrit JS window
	- error template
	- doplnit info o browseru
	- vytvorit chybovou hlasku
	- copy to clipboard button
}
catch(e){
	alert(msg + "\n\nurl: " + url +"\n\nline: "+ linenumber);
}
return true;
}
*/

/**
 * @brief	Event handler emulator for Gecko browsers
 * @author	DRZ 10.03.2005
 */
function emulateEventHandlers(eventNames) {
	for (var i = 0; i < eventNames.length; i++) {
		document.addEventListener(eventNames[i], function (e) {
			window.event = e;
		}, true);
	}
};
typeof(window.event)=="object" ? "" : emulateEventHandlers(["mousemove","mousedown","mouseover"]);

/**
 * @brief	sends given download.php url into iframe
 * @date	9.1.2007 14:48:04
 */
function downloadItem(path){
	if (currentBrowser().indexOf('MSIE') == 0){
		var win = window.open('server/download.php?'+path, "file", "directories=no,location=yes,toolbar=yes,status=yes,menubar=yes,resizable=yes,width=200,height=200");
			win.document.onload = function(){
	            window.close();
			};

		return;
	}

	var id = 'ifrm_download_'+unique_id(),
		frm = mkElement('iframe',{id:id, src:'server/download.php?'+path});
        frm.style.position = 'absolute';
        frm.style.width = '1';
        frm.style.height = '1';
	    frm.style.top = '0';
		frm.style.left = '-1000';

	document.getElementsByTagName('body')[0].appendChild(frm);
	setTimeout("try{ var elm; if ((elm = document.getElementById('"+id+"'))) elm.parentNode.removeChild(elm); }catch(r){}",5000);

	frm = null;
};

/**
 * @brief: cross browser compatible helper to register for events
 **
function AttachEvent (obj, eventname, handler) {
	if (isIE) {
		obj.attachEvent(eventname, handler);
	} else {
		obj.addEventListener(eventname.substr(2), handler, false);
	}
};
*/

function unique_id(){
	return (Math.random()*1000000000000000000)+''+(new Date).getTime();
};

/**
 * @brief: MATH extensions
 **/
Math.ceilFloat = function(num,n){
	n = this.pow(10, parseInt(n)) || 1;
	return this.ceil(parseFloat(num) * n)/n;
};

Math.rand = function(n){
	n = n || 10000000000000000;
	return (this.floor ( this.random ( ) * n + 1 ));
};

/**
 * @brief: Z-index whatever class :)
 **/
_me = cMaxZIndex.prototype;
function cMaxZIndex(){
	this.zindex = [500];
};
	_me.get = function(b){
		var z = this.zindex[this.zindex.length-1]+1;
		if(!b) this.zindex.push(z);
		return z;
	};

	_me.remove = function(z){
		var pos = inArray(this.zindex,z);
		if (pos>-1) this.zindex.splice(pos,1);
	};
maxZIndex = new cMaxZIndex();


function setSelectAll(eElement){
	//MOZILA (pozor nefachaj pak inputy!!!)
	try{
		eElement.style.setProperty ('MozUserSelect', 'all', '');
		eElement.style.setProperty ('-moz-user-select', 'all', '');
	}
	catch(e){}
	//MSIE
	try{ eElement.unselectable = "off"; }catch(e){};
	//KHTM
	try{ eElement.style.KhtmlUserSelect = ""; }catch(e){}
	//Safari
	try{ eElement.style.WebkitUserSelect = "auto"; }catch(e){}
};

function setSelectNone(eElement){
	//MOZILA (pozor nefachaj pak inputy!!!)
	try{
		eElement.style.setProperty ('MozUserSelect', 'none', '');
		eElement.style.setProperty ('-moz-user-select', 'none', '');
	}
	catch(e){}
	//MSIE
	try{ eElement.unselectable = "on"; }catch(e){};
	//KHTM
	try{ eElement.style.KhtmlUserSelect = "none"; }catch(e){}
	//Safari
	try{ eElement.style.WebkitUserSelect = "none"; }catch(e){}
};

/**
 * @brief   Eval JScode in public space (outside parent function)
 * @author  DRZ 28.03.2005
 *
 * Safari 1.2 cant Eval vars defined as:         var name; :(
 */
function pubEval(val){
	if (!val) return false;

	var nav = navigator.userAgent.toLowerCase();

	try{
		//MSIE
		if (typeof window.execScript == 'object')
			window.execScript(val);
		else{
			var tmp;
			//KHTML (Safari)                   FFox3 b1 RC was OK (currentBrowser() == 'Mozilla' && (tmp = nav.match(/firefox\/(\d)/)) && tmp[1]>2)
			if (currentBrowser() == 'Safari' || currentBrowser() == 'KHTML'){
				window.tmp_codeEval = val;

				var script_tag = document.createElement('script');
					script_tag.type = 'text/javascript';
					script_tag.innerHTML = 'eval(window.tmp_codeEval); window.tmp_codeEval = "";';

				document.getElementsByTagName('head')[0].appendChild(script_tag);
				script_tag.parentNode.removeChild(script_tag);
			}
			//Gecko
			else{
				// my solution doesnt work for safari
				window.eval(val);
			}
		}
	}
	catch(e){
		throw new Error("pubEval() - unable to Eval: \r\n" + val);
		return false;
	}
};

/**
 * @brief	search for given parent html element
 * @date	19.4.2006 19:24:23                       predelat na upper!!
 **/
function searchParent(me,eParent){

	if (Is.String(eParent)){
		eParent = eParent.toUpperCase();
		for(;;){
			me = me.parentNode;
			switch(me.tagName){
				case eParent : return me;
				case 'BODY': return false;
			}
		}
	}
	else{
		for(;;){
			try{
				me = me.parentNode;
				if (me.tagName == 'BODY') return false;
				if (me == eParent) return eParent;
			}
			catch(e){
				return false;
			}
		}
	}
};

/**
 * @brief   One-row createElement function
 * @author  DRZ 28.03.2005
 */
function mkElement(tElm,eatt) {
	var elm = document.createElement(tElm);
	if (typeof eatt == 'object') {
		for (var i in eatt){
			try {
				if (i.indexOf('on')==0) {
					elm[i] = function(){eval(eatt[i]);};
				} else {
					switch(i) {
						case 'href': elm[i] = eatt[i]?eatt[i]:'javascript: void(0);';
							break;
						case 'for': elm.setAttribute(i,eatt[i]);
							break;
						default: elm[i] = eatt[i];
					}
				}
			} catch(e) {}
		}
	}

	return elm;
};

/**
 * @brief: DOM isDescendent function
 **/
function isDescendent(x, y){
	while ((y = y.parentNode)) if (y == x) return true;
	return false;
};
/**
 * Returns count of actually added styles
 * If style already exists it doesnt count to $out but it is styll placed to the end
 **/
function addcss(elm){
	var out = 0,css = elm.className, r;
	for (var a = 1;a<arguments.length;a++) {
		r = new RegExp("\\b" + arguments[a] + "\\b",'gi');
		css = elm.className.replace(r,'');
		r = null;

		if (css == elm.className)
			out++;

		css += ' '+arguments[a];
		elm.className = css;
	}

	return out;
};

function removecss(elm){
	if (arguments.length<2) elm.className = '';

	var r, css = elm.className;
	for (var a = 1;a<arguments.length;a++) {
		if (!css || css == arguments[a]){
			css = '';
			break;
		}
		else{
			r = new RegExp("\\b" + arguments[a] + "\\b",'gi');
			css = css.replace(r,'');
			r = null;
		}
	}

	elm.className = css;
};

/**
 * @brief   returns array containing element's size and position
 * @author  DRZ 10.03.2005
 **/

function getSize(elm,doc){
	var doc = (doc || document), r = {x:0,y:0,h:elm.offsetHeight,w:elm.offsetWidth};

	//Mozilla 3 + MSIE somehow doesnt work if elkm is inside table or so!?
	if (currentBrowser == 'Mozilla' && elm.getBoundingClientRect){
		var box = elm.getBoundingClientRect(),
			bod = doc.getElementsByTagName('body')[0];

		r.x = box.left + bod.scrollLeft;
		r.y = box.top + bod.scrollTop;
	}
	else
	//Mozilla 2
	if (doc.getBoxObjectFor) {
		var box = doc.getBoxObjectFor(elm);
		r.x = box.x;
		r.y = box.y;
	}
	//Others
	else{
		r.x = elm.offsetLeft;
		r.y = elm.offsetTop;
		while((elm = elm.offsetParent)){
			if (elm.tagName == 'BODY') break;

			r.x += elm.offsetLeft;
			r.y += elm.offsetTop;
		}
	}
	return r;
};

////////////////////////////////////////////////////
//           TYPE DETECTION FUNCTIONS
////////////////////////////////////////////////////
_me = _Is.prototype;
function _Is(){};

/**
 * @fn   _Is.Boolean()
 * @brief   Chech whether the value is 'boolean'.
 * @param[in]  a  [any]
 * @return  [boolean]   true/false.
 */
_me.Boolean = function(a)  {
	return typeof a == 'boolean';
};

/**
 * @fn   _Is.Array()
 * @brief   Chech whether the value is 'array'.
 * @param[in]  a  [any]
 * @return  [boolean]   true/false.
 * 
 * Examples:
 *    - Is.Array([]) == true
 *    - Is.Array({}) == false    
 */
_me.Array = function(a) {
	return this.Object(a) && a.constructor == Array;
};

/**
 * @fn   _Is.Empty()
 * @brief   Chech whether the array or object is empty.
 * @param[in]  a  [any]
 * @return  [boolean]   true/false
 *    Return value depends on these input types:
 *    - array: true when it doesn't contain any elements, false otherwise.
 *    - object: true when it doens't contain any properties, false otherwise.
 *    - anything else: always true.
 *    
 * Examples:
 *    - Is.Empty([]) == true
 *    - Is.Empty([1, 2]) == false
 *    - Is.Empty({}) == true
 *    - Is.Empty(new Object()) == true          
 */
_me.Empty = function(o) {
	var i, v;
	if (this.Object(o)) {
		for (i in o) {
			v = o[i];
			if (!this.Undefined(v)) return false; // && this.Function(v)
		}
	}
	return true;
};

/**
 * @fn   _Is.Function()
 * @brief   Chech whether the value is 'function'.
 * @param[in]  a  [any]
 * @return  [boolean]   true/false.
 */
_me.Function = function(a) {
	return typeof a == 'function';
};

/**
 * @fn   _Is.Null()
 * @brief   Chech whether the value is 'null'.
 * @param[in]  a  [any]
 * @return  [boolean]   true/false.
 * 
 * Examples:
 *    - Is.Null(0) == false
 *    - Is.Null(new Object()) == false
 *    - Is.Null(null) == true     
 */
_me.Null = function(a) {
	return typeof a == 'object' && !a;
};

/**
 * @fn   _Is.Number()
 * @brief   Chech whether the value is 'number' and is finite.
 * @param[in]  a  [any]
 * @return  [boolean]   true/false.
 * 
 * Examples:
 *    - Is.Number(10) == true
 *    - Is.Number(3.14) == true 
 *    - Is.Number('10') == false
 *    - Is.Number(Infinity) == false
 *    - Is.Number(NaN) == false
 *    - Is.Number([1, 2]) == false       
 */
_me.Number = function(a) {
	return typeof a == 'number' && isFinite(a);
};

/**
 * @fn   _Is.Object()
 * @brief   Chech whether the value is 'object' (functions are considered
 * as objects too). 
 * @param[in]  a  [any]
 * @return  [boolean]   true if parameter 'a' is object (or function), false otherwise.
 * 
 * Examples:
 *    Is.Object([]) == true
 *    Is.Object({}) == true
 *    Is.Object(10) == false
 *    Is.Object(function (){})) == true   
 */ 
_me.Object = function(a) {
	return (a && typeof a == 'object') || this.Function(a);
};

/**
 * @fn   _Is.String()
 * @brief   Chech whether the value is 'string'.
 * @param[in]  a  [any]
 * @return  [boolean]   true/false
 */ 
_me.String = function(a) {
	return typeof a == 'string';
};

/**
 * @fn   _Is.Email()
 * @brief   Chech whether the string has proper email format.
 * @param[in]  a  [string]
 * @return  [boolean]   true/false
 */
_me.Email = function(a) {
	if (!this.String(a)) return false;

    return /^([a-z0-9][\\-\\_\\.]?)*[a-z0-9]+\\@[a-z0-9]+([\\.\\-\\_]?[a-z0-9])*\\.[a-z]{2,4}$/gim.test(a);
	//old return /^[A-Za-z0-9]+([_\.-][A-Za-z0-9]+)*@[A-Za-z0-9]+([_\.-][A-Za-z0-9]+)*\.([A-Za-z]){2,4}$/i.test(a);
};

/**
 * @fn   _Is.Email()
 * @brief   Chech whether the string has proper domain format.
 * @param[in]  a  [string]
 * @return  [boolean]   true/false
 */
_me.Domain = function(a) {
    if (!this.String(a)) return false;
	return /^([a-z0-9][\\-\\_\\.]?)*\\.[a-z]{2,4}$/gim.test(a);
};

/**
 * @fn   _Is.Undefined()
 * @brief   Chech whether the variable has 'undefined' value (uninitializated).
 * @param[in]  a  [any]
 * @return  [boolean]   true/false
 */
_me.Undefined = function(a) {
	return typeof a == 'undefined';
};

/**
 * @fn   _Is.Defined()
 * @brief   Chech whether the variable is 'defined' (previously initializated).
 * @param[in]  a  [any]
 * @return  [boolean]   true/false
 */
_me.Defined = function(x){
	return typeof(x)!="undefined";
};

/**
 * @fn   _Is.Date()
 * @brief   Check whether the provided date is valid.
 * @param[in]  nYear    [number] Any year, etc. 1836
 * @param[in]  nMonth   [number] 1 <= nMonth <= 12
 * @param[in]  nDay     [number] 1 <= nDay <= 31
 * @return  [boolean]   true/false
 * 
 * Examples:
 *    - Is.Date(2000,2,29) == true
 *    - Is.Date(2004,2,29) == true
 *    - Is.Date(1900,2,29) == false    
 */
_me.Date = function(nYear,nMonth,nDay){
	var arMonth=new Array(31,28,31,30,31,30,31,31,30,31,30,31);
	var intMaxDay=0;

	var nnYear = parseInt(nYear);
	var nnMonth = parseInt(nMonth);
	var nnDay = parseInt(nDay);

	if (!this.Number(nnYear) || !this.Number(nnMonth) || !this.Number(nnDay)) return false;

	if((nnYear%4==0 && nnYear%100!=0) || nnYear%400==0)
		arMonth[1]=29;
	else
		arMonth[1]=28;

	intMaxDay = arMonth[nnMonth-1];

	if (nnYear < 0) return false;
	if (nnMonth > 12 || nnMonth < 1) return false;
	if (nnDay > intMaxDay || nnDay < 1) return false;
	return true;
};

Is = new _Is();

////////////////////////////////////////////////////
//               STRING EXTENSIONS
////////////////////////////////////////////////////

/** 
 * @brief	Replace & < > " ' by &amp; &lt; &gt; &quot; &#039;
 * Example:
 *    - "&<>\"'".entityify() == "&amp;&lt;&gt;&quot;&#039;" 
 */
String.prototype.entityify = function() {
	return this.replace(/&/g,"&amp;").replace(/\"/g,"&quot;").replace(/\'/g,"&#039;").replace(/</g,"&lt;").replace(/>/g,"&gt;");
};

/**
 * @brief	Replace &amp; &lt; &gt; &quot; &#039; by & < > " '
 * Example:
 *		"&amp;&lt;&gt;&quot;&#039;".unentityify() == "&<>\"'"
 */   
String.prototype.unentityify = function() {
	return this.replace(/&gt;/g,">").replace(/&lt;/g,"<").replace(/&#039;/g,"\'").replace(/&quot;/g,"\"").replace(/&amp;/g,"&");
};


String.prototype.escapeHTML = function() {
	var div = document.createElement('div');
		div.appendChild(document.createTextNode(this));

	if (currentBrowser() == 'Safari' || currentBrowser() == 'KHTML')
    	return div.innerHTML.replace(/>/gm,'&gt;');
	else
		return div.innerHTML;
};

String.prototype.unescapeHTML = function() {
	if (this.indexOf('&')<0) return this.toString();

	var div = document.createElement('div');
    	div.innerHTML = this.toString();

 	return div.childNodes[0].nodeValue;
};

/**
 * @brief	Analogy to quote meta in PHP
 * Example:
 *    - '\b\f\n\r\t'.quote() == '"\\b\\f\\n\\r\\t"'
 */   
String.prototype.quote = function() {
	var c, i, l = this.length, o = '"';

	for (i = 0; i < l; i += 1) {
		c = this.charAt(i);
		if (c >= ' ') {
			if (c == '\\' || c == '"') o += '\\';
			o += c;
		}
		else {
			switch (c) {
				case '\b':
					o += '\\b';
					break;
				case '\f':
					o += '\\f';
					break;
				case '\n':
					o += '\\n';
					break;
				case '\r':
					o += '\\r';
					break;
				case '\t':
					o += '\\t';
					break;
				default:
					c = c.charCodeAt().toString(16);
					if (c.length == 1) {
						o += '\\u000'+c;
					} else {
						o += '\\u00' + c;
					}
			}
		}
	}
	return o + '"';
};

/**
 * @brief   Strip whitespace from the beginning and end of a string.
 * Example:
 *    - "   Lorem ipsum dolor sit amet  ".trim() == "Lorem ipsum dolor sit amet"
 */
String.prototype.trim = function() {
	return this.replace(/^\s*(\S*(\s+\S+)*)\s*$/, "$1");
};

/**
 * @brief   Remove substrin specified by regular expression.
 * @param[in]  sRegExp  [string|regexp]   Etc. 'abc' or /abc/
 * @param[in]  sOption  [string] Regular expression flag. Possible values are:
 *    - 'g'   Global replace
 *    - 'i'   Ignore case
 *    - 'm'   Multiline   
 * Default value is 'g'. This parametr has only meaning when the first
 * parametr is 'string'. When it is is regular expression, this parametr is
 * ignored.   
 *    
 * Examples:
 *    - "aadvark".remove('a', '') == "advark"
 *    - "aadvark".remove('a') == "dvrk"
 *    - "aadvark".remove('a', 'g') == "dvrk"
 *    - "aadvark".remove(/a/) == "dvrk"
 *
 *    - "Aadvark".remove('a', '') == "Advark"
 *    - "Aadvark".remove('a', 'i') == "advark"
 *    - "Aadvark".remove('a', 'gi') == "dvrk"
 *
 *    - "ten\nton\ntin".remove('n$', '') == "ten\nton\nti"
 *    - "ten\nton\ntin".remove('n$', 'm') == "te\nton\ntin"
 *    - "ten\nton\ntin".remove('n$', 'gm') == "te\nto\nti"
 */   
String.prototype.remove = function(sRegExp,sOption){
	var regEx;
	if (Is.String(sRegExp))
		regEx = new RegExp(sRegExp,(typeof sOption != "undefined")?sOption:"g");
	else
		regEx = sRegExp;
	return this.replace(regEx,"");
};

/**
 * @brief   Remove HTML tags from string.
 *			inline	= ''
 *			block   = ' '
 * Example:
 * 			"<b>Lorem ipsum <i>dolor</i> sit amet</b>".removeTags() == "Lorem ipsum dolor sit amet"
 */   
String.prototype.removeTags = function(str){
	return this.replace(/<[\/]?([a-zA-Z0-9]+)[^>^<]*>/gm,str || '');
};

/**
 * @brief   Quote characters that are not digits nor alphas.
 * Example:
 *    - "@#$%".quoteMeta() == "\@\#\$\%"
 */   
String.prototype.quoteSQL =  function(){
	return this.replace(/([\'\\])/g, "$1$1").replace(/([%])/g , "\\$1");
};
String.prototype.quoteMeta = function(){
	return this.replace(/([\!\#\$\%\^\@\.\&\*\(\)\-\_\=\+\:\;\"\'\\\/\?\<\>\~\[\]\{\}\`])/g , "\\$1" );
};

////////////////////////////////////////////////////
//                 DATE  TOOLS
////////////////////////////////////////////////////

/**
 * @brief   Return date in "webmail" format.
 * @param	bDateOnly	[boolean] 
 * Example:
 *		(new Date()).toWMString() == '11/21/06 09:58'
 *		(new Date()).toWMString(true) == '11/21/06'
 */
Date.prototype.toWMString = function(bDateOnly,bTimeOnly){
	var regEx = /^(\d{1})$/g;
	
	with(this) {
		var full = '';

		if (!bTimeOnly){
			var year = getFullYear().toString();
			var month = (getMonth()+1).toString().replace(regEx,'0$1');
			var day = getDate().toString().replace(regEx,'0$1');

			storage.library('gw_others');
			switch(parseInt(GWOthers.getItem('LAYOUT_SETTINGS','date_format'))) {
				default:
				case 0: // 'mm/dd/yy'
					full = month + '/' + day + '/' + year.substr(2);
					break;

				case 1: // 'mm/dd/yyyy'
					full = month + '/' + day + '/' + year;
					break;

				case 2: // 'dd-mm-yyyy'
					full = day + '-' + month + '-' + year;
					break;

				case 3: // 'dd/mm/yyyy'
					full = day + '/' + month + '/' + year;
					break;

				case 4: // 'yyyy-mm-dd'
					full = year + '-' + month + '-' + day;
					break;
			}
		}
		
		if (bDateOnly)
			return full;
		else	
			return full + ' ' + getHours().toString().replace(regEx,'0$1')
					+ ':' +
					getMinutes().toString().replace(regEx,'0$1');

	}
};

/**
 * @brief	Get actual unix time (number of seconds since 1970-01-01).
 * @return	[number] UNIX time. 
 */
Date.prototype.getUNIX = function(){
	return Math.floor(this.getTime()/1000);
};

/**
 * @brief	Set Date object by UNIX time.
 * @param[in]	iSec	[number]
 */ 
Date.prototype.setUNIX = function(iSec){
	return this.setTime(iSec*1000);
};

/**
 * @brief	Set Date by juliand date and number of minutes.
 * @param[in]	iDate	[number]	Julian date.
 * @param[in]	iIimte	[number]	Number of minutes.
 * Example:
 * 		var date1 = new Date();
 *		var date2 = new Date();
 *		
 * 		date1.setGWTime((new Date()).getJulianDate(), 120);
 *		date2.setHours(2, 0, 0);
 *		
 *		// date1.toString() == date2.toString();
 */ 
Date.prototype.setGWTime = function(iDate,iTime){
	this.setQTime(iDate, iTime ? iTime*60 : 0);
};

/**
 * @brief	Set Date by juliand date and number of seconds.
 * @param[in]	iDate	[number]	Julian date.
 * @param[in]	iIimte	[number]	Number of seconds.
 * Example:
 *		var date1 = new Date();
 *		var date2 = new Date();
 *		
 * 		date1.setQTime((new Date()).getJulianDate(), 3600);
 *		date2.setHours(1, 0, 0);
 *		
 *		// date1.toString() == date2.toString(); 
 */
Date.prototype.setQTime = function(iDate,iTime){
	if (typeof iTime == 'undefined' || isNaN(iTime) || iTime == -1)
		iTime = 0;
 
	var hours,mins,secs;
	with (Math) {
		hours = floor(iTime/3600);
		mins = floor((iTime%3600)/60);
		secs = (iTime%3600)%60;
	}

	var oDate = parseJulianDate(iDate);
	this.setFullYear(oDate.year,oDate.month-1,oDate.day);
	this.setHours(hours, mins, secs, 0);
};

Date.prototype.setVersit = function(iDate){
	var x = /([0-9]{4})([0-9]{2})([0-9]{2})(T([0-9]{2})([0-9]{2})([0-9]{2})(Z)?)?/g;

	var r = x.exec(iDate);
	if (!r) //In case of FFox bug
		r = x.exec(iDate);
	x = null;

	if (r){
		this[r[8]?'setUTCFullYear':'setFullYear'](r[1]*1,(r[2]*1)-1,r[3]*1);

        r[5] = r[5] || 0;
        r[6] = r[6] || 0;
        r[7] = r[7] || 0;

		this[r[8]?'setUTCHours':'setHours'](r[5]*1,r[6]*1,r[7]*1);
	}
};

/**
 * @brief	Get julian date of current object.
 * @return	[number]	Julian date.
 * Example:
 * 		// Prints current julian date
 * 		alert((new Date()).getJulianDate());
 */
Date.prototype.getJulianDate = function() {
	return getJulianDate(this.getDate(), this.getMonth()+1, this.getFullYear());
};

/**
 * @brief	Get week of year (1 - 53).
 * @return	[number]	Week of year (1 - 53).
 * Example:
 *		var date = new Date();
 *		date.setFullYear(2006, 0, 1);
 *
 *		// date.getWeekOfYear() == 1;
 */
Date.prototype.getWeekOfYear = function() {
	var juldate = this.getJulianDate();
	var new_year = new Date(this.getFullYear(),0,1);
	var diff = juldate - new_year.getJulianDate();
	diff += new_year.getDay();
	return Math.floor(diff / 7) + 1;
};

/**
 * Translates day, month and year into julian date.
 * This function is opposite to parseJulianDate(). 
 * @param[in]	day		[number]
 * @param[in]	month	[number]
 * @param[in]	year	[number]
 * @return		[number]	Julian date.
 * @see		parseJulianDate() 
 */
function getJulianDate(day, month, year){
	
	var greg,julian,sign,absm,jul;
	
	with (Math) {  
		
		if (year <= 1585) 
			greg = 0;
		else
			greg = 1;
		
		if ((month - 9)<0) 
			sign=-1;
		else
			sign=1;
				
		julian = -1 * floor(7 * (floor((month + 9) / 12) + year) / 4);
		
		absm = abs(month - 9);
		jul = floor(year + sign * floor(absm / 7));
		jul = -1 * floor((floor(jul / 100) + 1) * 3 / 4);
		julian = julian + floor(275 * month / 9) + day + (greg * jul);
		julian = julian + 1721027 + 2 * greg + 367 * year;
	}
	
	return julian;
};

/**
 * Translates julian date into day, month and year.
 * This function is opposite to getJulianDate(). 
 * @param[in]	julian	[number]	Julian date.
 * @return		[array]		Associative array {'date': 1-31, 'month': 1-12, 'year': [number]}.
 * @see		getJulianDate()
 */    
function parseJulianDate(julian){
	
	var juli,base1,base2,year,month,day;
	var date = new Object();
	
	with (Math) {
		juli = floor(julian);
		base1 = floor(juli + 68569);
		base2 = floor(4 * base1 / 146097);
		base1 = base1 - floor((146097*base2 + 3)/4);
		year = floor(4000*(base1 + 1)/1461001);
		base1 = base1 - floor(1461 * year / 4) + 31;
		month = floor(80 * base1 / 2447);
		day = base1 - floor(2447 * month / 80);
		base1 = floor(month/11);
		month = month + 2 - 12*base1;
		year = 100*(base2 - 49) + year + base1;
	}

	date.day = day;
	date.month = month;
	date.year = year;
	
	return date;
};

/**
 * Translates seconds to minutes and seconds.
 * @param[in]	iTime	[number]	Number of seconds.
 * @return	[string]	Of format 'minutes:seconds'.
 * Example:
 * 		parseJulianTime(3601) == '1:01';
 */     
function parseJulianTime(iTime){

	var minute = Math.ceil(iTime%3600/60);
		minute = minute<10?'0'+minute:minute;

	return (iTime-iTime%3600)/3600 + ':' + minute;
};

/**
 *	Date Format 1.1
 *	(c) 2007 Steven Levithan <stevenlevithan.com>
 *	MIT license
 *	With code by Scott Trenda (Z and o flags, and enhanced brevity)
 **/
var dateFormat = function (){

	var	token        = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTtn])\1?|[LloZ]|"[^"]*"|'[^']*'/g,
		timezone     = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
		timezoneClip = /[^-+\dA-Z]/g,
		pad = function (value, length) {
			value = String(value);
			length = parseInt(length) || 2;
			while (value.length < length)
				value = "0" + value;
			return value;
		};

	// Regexes and supporting functions are cached through closure
	return function (date, mask) {

		// Treat the first argument as a mask if it doesn't contain any numbers
		if (arguments.length == 1 && (typeof date == "string" || date instanceof String) && !/\d/.test(date)) {
			mask = date;
			date = undefined;
		}

		date = date ? new Date(date) : new Date();
		if (isNaN(date))
			throw "invalid date";

		var dF = dateFormat;
		mask   = String(dF.masks[mask] || mask || dF.masks["default"]);

		var	d = date.getDate(),
			D = date.getDay(),
			m = date.getMonth(),
			y = date.getFullYear(),
			H = date.getHours(),
			M = date.getMinutes(),
			s = date.getSeconds(),
			L = date.getMilliseconds(),
			o = date.getTimezoneOffset(),
			flags = {
				d:    d,
				dd:   pad(d),
				ddd:  dF.i18n.dayNames[D],
				dddd: dF.i18n.dayNames[D + 7],
				m:    m + 1,
				mm:   pad(m + 1),
				mmm:  dF.i18n.monthNames[m],
				mmmm: dF.i18n.monthNames[m + 12],
				yy:   String(y).slice(2),
				yyyy: y,
				h:    H % 12 || 12,
				hh:   pad(H % 12 || 12),
				H:    H,
				HH:   pad(H),
				M:    M,
				MM:   pad(M),
				n:    M,
				nn:   pad(M),
				s:    s,
				ss:   pad(s),
				l:    pad(L, 3),
				L:    pad(L > 99 ? Math.round(L / 10) : L),
				t:    H < 12 ? "a"  : "p",
				tt:   H < 12 ? "am" : "pm",
				T:    H < 12 ? "A"  : "P",
				TT:   H < 12 ? "AM" : "PM",
				Z:    (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
				o:    (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4)
			};

		return mask.replace(token, function ($0) {
			return ($0 in flags) ? flags[$0] : $0.slice(1, $0.length - 1);
		});
	};
}();

// Some common format strings
dateFormat.masks = {
	"default":"ddd mmm d yyyy HH:MM:ss",
	shortDate:"m/d/yy",
	mediumDate:"mmm d, yyyy",
	longDate:"mmmm d, yyyy",
	fullDate:"dddd, mmmm d, yyyy",
	shortTime:"h:MM TT",
	mediumTime:"h:MM:ss TT",
	longTime:"h:MM:ss TT Z",
	isoDate:"yyyy-mm-dd",
	isoTime:"HH:MM:ss",
	isoDateTime:"yyyy-mm-dd'T'HH:MM:ss",
	isoFullDateTime:"yyyy-mm-dd'T'HH:MM:ss.lo"
};

// Internationalization strings
dateFormat.i18n = {
	dayNames: [
		"Sun", "Mon", "Tue", "Wed", "Thr", "Fri", "Sat",
		"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
	],
	monthNames: [
		"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
		"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
	]
};

// For convenience...
Date.prototype.format = function (mask) {
	return dateFormat(this, mask);
}

////////////////////////////////////////////////////
//                 ARRAY  TOOLS
////////////////////////////////////////////////////

/**
 * @brief   Returns keys of array (or object).
 * If the parametr is object, take only non-null properties. 
 * @param[in]  arr   [array|object] 
 * @author  DRZ 10.03.2005
 * @return  Array of keys. 
 * Example: 
 *    arrayKeys(["lorem", "ipsum"]); // == [0, 1] 
 *    arrayKeys({"lorem": true, "ipsum": false}) // == ["lorem", "ipsum"]
 *    
 *    var oObject = new Object();
 *    oObject.a = 10;
 *    oObject.b = null;
 *    oObject.c = "test";
 *    
 *    arrayKeys(oObject); // == ["a", "c"]       
 */
function arrayKeys(arr){
	var keys = new Array();
	for (var i in arr)
		if (arr[i] != null)
			keys.push(i);

	return keys;
};

/**
 * @brief   Search value in string, array or object.
 * @param[in]  sElm  [string|array|object]
 * @author  DRZ 10.03.2005 
 * @return  If the parameter is:
 *    - string: then returns position of 'sElm' in string.
 *    - array:  index in the array.
 *    - object: name of the property which has the same value as 'sElm'.
 *    
 *    If the value isn't found, return -1.
 *    
 * Example:
 *    - inArray("lorem ipsum", "ipsum") == 6
 *    - inArray("lorem ipsum", "dolor") == -1
 *    - inArray(["lorem", "ipsum"], "ipsum") == 1
 *    - inArray({"prop1": "lorem", "prop2": "ipsum"}, "ipsum") == "prop2"         
 */
function inArray (aArray,sElm)
{
	//if (aArray.indexOf) return aArray.indexOf(sElm);
	
	for(var i in aArray)
		if(aArray[i]==sElm) return i;

	return -1;
};

/**
 * @brief   Reverse the order of items in the array of object.
 * @param[in]  oObj  [array|object]
 * @return  Array or object with items in reversed order.
 *
 * Example:
 *    - reverse(["lorem", "ipsum"] == ["ipsum", "lorem"]
 *    - reverse({"lorem": 1, "ipsum": 2}) == {"ipsum": 2, "lorem": 1}      
 */ 
function reverse (oObj){
	// reverse array
	if (oObj.constructor == Array)
		return oObj.reverse();

	// reverse object
	var key=[],oOut = {};
	for (var i in oObj)
		key.push(i);

	key.reverse();
	for (var i in key)
		oOut[key[i]] = oObj[key[i]];

	return oOut;
};

/**
 * @brief   Concat unlimited number of associative arrays.
 * @param[in]  '...'  [object] Unlimited number of associative arrays. 
 * @author  DRZ 22.05.2005
 * @warning Doesn't work on normal arrays! 
 * @return  Union of all arrays.  
 *
 * Example:
 *    // {"color": "red", "shape": "triangle", "size": "small", "position": "bottom"}
 *    arrConcat({"color": "red", "shape": "triangle"}, {"size": "small"}, {"position": "bottom"});
 *
 *     // BAD USAGE, returns ["blue", "green"]
 *    arrConcat(["red", "green"], ["blue"]);    
 */
function arrConcat(){
	main = {};
	for (var a = 0;a<arguments.length;a++)
		for (var i in arguments[a]) main[i] = arguments[a][i];

	return main;
};

/**
 * @brief   : concat & unique array
 *            doesnt affect original array
 * @warning : work on normal array ONLY!
 **/
function arrConcatValues(){

	main = clone(arguments[0]);

	for (var a = 1;a<arguments.length;a++)
		for (var i in arguments[a])
			if (inArray(main,arguments[a][i])<0)
				main.push(arguments[a][i]);

	return main;
};

/**
 * @brief   Makes multidimensional array.
 * @param[in]  keys  [array]  List of keys.
 * @param[out]  arr   [array]  Optional, create subarray into alredy exising array. 
 * @author  DRZ 01.05.2005
 * @return  Multidimensional array indexed by keys from 'keys' argument.
 * 
 * Example:
 *    var aArray = {"first": []};
 *
 *    // Prints only structure of created subarray. 
 *    // [first]
 *    //    [second]  
 *    inspect2(mkArrayPath(["second", "third"], aArray["first"]));
 *
 *    // But the whole array looks like this:     
 *    // [first]
 *    //    [second]
 *    //       [third]
 *    inspect2(aArray);    
 */
function mkArrayPath(keys,arr){
	var logic;
	if(typeof arr != 'object') arr = [];

	var out = arr;

	for (var i in keys){
		if (typeof arr[keys[i]] != 'object') arr[keys[i]]=[];
		arr = arr[keys[i]];
	}
	return out;
};

/**
 * @brief: Search in array for substrings.
 * @param[in]  aArray   [array]  List of strings. Non-string items are ignored.
 * @param[in]  sNeedle  [string] Searched substring, e.g. "html".
 * @param[in]  bCase    [boolean]   Ignore case, default false.   
 * @date : 25.3.2006 18:25:40
 * @note : DODELAT ADDSLASHES
 * @return  Array of items containing substring 'sNeedle'. 
 * 
 * Example:
 *    - arraySearch(["he", "she", "there"], "he") == ["he", "she", "there"]
 *    - arraySearch(["he", "she", "there"], "re") == ["there"]     
 */
function arraySearch(aArray,sNeedle,bCase){
	var sFlag = 'g',aOut = [];
	if(bCase) sFlag = 'gi';

	if(!Is.Array(aArray) || !Is.String(sNeedle)) return aOut;

	var rRe = new RegExp(sNeedle.quoteMeta(),sFlag);

	for (var i in aArray)
		if (aArray[i].match && aArray[i].match(rRe)) aOut.push(aArray[i]);

	return aOut;
};

/**
 * @fn   substract(Array1,Array2[,Array3...])
 * @brief   Removes values from Array1 which are contained in remaining arguments.
 * @param[in]  main  [array|object]  Main array from which the values are removed. 
 * @param[in]  '...' [array|object]  List of arrays of values which are removed from the 'main'.
 * @return  Array of values which are contained in 'main' but NOT in the rest arrays. 
 * @note Resulted array can cantain 'gaps', if you want classic array starting from zero
 * use compact() moreover.
 * @see  compact()  
 * @date    12.5.2006 14:01:36
 * 
 * Example:
 *    - substract(["red", "green", "blue", "black"], ["red", "blue"], ["black"]) == {"1": "green"}
 *    - substract({"one": "green", "two": "red"}, {"three": "green"}) == {"two": "red"}   
 */
function substract(main){
	if (arguments.length<2) return main;
	var a,n;
	for (var ii = 1;ii<arguments.length;ii++){
		a = arguments[ii];
		for(var i in a)
			if((n = inArray(main,a[i])) != -1) delete main[n];
	}
	return main;
};

/**
 * @brief   Return lowest free key in array. (Array must be classical starting from zero!).
 * @param[in]  arr   [array]
 * @return  The first index which isn't defined. If array doesn't contain any gaps,
 * return index rigth after the last item.   
 * @date : 10.5.2006 9:32:22
 * 
 * Example:
 *    var aArray = ["one", "two", "three"];
 *    delete aArray[1]; // make 'hole'
 *    
 *    // prints 1  
 *    alert(getFreeKey(aArray));   
 */
function getFreeKey(arr){
	for(var i = 0;i <= arr.length;i++)
		if (typeof arr[i] == 'undefined')
		  return i;
};

/**
 * @brief   Leave only specified keys from arr2 in arr1.
 * @param[in]  arr1  [object] Associative array {key1:value,key2:value}.
 * @param[in]  arr2  [array] Array [key1,key2,...].
 * @return  Array containing only specified items. 
 * @todo What is it good for when the second parametr is assoc. array? 
 * @date : 16.5.2006 11:14:05
 * 
 * Example:
 *    - arrKeySlice({"one": "red", "two": "green", "three": "blue"}, ["two"]) == {"two": "green"}  
 */
function arrKeySlice(arr1,arr2){
	/* create Arrr or object along to arr1 type */
	var k,isa = false,out = [];
	if (arr2.constructor == Array) isa=true;

	if (!arr1 || !arr2) return isa?out:compact(arr2);

	for (var i in arr2){
		if (isa)
			k = arr2[i]
		else
			k = i;

		if(!isa && !arr1[k] && arr2[k])
			out[k] = arr2[k];  // TODO: what is it good for?
		else if (typeof arr1[k] != 'undefined')
			out[k] = arr1[k];
	}
	return out;
};

/**
 * @brief	Remove empty and null items from the array.
 * @param[in]  a  [array|object]
 * @return	New array (the old one is left unchanged) with stripped null and
 * empty strings. 
 * 
 * Example:
 *		compact([1, '2', '', 3, null, '4']) => [1, '2', 3, '4']       
 */
function compact(a){
	var b;
	if (Is.Array(a)){
		b = [];
		for(var i in a)
			if(a[i]) b.push(a[i]);
	}
	else{
		b = {};
		for(var i in a)
			if(a[i]) b[i] = a[i];
	}
	return b;
};


/**
 * @brief   Return number of values in array or object.
 * @param[in]  arr   [array|object] 
 * @date : 10.5.2006 9:31:05
 * 
 * Example:
 *    - count({"one": "red", "two": "green"}) == 2
 *    - count(["one", "two", "three"]) == 3    
 */
function count (arr){
	var i = 0;
	//if (arr.constructor == Array) return arr.length;  - nahovno arraycount == maxkey+1
	if (typeof arr == 'object') {
		for (var v in arr) i++;
		return i;
	}
	return -1;  // invalid argument
};

/**
 * @brief   Check if two one dimensional arrays are identical (keys must be the same!).
 * Items are compared one by one so be careful when comparing multidimensional arrays.
 * This function works on one-dimensional array as you expected (items are atomic values).
 * When comparing subarrays, the are considered the same only if they are the same
 * references (they point to the same address in the memory).  
 * @param[in]  arr1  [array]
 * @param[in]  arr2  [array]
 * @return  true/false
 *     
 * @warning arrayCompare(["one", "two"], ["two", "one"]) == false because of different order!
 * (["one", "two"] == {"0": "one", "1": "two"} != {"0": "two", "1": "one"}).
 * @warning Only first dimension is compared so arrayCompare([[1]], [[1]]) == false. 
 * 
 * Example:
 *    - arrayCompare(["one", "two"], ["one", "two"]) == true
 *    - arrayCompare(["one", "two"], ["two", "one"]) == false
 *    - arrayCompare(["one", "two"], {"1": "two", "0": "one"}) == true
 *    - arrayCompare([[1]], [[1]]) == false
 *    
 *    // Special case with multidimensional array
 *    var aArray = [1]; 
 *    arrayCompare([aArray], [aArray]); // == true
 */ 
function arrayCompare(arr1, arr2) {
	var length = 0;

	for (var key in arr1) {
		if (arr1[key] != arr2[key]) {
			return false;
		}
		length++;
	}
	if (count(arr2) == length)
		return true;
	else
		return false;
};

////////////////////////////////////////////////////
//                   URL  TOOLS
////////////////////////////////////////////////////

/**
 * @brief   Function build URL GET string from JS array.
 * Don't worry about special characters like & or %, they are URL encoded. 
 * @param[in]  varList  [object] Associative array of name->value.
 * @return GET string composed from pairs (name,value) from 'varList'.
 * @author DRZ 10.03.2005
 * 
 * Example:
 *    - buildURL({"size": "normal", "special": "%^&"}) == "size=normal&special=%25%5E%26"   
 */
function buildURL(varList) {
	var separator = '';
	var url = '';

	for (var name in varList ) {
		url += separator + encodeURIComponent(name)
			+ '=' + encodeURIComponent(varList[name]);
		separator = '&';
	}

	return url;
};

/**
 * @brief   Function parses URL GET variables to JS array.
 * @param[in]  url   [string] URL encoded string.
 * @return  Associative array of name->value obtained from url.  
 * @author  DRZ 10.03.2005
 * 
 * Example:
 *    - parseURL("size=normal&special=%25%5E%26") == {"size": "normal", "special": "%^&"}   
 */
function parseURL(url){
	var p,r,output = [];
	if (!url) url = self.location.href;
	if ((p = url.indexOf('?'))>-1 && (p<url.indexOf('='))) url = url.substr(p+1);
	argList = url.split('&');
	for (var i=0; i<argList.length; i++){
		newArg = argList[i].split('=');
		output[unescape(newArg[0])] = unescape(newArg[1]);
	}
	return output;
};



////////////////////////////////////////////////////
//                COOKIES  MANAGER
////////////////////////////////////////////////////
_me = cCookieManager.prototype;
function cCookieManager(){}

/**
 * @brief   Set value of the cookie.
 * @param[in]  sName    [string] Name of the cookie.
 * @param[in]  aValue   [object] Associative array of name->value.
 * @param[in]  iDays    [number] Optional, in how many days should this cookie
 * expire. 
 */  
_me.set = function(sName,aValue,iDays) {
	var sExpires = "";
	var dDate = new Date();

	if(typeof aValue == 'string') aValue = [aValue];

	if(!Is.Defined(document.cookie)) return;

	if(iDays){
		dDate.setTime(dDate.getTime()+(iDays*86400000));
		sExpires = "; expires="+dDate.toGMTString();
	}
	else sExpires = "";

	document.cookie = sName+ "=" + buildURL(aValue) + sExpires + "; path=/";
};

/**
 * @brief   Get value of the cookie.
 * @param[in]  sName    [string] Name of the cookie.
 * @return  [object] Associative array of name->value.
 */   
_me.get = function(sName) {
	if(!document.cookie) return null;

	var sSeek	= sName + "=";
	var sCookie	= "";
	var aCookie	= document.cookie.split(";");
	var sCookieValue;
	
	for (var i in aCookie){
		sCookie = aCookie[i].trim();
		if (sCookie.indexOf(sSeek)!=0) continue;

		sCookieValue = sCookie.substring(sSeek.length);
		
		if (sCookieValue)
			return parseURL(sCookie.substring(sSeek.length));
		else
			return [];
	}
	return null;
};

var cookieManager = new cCookieManager();

////////////////////////////////////////////////////
//                 Miscellaneous
////////////////////////////////////////////////////

// TODO unless executeCallbackFunction reorders the parameters
// this hacker function wouldn't be nedeed
function pushParameterToCallback(aResponse, arg) {
	if (Is.Function(aResponse[0])) {
		if (Is.Array(aResponse[1]))
			aResponse[1].push(arg);
		else
			aResponse[1] = [arg];
	}
	else
	if (Is.Object(aResponse[0])) {
		if (Is.Array(aResponse[2]))
			aResponse[2].push(arg);
		else
			aResponse[2] = [arg];
	}
	else
		throw Exception('Invalid argument');
};

/**
 * @brief	Implements calling registered function.
 * This function is used everywhere the callback is needed, mostly in reaction on some event
 * in the form. Etc. when the user submit some form and we need extra actions connected to that event.
 * @param[in]	aResponse	[array]
 * 		[0] - [Object|Function]		Depends on whether we call standalone function or member function.
 * 		[1] - [String|Array|Function]
 * 									If the first parameter is Object, the second must be string (name
 * 									of the function, otherwise array containing arguments to the function.
 * 		[3]	- [Array]				Optional. It can be preset in case the first parameter is object and
 * 									it represents argument to the function.
 * 									
 * @param[in]				[all]	Optional. The callback function is then called with these parameters and
 * 									they have 'higher priority' to aResponse[3] in that way they are first.
 * 									
 * @TODO	Don't reorder parameters!  
 * 									
 * Example 1:
 * 		var func = function(arg) {
 * 			alert(arg1);
 * 			alert(arg2);
 * 		}
 * 		
 *		executeCallbackFunction([func, ['2']], '1');	// Will print '1' and '2'
 *		
 * Example 2:
 * 		var date = new Date();
 *			
 *		executeCallbackFunction([date, 'setHours', [2, 3, 0], xml|array (default)|text], 1);	// Sets 1 hours, 2 minutes, 3 seconds and 0 milliseconds.
 */
 



function getCallbackFunction(aResponse){
	if (Is.Function(aResponse[0]))
	    return aResponse[0];
	else
	if (Is.Function(aResponse[1]))
	    return aResponse[1];
	else
		return aResponse[0][aResponse[1]];
};

function executeCallbackFunction(aResponse)
{
	if (Is.Array(aResponse) && ((Is.Object(aResponse[0]) && (Is.String(aResponse[1]) || Is.Function(aResponse[1]))) || Is.Function(aResponse[0])))
		try
		{
			//Method or function?
			var nIndex;
			if (Is.Function(aResponse[0]))
				nIndex = 1;
			else
				nIndex = 2;

			//Prepare arguments
			var args = [];
			for (var i = 1; i < arguments.length; i++)
				args.push(arguments[i]);

			if (Is.Array(aResponse[nIndex]))
				args = args.concat(aResponse[nIndex]);

			// function, [args]
			if (nIndex == 1) //Is.Function(aResponse[0])
                aResponse[0].apply(null,args);
			else
			// object, method, [args]
			if (Is.Function(aResponse[1]))
				aResponse[1].apply(aResponse[0], args);
			// object, "method", [args]
			else{
				aResponse[0][aResponse[1]].apply(aResponse[0],args);

				if (aResponse[0]._destructed == true)
					return false;
			}

			return true;
		}
		catch(e){

			inspect2(e); // TODO remove this debug

			if (Is.String(aResponse[0]))
				throw new Error("Error while executing "+aResponse[0]+"() in browser_ext:executeCallbackFunction()");
			else
				throw new Error("Error while executing oObject."+aResponse[1]+"() in browser_ext:executeCallbackFunction()");

			return false;
		}
	else
		return false;
};


function getPrimaryAccountFromAddress() {
	var aAccInfo = dataSet.get('accounts',[sPrimaryAccount]);
	if (aAccInfo['FULLNAME'])
		return '"' + aAccInfo['FULLNAME'] + '" <' + sPrimaryAccount + '>';
	else
		return sPrimaryAccount;
}

function getSubobjects(oObject) {
	function _getSubobjects(oObject, aObjects) {
		for (var i in oObject) {
			if (i.charAt(0) != '_' && i.substr(0,2) != 'X_' && i.substr(0,2) != 'x_') {
				if (oObject[i]._type == 'obj_tabs' || oObject[i]._type == 'obj_tab') {
					_getSubobjects(oObject[i], aObjects);
				} else {
					aObjects[i] = oObject[i];
				}
			}
		}
	}
	
	var aObjects = {};
	_getSubobjects(oObject, aObjects);
	return aObjects;
};

function getAuxiliarySubobjects(oObject) {
	function _getAuxiliarySubobjects(oObject, aObjects) {
		for (var i in oObject) {
			if (i.charAt(0) != '_') {
				if (i.substr(0,2) == 'X_' || i.substr(0,2) == 'x_') {
					aObjects[i] = oObject[i];
				} else if (oObject[i]._type == 'obj_tabs' || oObject[i]._type == 'obj_tab') {
					_getAuxiliarySubobjects(oObject[i], aObjects);
				}
			}
		}
	}
	
	var aObjects = {};
	_getAuxiliarySubobjects(oObject, aObjects);
	return aObjects;
};

function loadDataIntoForm(oObject, aValues) {
	var aObjects = getSubobjects(oObject);
	for (var i in aObjects) {
		if (Is.Defined(aValues[i]) && aValues[i] != 'undefined') {
			aObjects[i]._value(aValues[i]);
		}
	}
}

function loadDataIntoFormOnAccess(oObject, aValues, bIgnoreDomain){
	var aObjects = getSubobjects(oObject,aObjects);
	if (aValues['USERACCESS'] || aValues['DOMAINADMINACCESS'])
		var aAuxiliaryObjects = getAuxiliarySubobjects(oObject);
	
	for (var i in aObjects) {
		if (aValues['ACCESS'][i]) {
			switch(aValues['ACCESS'][i]){
				case 'full':
					aObjects[i]._value(aValues['VALUES'][i]);
					break;
				case 'view':
					aObjects[i]._value(aValues['VALUES'][i]);
					aObjects[i]._disabled(true);
					break;

				case 'none':
					aObjects[i]._main.parentNode.style.display = "none";
			}
		}
		if (aValues['DOMAINADMINACCESS'] && !bIgnoreDomain) {
			if (aAuxiliaryObjects['x_'+i+'_set']) {
				aAuxiliaryObjects['x_'+i+'_set'].domadmin._value((aValues['DOMAINADMINACCESS'][i] == 'view') ? true : false);
				aAuxiliaryObjects['x_'+i+'_set'].domadmin._onclick();
			}
		}
		if (aValues['USERACCESS']) {
			if (aAuxiliaryObjects['x_'+i+'_set']) {
				aAuxiliaryObjects['x_'+i+'_set'].user._value((aValues['USERACCESS'][i] == 'view') ? true : false);
				aAuxiliaryObjects['x_'+i+'_set'].user._onclick();
			}
		}
	}
};

function storeDataFromFormWithAccess(oObject, aValues, aAccess) {
	var aObjects = getSubobjects(oObject);
	var aAuxiliaryObjects = getAuxiliarySubobjects(oObject);
	
	var value;
	for(var i in aObjects) {
		if (Is.Defined((value = aObjects[i]._value())))
			aValues[i] = value;
		else
			aValues[i] = '';
		
		if (aAuxiliaryObjects['x_'+i+'_set'] && aAuxiliaryObjects['x_'+i+'_set'].domadmin) {
			if (!aAccess['DOMAINADMINACCESS']) aAccess['DOMAINADMINACCESS'] = {};
			aAccess['DOMAINADMINACCESS'][i] = aAuxiliaryObjects['x_'+i+'_set'].domadmin._value() ? 'view' : 'full';
		}

		if (aAuxiliaryObjects['x_'+i+'_set']) {
			if (!aAccess['USERACCESS']) aAccess['USERACCESS'] = {};
			aAccess['USERACCESS'][i] = aAuxiliaryObjects['x_'+i+'_set'].user._value() ? 'view' : 'full';
		}
	}
};

function storeDataFromForm(oObject, aValues) {
	var aObjects = getSubobjects(oObject);
	var value;
	for(var i in aObjects){
		if (Is.Defined((value = aObjects[i]._value())))
			aValues[i] = value;
		else
			aValues[i] = '';
	}
};

function firstIndex(oObject) {
	if (Is.Object(oObject)) {
		for(var i in oObject)
			return i;
		return null;
	}
	else
		return null;
}

function firstValue(oObject) {
	if (Is.Object(oObject)) {
		for (var i in oObject)
			return oObject[i];
		return null;
	}
	else
		return null;
}

function shiftObject(oObject) {
	if (Is.Object(oObject)) {
		for (var i in oObject) {
			var result = oObject[i];
			delete oObject[i];
			return result;
		}
		return null;
	}
	else
		return null;
}

function isFormEmpty(aValues) {
	for (var i in aValues) {
		if (Is.Object(aValues[i])) {
			if (!isFormEmpty(aValues[i])) return false;
		}
		else
		if (aValues[i] != '') return false;
	}
	return true;
}

function translateFolder(sFolder) {
	var sSpecialName;
	if ((sSpecialName = getSpecialFolderName(sFolder)))
		return getLang(sSpecialName);
	else
		return sFolder;
}

function getSpecialFolderName(sFolder) {
	if (inArray(['Drafts','INBOX','Sent','Trash','SPAM_QUEUE','Spam','Events','Tasks','Notes','Contacts','Files','Journal'], sFolder) >= 0)
		return 'COMMON_FOLDERS::'+sFolder.toUpperCase();
	else
		return '';
}

/**
 * @brief: color conversions etc...
 * @note : adopted from http://www.easyrgb.com/math.html
 * @date : 19.9.2006 10:38:52
 **/
_me = cColors.prototype;
function cColors(){
	this.hexchars = "0123456789ABCDEF";
};

_me.rgb2hsv = function(r,g,b){

	var R = r/255;                     //RGB values = 0 Ă· 255
	var G = g/255;
	var B = b/255;

	var iMin = Math.min(R, G, B);    //Min. value of RGB
	var iMax = Math.max(R, G, B);    //Max. value of RGB
	var dMax = iMax - iMin;          //Delta RGB value

	var H,S,V = iMax;

	//This is a gray, no chroma... HSV results = 0 Ă· 1
	if (dMax == 0){
		H = 0;
		S = 0;
	}
    //Chromatic data...
	else{
		S = dMax/iMax;

		var dR = (((iMax - R) / 6) + (dMax/2)) / dMax;
		var dG = (((iMax - G) / 6) + (dMax/2)) / dMax;
		var dB = (((iMax - B) / 6) + (dMax/2)) / dMax;

		if (R == iMax) H = dB - dG;
		else
		if (G == iMax) H = (1/3) + dR - dB;
		else
		if (B == iMax) H = (2/3) + dG - dR;

		if (H < 0) H += 1;
		if (H > 1) H -= 1;
	}

	return [H*255,S*255,V*255];
};

_me.rgb2hsl = function(r,g,b){
	var R = r / 255;                 //Where RGB values = 0 Ă· 255
	var G = g / 255;
	var B = b / 255;

	var iMin = Math.min(R, G, B);    //Min. value of RGB
	var iMax = Math.max(R, G, B);    //Max. value of RGB
	var dMax = iMax - iMin;			 //Delta RGB value

	var H,S,L = (iMax + iMin)/2;

	if (dMax == 0){                  //This is a gray, no chroma...
		H = 0;                       //HSL results = 0 Ă· 1
		S = 0;
	}
	else{                            //Chromatic data...
		if (L < 0.5)
			S = dMax / (iMax + iMin);
		else
			S = dMax / (2 - iMax - iMin);

		var dR = ( ( ( iMax - R ) / 6 ) + ( dMax / 2 ) ) / dMax;
		var dG = ( ( ( iMax - G ) / 6 ) + ( dMax / 2 ) ) / dMax;
		var dB = ( ( ( iMax - B ) / 6 ) + ( dMax / 2 ) ) / dMax;

		if (R == iMax )
			H = dB - dG;
		else
		if (G == iMax)
			H = ( 1 / 3 ) + dR - dB;
		else
		if (B == iMax)
			H = ( 2 / 3 ) + dG - dR;

		if (H < 0) H += 1;
		if (H > 1) H -= 1;
	}
	return [Math.ceil(H*255),Math.ceil(S*255),Math.ceil(L*255)];
};

_me.isValidRGB = function(aRGB){
	if ((!aRGB[0] && aRGB[0] !=0) || isNaN(aRGB[0]) || aRGB[0] < 0 || aRGB[0] > 255 ||
		(!aRGB[1] && aRGB[1] !=0) || isNaN(aRGB[1]) || aRGB[1] < 0 || aRGB[1] > 255 ||
		(!aRGB[2] && aRGB[2] !=0) || isNaN(aRGB[2]) || aRGB[2] < 0 || aRGB[2] > 255) return false;

	return true;
};

_me.hex2rgb = function(str) {
	str = str.replace('#','');
	return	[
			(this.toDec(str.substr(0, 1)) * 16) + this.toDec(str.substr(1, 1)),
			(this.toDec(str.substr(2, 1)) * 16) + this.toDec(str.substr(3, 1)),
			(this.toDec(str.substr(4, 1)) * 16) + this.toDec(str.substr(5, 1))
			];

	return rgb;
};

_me.toDec = function(hexchar) {
	return this.hexchars.indexOf(hexchar.toUpperCase());
};

_me.rgb2hex = function(r,g,b) {
	return this.toHex(r) + this.toHex(g) + this.toHex(b);
};

_me.toHex = function(n) {
	n = n || 0;
	n = parseInt(n, 10);
	if (isNaN(n)) n = 0;
	n = Math.round(Math.min(Math.max(0, n), 255));

	return this.hexchars.charAt((n - n % 16) / 16) + this.hexchars.charAt(n % 16);
};
colors = new cColors();

function getActualEventTime() {
	var now = new Date();
	var julian = now.getJulianDate();
	var time = now.getHours()*60 + now.getMinutes();
	time -= time%30;

	return {
		'EVNSTARTDATE': julian,
		'EVNSTARTTIME': time,
		'EVNENDDATE': julian,
		'EVNENDTIME': time+30
	};
};

function arrToString(arr){
	if (arr === null)
		return 'null';
		
	switch(typeof arr){
		case 'string':
			return "'" + arr + "'";

		case 'number':
			return arr;

		case 'object':
			var aResult = ['{'],bEnd;

			for(var sKey in arr) {
				if (bEnd)
					aResult.push(',');
					
				aResult.push("'" + sKey + "'", ':', arrToString(arr[sKey]));
				bEnd = true;
			}
			aResult.push('}');
			return aResult.join('');

		case 'undefined':
		    return 'undefined';
	}
};

function valuesToString(arr){
	var sResult = '';

	for(var n in arr)
		sResult += arr[n] + '|';

	return sResult.substr(0,sResult.length-1);
};

////////////////////////////////////////////////////////////////////////////////////////////////////
//                                       Class MailAddress 
////////////////////////////////////////////////////////////////////////////////////////////////////

/**
 * @class	MailAddress
 */
function MailAddress() {}
MailAddress.createEmail = function(name,email){
	var out = '';
	if (name){
		name = name.replace('"','\\"').trim();
		out = (name.indexOf(' ')>-1 || name.indexOf(',')>-1?'"'+name+'"':name);
	}

	if (email){
		if (out) out += ' ';
		out += '<'+ email +'>';
	}
	
	return out;
};

MailAddress.splitEmails = function(sMails) {
	if (!sMails) return [];
	return MailAddress.parseMail(sMails, 'address_array');
};

MailAddress.splitEmailsAndNames = function(sMails) {
	if (!sMails) return [];
	return MailAddress.parseMail(sMails, 'name_and_email');
};


MailAddress.parseMail = function(sMails, sFormat) {
	if (!sMails) return '';

	/* parse email addresses from string to an array */
	function getAddresses(sMails, sFormat){
		/* find next delimiter in the string */
		function nextDelimiter(sString, nIndex, items){
			var result = [];
			
			if (!items)
				items = new Array('\\', '"', ',', ';', '<'); //'\'',

			result[0] = -1;
			for (var i in items){
				ind = sString.indexOf(items[i],nIndex);
				if (ind != -1 && (result[0] == -1 || ind < result[0])){
					result[0] = ind;
					result[1] = items[i];
				}
			}
			return result;
		}

		/* get string starting at nIndex position of sString (ended by cDelimiter) */
		function getString(sString, nIndex, cDelimiter, bStripDelimiter){
			var str = '';
			var ind = nIndex+1;
			var result = [];
			var aInd;

			while (1){
				aInd = nextDelimiter(sString, ind);
				// delimiter not found, use whole string
				if (aInd[0] == -1){
					str += sString.substr(ind);
					ind = -1;
					break;
				}
				// closing character found, append rest of the string
				if (aInd[1] == cDelimiter){
					str += sString.substring(ind,aInd[0]);
					ind = aInd[0]+1;
					break;
				}
				// backslash found, append string + next character
				else
				if (aInd[1] == '\\'){
					str += sString.substring(ind,aInd[0]) + (bStripDelimiter ? '' : '\\') + sString.charAt(aInd[0]+1);
					ind = aInd[0]+2;
				}
				// another delimiter found, append string
				else{
					str += sString.substring(ind,aInd[0]) + aInd[1];
					ind = aInd[0]+1;
				}
			}

			result[0] = ind;
			result[1] = str.trim();

			return result;
		}
		
		/* get string starting at nIndex position of sString (ended by ',' or ';') */
		function getStringTillDelimiter(sString, nIndex, bStripDelimiter)
		{
			var str = '';
			var ind = nIndex;
			var result = [];
			var aInd;

			while (1){
				aInd = nextDelimiter(sString, ind);
				// delimiter not found, use whole string
				if (aInd[0] == -1){
					str += sString.substr(ind);
					ind = -1;
					break;
				}
				// closing character found, append rest of the string
				if (aInd[1] == ',' || aInd[1] == ';'){
					str += sString.substring(ind,aInd[0]);
					ind = aInd[0]+1;
					break;
				}
				// backslash found, append string + next character
				else if (aInd[1] == '\\'){
					str += sString.substring(ind,aInd[0]) + (bStripDelimiter ? '' : '\\') + sString.charAt(aInd[0]+1);
					ind = aInd[0]+2;
				}
				// beginning of string found, append whole string
				else if (aInd[1] == '\'' || aInd[1] == '"'){
					var aString = getString(sString,aInd[0],aInd[1], bStripDelimiter);
					if (aString[0] == -1){
						// there is nothing behind the string, so finish
						str += aInd[1] + aString[1];
						ind = -1;
						break;
					}
					else{
						str += aInd[1] + aString[1] + aInd[1];
						ind = aString[0];
					}
				}
				// another delimiter found, append string
				else{
					str += sString.substring(ind,aInd[0]) + aInd[1];
					ind = aInd[0]+1;
				}
			}

			result[0] = ind;
			result[1] = str.trim();

			return result;
		}

		function stripEmailBrackets(sEmail){
			var nStart = 0;
			var nEnd = sEmail.length;
			if (sEmail.charAt(0) == '<')
				nStart++;
			if (sEmail.charAt(nEnd-1) == '>')
				nEnd--;
			return sEmail.substring(nStart, nEnd);
		}






		function parseNameAndEmail(sMails){
			var sTmp = '';
			var aResult = [];
			var aItem = [];
			var nIndex = 0;
			var aDelimiter = nextDelimiter(sMails,0);

			var aString;

			while (1){
				// append the rest of the string and finish
				if (aDelimiter[0] == -1){
					sTmp += sMails.substr(nIndex);
					aItem['name'] = '';
					aItem['email'] = sTmp.trim();
					aResult.push(aItem);
					break;
				}

				if (aDelimiter[1] == '\'' || aDelimiter[1] == '"'){
					// beginning of string found, get whole string
					aString = getString(sMails,aDelimiter[0],aDelimiter[1],true);

					if (aString[0] == -1){
						// there is nothing behind the string, add empty name and finish
						aItem['name'] = '';
						aItem['email'] = aString[1];
						aResult.push(aItem);
						break;
					}
					else{
						// find next breaking delimiter, add an email address
						aItem['name'] = aString[1];
						aString = getStringTillDelimiter(sMails,aString[0],true);
						aItem['email'] = aString[1];
						aResult.push(aItem);
						aItem = [];
						if (aString[0] == -1)
							break;
						else
							nIndex = aString[0];
					}
				}
				else
				if (aDelimiter[1] == '\\'){
					// skip the \ in the result
					sTmp += sMails.substring(nIndex,aDelimiter[0]) + sMails.charAt(aDelimiter[0]+1);
					nIndex = aDelimiter[0]+2;
				}
				else
				if (aDelimiter[1] == '<'){
					// append the beginning of string as name, set sTmp to '<' (because email address follows)
					aString = getStringTillDelimiter(sMails,aDelimiter[0],true);
					sTmp += sMails.substring(nIndex,aDelimiter[0]);
					aItem['name'] = sTmp.trim();
					aItem['email'] = aString[1];
					aResult.push(aItem);
					if (aString[0] == -1)
						break;

					// else
					aItem = [];
					sTmp = '';
					nIndex = aString[0];
				}
				else
				if (aDelimiter[1] == ',' || aDelimiter[1] == ';'){
					// end of email address reached, append it to the result
					sTmp += sMails.substring(nIndex,aDelimiter[0]);
					aItem['name'] = '';
					aItem['email'] = sTmp.trim();
					aResult.push(aItem);
					aItem = [];
					nIndex = aDelimiter[0]+1;
					sTmp = '';
				}
				else{
					// another delimiter found, append string
					str += sMails.substring(nIndex,aDelimiter[0]);
					ind = aDelimiter[0]+1;
				}

				aDelimiter = nextDelimiter(sMails,nIndex);
			}
			
			return aResult;
		}
		
		function parseAddresses(sMails){
			var aResult = [];
			var nIndex = 0;
			var aString;
			
			while (1){
				// append the rest of the string and finish
				aString = getStringTillDelimiter(sMails,nIndex,false);
				if (aString[1]) aResult.push(aString[1]);
				if (aString[0] == -1)
					break;
				else
					nIndex = aString[0];
			}
			
			return aResult;
		}

		var aMails;

		switch (sFormat){
			case 'name_list':
				aMails = parseNameAndEmail(sMails);
				for(var n in aMails)
					if (aMails[n]['name'])
						aMails[n] = aMails[n]['name'].entityify();
					else
						aMails[n] = aMails[n]['email'].entityify();
				return aMails.join(', ');

			case 'name_and_email':
				aMails = parseNameAndEmail(sMails);
				for(var n in aMails) {
					if (aMails[n]['name'])
						aMails[n]['name'] = aMails[n]['name'];//.entityify();    odstraneno kuli suggest/ukladani do cookie
					if (aMails[n]['email'])
						aMails[n]['email'] = stripEmailBrackets(aMails[n]['email']);//.entityify();
				}
				return aMails;

			case 'address_array':
				return parseAddresses(sMails);
		}
	}
	
	return getAddresses(sMails, sFormat);
};

MailAddress.findDistribList = function(aType)
{
	var aEmails,sEmail,sDistribList,aDistribList,sAccId,sFolId,aName,sName;
	var aResult = {};
	var aDistrib = {};
	
	//Procházíme jednotlivé typy
	for(var sType in aType)
	{
		aResult[sType] = '';
		
		if (!aType[sType])
			continue;

		aEmails = MailAddress.splitEmails(aType[sType])

		//Procházíme jednotlivé emaily
		for(var n in aEmails)
		{
			sEmail = aEmails[n];

			//Nasli jsme distribuční seznam?
			if (sEmail.charAt(0) == '[' && sEmail.charAt(sEmail.length-1) == ']')
			{
				sDistribList = sEmail.substr(1,sEmail.length-2);
				aDistribList = sDistribList.split('::');

				sAccId = '';
				sFolId = '';
				aName = [];

				//Identifikace moľného distribučního seznamu
				switch(aDistribList.length <= 3 ? aDistribList.length : 3)
				{
					case 3:
						sAccId = aDistribList.shift();

					case 2:
					sFolId = aDistribList.shift();

					case 1:
						for(var m in aDistribList)
							aName.push(aDistribList[m]);
						
						sName = aName.join('::');
				}
				//Není-li zadán account, bereme primární
				if (!sAccId)
					sAccId = sPrimaryAccount;

				//Není-li zadán folder, bereme default
				if (!sFolId)
				sFolId = Mapping.getDefaultFolderForGWType('C');

				//Naplnění distribučního seznamu
				if (!aDistrib[sAccId])
					aDistrib[sAccId] = {};

				if (!aDistrib[sAccId][sFolId])
					aDistrib[sAccId][sFolId] = {'to':[],'cc':[],'bcc':[]};

				aDistrib[sAccId][sFolId][sType].push(sName);
			}
			else
			aResult[sType] += sEmail + ',';
		}
		aResult[sType] = aResult[sType].substr(0,aResult[sType].length-1);
	}
	aResult['distrib'] = aDistrib;

	return aResult;
};


/*
function parsemail(sMail){

	for(var i = 0;i<sMail.length;i++){



	}
};
*/
////////////////////////////////////////////////////////////////////////////////////////////////////
//                                       Class Path 
////////////////////////////////////////////////////////////////////////////////////////////////////

/**
 * @class	Path
 */
function Path() {}

/**
 * @brief   Split forder path into account path and folderID.
 * This function is used with function which operate with AccountID and FolderID,
 * e.g. item.copy(), item.move() etc.
 * 
 * @param[in]  sFolderPath [string] Full folder name, e.g. 'admin@merakdemo.com/INBOX'.
 * @return aOut  [object]
 *    - [0]  Contains account id, e.g. 'admin@merakdemo.com'.
 *    - [1]   Contains folder id, e.g. 'INBOX'. When only account is
 *    specified, empty string is returned in this item.
 *    
 * Example:
 *    - Path.split(false) => ['', '']
 *    - Path.split('admin@merakdemon.com/INBOX') == ['admin@merakdemon.com', 'INBOX']
 *    - Path.split('admin@merakdemon.com') == ['admin@merakdemon.com', '']                 
 */
Path.split = function(sFolderPath) {
	var aRet = [];

	if (!Is.String(sFolderPath)) {
		aRet[0] = '';
		aRet[1] = '';
	}
	else{
		var nIndex;
		if ((nIndex = sFolderPath.indexOf('/')) >= 0) {
			aRet[0] = sFolderPath.substring(0, nIndex);
			aRet[1] = sFolderPath.substring(nIndex+1);
		}
		else{
			aRet[0] = sFolderPath;
			aRet[1] = '';
		}
	}

	return aRet;
};

/**
 * @brief   Returns filename component of path.
 * Given string containing a path to a file, this function will return the base name of the file.
 * @param[in]	sPath	[string]	String containing a path to a file.
 * @return	[string]    Filename component of path.
 *
 * Example: Path.basename('/home/httpd/html/index.php') == 'index.php'
 */
Path.basename = function(sPath) {
	if (!Is.String(sPath)) return false;
	return sPath.split('/').pop();
};

////////////////////////////////////////////////////////////////////////////////////////////////////
//                                       Class Mapping 
////////////////////////////////////////////////////////////////////////////////////////////////////

/**
 * @class	Mapping
 */
function Mapping() {} 

/**
 * @brief   Get default folder for GW item depending on its type.
 * @param[in]   sType   [string]    One character type, e.g. 'C' or 'T'.
 * @return  [string]    Default folder, e.g. 'Contacts'. This mapping is used:
 *  - 'C' => 'Contacts'
 *  - 'E' => 'Events'
 *  - 'J' => 'Journal'
 *  - 'N' => 'Notes'
 *  - 'T' => 'Tasks'
 *  - 'F' => 'Files'
 */
Mapping.getDefaultFolderForGWType = function(sType) {
	switch (sType) {
		case 'C': return 'Contacts';
		case 'L': return 'Contacts';
		case 'E': return 'Events';
		case 'J': return 'Journal';
		case 'N': return 'Notes';
		case 'T': return 'Tasks';
		case 'F': return 'Files';
		default: throw new Error('Not implemented');return false;
	}
};

/**
 * @brief   Get form name depending on GW type.
 * @param[in]   sType   [string]    One character type, e.g. 'C' or 'T'.
 * @return  [string]    Default folder, e.g. 'frm_contact' or 'frm_event'.
 */
Mapping.getFormNameByGWType = function(sType) {
	switch (sType) {
		case 'C': return 'frm_contact';
		case 'E': return 'frm_event';
		case 'N': return 'frm_note';
		case 'T': return 'frm_task';
		case 'J': return 'frm_journal';
		case 'L': return 'frm_distrib';
		case 'F': return 'frm_file';
		default: throw new Error('Not implemented');return false;
	}
};

function toString(o) {
	return (o == undefined || o == null) ? '' : o.toString();
};

function makeIDFromIDS(ids, i) {
	return [ids[0], ids[1], ids[2][i]];
};

function makeIDSFromID(id) {
	return [id[0], id[1], [id[2]]];
};

function getPathFromDataset(sDataset) {
	var items = dataSet.get(sDataset);
	for (var sAccId in items)
		for (var sFolId in items[sAccId])
			return [sAccId, sFolId];
};

/**
 * get browser
 * Edit: 13.6.2008 12:15:57
 **/
window.currentBrowser = function (){
	var out = '',
	    v = '',
		str = navigator.userAgent.toUpperCase();

	if (str.indexOf('WEBKIT')>-1){
		out = 'Safari';

		// 525 = 3.x
		// 528 = 4.x
		v = parseInt(str.substr(str.indexOf('SAFARI/')+7));
	}
	else
	if (str.indexOf('KHTML')>-1)
		out = 'KHTML';
	else
	if (str.indexOf('GECKO')>-1)
		out = 'Mozilla';
	else
	if (str.indexOf('OPERA')>-1)
		out = 'Opera';
	else
	if (str.indexOf('MSIE 6.0')>-1)
		out = 'MSIE6';
	else
	if (str.indexOf('MSIE 7')>-1 || str.indexOf('MSIE 8')>-1)
		out = 'MSIE7';

	return function(bV){
		return bV?v:out;
	}
}();