_me = frm_change_channel.prototype;
function frm_change_channel(){};

/**
 * @brief   Form for adding folder.
 * Form has three input objects:
 *    - text input for name of the folder (folder must
 *    match this regular expr. /^ *[a-zA-Z0-9#\.\_\-]+[ a-zA-Z0-9#\.\_\-]*$/).
 *    - select box for folder type specification (mail, contact, event, journal, note, task).
 *    - folder three.
 * 'OK' button is active only if the name of the folder match the regular expr. above. 
 *     
 * @param[in]  sAccountID  [string] Only folders from this account will be listed because of
 * moving folders between accounts is disabled. 
 * @param[in]  sFolderID   [string] Optional. Forder with this ID will be preselected. 
 * 
 * @see  objects/frm_add_folder.xml
 * @see  inc/frm_add_folder.js
 */
_me.__constructor = function(sAccountID, sFolderID){
	var me = this;

	if (!Is.Defined(sAccountID)) return;

	this._title('POPUP_FOLDERS::CHANGE_CHANNEL');
	this._size(300,'',true);

	// Create formular from template
	this._draw('frm_change_channel', 'main');
/*
	this.x_btn_ok._disabled(true);
	this.input_channel._onerror = function(isError) {
		me.x_btn_ok._disabled(isError);
	};
*/
	this.input_channel._onsubmit = function(){
//		if (!me.x_btn_ok._disabled())
			me.x_btn_ok._onclick();
	};

	aDefault = dataSet.get('folders',[sAccountID,sFolderID]);

	this.input_channel._value(aDefault.CHANNEL);

	// This function is triggered when 'OK' button is pressed
	this.x_btn_ok._onclick = function() {
		folders.add({'aid': sAccountID, 'fid': sFolderID, 'channel': me.input_channel._value(), 'type': 'R'}, 'folders');
		me._destruct();
	}
};