_me = frm_settings_admin.prototype;
function frm_settings_admin(){};

_me.__constructor = function(bDomainadmin,sDomainName)
{
	var me = this;
	this._size(600,470,true);


	if ((this._bDomainadmin = bDomainadmin?true:false))
		this._title(getLang('MAIN_MENU::DOMAIN_OPTIONS')+(sDomainName?' ('+ sDomainName +')':''),true);
	else
		this._title('MAIN_MENU::ADMIN_OPTIONS');
		
	this._xmlns = 'public';

	if (this._bDomainadmin) {
		this._draw('frm_settings_domainadmin','main',{domain_settings:true});
		this._storage = 'domainadmin_storage';
		if (sDomainName){
            this._domain = sDomainName.trim();
			this._storage += '_' + this._domain;
		}
	}
	else {
		//include domains
		storage.library('wm_domains');
		this._domains = new wm_domains;

		this._draw('frm_settings_admin','main',{admin_settings:true});
		this._storage = 'admin_storage';
	}

	var aRsc = ['skins',
				'gw_groups',
				'mail_settings_general',
				'mail_settings_default',
				'layout_settings',
				'languages',
				'forgot_settings',
				'calendar_settings',
				'default_calendar_settings',
				'default_reminder_settings',
				'global_settings',
				'spellchecker_languages',
				'restrictions',
				'imip_settings'
				];

	if (!this._bDomainadmin)
		aRsc.push('domains_settings');

	storage.library('wm_storage');

    if (this._bDomainadmin && this._domain)
		dataSet.add(this._storage, '', WMStorage.get({'xmlns': this._xmlns,'domain':this._domain,'resources':aRsc}));
	else
		dataSet.add(this._storage, '', WMStorage.get({'xmlns': this._xmlns,'resources':aRsc}));
		
	this.__loadItems();
	
	this.x_btn_ok._onclick = function(){
		me.__saveItems();
		//if (GWOthers.getItem('LAYOUT_SETTINGS', 'language') != me._curLanguage)
		//	alert(getLang('LANGUAGES::ONCHANGE_INFO'));
	}
	
	this._defaultSize();
};

_me.__loadItems = function()
{
	var me = this;
	
	// ********************************************
	// MAILSETTINGS
	
	this.maintab.mail_settings._onactive = function (bFirstTime) {
		if (!bFirstTime)
			return;
		
		var oTab = this.maintab;
	
		// TAB1 - GENERAL
		oTab.general._onactive = function (bFirstTime) {
			if (bFirstTime) {
				this.default_flag._fillLang({
					'1':["COLOR_LABELS::RED_FLAG",'bg_red'],
					'2':["COLOR_LABELS::BLUE_FLAG",'bg_blue'],
					'3':["COLOR_LABELS::GREEN_FLAG",'bg_green'],
					'5':["COLOR_LABELS::ORANGE_FLAG",'bg_orange'],
					'8':["COLOR_LABELS::PURPLE_FLAG",'bg_purple'],
					'a':["COLOR_LABELS::YELLOW_FLAG",'bg_yellow']
				});
	
				var aData = GWOthers.get('MAIL_SETTINGS_GENERAL', me._storage, true);
				if (aData)
					loadDataIntoFormOnAccess(this, aData, me._bDomainadmin);
			}
		}
		
		// TAB2 - DEFAULT
		oTab.mail_default._onactive = function (bFirstTime) {
			if (bFirstTime) {
				
				//spellchecker default lang
				var aLang = GWOthers.get('SPELLCHECKER_LANGUAGES', me._storage, true);
    			var aData = {};
				for (var lang in aLang['VALUES'])
					aData[lang] = aLang['VALUES'][lang];
				this.spellchecker._fill(aData);
				
				var aData = GWOthers.get('MAIL_SETTINGS_DEFAULT', me._storage, true);
				if (aData)
					loadDataIntoFormOnAccess(this, aData, me._bDomainadmin);
			}
		}
		
		// force drawing first tab
		oTab.general._onactive(true);
	}
	
	// ********************************************
	// GENERALSETTINGS
	
	this.maintab.general_settings._onactive = function (bFirstTime) {
		if (!bFirstTime)
			return;

		var oTab = this.maintab;

		// TAB1 - LAYOUT
		oTab.layout._onactive = function (bFirstTime) {
			if (bFirstTime) {

				//LANGs
				var aLang = GWOthers.get('LANGUAGES', me._storage, true);
				var aData = {};
				for (var lang in aLang['VALUES'])
					aData[lang] = aLang['VALUES'][lang];

				this.language._fill(aData);

				if (!aData[GWOthers.getItem('LAYOUT_SETTINGS','language')])
					GWOthers.setItem('LAYOUT_SETTINGS','language',GWOthers.getDefaultValues('LAYOUT_SETTINGS').LANGUAGE);


				//SKINs
				var aSkin = GWOthers.get('SKINS', me._storage, true);
				var aData = {};
				for (var i in aSkin['VALUES'])
					if (i != 'value')
						aData[i] = aSkin['VALUES'][i];

				this.skin._fill(aData);

				if (!aData[GWOthers.getItem('LAYOUT_SETTINGS','skin')])
					GWOthers.setItem('LAYOUT_SETTINGS','skin',GWOthers.getDefaultValues('LAYOUT_SETTINGS').SKIN);


				//DATE
				this.date_format._fill({
					0:'mm/dd/yy',
					1:'mm/dd/yyyy',
					2:'dd-mm-yyyy',
					3:'dd/mm/yyyy',
					4:'yyyy-mm-dd'
				});

				var aData = GWOthers.get('LAYOUT_SETTINGS', me._storage, true);
				if (typeof aData == 'object')
					loadDataIntoFormOnAccess(this, aData, me._bDomainadmin);

				if (this.title._value() == '')
					this.title._value(getLang('LOGIN_SCREEN::TITLE'));
				
				if (this.login_title._value() == '')
					this.login_title._value(getLang('LOGIN_SCREEN::LOGIN_CAPTION'));
			}
		}
		
		// TAB2 - FORGOT
		if (oTab.forgot)
			oTab.forgot._onactive = function (bFirstTime) {
				if (bFirstTime) {
					var aData = GWOthers.get('FORGOT_SETTINGS', me._storage, true);
					if (typeof aData == 'object')
						loadDataIntoFormOnAccess(this, aData, me._bDomainadmin);
				}
			};

		// TAB3 - SERVER
		if (oTab.server)
			oTab.server._onactive = function (bFirstTime) {
				if (bFirstTime) {
					var aData = GWOthers.get('GLOBAL_SETTINGS', me._storage, true);
					if (typeof aData == 'object')
						loadDataIntoFormOnAccess(this, aData, me._bDomainadmin);
				}
			};

		// TAB4 - RESTRICTIONS
		if (oTab.restrictions)
			oTab.restrictions._onactive = function (bFirstTime) {
				if (bFirstTime) {
					var aData = GWOthers.get('RESTRICTIONS', me._storage, true);
					if (typeof aData == 'object')
						loadDataIntoFormOnAccess(this, aData, me._bDomainadmin);

					if (aData.VALUES.disable_gw_types){
						if (aData.VALUES.disable_gw_types.indexOf('c')>-1)
							oTab.restrictions.x_c._value(1);
						if (aData.VALUES.disable_gw_types.indexOf('e')>-1)
							oTab.restrictions.x_e._value(1);
						if (aData.VALUES.disable_gw_types.indexOf('j')>-1)
							oTab.restrictions.x_j._value(1);
						if (aData.VALUES.disable_gw_types.indexOf('n')>-1)
							oTab.restrictions.x_n._value(1);
						if (aData.VALUES.disable_gw_types.indexOf('t')>-1)
							oTab.restrictions.x_t._value(1);
						if (aData.VALUES.disable_gw_types.indexOf('f')>-1)
							oTab.restrictions.x_f._value(1);
						if (aData.VALUES.disable_gw_types.indexOf('r')>-1)
							oTab.restrictions.x_r._value(1);
					}

					if (oTab.restrictions.x_disable_gw_types_set.domadmin)
						oTab.restrictions.x_disable_gw_types_set.domadmin._value(aData.DOMAINADMINACCESS.disable_gw_types == 'view');
				}
			};

			//GWOthers.getItem('RESTRICTIONS', 'disable_gw_types').indexOf()
			
		// force drawing first tab
		oTab.layout._onactive(true);
	};
	
	// ********************************************
	// CALENDARSETTINGS
	
	this.maintab.calendar_settings._onactive = function (bFirstTime) {
		if (!bFirstTime)
			return;
		
		var oTab = this.maintab;

		// TAB1 - MAIN
		oTab.main._onactive = function (bFirstTime) {
			if (bFirstTime) {
                this.gw._wasActivated = true;
				var prdka = this.calendar;
                	prdka._wasActivated = true;
                	
				// init
				prdka.week_begins._fillLang({
					'sunday': "DAYS::SUNDAY",
					'monday': "DAYS::MONDAY",
					'tuesday': "DAYS::TUESDAY",
					'wednesday': "DAYS::WEDNESDAY",
					'thursday': "DAYS::THURSDAY",
					'friday': "DAYS::FRIDAY",
					'saturday': "DAYS::SATURDAY"
				});
				
				prdka.week_begins._value('sunday');
				
				var aHours = {};
				for (var i=0; i<24; i++)
					aHours[i] = i.toString() + ':00';
				prdka.day_begins._fill(aHours);
				prdka.day_ends._fill(aHours);
				
				prdka.day_begins._onchange = function (){
					if (parseInt(prdka.day_begins._value()) > parseInt(prdka.day_ends._value()))
						prdka.day_ends._value(prdka.day_begins._value());
				}
				prdka.day_ends._onchange = function (){
					if (parseInt(prdka.day_begins._value()) > parseInt(prdka.day_ends._value()))
						prdka.day_begins._value(prdka.day_ends._value());
				}

				// load data
				var aData = GWOthers.get('CALENDAR_SETTINGS', me._storage, true);
				if (aData)
					loadDataIntoFormOnAccess(prdka, aData, me._bDomainadmin);
					
				var aData = GWOthers.get('GW_GROUPS', me._storage, true);
				if (aData)
					loadDataIntoFormOnAccess(this.gw, aData, me._bDomainadmin);
			}
		}
		
		// TAB2 - DEFAULT SETTINGS
		oTab.default_settings._onactive = function (bFirstTime) {
			if (bFirstTime) {
				var aData = GWOthers.get('DEFAULT_CALENDAR_SETTINGS', me._storage, true);
				if (aData)
					loadDataIntoFormOnAccess(this, aData, me._bDomainadmin);
			}
		}
		
		// TAB3 - DEFAULT REMINDER
		oTab.default_reminder._onactive = function (bFirstTime) {
			if (bFirstTime) {
				var aData = GWOthers.get('DEFAULT_REMINDER_SETTINGS', me._storage, true);
				if (aData)
					loadDataIntoFormOnAccess(this, aData, me._bDomainadmin);
			}
		}
		
		// TAB3 - DEFAULT REMINDER
		oTab.imip._onactive = function (bFirstTime) {
			if (bFirstTime) {
				var aData = GWOthers.get('IMIP_SETTINGS', me._storage, true);
				if (aData)
					loadDataIntoFormOnAccess(this, aData, me._bDomainadmin);
			}
		}

		// force drawing first tab
		oTab.main._onactive(true);
	};
	
	// ********************************************
	// DOMAINS
	if (this.maintab.domains_settings)
	this.maintab.domains_settings._onactive = function (bFirstTime) {
		if (!bFirstTime)
			return;

		// init
		this.x_adddomain._onclick = function(){
			var sDomain = (this._parent.x_domain._value() || '').trim();
			if (sDomain != ''){

				//domains are unigue
				var old = this._parent.domains._value();
				for(var i in old)
					if(old[i].domain == sDomain) return;

				this._parent.domains._add([{'domain':sDomain}]);
			}
		};

		this.x_remove._onclick = function(){
			this._parent.domains._removeSelected();
		};

		this.domains._ondblclick = function(){
        	var aDomain = this._getSelectedValue();
			if (aDomain && aDomain.domain)
        		gui._create('settings','frm_settings_admin','','',true,aDomain.domain);
		};

		this.x_editdomain._onclick = function(){
			var aDomain = this._parent.domains._getSelectedValue();
			if (aDomain && aDomain.domain)
				gui._create('settings','frm_settings_admin','','',true,aDomain.domain);
		};

		// load values into lister
		var aDomains = me._domains.get(me._storage,true);
        if (aDomains)
			this.domains._add(aDomains);

		// load values into select
		var aDomains = me._domains.get(me._storage);
		if (aDomains){
			var str,arr = {};
			for(var i in aDomains){
				if (aDomains[i].domain){
					str = aDomains[i].domain.toString().trim();
					arr[str] = str;
				}
			}
			this.x_domain._fill(arr);
		}
	};
	
	// ********************************************
	// FINALIZATION

	// force drawing first tab
	this.maintab.mail_settings._onactive(true);
};

_me.__saveItems = function()
{
	var me = this;
	var aValues = {};
	
	function storeNonWellKnown(oForm, sResource) {
		var aValues = {};
		var aAccess = {};
		if (oForm._wasActivated) {
			storeDataFromFormWithAccess(oForm, aValues, aAccess);
			GWOthers.set(sResource, aValues, me._storage, aAccess);
		}
	}
	// ********************************************
	// MAILSETTINGS
	if (this.maintab.mail_settings._wasActivated) {
		var oTab = this.maintab.mail_settings.maintab;

		//storeNonWellKnown(oTab.general, 'MAIL_SETTINGS_GENERAL');
		
		
		
		storeNonWellKnown(oTab.mail_default, 'MAIL_SETTINGS_DEFAULT');
		
        if (oTab.general && oTab.general._wasActivated){
			var aValues = {},aAccess = {};
			storeDataFromFormWithAccess(oTab.general, aValues, aAccess);



			if (aAccess.DOMAINADMINACCESS){
                aAccess.DOMAINADMINACCESS.autoupdate_minutes = aAccess.DOMAINADMINACCESS.autoupdate;
                aAccess.DOMAINADMINACCESS.autosave_minutes = aAccess.DOMAINADMINACCESS.autosave;
                aAccess.DOMAINADMINACCESS.autoclear_trash_days = aAccess.DOMAINADMINACCESS.autoclear_trash;
			}
			if (aAccess.USERACCESS){
                aAccess.USERACCESS.autoupdate_minutes = aAccess.USERACCESS.autoupdate;
                aAccess.USERACCESS.autosave_minutes = aAccess.USERACCESS.autosave;
                aAccess.USERACCESS.autoclear_trash_days = aAccess.USERACCESS.autoclear_trash;
			}
			
			GWOthers.set('MAIL_SETTINGS_GENERAL', aValues, this._storage, aAccess);
		}
	}
	// ********************************************
	// GENERALSETTINGS
	if (this.maintab.general_settings._wasActivated) {
		var oTab = this.maintab.general_settings.maintab;

		//Layout settings
		if (oTab.layout && oTab.layout._wasActivated) {
			if (oTab.layout.title._value() == getLang('LOGIN_SCREEN::TITLE')) oTab.layout.title._value('');
			if (oTab.layout.login_title._value() == getLang('LOGIN_SCREEN::LOGIN_CAPTION')) oTab.layout.login_title._value('');
			storeNonWellKnown(oTab.layout, 'LAYOUT_SETTINGS');
		}

		if (oTab.forgot && oTab.forgot._wasActivated)
			storeNonWellKnown(oTab.forgot, 'FORGOT_SETTINGS');
			
		if (oTab.server && oTab.server._wasActivated)
			storeNonWellKnown(oTab.server, 'GLOBAL_SETTINGS');
			
        if (oTab.restrictions && oTab.restrictions._wasActivated){
			var aValues = {},aAccess = {};
			storeDataFromFormWithAccess(oTab.restrictions, aValues, aAccess);

			//DISABLE_GW_TYPES
			if (aAccess.DOMAINADMINACCESS)
				aAccess.DOMAINADMINACCESS.disable_gw_types = oTab.restrictions.x_disable_gw_types_set.domadmin._value()?'view':'full';

			aAccess.USERACCESS.disable_gw_types = oTab.restrictions.x_disable_gw_types_set.user._value()?'view':'full';
			aValues.disable_gw_types =	(oTab.restrictions.x_c._value()?'c':'')+
										(oTab.restrictions.x_e._value()?'e':'')+
										(oTab.restrictions.x_j._value()?'j':'')+
										(oTab.restrictions.x_n._value()?'n':'')+
										(oTab.restrictions.x_t._value()?'t':'')+
										(oTab.restrictions.x_r._value()?'r':'')+
										(oTab.restrictions.x_f._value()?'f':'');
										
			GWOthers.set('RESTRICTIONS', aValues, this._storage, aAccess);
		}
	}
	// ********************************************
	// CALENDARSETTINGS
	if (this.maintab.calendar_settings._wasActivated) {
		var oTab = this.maintab.calendar_settings.maintab;

		storeNonWellKnown(oTab.main.calendar, 'CALENDAR_SETTINGS');
		storeNonWellKnown(oTab.main.gw, 'GW_GROUPS');
		storeNonWellKnown(oTab.default_reminder, 'DEFAULT_REMINDER_SETTINGS');
		
		storeNonWellKnown(oTab.imip, 'IMIP_SETTINGS');
		
		storeNonWellKnown(oTab.default_settings, 'DEFAULT_CALENDAR_SETTINGS');
	}
	// ********************************************
	// DOMAINSSETTINGS
	if (this.maintab.domains_settings && this.maintab.domains_settings._wasActivated) {
        var oTab = this.maintab.domains_settings;
		var aValues = {};

		storeDataFromForm(oTab,aValues);
		me._domains.set(aValues.domains,this._storage);
	}
	
	//Záloha stávajícího storage
	dataSet.add('tmp_storage','',dataSet.get(this._storage));

	//Hromadné posílání povolených změn na server
	if (this._bDomainadmin && this._domain)
		var nOK = WMStorage.set({'xmlns':this._xmlns,'domain':this._domain,'resources':dataSet.get(this._storage)},this._storage,'',[this,'__saveItemsHandler']);
	else
		var nOK = WMStorage.set({'xmlns':this._xmlns,'resources':dataSet.get(this._storage)},this._storage,'',[this,'__saveItemsHandler']);
	
	//Na server se nic neposílá?
	if (nOK == 2) {
		dataSet.remove('tmp_storage');
		this._destruct();
	}
	else
		this._main.style.display = "none";
};

_me.__saveItemsHandler = function(bOK)
{
	//Přijal server náš dotaz?
	if (bOK){
		dataSet.remove('tmp_storage');
		this._destruct();
	}
	else{
		dataSet.add(this._storage,'',dataSet.get('tmp_storage'));
		dataSet.remove('tmp_storage');
		this._main.style.display = "block";
	}
};
