function gw_groups(){};

var _me = gw_groups.prototype;

//********************************************************************************
//Základní GET funkce pro práci s gw_groups
//********************************************************************************
//Vstup:  sDataSet ... globální pole, kde jsou uloženy všechny resource
//Výstup: pole asociativních polí
//********************************************************************************

_me.get = function(sDataSet)
{
	//Zadali jsem parametr?
	if (!sDataSet)
		return false;

	var aGroups = dataSet.get(sDataSet,['GW_GROUPS']);

	//Je tento resource inicializovaný?
	if (typeof aGroups != 'object')
		return false;

	var aGroupFrame;
	var aResult = [];
	var aGroupResult;

	//Procházíme jednotlivé group
	for(var n in aGroups['ITEMS'])
	{
		aGroupFrame = aGroups['ITEMS'][n];
		aGroupResult = {};
		aGroupResult['UID'] = aGroupFrame['ATTRIBUTES']['UID'];

		//Procházíme jednotlivé hodnoty group
		for(var sValue in aGroupFrame['VALUES'])
			aGroupResult[sValue] = aGroupFrame['VALUES'][sValue]['VALUE'];

		aResult.push(aGroupResult);
	}
	return aResult;
};

//********************************************************************************
//Základní SET funkce pro práci s gw_groups
//********************************************************************************
//Vstup: aSubscribe ... asociativní pole GroupId -> textová booleovská hodnota
//********************************************************************************

_me.set = function(aSubscribe,sDataSet){

	var aGroups = dataSet.get(sDataSet,['GW_GROUPS','ITEMS']);

	//Je tento resource inicializovaný?
	if (typeof aGroups != 'object')
		return false;

	var bChange = false;

	//Procházíme jednotlivé poslané groups
	for(var sGrpId in aSubscribe)
		//Procházíme stávající groups
		for(var n in aGroups)
			//Nalezli jsme odpovídající group
			if (sGrpId == aGroups[n]['ATTRIBUTES']['UID'])
			{
				//Změnili jsme hodnotu?
				if (aSubscribe[sGrpId] != aGroups[n]['VALUES']['SUBSCRIBED']['VALUE'])
				{
					aGroups[n]['VALUES']['SUBSCRIBED']['VALUE'] = aSubscribe[sGrpId];
					aGroups[n]['ATTRIBUTES']['DONT_SEND'] = false;
					bChange = true;
				}
				break;
			}

	//Máme nějaké změny?
	if (bChange){
		dataSet.add(sDataSet,['GW_GROUPS','ITEMS'],aGroups);
		dataSet.add(sDataSet,['GW_GROUPS','ATTRIBUTES','DONT_SEND'],false);
	}

	return true;
};