function gw_shared(){};

var _me = gw_shared.prototype;

//********************************************************************************
//Základní GET funkce pro práci s gw_shared
//********************************************************************************
//Vstup:  sDataSet ... globální pole, kde jsou uloženy všechny resource
//Výstup: pole asociativních polí
//********************************************************************************

_me.get = function(sDataSet)
{
  //Zadali jsem parametr?
	if (!sDataSet)
	  return false;
	  
	var aSharedAccounts = dataSet.get(sDataSet,['SHARED_ACCOUNTS']);

	//Je tento resource inicializovaný?
	if (typeof aSharedAccounts != 'object')
	  return false;

	var aSharedAccountFrame;
	var aResult = [];
	var aSharedAccountResult;
	
	//Procházíme jednotlivé friend
	for(var n in aSharedAccounts['ITEMS'])
	{
		aSharedAccountFrame = aSharedAccounts['ITEMS'][n];
		aSharedAccountResult = {};
	  aSharedAccountResult['UID'] = aSharedAccountFrame['ATTRIBUTES']['UID'];

    //Procházíme jednotlivé hodnoty friend
		for(var sValue in aSharedAccountFrame['VALUES'])
		  aSharedAccountResult[sValue] = aSharedAccountFrame['VALUES'][sValue]['VALUE'];
		  
		aResult.push(aSharedAccountResult);
 	}
	return aResult;
};

//********************************************************************************
//Základní SET funkce pro práci s gw_shared
//********************************************************************************
//Vstup: aSharedAccountsInfo ... pole asociativních polí klíč -> hodnota
//       sDataSet            ... globální pole, kam se ukládají všechny resource
//********************************************************************************

_me.set = function(aSharedAccountsInfo,sDataSet)
{
	//Zadali jsme oba parametry?
	if (typeof aSharedAccountsInfo != 'object' || !sDataSet)
		return false;

	var aSharedAccounts = dataSet.get(sDataSet,['SHARED_ACCOUNTS']);

	//Je tento resource inicializovaný?
	if (typeof aSharedAccounts != 'object')
		return false;

	//Promazeme prazdne a spatne zapsane
	var bChange = false;
	for (var m in aSharedAccounts.ITEMS)
		if (aSharedAccounts.ITEMS[m].VALUES && aSharedAccounts.ITEMS[m].VALUES.EMAIL && !aSharedAccounts.ITEMS[m].VALUES.EMAIL.VALUE){
		 	aSharedAccounts.ITEMS[m].VALUES = {};
		 	aSharedAccounts.ITEMS[m].ATTRIBUTES.DONT_SEND = false;
            bChange = true;
		}
		

	var aSharedAccount,aItem,aValues;
	var aSharedAccountInfo,sUId;

	var bValuesChanged;
	
	//Procházíme poslané shared
	for(var n in aSharedAccountsInfo)
	{
		aSharedAccountInfo = aSharedAccountsInfo[n];
		sUId = aSharedAccountInfo['uid'];
	
		//Mažeme či přidáváme shared
		if (sUId)
		{
			//Procházíme stávající shared
			for(var m in aSharedAccounts['ITEMS'])
			{
				aSharedAccount = aSharedAccounts['ITEMS'][m];
				
				//Nalezli jsme odpovídající shared
				if (sUId == aSharedAccount['ATTRIBUTES']['UID'])
				{
					//Mažeme shared?
					if (count(aSharedAccountInfo) <= 1)
					{
						aSharedAccount['VALUES'] = {};
						aSharedAccount['ATTRIBUTES']['DONT_SEND'] = false;
						bChange = true;
					}
					break;
				}
			}
		}
		else
		{
			//Přidáváme nový shared
			aItem = {'ATTRIBUTES':{'DONT_SEND':false},'VALUES':{}};
			aValues = aItem['VALUES'];
			
			//Procházíme jednotlivé hodnoty shared
			for(var sValue in aSharedAccountInfo)
				aValues[sValue.toUpperCase()] = {'VALUE':aSharedAccountInfo[sValue],'ATTRIBUTES':{}};

			aSharedAccounts['ITEMS'].push(aItem);
			bChange = true;
		}
	}


	//Máme nějaké změny?
	if (bChange)
	{
		aSharedAccounts['ATTRIBUTES']['DONT_SEND'] = false;
		dataSet.add(sDataSet,['SHARED_ACCOUNTS'],aSharedAccounts);
	}
	return true;
};
