_me = obj_attendees.prototype;
function obj_attendees() {};

_me.__constructor = function(sType,owner) {
	var me = this,dialog_name,title_prefix;

	this.__owner = owner || sPrimaryAccount;
	
	this.__atts = {};
	this.__new_count = 0;
	this.aDatagridRows = [];
	this.sType = sType;

	switch (this.sType) {
		case 'DISTRIB_LIST':
			this.grid._addColumns({	'LCTDESCRIPTION':{"title":'DISTRIB_LIST::NAME',"width":'200'},
									'LCTEMAIL1':{"title":'DISTRIB_LIST::EMAIL',"width":'200'}});

			// please note that first entry of this.items array has to be a description and the second an email
			// otherwise the function __onAddNewFromAddressbook() wouldn't work properly
			this.items = ['LCTDESCRIPTION','LCTEMAIL1'];
			dialog_name = 'frm_edit_dl_member';
			title_prefix = 'DISTRIB_LIST';
			break;
		
		case 'ATTENDEES':
			this.grid._addColumns({
            'CNTSTATUS':{'width':18,'arg':{'sort':'desc'},'css':'status',"type":'static',"text":'&nbsp;'},
            'CNTROLE':{'width':18,'arg':{'sort':'desc'},'css':'role',"type":'static',"text":'&nbsp;'},
			'CNTCONTACTNAME':{"title": 'DISTRIB_LIST::NAME',"width":'200'},
			'CNTEMAIL':{"title": 'DISTRIB_LIST::EMAIL',"width":'200'}
			});
			
			// please note that first entry of this.items array has to be a description and the second an email
			// otherwise the function __onAddNewFromAddressbook() wouldn't work properly
			this.items = ['CNTCONTACTNAME','CNTEMAIL','CNTROLE','CNTSTATUS'];
			dialog_name = 'frm_edit_attendee';
			title_prefix = 'ATTENDEES';
			
			this._create('invitation','obj_checkbox')._title('ATTENDEES::SEND_INVITATION');

			// CONTEXT MENU
			this.grid._oncontext = function(e,elm,tr,arg,id,cell){
				if (id && (cell=='CNTROLE' || cell=='CNTSTATUS')){
					var pos = getSize(elm);

					me.cmenu = gui._create('cmenu','obj_context','','obj_attendees_context');
		            me.cmenu._place(pos.x,pos.y+pos.h);

					var aMenu;
					if (cell=='CNTROLE')
						aMenu = [{'title':'ATTENDEES::ROLE_Q',css:'bg_role_Q','arg':{'id':id,'key':'CNTROLE',value:'Q'}},
								{'title':'ATTENDEES::ROLE_S',css:'bg_role_S','arg':{'id':id,'key':'CNTROLE',value:'S'}},
								{'title':'ATTENDEES::ROLE_T',css:'bg_role_T','arg':{'id':id,'key':'CNTROLE',value:'T'}}];
					else
						aMenu = [{'title':'ATTENDEES::STATUS_P',css:'bg_status_P','arg':{'id':id,'key':'CNTSTATUS',value:''}},
								{'title':'ATTENDEES::STATUS_A',css:'bg_status_A','arg':{'id':id,'key':'CNTSTATUS',value:'A'}},
								{'title':'ATTENDEES::STATUS_D',css:'bg_status_D','arg':{'id':id,'key':'CNTSTATUS',value:'D'}}];

					me.cmenu._fill(aMenu);
					me.cmenu._onclick = function(e,elm,id,arg){
						if (arg.id && arg.key){
							var aValue = me.__getItemDetails(arg.id);
							if (aValue){
								aValue[arg.key] = arg.value;
								me.__onEdit(aValue,arg.id);
							}
						}
					};
				}

				return false;
			};

			break;
			
		default:
			throw new Error('Not implemented');
	}
	
	this.grid._ondblclick = function() {
		me.edit_button._onclick();
	}
	
	this.add_button._onclick = function() {
		gui._create('address_book', 'frm_addaddress', '', '',[me, '__onAddNewFromAddressbook'], ['ADDRESS_BOOK::SELECT_ADDRESSES']);
	}
	
	this.add_new_button._onclick = function() {
		gui._create('edit_dialog', 'frm_edit_attendee', '', '', dialog_name, title_prefix + '::ADD_TITLE', [me, '__onEdit']);
	}
	
	this.edit_button._onclick = function() {
		var items = me.grid._value();

		if (items && Is.Defined(items[0]))
			items = items[0];
		else
			return;

		gui._create('edit_dialog', 'frm_edit_attendee', '', '', dialog_name, title_prefix + '::EDIT_TITLE', [me, '__onEdit'], me.__getItemDetails(items,true), items);
	}
	
	this.remove_button._onclick = function() {
		me.__removeItems(me.grid._value());
	}
	
};

_me._value = function(aValues) {
	if (Is.Defined(aValues)) {

		this.aDatagridRows = [];
		this.__atts = {};
		var aData,css;

		this.__value = aValues;

		for (var i in aValues) {
			aData = {}, css = '';
			for (var j in this.items){

				if (this.items[j] == 'CNTSTATUS' && aValues[i]['values'][this.items[j]])
                    css += (css?' ':'') + "status_"+aValues[i]['values'][this.items[j]];
	            else
                if (this.items[j] == 'CNTROLE' && aValues[i]['values'][this.items[j]])
                	css += (css?' ':'') + "role_"+aValues[i]['values'][this.items[j]];

				aData[this.items[j]] = aValues[i]['values'][this.items[j]];
			}

			this.aDatagridRows.push({"id": i, "data": aData,'css':css});

   			this.__atts[i] = {'action':'ignore','id':i};
		}

		this.grid._fill(this.aDatagridRows);
	}
	else {
		var aResult = [];
		for (var i in this.__atts) {
			switch (this.__atts[i]['action']) {
				case 'remove':
					aResult.push({'uid': this.__atts[i]['id']});
					break;
				case 'edit':
					aResult.push({'uid': this.__atts[i]['id'], 'values': this.__getItemDetails(i)});
					break;
				case 'new':
					aResult.push({'values': this.__getItemDetails(i)});
				default:
					break;
			}
		}
		return aResult;
	}
};

_me.__getItemDetails = function (nInd,bDatagridOnly)
{
	var aValues;

	for(var n in this.aDatagridRows)
		if (this.aDatagridRows[n]['id'] == nInd){
			aValues = this.aDatagridRows[n]['data'];
			break;
		}

	if (bDatagridOnly || this.sType != 'DISTRIB_LIST')
		return aValues;

	aValues['LCTTYPE'] = 'O';
	return aValues;
}

_me.__removeItems = function(aIDs)
{
	for (var i in aIDs)
	  for(var n in this.aDatagridRows)
			if (this.aDatagridRows[n]['id'] == aIDs[i])
			{
				this.aDatagridRows.splice(n,1);
				this.__atts[aIDs[i]]['action'] = this.__atts[aIDs[i]]['action'] == 'new' ? 'ignore' : 'remove';
				break;
			}
	this.grid._fill(this.aDatagridRows);
};

_me.__onEdit = function(aValues, sID)
{
	var itmId,sAction,aData = {},css = '';
	if (Is.Defined(sID)) {
		itmId = sID;
		this.__atts[itmId]['action'] = this.__atts[itmId]['action'] == 'new' ? 'new' : 'edit';
	} else {
		itmId = this.__new_count++;
		this.aDatagridRows.push({'id':itmId,'data':aValues});
		this.__atts[itmId] = {'action':'new'};
	}

	for (var i in this.items){
		if (this.items[i] == 'CNTSTATUS' && aValues[this.items[i]])
            css += (css?' ':'') + "status_"+aValues[this.items[i]];
        else
        if (this.items[i] == 'CNTROLE' && aValues[this.items[i]])
        	css += (css?' ':'') + "role_"+aValues[this.items[i]];

		aData[this.items[i]] = aValues[this.items[i]];
	}

	for(var n in this.aDatagridRows)
		if (this.aDatagridRows[n]['id'] == itmId){
			this.aDatagridRows[n]['data'] = aData;
			this.aDatagridRows[n]['css'] = css;
			break;
		}

	this.grid._fill(this.aDatagridRows);
};


_me.__onAddNewFromAddressbook = function(bOK, aAddresses)
{
	if (bOK) {
		var aEmail,itmId,count,aData;
		for (var i in aAddresses[0]) {
			aEmail = MailAddress.splitEmailsAndNames(aAddresses[0][i]);
			
			// parse data from address book form in special logic:
			// first entry in this.items stands for description, the second entry stands for email
			aData = {};
			count = 0;
			for (var j in this.items) {
				if (count == 0)
					aData[this.items[j]] = aEmail[0]['name'];
				else
					aData[this.items[j]] = aEmail[0]['email'];
				count++;
				if (count > 1)
					break;
			}
			
			itmId = this.__new_count++;
			this.aDatagridRows.push({'id': itmId, 'data': aData});
			this.__atts[itmId] = {'action':'new'};
		}
		this.grid._fill(this.aDatagridRows);
	}
	// TODO: allow only one instance of frm_addaddress
	//this.__bContactsOpened = false;
};
