_me = obj_context_item.prototype;
function obj_context_item() {};

obj_context_item.createColorMailMenu = function(id) {
	return [
	{"title": 'COLOR_LABELS::RED_FLAG', "css": 'bg_red', 'arg': [OldMessage.setColor, [id, Item.COLORS.RED]]},
	{"title": 'COLOR_LABELS::BLUE_FLAG', "css": 'bg_blue', 'arg': [OldMessage.setColor, [id, Item.COLORS.BLUE]]},
	{"title": 'COLOR_LABELS::GREEN_FLAG', "css": 'bg_green', 'arg': [OldMessage.setColor, [id, Item.COLORS.GREEN]]},
	{"title": 'COLOR_LABELS::ORANGE_FLAG', "css": 'bg_orange', 'arg': [OldMessage.setColor, [id, Item.COLORS.ORANGE]]},
	{"title": 'COLOR_LABELS::PURPLE_FLAG', "css": 'bg_purple', 'arg': [OldMessage.setColor, [id, Item.COLORS.PURPLE]]},
	{"title": 'COLOR_LABELS::YELLOW_FLAG', "css": 'bg_yellow', 'arg': [OldMessage.setColor, [id, Item.COLORS.YELLOW]]},
	{"title": '-'},
	{"title": 'COLOR_LABELS::FLAG_COMPLETE', "css": 'bg_complete', 'arg': [OldMessage.setColor, [id, Item.COLORS.COMPLETE]]},
	{"title": 'COLOR_LABELS::CLEAR_FLAG', "css": 'bg_none', 'arg': [OldMessage.setColor, [id, Item.COLORS.CLEAR]]},
	];
};

obj_context_item.createColorNoteMenu = function(id) {
		return [
		{"title": 'COLOR_LABELS::NONE', "css":'bg_none', 'arg': [Item.setColor, [id, Item.NOTE_COLORS.CLEAR]]},
		{"title": '-'},
		{"title": 'COLOR_LABELS::BLUE_FLAG', "css": 'bg_blue', 'arg': [Item.setColor, [id, Item.NOTE_COLORS.BLUE]]},
		{"title": 'COLOR_LABELS::GREEN_FLAG', "css": 'bg_green', 'arg': [Item.setColor, [id, Item.NOTE_COLORS.GREEN]]},
		{"title": 'COLOR_LABELS::RED_FLAG', "css": 'bg_red', 'arg': [Item.setColor, [id, Item.NOTE_COLORS.RED]]},
		{"title": 'COLOR_LABELS::WHITE_FLAG', "css": 'bg_gray', 'arg': [Item.setColor, [id, Item.NOTE_COLORS.WHITE]]},
		{"title": 'COLOR_LABELS::YELLOW_FLAG', "css": 'bg_yellow', 'arg': [Item.setColor, [id, Item.NOTE_COLORS.YELLOW]]}
		];
};

obj_context_item.createColorMenu = function(id) {
	return [
	{"title": 'COLOR_LABELS::NONE', "css":'bg_none', 'arg': [Item.setColor, [id, Item.COLORS.CLEAR]]},
	{"title": '-'},
	{"title": 'COLOR_LABELS::IMPORTANT', "css": 'bg_red', 'arg': [Item.setColor, [id, Item.COLORS.RED]]},
	{"title": 'COLOR_LABELS::BUSINESS', "css": 'bg_blue', 'arg': [Item.setColor, [id, Item.COLORS.BLUE]]},
	{"title": 'COLOR_LABELS::PERSONAL', "css": 'bg_green', 'arg': [Item.setColor, [id, Item.COLORS.GREEN]]},
	{"title": 'COLOR_LABELS::VACATION', "css": 'bg_gray', 'arg': [Item.setColor, [id, Item.COLORS.GREY]]},
	{"title": 'COLOR_LABELS::MUST_ATTEND', "css": 'bg_orange', 'arg': [Item.setColor, [id, Item.COLORS.ORANGE]]},
	{"title": 'COLOR_LABELS::TRAVEL_REQUIRED', "css": 'bg_cyan', 'arg': [Item.setColor, [id, Item.COLORS.CYAN]]},
	{"title": 'COLOR_LABELS::NEEDS_PREPARATION', "css":'bg_brown', 'arg': [Item.setColor, [id, Item.COLORS.BROWN]]},
	{"title": 'COLOR_LABELS::BIRTHDAY', "css":'bg_purple', 'arg': [Item.setColor, [id, Item.COLORS.PURPLE]]},
	{"title": 'COLOR_LABELS::ANNIVERSARY', "css":'bg_light_blue', 'arg': [Item.setColor, [id, Item.COLORS.LIGHT_BLUE]]},
	{"title": 'COLOR_LABELS::PHONE_CALL', "css":'bg_yellow', 'arg': [Item.setColor, [id, Item.COLORS.YELLOW]]}
	];
};

obj_context_item.createRSSMenu = function(id,ids,bMultiple,aRights){
	var aMenu = [];

	aMenu = aMenu.concat([
	{"title": 'POPUP_ITEMS::OPEN', 'disabled': bMultiple, 'arg': [OldMessage.open, [id]]},
    {"title": 'POPUP_ITEMS::OPEN_WINDOW', 'disabled': bMultiple, 'arg': [OldMessage.openwindow, [id]]},
	{"title": '-'},
	{"title": 'POPUP_ITEMS::MARK_AS_READ', 'arg': [OldMessage.markAsRead, [ids]]},
	{"title": 'POPUP_ITEMS::MARK_AS_UNREAD', 'arg': [OldMessage.markAsUnread, [ids]]},
	{"title": 'POPUP_ITEMS::DELETE', 'arg': [Item.remove, [ids]],'disabled':!aRights.remove}
	]);

	return aMenu;
}

obj_context_item.createMailMenu = function(id, ids, bMultiple, sFrom, aRights) {
	// In Drafts or Sent folders some items should not be available:
	var folders = GWOthers.get('DEFAULT_FOLDERS', 'storage')['VALUES'];
	var sFolderID = id[0] + '/' + id[1];
	// If SPAM_QUEUE/Blacklist folder doesn't exist, some items should not be available:
	var aSpamFolder = dataSet.get('folders', [sPrimaryAccount, 'SPAM_QUEUE/Blacklist']);
	var bNoSpam = !Is.Object(aSpamFolder);
	var bDraft = (sFolderID == folders['drafts']);
	var bSent = (sFolderID == folders['sent']);

	var aMenu = [];
	if (bDraft) aMenu.push(
	{"title": 'POPUP_ITEMS::EDIT', 'disabled': bMultiple, 'arg': [OldMessage.edit, [id]]}
	);
	
	aMenu = aMenu.concat([
	{"title": 'POPUP_ITEMS::OPEN', 'disabled': bMultiple, 'arg': [OldMessage.open, [id]]},
    {"title": 'POPUP_ITEMS::OPEN_WINDOW', 'disabled': bMultiple, 'arg': [OldMessage.openwindow, [id]]},
	{"title": 'MAIN_MENU::NEW', 'arg': [NewMessage.compose]},
	{"title": '-'}
	]);

	if (sFrom){

		var sTmp,aFrom = MailAddress.parseMail(sFrom, 'name_and_email')[0];
		var aLCTval = {};

		if (aFrom.name){
			aLCTval.ITMCLASSIFYAS = aFrom.name;

			var aName = aFrom.name.split(' ');
			if (aName.length>1){

				//FirstName
				sTmp = aName.shift();
				if (sTmp.indexOf('.')>0){
					sTmp = sTmp.split('.');
					aLCTval.ITMTITLE = sTmp[0];
					aLCTval.ITMFIRSTNAME = sTmp[1];
				}
				else
					aLCTval.ITMSURNAME = sTmp;

				//MiddleName
				sTmp = aName.shift();
				if (aLCTval.length>2 && aLCTval[2].indexOf('.')!=0){
					aLCTval.ITMMIDDLENAME = sTmp;
					sTmp = aName.shift();
				}
				
				//SurName
				if (sTmp.indexOf('.')>-1){
					sTmp = sTmp.split('.');
					aLCTval.ITMSURNAME = sTmp.shift();
					aLCTval.ITMSUFFIX = sTmp.join('.');
				}
				else{
					aLCTval.ITMFIRSTNAME = sTmp;

					//Suffix 2
					if ((sTmp = aName.shift()))
						aLCTval.ITMSUFFIX = sTmp;
				}
			}
		}


		if (sPrimaryAccountGW>0){
			var dgw = GWOthers.getItem('RESTRICTIONS', 'disable_gw_types');
			if (!dgw || dgw.indexOf('c')<0){

				if (aFrom.email)
				    aLCTval.LOCATIONS = [{'values': {'LCTEMAIL1':aFrom.email,'LCTTYPE': 'H'}}];

				aMenu = aMenu.concat([
					{"title": 'POPUP_ITEMS::ADD_TO_CONTACTS', 'disabled': bMultiple,
						'arg': [gui, '_create', ['frm_contact', 'frm_contact', '', '', sPrimaryAccount, Mapping.getDefaultFolderForGWType('C'), '',aLCTval]]
					},
					{"title": '-'}
				]);
			}
		}
	}
	if (!bDraft && !bSent) aMenu = aMenu.concat([
	{"title": 'POPUP_ITEMS::REPLY_TO_SENDER', 'disabled': bMultiple, 'arg': [OldMessage.reply, [id, false]]},
	{"title": 'POPUP_ITEMS::REPLY_TO_ALL', 'disabled': bMultiple, 'arg': [OldMessage.reply, [id, true]]}
	]);

	aMenu = aMenu.concat([
	{"title": 'POPUP_ITEMS::FORWARD', 'disabled': bMultiple, 'arg': [OldMessage.forward, [id, false]]},
	{"title": 'POPUP_ITEMS::FORWARD_AS_MESSAGE', 'disabled': bMultiple, 'arg': [OldMessage.forward, [id, true]]},
	{"title": 'POPUP_ITEMS::REDIRECT', 'disabled': bMultiple, 'arg': [OldMessage.redirect, [id]]},
	{"title": '-'},
	{"title": 'POPUP_ITEMS::MARK_AS_READ', 'arg': [OldMessage.markAsRead, [ids]]},
	{"title": 'POPUP_ITEMS::MARK_AS_UNREAD', 'arg': [OldMessage.markAsUnread, [ids]]},
	{"title": '-'}
	]);
	if (!bDraft && !bSent && !bNoSpam) aMenu = aMenu.concat([
	{"title": 'POPUP_ITEMS::BLACKLIST_SENDER', 'arg': [OldMessage.blacklistSender, [ids]]},
	{"title": 'POPUP_ITEMS::WHITELIST_SENDER', 'arg': [OldMessage.whitelistSender, [ids]]},
	{"title": '-'}
	]);
	
	aMenu = aMenu.concat([
	{"title": 'POPUP_ITEMS::SAVE_AS', 'disabled': bMultiple, 'arg': [Item.downloadSource, [id,'text']],
     "nodes":[
		{"title": 'POPUP_ITEMS::TEXT', 'arg': [Item.downloadSource, [id,'text']]},
		{"title": 'POPUP_ITEMS::HTML', 'arg': [Item.downloadSource, [id,'html']]},
		{"title": 'POPUP_ITEMS::EML', 'arg': [Item.downloadSource, [id]]}
	 ]
	},
	{"title": '-'},
	{"title": 'POPUP_ITEMS::MOVE_MAIL_TO', 'arg': [Item.move, [ids]],'disabled':!aRights.remove},
	{"title": 'POPUP_ITEMS::COPY_MAIL_TO', 'arg': [Item.copy, [ids]]},
	{"title": 'POPUP_ITEMS::DELETE', 'arg': [Item.remove, [ids]],'disabled':!aRights.remove}
	]);
	
	return aMenu;	
};

obj_context_item.createGWMenu = function(id, ids, sFolType, bMultiple, oRepeating,aRights) {
	var sDownload;
	var bWithDistriblist = false;

	switch (sFolType) {
		case 'C':
		case 'L':	sDownload = 'DOWNLOAD_VCARD'; bWithDistriblist = true; break;
		case 'E':
		case 'J':
		case 'T':	sDownload = 'DOWNLOAD_VCALENDAR'; break;
		case 'N':	sDownload = 'DOWNLOAD_VNOTE'; break;
		case 'F':	sDownload = 'DOWNLOAD_FILE'; break;
		default:	sDownload = 'DOWNLOAD_SOURCE'; break;
	}
	var aMenu = [
	{"title": 'POPUP_ITEMS::OPEN_ITEM', 'disabled': bMultiple, 'arg': [Item.open, [id,oRepeating]]},
	{"title":'MAIN_MENU::NEW','arg': [Item.createInFolder, [id[0], id[1]]],'disabled':!aRights.write}
	];
	if (bWithDistriblist)
		aMenu.push({"title":'POPUP_ITEMS::NEW_DISTRIBLIST', 'arg': [Item.create, ['L', id[0], id[1]]],'disabled':!aRights.write});


	if (sFolType == 'C'){
		var aContact = dataSet.get('items', [id[0], id[1], id[2]]);
		if (aContact.LCTEMAIL1 || aContact.LCTEMAIL2 || aContact.LCTEMAIL3){
			aMenu.push(
			{"title":'-'},
			{"title":'POPUP_ITEMS::SEND_EMAIL_TO',"caption":true}
			);

			var sName = aContact.ITMCLASSIFYAS || ((aContact.ITMFIRSTNAME || '') + (aContact.ITMSURNAME?' '+aContact.ITMSURNAME:'')) || '';

			if (aContact.LCTEMAIL1)
				aMenu.push({"text":aContact.LCTEMAIL1.entityify(),'arg': [NewMessage.compose,[{to:MailAddress.createEmail(sName,aContact.LCTEMAIL1)}]]});

			if (aContact.LCTEMAIL2)
				aMenu.push({"text":aContact.LCTEMAIL2.entityify(),'arg': [NewMessage.compose,[{to:MailAddress.createEmail(sName,aContact.LCTEMAIL2)}]]});

			if (aContact.LCTEMAIL3)
				aMenu.push({"text":aContact.LCTEMAIL3.entityify(),'arg': [NewMessage.compose,[{to:MailAddress.createEmail(sName,aContact.LCTEMAIL3)}]]});
		}
	}
	else
	if (sFolType == 'L'){
		var aContact = dataSet.get('items', [id[0], id[1], id[2]]);
		aMenu.push(
		{"title":'-'},
		{"title":'POPUP_ITEMS::SEND_EMAIL_TO','arg':[NewMessage.compose,[{to:'['+aContact.fid+'::'+aContact.ITMTITLE+']'}]]}
		);
	}
	
	return aMenu.concat([
	{"title":'-'},
	{"title":'POPUP_ITEMS::SEND_AS_EMAIL', 'disabled': bMultiple, 'arg': [Item.sendAsEmail, [id]]},
	{'title':"-"},
	{"title":'POPUP_ITEMS::' + sDownload, 'disabled': bMultiple, 'arg': [(sFolType=='F'?Item.downloadFile:Item.downloadSource), [id]]},
	{'title':"-"},
	{"title":'POPUP_ITEMS::MOVE_ITEM_TO', 'arg': [Item.move, [ids]],'disabled':!aRights.remove},
	{"title":'POPUP_ITEMS::COPY_ITEM_TO', 'arg': [Item.copy, [ids]]},
	{"title":'POPUP_ITEMS::DELETE', 'arg': [Item.remove, [ids,false,oRepeating]],'disabled':!aRights.remove}
	]);
};



obj_context_item.createQuarantineMenu = function(ids) {
	return [
	{"title": 'POPUP_ITEMS::DELIVER', 'arg': [OldMessage.deliver, [ids]]},
	{"title": 'POPUP_ITEMS::WHITE_LIST', 'arg': [OldMessage.whitelist, [ids]]},
	{"title": 'POPUP_ITEMS::BLACK_LIST', 'arg': [OldMessage.blacklist, [ids]]},
	{"title": 'POPUP_ITEMS::DELETE', 'arg': [Item.remove, [ids]]}
	];
};

obj_context_item.createBlacklistMenu = function(ids) {
	return [
	{"title": 'POPUP_ITEMS::WHITE_LIST', 'arg': [OldMessage.whitelist, [ids]]},
	{"title": 'MAIN_MENU::NEW', 'arg': [gui, '_create', ['gw', 'frm_blackwhite', '', '', ids[0], ids[1]]]},
	{"title": '-'},
	{"title": 'POPUP_ITEMS::DELETE', 'arg': [Item.remove, [ids]]}
	];
};

obj_context_item.createWhitelistMenu = function(ids) {
	return [
	{"title": 'POPUP_ITEMS::BLACK_LIST', 'arg': [OldMessage.blacklist, [ids]]},
	{"title": 'MAIN_MENU::NEW', 'arg': [gui, '_create', ['gw', 'frm_blackwhite', '', '', ids[0], ids[1]]]},
	{"title": '-'},
	{"title": 'POPUP_ITEMS::DELETE', 'arg': [Item.remove, [ids]]}
	];
};

_me._fillMenu = function(sType, arg, iid_list, bDisableOpen, aInitMenu, sColumn)
{
	var id = [arg['aid'], arg['fid'], arg['iid']];
	var ids = [arg['aid'], arg['fid'], iid_list];

	var aRights = WMFolders.getAccess(arg);
	
	if (iid_list.length > 1)
		var bMultiple = true;
	else
		var bMultiple = false;
	
	if (sType == 'M' && (sColumn == 'FROM' || sColumn == 'TO')) {
		var sFrom = dataSet.get('items', id.concat([sColumn]));
		aMenu = obj_context_item.createMailMenu(id, ids, bMultiple, sFrom, aRights);
	}
	else
	if (sColumn == 'COLOR' || sColumn == 'EVNCOLOR') {

		if (!aRights.modify) return;
		
		addcss(this._main,"obj_context_itemflags");
		if (sType == 'M' || sType == 'R')
			aMenu = obj_context_item.createColorMailMenu(id);
		else
		if (sType == 'N')
			aMenu = obj_context_item.createColorNoteMenu(id);
		else
			aMenu = obj_context_item.createColorMenu(id);

	}
	else {
		switch (sType) {
			case 'R': aMenu = obj_context_item.createRSSMenu(id,ids,bMultiple,aRights); break;
			case 'E':
			case 'J':
			case 'T':
			case 'N':
			case 'F':
			case 'C':
			case 'L': aMenu = obj_context_item.createGWMenu(id, ids, sType, bMultiple,'',aRights); break;
			case 'M': aMenu = obj_context_item.createMailMenu(id, ids, bMultiple,'',aRights); break;
			case 'Q': aMenu = obj_context_item.createQuarantineMenu(ids); break;
			case 'QL':
				if (arg['fid'].indexOf('White') >= 0)
					aMenu = obj_context_item.createWhitelistMenu(ids);
				else
					aMenu = obj_context_item.createBlacklistMenu(ids);
				break;
		}
	}

	if (aInitMenu) {
		aInitMenu = reverse(aInitMenu);

		for (var i in aInitMenu)
			aMenu.unshift(aInitMenu[i]);
	}

	this._fill(aMenu);
};

_me._fillGeneralMenu = function(sType, oFolder) {
	var aMenu;
	var aid = oFolder['aid'];
	var fid = oFolder['fid'];

	var aRights = WMFolders.getAccess(oFolder);

	switch(sType) {
		case 'M':
			aMenu = [{"title": 'MAIN_MENU::NEW', 'arg': [NewMessage.compose],'disabled':!aRights.write}];
			break;

		case 'E':
			aMenu =[
				{"title": 'MAIN_MENU::NEW', 'arg': [Item.createInFolder, [aid, fid]],'disabled':!aRights.write},
				{"title": '-'},
				{"title": 'MAIN_MENU::DAY_VIEW', 'arg': [gui.frm_main, '_selectView', [oFolder, 'day_view', true]]},
				{"title": 'MAIN_MENU::WEEK_VIEW', 'arg': [gui.frm_main, '_selectView', [oFolder, 'week_view', true]]},
				{"title": 'MAIN_MENU::MONTH_VIEW', 'arg': [gui.frm_main, '_selectView', [oFolder, 'month_view', true]]},
				{"title": 'MAIN_MENU::EVENTS_LIST', 'arg': [gui.frm_main, '_selectView', [oFolder, 'list_view', true]]}
			];
			break;

		case 'C':
			aMenu = [
				{"title": 'MAIN_MENU::NEW', 'arg': [Item.createInFolder, [aid, fid]],'disabled':!aRights.write},
				{"title": 'POPUP_ITEMS::NEW_DISTRIBLIST', 'arg': [Item.create, ['L', aid, fid]],'disabled':!aRights.write}/*,
				{"title": '-'},
				{"title": 'MAIN_MENU::CONTACTS_LIST', 'arg': {'method': 'phone_list', 'folder': oFolder}},
				{"title": 'MAIN_MENU::ADDRESS_CARD', 'arg':{'method':'address_card','folder':oFolder}}*/
			];
			break;

		case 'T':
			aMenu = [
				{"title": 'MAIN_MENU::NEW', 'arg': [Item.createInFolder, [aid, fid]],'disabled':!aRights.write}/*,
				{"title": '-'},
				{"title": 'MAIN_MENU::TASKS_LISTS', 'arg': {'method': 'tasks_simple', 'folder': oFolder}},
				{"title": 'MAIN_MENU::TASKS_DETAILED', 'arg':{'method':'tasks_detailed','folder': oFolder}},
				{"title": 'MAIN_MENU::ACTIVE_TASKS', 'arg':{'method':'active_tasks','folder': oFolder}}*/
			];
			break;

		case 'J':
			aMenu = [
				{"title": 'MAIN_MENU::NEW', 'arg': [Item.createInFolder, [aid, fid]],'disabled':!aRights.write}/*,
				{"title": '-'},
				{"title": 'MAIN_MENU::JOURNAL_DAY_VIEW', 'arg':{'method':'journal_day_view','folder':oFolder}},
				{"title": 'MAIN_MENU::JOURNAL_WEEK_VIEW', 'arg':{'method':'journal_week_view','folder':oFolder}},
				{"title": 'MAIN_MENU::JOURNAL_MONTH_VIEW', 'arg':{'method':'journal_month_view','folder':oFolder}},
				{"title": 'MAIN_MENU::JOURNAL_LIST', 'arg':{'method':'journal_list','folder':oFolder}}*/
			];
			break;

		case 'N':
			aMenu = [{"title": 'MAIN_MENU::NEW', 'arg': [Item.createInFolder, [aid, fid]],'disabled':!aRights.write}];
			break;
		
		case 'QL':
			aMenu = [{"title": 'MAIN_MENU::NEW', 'arg': [gui, '_create', ['gw', 'frm_blackwhite', '', '', aid, fid]]}];
			break;

		case 'F':
			aMenu = [{"title": 'MAIN_MENU::NEW', 'arg': [Item.createInFolder, [aid, fid]],'disabled':!aRights.write}];
			break;
	}

	this._fill(aMenu);
};