_me = obj_datagrid_item.prototype;

function obj_datagrid_item(){};

_me.__constructor = function(bDontListen)
{
	if (!bDontListen){
		this._listen_data('items','',true); //listen but do not update immediately
	}

	var nMozillaCoeficient = 6;
	var nIE7Coeficient = 4;
	var nIE6Coeficient = 2;

	this._cookiesEnabled = true;
	this._dataSet = 'items';
	this._specialType = '';

	this._refreshHeader = true;

	this._lastOffset = 0;
	this._lastSort = '';

	this.__dragtype = ''; // usually "item" (set in serversort)

	this._SQLfilter = '';
	this._SQLfulltext = '';
};

_me._onkeydown = function(e){

	// nacte vybrane radky
	var value = this._value();
	if (count(value)<1) return;

	//ziska sFolId a sAccId
	var aItems = dataSet.get(this._dataSet);
	if (!aItems) return;
	for(var sAccId in aItems)
		for(var sFolId in aItems[sAccId])
			break;

	var sType = dataSet.get('folders',[sAccId,sFolId,'TYPE']);

	//numbers as Flags
	if ((e.keyCode>95 && e.keyCode<106) || (e.keyCode==107 || e.keyCode==109)){
		var color;
		if (e.keyCode==107)
			color = 'COMPLETE';
		else
		if (e.keyCode==109)
			color = 'CLEAR';
		else{
			if (sType == 'M' || sType == 'R')
				var colors = ['RED','BLUE','GREEN','ORANGE','PURPLE','YELLOW'];
			else
			if (sType == 'N')
				var colors = ['BLUE','GREEN','RED','','GREY','YELLOW'];
			else
				var colors = ['RED','BLUE','GREEN','GREY','ORANGE','CYAN','BROWN','PURPLE','LIGHT_BLUE','YELLOW'];

			if(!(color = colors[e.keyCode-96])) return;
		}

		for(var i in value)
			if (sType == 'M' || sType == 'R')
				OldMessage.setColor([sAccId,sFolId,value[i]], Item.COLORS[color]);
			else
			if (WMFolders.getAccess({aid:sAccId,fid:sFolId},'modify'))
				Item.setColor([sAccId,sFolId,value[i]], Item.COLORS[color]);
	}
	else
	switch(e.keyCode){
	case 82:
		//r - Reply or Reply All
	    if (sType=='M')
			OldMessage.reply([sAccId,sFolId,value[0]],e.shiftKey);
		break;
	case 70:
		//f - Forward or FW as attachment
	    if (sType=='M')
			OldMessage.forward([sAccId,sFolId,value[0]],e.shiftKey);
		break;
	case 78: //n - New
	    if (sType=='M')
	        NewMessage.compose();
	    break;
	case 67: //c - Copy
		Item.copy([sAccId,sFolId,value]);
	    break;
	case 77: //m - Move
 		if (sType!='M' && !WMFolders.getAccess({aid:sAccId,fid:sFolId},'remove')) break;
		Item.move([sAccId,sFolId,value]);
	    break;
	case 69: //e - Read
	    if (sType=='M' || sType=='R')
			for(var i in value)
				OldMessage.markAsRead([sAccId,sFolId,value]);
		break;
	case 85: //u - Unread
	    if (sType=='M' || sType=='R')
			for(var i in value)
				OldMessage.markAsUnread([sAccId,sFolId,value]);

	    break;
	case 46: //delete
	case  8: //backspace

		if (sType!='Q' && sType!='QL' && !WMFolders.getAccess({aid:sAccId,fid:sFolId},'remove')) break;

		var pos = this.__idTable[value[value.length-1]];
		if (typeof pos != 'undefined'){
			pos = parseInt(pos);
			
			for(var i in value)
				delete this.__idTable[value[i]];

			var before,after,val,itm;
			for(var i in this.__idTable){

				val = parseInt(this.__idTable[i]);

				if (val<pos && !after){
					if (typeof before != 'undefined')
                        before = Math.max(before,val);
					else
						before = val;

					if (val==before) itm = i;
				}
				else
				if (val>pos){
					if (typeof after != 'undefined')
                        after = Math.min(after,val);
					else
						after = val;

					if (val==after) itm = i;
				}
			}

			if (typeof itm != 'undefined')
				this.__value = [itm];
			else{
                this.__value = [];
				this.__selectpos == 'first';
			}
		}

		Item.remove([sAccId,sFolId,value],e.shiftKey);  //,'','',this
	    break;
	}
};

_me.__parseTime = function(nUTime)
{
  if (!nUTime) return '';
  
	var oDate = new Date(nUTime*1000);
	return oDate.toWMString(false);
};

_me.__parseGwTime = function(sDate,sTime)
{
	if (typeof sTime == 'undefined') 
		if (typeof sDate == 'undefined' || sDate == 0) 
			return '';
		else
			sTime = -1;
	
	// string muze na zacatku obsahovat # - v tom pripade by se mel zobrazit pouze Date (nikoliv Time)
	var bDateOnly;
	
	if (sTime == -1){
		bDateOnly = true;
		sTime = 0;
	}
	else
		bDateOnly = false;

	var oDate = new Date();
		oDate.setGWTime(sDate,sTime);
	
	return oDate.toWMString(bDateOnly);
};

_me.__parseQTime = function(sDate,sTime)
{
	if (typeof sTime == 'undefined')
		if (typeof sDate == 'undefined' || sDate == 0)
			return '';
		else
			sTime = -1;

	// string muze na zacatku obsahovat # - v tom pripade by se mel zobrazit pouze Date (nikoliv Time)
	var bDateOnly;

	if (sTime == -1){
		bDateOnly = true;
		sTime = 0;
	}
	else
		bDateOnly = false;

	var oDate = new Date();
	oDate.setQTime(sDate,sTime);

	return oDate.toWMString(bDateOnly);
};


_me.__parseSize = function(nSize){
	return Math.round(nSize*10/1024)/10+' kB';
};

_me.__update = function(sName, aDPath)
{
	var aItems;

	if (!(aItems = dataSet.get(sName ? sName : 'items'))){
		this._addColumns([]);
		return;
	}

	/*	Edit just one row value (Part 1)
		if value in column with is same as sort	column is changet than whole list is refreshed
		if column name (aDPath[3]) is undefined then only row's CSS is changed */
	if (aDPath && aDPath[2] && (!aDPath[3] || (aDPath[3] && this.__sortColumn!=aDPath[3]))){

		var editrow;
		if ((editrow = document.getElementById(this._pathName+'/'+aDPath[2]))){
			try{
				var tmp = {};
					tmp[aDPath[0]] = {};
					tmp[aDPath[0]][aDPath[1]] = {};
					tmp[aDPath[0]][aDPath[1]][aDPath[2]] = aItems[aDPath[0]][aDPath[1]][aDPath[2]];
					aItems = tmp;
					tmp = null;
			}
			catch(e){
	            editrow = null;
			}
		}
	}

	// Vlozi obsah folderu do aItems
	for(var sAccId in aItems)
		for(var sFolId in aItems[sAccId])
			aItems = clone(aItems[sAccId][sFolId],1); //clone because I have to keep # and / keys

		//TOTAL
		if (typeof aItems['/'] != 'undefined'){
			this.__total = 0;
			if (aItems['/']>=0)
				this.__total = parseInt(aItems['/']);

			delete aItems['/'];
		}
		else
		if (!count(aItems))
			this.__total = 0;

		//SUBTOTAL
		if (typeof aItems['#'] != 'undefined'){
			if (aItems['#']>=0)
				var iSubtotal = parseInt(aItems['#']);

			delete aItems['#'];
		}
		
		//OFFSET
		delete aItems['$'];


/*
	else
	if (typeof this.__total == 'undefined')
		this.__total = dataSet.get("folders",[sAccId,sFolId,'TOTAL']);
*/

	if (this.lister){
		this.lister._range(this.__total);
		this.lister._selected(this.__total<count(this.__value)?this.__total:count(this.__value));
	}

	var aDefaultColumns;

	if (this._specialType)
	{
        this.__dragtype = '';
		switch(this._specialType)
		{
			case 'ADDRESS':
				aDefaultColumns = {'ITMCLASSIFYAS':{'width':120},'CONTACT_EMAIL':{'width':150}};
				break;
		}
	}
	else
	{
		var sFolType = dataSet.get("folders",[sAccId,sFolId,'TYPE']);

		this.__dragtype = 'item';
        
		switch(sFolType)
		{
			case 'C':
				aDefaultColumns = {'ITMCLASSIFYAS':{'width':140,'arg':{'sort':'asc'}},'CONTACT_FULLNAME':{'width':180,'arg':{'sort':'asc'}},'ITMCOMPANY':{'width':120,'arg':{'sort':'asc'}},'CONTACT_EMAIL':{'width':160,'arg':{'sort':'asc'}},'ITMCATEGORY':{'width':120,'arg':{'sort':'asc'}}};
				break;

			case 'E':
				aDefaultColumns = {'EVNTITLE':{'width':190,'arg':{'sort':'asc'}},'EVNLOCATION':{'width':120,'arg':{'sort':'asc'}},'EVENT_STARTDATE':{'width':120,'arg':{'sort':'desc'}},'EVENT_ENDDATE':{'width':120,'arg':{'sort':'desc'}},'EVNTYPE':{'width':120,'arg':{'sort':'asc'}},'RECCURENCE':{'width':20,'css':'recurence','arg':{'sort':'desc'},"text":'&nbsp;'},'EVNCOLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
				break;

			case 'J':              //'EVNLOCATION':{'width':120,'arg':{'sort':'asc'}},
				aDefaultColumns = {'EVNTITLE':{'width':190,'arg':{'sort':'asc'}},'EVENT_STARTDATE':{'width':120,'arg':{'sort':'desc'}},'EVENT_ENDDATE':{'width':120,'arg':{'sort':'desc'}},'EVNTYPE':{'width':120,'arg':{'sort':'asc'}},'EVNCOLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
				break;
			
			case 'F':
				aDefaultColumns = {'EVNFILENAME':{'width':120,'arg':{'sort':'asc'}},'EVNNOTE':{'width':190,'arg':{'sort':'asc'}},'EVNFILEMODIFIED':{'width':120,'arg':{'sort':'desc'}},'EVNFILESIZE':{'width':50,'arg':{'sort':'asc'},'css':'ralign'},'EVNTYPE':{'width':120,'arg':{'sort':'asc'}},'EVNCOLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
				break;

			case 'M':
				var folders = (new gw_others).get('DEFAULT_FOLDERS','storage')['VALUES'];
				var sDraftFolder = folders['drafts'];
				var sSentFolder = folders['sent'];
				var sFolderID = sAccId + '/' + sFolId;

				if (sFolderID == sDraftFolder || sFolderID == sSentFolder)
					aDefaultColumns = {'PRIORITY':{'width':12,'arg':{'sort':'desc'},'css':'priority',"type":'static',"text":'&nbsp;'},'HAS_ATTACHMENT':{'width':18,'arg':{'sort':'desc'},'css':'attachment',"type":'static',"text":'&nbsp;'},'FLAGS':{'width':20,'arg':{'sort':'asc'},'css':'ico',"type":'static',"text":'&nbsp;'},'TO':{'width':160,'arg':{'sort':'asc'}},'SUBJECT':{'width':300,'arg':{'sort':'asc'}},'DATE':{'width':120,'arg':{'sort':'desc'}},'SIZE':{'width':60,'arg':{'sort':'desc'},'css':'ralign'},'COLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
				else{
					//get groups
					var bShared = false;
					if (sAccId == sPrimaryAccount){
						storage.library('gw_groups');
						var groups = new gw_groups;
						var aGroupsProps = groups.get('storage');
						for(var n in aGroupsProps)
							if (sFolId == aGroupsProps[n]['GRPTITLE'])
				                bShared = true;
					}

					if(bShared)
						aDefaultColumns = {'PRIORITY':{'width':12,'arg':{'sort':'desc'},'css':'priority',"type":'static',"text":'&nbsp;'},'HAS_ATTACHMENT':{'width':18,'arg':{'sort':'desc'},'css':'attachment',"type":'static',"text":'&nbsp;'},'FLAGS':{'width':20,'arg':{'sort':'asc'},'css':'ico',"type":'static',"text":'&nbsp;'},'FROM':{'width':160,'arg':{'sort':'asc'}},'TO':{'width':160,'arg':{'sort':'asc'}},'SUBJECT':{'width':250,'arg':{'sort':'asc'}},'DATE':{'width':120,'arg':{'sort':'desc'}},'SIZE':{'width':60,'arg':{'sort':'desc'},'css':'ralign'},'COLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
					else
						aDefaultColumns = {'PRIORITY':{'width':12,'arg':{'sort':'desc'},'css':'priority',"type":'static',"text":'&nbsp;'},'HAS_ATTACHMENT':{'width':18,'arg':{'sort':'desc'},'css':'attachment',"type":'static',"text":'&nbsp;'},'FLAGS':{'width':20,'arg':{'sort':'asc'},'css':'ico',"type":'static',"text":'&nbsp;'},'FROM':{'width':160,'arg':{'sort':'asc'}},'SUBJECT':{'width':300,'arg':{'sort':'asc'}},'DATE':{'width':120,'arg':{'sort':'desc'}},'SIZE':{'width':60,'arg':{'sort':'desc'},'css':'ralign'},'COLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
				}
				break;

			case 'R':
					aDefaultColumns = {'FLAGS':{'width':20,'arg':{'sort':'asc'},'css':'ico',"type":'static',"text":'&nbsp;'},'SUBJECT':{'width':400,'arg':{'sort':'asc'}},'FROM':{'width':160,'arg':{'sort':'asc'}},'DATE':{'width':120,'arg':{'sort':'desc'}},'COLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
				break;

			case 'T':
				aDefaultColumns = {'EVNSTATUS':{'width':18,'arg':{'sort':'asc'},"type":'static',"text":'&nbsp;','css':'status'},'EVNTITLE':{'width':240,'arg':{'sort':'asc'}},'TASK_ENDDATE':{'width':200,'arg':{'sort':'desc'}},'EVNTYPE':{'width':120,'arg':{'sort':'asc'}},'RECCURENCE':{'width':20,'css':'recurence','arg':{'sort':'desc'},"type":'static',"text":'&nbsp;'},'EVNCOLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
				break;

			case 'N':
				aDefaultColumns = {'EVNTITLE':{'width':500,'arg':{'sort':'asc'}},'EVNTYPE':{'width':120,'arg':{'sort':'asc'}},'EVNCOLOR':{'width':18,'arg':{'sort':'asc'},'css':'flags',"type":'static',"text":'&nbsp;'}};
				break;

			case 'Q':
				aDefaultColumns = {'SNDEMAIL':{'width':150,'arg':{'sort':'asc'}},'SNDSUBJECT':{'width':250,'arg':{'sort':'asc'}},'QDATE':{'width':110,'arg':{'sort':'desc'}},'SNDOWNER':{'width':100,'arg':{'sort':'asc'}},'SNDDOMAIN':{'width':80,'arg':{'sort':'asc'}}};
				break;

			case 'QL':
				aDefaultColumns = {'SNDEMAIL':{'width':160,'arg':{'sort':'asc'}},'SNDOWNER':{'width':160,'arg':{'sort':'asc'}},'SNDDOMAIN':{'width':160,'arg':{'sort':'asc'}}};
                this.__dragtype = ''; // No Drag & Drop
				break;
		}
	}
	
	var aColumns = {};

	//Máme zapnutou podporu cookies?
	if (this._cookiesEnabled)
	{
		var aCookieColumns = dataSet.get('datagrid_views',[sAccId,sFolId,'columns']);
		var bRepair = false;
		
		if (aCookieColumns)
		{
			for(var sColumn in aDefaultColumns)
			if (typeof aCookieColumns[sColumn] == 'undefined')
			{
				bRepair = true;
				break;
			}

			if (!bRepair)
				for(var sColumn in aCookieColumns)
					if (typeof aDefaultColumns[sColumn] == 'undefined')
					{
						bRepair = true;
						break;
					}
		}
		else
			bRepair = true;

		if (bRepair)
		{
			aCookieColumns = {};

			for(var sColumn in aDefaultColumns)
				aCookieColumns[sColumn] = aDefaultColumns[sColumn]['width'];

			dataSet.add('datagrid_views',[sAccId,sFolId,'columns'],aCookieColumns);
			aColumns = aDefaultColumns;
		}
		else
			for(var sColumn in aCookieColumns)
			{
				aColumns[sColumn] = aDefaultColumns[sColumn];
				aColumns[sColumn]['width'] = aCookieColumns[sColumn];
			}
		
		this._lastSort = dataSet.get('datagrid_views',[sAccId,sFolId,'sort']);
	}
	else
		aColumns = aDefaultColumns;




	//UPDATE, REFRESH
	if (!editrow && this.lister){
		var iCount = count(aItems);

		if (this.lister.__list != iCount && !(typeof iSubtotal!= 'undefined' && iSubtotal == iCount)){

			if (iCount<this.lister.__list && this.lister._value()+iCount<this.__total){
//			if (this.lister._value()+this.lister.__list<this.__total || this.__total<iCount){
				this._serverSort({'aid':sAccId,'fid':sFolId},this._lastSort.column,this._lastSort.type,0);
				return;
			}
			else
			if (this.lister._value()>0 && !iSubtotal){
				this.lister._value(this.lister._value()-this.lister.__list);
				return;
			}
		}
	}

	//Je třeba naplnit header?
/*
	if (this._refreshHeader)
	{
*/
		var aHeaders = {};
		var aHeader;

		for(var sTitle in aColumns)
		{
			aHeader = {};

			if (!aColumns[sTitle].text)
				aHeader['title'] = 'DATAGRID_ITEMS_VIEW::' + sTitle;

			for(var sProperty in aColumns[sTitle])
				aHeader[sProperty] = aColumns[sTitle][sProperty];

			aHeaders[sTitle] = aHeader;
		}
		this._addColumns(aHeaders);
/*
		this._refreshHeader = false;
	}
*/

	//Naplnění pole pro datagrid
	var aResult = [];
	var aRow,scss;
	var aColors =  {'1':'red','2':'blue','3':'green','4':'gray','5':'orange','6':'cyan',
					'7':'brown','8':'purple','9':'light_blue','A':'yellow','Y':'complete'};

	var aNoteColors =  {'1':'blue','2':'green','3':'red','5':'gray','6':'yellow'};

	for(var sItId in aItems)
	{
		aRow = {};
		scss = '';

		for(var sTitle in aColumns)
		{
			switch(sTitle)
			{
				//Contacts
				case 'CONTACT_EMAIL':
					var sContactEmail = '';

					//Nezobrazujeme maily pro distribuční seznam
					if (aItems[sItId]['ITMCLASS'] == 'C')
					{
						var aContactEmailParts = ['LCTEMAIL1','LCTEMAIL2','LCTEMAIL3'];

						for (var n in aContactEmailParts)
							if (aItems[sItId][aContactEmailParts[n]])
							{
								if (sContactEmail)
									sContactEmail += ', ';

								sContactEmail += aItems[sItId][aContactEmailParts[n]];
							}
					}
					aRow[sTitle] = sContactEmail;
					break;

				case 'ITMCLASSIFYAS':
					if (aItems[sItId][sTitle]){
	                    if (Is.String(aItems[sItId][sTitle]))
							aRow[sTitle] = [aItems[sItId][sTitle].entityify(),aItems[sItId][sTitle]];
						else
							aRow[sTitle] = aItems[sItId][sTitle];

						break;
					}
					
				case 'CONTACT_FULLNAME':
					var sFullName = '';
					var aFullNameParts = ['ITMTITLE','ITMFIRSTNAME','ITMMIDDLENAME','ITMSURNAME','ITMSUFFIX'];

					for (var n in aFullNameParts)
						if (aItems[sItId][aFullNameParts[n]])
							sFullName += aItems[sItId][aFullNameParts[n]] + ' ';

					sFullName.trim();
					aRow[sTitle] = sFullName;
				break;

				// Events
				case 'EVENT_ENDDATE':
					aRow[sTitle] = [this.__parseGwTime(aItems[sItId]['EVNENDDATE'],aItems[sItId]['EVNENDTIME']),parseInt(aItems[sItId]['EVNENDDATE'])*10000 + parseInt(aItems[sItId]['EVNENDTIME'])];
					break;

				case 'EVENT_STARTDATE':
				case 'EVNFILEMODIFIED':
					aRow[sTitle] = [this.__parseGwTime(aItems[sItId]['EVNSTARTDATE'],aItems[sItId]['EVNSTARTTIME']),parseInt(aItems[sItId]['EVNSTARTDATE'])*10000 + parseInt(aItems[sItId]['EVNSTARTTIME'])];
					break;

				case 'RECCURENCE':
					if (aItems[sItId]['EVNRCR_ID']) {
						scss += ' recurence';
						aRow[sTitle] = ['',1];
					} else
						aRow[sTitle] = ['',0];
					break;

				case 'EVNFILENAME':
					aRow[sTitle] = aItems[sItId]['EVNLOCATION'];
					break;

				case 'EVNSTATUS':
					switch (aItems[sItId][sTitle]) {
						case 'S': scss += ' not_started'; break;
						case 'N': scss += ' in_progress'; break;
						case 'D': scss += ' completed'; break;
						case 'L': scss += ' delegated'; break;
						case 'A': scss += ' needs_action'; break;
					}
					aRow[sTitle] = ['',aItems[sItId][sTitle]];
					break;
				//Tasks
				case 'TASK_ENDDATE':
					aRow[sTitle] = [this.__parseGwTime(aItems[sItId]['EVNSTARTDATE']),parseInt(aItems[sItId]['EVNSTARTDATE'])];
					break;
				//Mails
				case 'DATE':    //EMAIL
                case 'QDATE':	//Quarantine
					aRow[sTitle] = [this.__parseTime(aItems[sItId][sTitle]),parseInt(aItems[sItId][sTitle])];
					break;

				case 'PRIORITY':
					switch (aItems[sItId]['PRIORITY']) {
						case '1':
						case '2':
							scss += ' priority_high';
							aRow[sTitle] = ['',2];
							break;

						case '4':
						case '5':
							scss += ' priority_low';
							aRow[sTitle] = ['',0];
							break;

						default:
							aRow[sTitle] = ['',1];
					}
					break;

                case 'EVNCOLOR':
				case 'COLOR':
					var sTag = WMItems.getColorTag(sFolType);
					if (sTag) {
						if (aItems[sItId][sTag] && Is.Defined(aColors[aItems[sItId][sTag]])){
							scss += ' bg_';
							if (sFolType == 'N')
							    scss += aNoteColors[aItems[sItId][sTag]];
							else
								scss += aColors[aItems[sItId][sTag]];
						}
						aRow[sTitle] = ['', aItems[sItId][sTag]];
					}
					break;

				case 'FLAGS':
					var nFlags = aItems[sItId]['FLAGS'];
					var flag = '';

					if (!WMItems.hasFlag(nFlags, 'SEEN')) {
						flag = 'unread';
						aRow[sTitle] = ['',nFlags];
					} else if (WMItems.hasFlag(nFlags, 'ANSWERED')) {
						if (WMItems.hasFlag(nFlags, 'FORWARDED'))
							flag = 'replied_and_forwarded';
						else
							flag = 'replied';

						aRow[sTitle] = ['',nFlags];
					} else if (WMItems.hasFlag(nFlags, 'FORWARDED')) {
						flag = 'forwarded';
						aRow[sTitle] = ['',nFlags];
					} else {
						aRow[sTitle] = ['',nFlags];
					}

					if (parseInt(aItems[sItId]['SMIME_STATUS']) > 1)
						flag = 'smime' + ( flag ? '_' + flag : '' );

					if (flag)
						scss += ' ' + flag;
					break;

				case 'HAS_ATTACHMENT':
					if (aItems[sItId]['HAS_ATTACHMENT']=='true') {
						scss += ' attachment';
						aRow[sTitle] = ['',1];
					} else
						aRow[sTitle] = ['',0];
					break;

				case 'FROM':
				case 'TO':
					if (aItems[sItId][sTitle] == 'undisclosed-recipients:;')
						aRow[sTitle] = '';
					else
						aRow[sTitle] = MailAddress.parseMail(aItems[sItId][sTitle],'name_list');
					break;

				case 'SIZE':
					aRow[sTitle] = [this.__parseSize(aItems[sItId][sTitle]),parseInt(aItems[sItId][sTitle])];
					break;

				case 'EVNFILESIZE':
					var sSize = aItems[sItId]['EVNCOMPLETE'];
					if (!Is.Defined(sSize))
						sSize = 0;
					aRow[sTitle] = [this.__parseSize(sSize),parseInt(sSize)];
					break;


				default:

                    if (Is.String(aItems[sItId][sTitle]))
						aRow[sTitle] = [aItems[sItId][sTitle].entityify(),aItems[sItId][sTitle]];
					else
						aRow[sTitle] = aItems[sItId][sTitle];

					break;
			}
		}

		aResult.push({"id":sItId,"css":scss,"data":aRow,"arg":{'aid':sAccId,'fid':sFolId,'iid':sItId}});
	}

	var aCookie = dataSet.get('datagrid_views',[sAccId,sFolId]);

	// SERVER sort
	var tmp;
	if (this.__sortColumn!=null){
		if((tmp = document.getElementById(this._pathName +'#'+ this.__sortColumn))){
			removecss(tmp,'desc');
			removecss(tmp,'asc');
		}
		tmp = null;
	}

	this.__sortColumn = aCookie['sort']['column'];
	this.__sortType = (aCookie['sort']['type']=='desc'?1:0);

	if((tmp = document.getElementById(this._pathName +'#'+ this.__sortColumn))){
		addcss(tmp,(this.__sortType?'desc':'asc'));
		tmp = null;
	}

	this._lastOffset = 0;


	// Edit just one row value (Part 2)
	if (editrow){

		aResult = aResult[0];

		for(var pos in this._aData){
			if (this._aData[pos].id == aResult.id){
	        	editrow.className = this._aData[pos].css = aResult['css'];
				if (inArray(this.__value, aDPath[2])>-1)
					addcss(editrow,'active');

				break;
			}
		}

		if (aDPath[3]){
			var cell;
			if((cell = document.getElementById(this._pathName+'/'+aDPath[2]+'/'+aDPath[3]))){
				cell.innerHTML = (typeof aResult.data[aDPath[3]] == 'object'?aResult.data[aDPath[3]][0]:aResult.data[aDPath[3]]) || '&nbsp;';
				cell = null;
			}
		}

		editrow = null;
	}
	// Refill whole body
	else
		this._fill(aResult);

	aRow = null;
	aResult = null;
};

_me.__dragbody = function(){

	//get info
	var aItems = dataSet.get(this._dataSet);
	if (!aItems) return;
	for(var sAccId in aItems)
		for(var sFolId in aItems[sAccId])
			break;
	var sType = dataSet.get('folders',[sAccId,sFolId,'TYPE']);

	var v, out = '<table class="tbl_datagrid_'+sType+'">';
	for(var i in this.__value){
		v = this._aData[this.__idTable[this.__value[i]]];
		switch(sType){
		case 'R':
		    return false;
		case 'Q':
		case 'M':
			out += '<tr><th>'+ (v.data.SUBJECT?v.data.SUBJECT[0]:'') +'</th><td>'+ (v.data.DATE?v.data.DATE[0]:'') +'</td><td>'+ (v.data.SIZE?v.data.SIZE[0]:'') +'</td></tr>';
			break;
        case 'J':
		case 'E':
			out += '<tr><th>'+ (v.data.EVNTITLE?v.data.EVNTITLE[0]:'') +'</th><td>'+ (v.data.EVENT_STARTDATE?v.data.EVENT_STARTDATE[0]:'') +'</td><td>-</td><td>'+ (v.data.EVENT_ENDDATE?v.data.EVENT_ENDDATE[0]:'') +'</td></tr>';
			break;
		case 'N':
			out += '<tr><th>'+ (v.data.EVNTITLE?v.data.EVNTITLE[0]:'') +'</th>';
			break;
		case 'T':
			out += '<tr><th>'+ (v.data.EVNTITLE?v.data.EVNTITLE[0]:'') +'</th><td>'+ (v.data.TASK_ENDDATE?v.data.TASK_ENDDATE[0]:'') +'</td></tr>';
			break;
		case 'C':
			out += '<tr><th>'+ (v.data.ITMCLASSIFYAS?(typeof v.data.ITMCLASSIFYAS == 'object'?v.data.ITMCLASSIFYAS[0]:v.data.ITMCLASSIFYAS):'') +'</th><td>'+ v.data.CONTACT_EMAIL +'</td></tr>';
			break;
		case 'F':
			out += '<tr><th>'+ v.data.EVNFILENAME +'</th><td>'+ (v.data.EVNFILESIZE?v.data.EVNFILESIZE[0]:'') +'</td></tr>';
			break;
		}
	}
	
	return out + '</table>';
};

_me._onclick = function(e,elm,etr,arg,line,column,aClickType)
{
	if (inArray(aClickType,'SHIFT') > -1 || inArray(aClickType,'CTRL') > -1)
		return;

	var sType = dataSet.get('folders',[arg['aid'],arg['fid'],'TYPE']);

	switch (sType) {
		case 'Q':
		case 'M':
			if (column == 'COLOR') {
				var id = [arg['aid'],arg['fid'],arg['iid']];
				var sColor = OldMessage.getColor(id);
				
				if (sColor && (sColor == Item.COLORS.COMPLETE || sColor == Item.COLORS.CLEAR)) {
					storage.library('gw_others');
					var sDefaultColor = GWOthers.getItem('MAIL_SETTINGS_GENERAL','default_flag');
					
					OldMessage.setColor(id, sDefaultColor);
				} else {
					OldMessage.setColor(id, Item.COLORS.COMPLETE); 
				}
			}
			else {
				dataSet.add('active_mails',[arg['aid'],arg['fid']],arg['iid']);
				OldMessage.open([arg['aid'], arg['fid'], arg['iid']]);
			}
			break;
		case 'R':
			dataSet.add('active_mails',[arg['aid'],arg['fid']],arg['iid']);
			OldMessage.open([arg['aid'], arg['fid'], arg['iid']]);

			break;

		case 'T':
			if (column == 'EVNSTATUS') {
				var sCurrentStatus = dataSet.get('items',[arg['aid'],arg['fid'],arg['iid']])['EVNSTATUS'];
				
				var sStatus = (sCurrentStatus != 'D') ? 'D' : 'N'; 				
				
				// TODO rollback on error
				dataSet.add('items', [arg['aid'], arg['fid'], arg['iid'], 'EVNSTATUS'], sStatus);				
				WMItems.add([arg['aid'], arg['fid'], arg['iid']], {'values': {'EVNSTATUS': sStatus}}, 'items');
				break;
			}

		case 'C':
		case 'E':
		case 'J':
		case 'N':
		case 'F':
			//Execute Edit dialog on Enter
			if (e.type == 'keydown' && e.keyCode == 13)
                gui._create('gw',Mapping.getFormNameByGWType(sType),'','',arg['aid'],arg['fid'],arg['iid']);
	}
};


_me._ondblclick = function(e,elm,etr,arg)
{
    if (!etr){
        arg = this._getFolder();
		var sType = dataSet.get('folders',[arg['aid'],arg['fid'],'TYPE']);
		switch(sType){
			case 'C':
			case 'L':
			case 'E':
			case 'T':
			case 'J':
			case 'F':
			case 'N':
				Item.createInFolder(arg['aid'],arg['fid']);
			break;
			case 'M':
				NewMessage.compose();
		}
        return;
	}

	var sType = dataSet.get('folders',[arg['aid'],arg['fid'],'TYPE']);
	if (sType == 'C' && dataSet.get('items',[arg['aid'],arg['fid'],arg['iid'],'ITMCLASS']) == 'L')
		sType = 'L';

	if (sType == 'M') {
		var others = new gw_others;

		var aDraftFolder = Path.split(others.get('DEFAULT_FOLDERS','storage')['VALUES']['drafts']);
	
		if (aDraftFolder[0] != arg['aid'] || aDraftFolder[1] != arg['fid'])
		{
			//dataSet.add('active_mails',[arg['aid'],arg['fid']],arg['iid']);
			OldMessage.openwindow([arg['aid'], arg['fid'], arg['iid']]);
		}
		else
			OldMessage.edit([arg['aid'], arg['fid'], arg['iid']]);
	}
	else
	if (sType == 'F') {
	
        if (!Item.downloadFile([arg['aid'], arg['fid'], arg['iid']]))
        	gui._create('gw',Mapping.getFormNameByGWType(sType),'','',arg['aid'],arg['fid'],arg['iid']);
	}
	else
		gui._create('gw',Mapping.getFormNameByGWType(sType),'','',arg['aid'],arg['fid'],arg['iid']);
};


_me._oncontext = function(e,elm,etr,arg,sLineId,sColumn){
	var bOut = false;

	//Klikly jsme na místo bez položek?
	if (!arg || !arg['iid']){
		aItems = dataSet.get('items');

		for(var sAccId in aItems)
			for(var sFolId in aItems[sAccId])

		var arg = {'aid':sAccId,'fid':sFolId};
		bOut = true;
	}

	var sType = dataSet.get('folders',[arg['aid'],arg['fid'],'TYPE']);

	if (!bOut){
		if (sType == 'C' && dataSet.get('items',[arg['aid'],arg['fid'],arg['iid'],'ITMCLASS']) == 'L')
			sType = 'L';

		var aSelected = this._value();
		var bDisableOpen;

		if (inArray(aSelected,arg['iid']) >= 0 && aSelected.length > 1)
			bDisableOpen = true;
		else
			bDisableOpen = false;

		if (inArray(aSelected,arg['iid']) < 0)
			aSelected = [arg['iid']];
	}

	gui._create("cmenu","obj_context_item");

	if (bOut)
		gui.cmenu._fillGeneralMenu(sType,arg);
	else
		gui.cmenu._fillMenu(sType,arg,aSelected,bDisableOpen,false,sColumn);

	gui.cmenu._place(e.clientX,e.clientY);
};


_me._onchange = function(aColumns)
{
	if (this._cookiesEnabled)
	{
		var oFolder = this._getFolder();
		if (!oFolder)
			return;

		var aNewColumns = {};
	
		for(var sColumn in aColumns)
			aNewColumns[sColumn] = aColumns[sColumn]['width'];
			
		dataSet.remove('datagrid_views',[oFolder['aid'],oFolder['fid'],'columns']);
		dataSet.add('datagrid_views',[oFolder['aid'],oFolder['fid'],'columns'],aNewColumns);
	}
};


_me._onsort = function(e,elm,id,arg,type)
{
	if (!this._dataSet)
	  return;

	var oFolder = this._getFolder();
	if (!oFolder) return;

	var sAccId = oFolder['aid'];
	var sFolId = oFolder['fid'];
	
	this._serverSort({'aid':sAccId,'fid':sFolId},id,type,0);

	//Zapamatujeme si offset a sort pro strankování
	this._lastOffset = 0;
	this._lastSort = {'column':id,'type':type};

	//Používáme cookies?
	if (this._cookiesEnabled){
		dataSet.add('datagrid_views',[sAccId,sFolId,'offset'],0);
		dataSet.add('datagrid_views',[sAccId,sFolId,'sort'],{'column':id,'type':type});
	}

	//Máme připojený objekt lister?
	//if (this.lister) this.lister._value(0);
};


_me._serverSort = function(oFolder,sColumn,sSortType,aHandler)
{
	if (!(oFolder = oFolder || this._getFolder()))
	    return;

	sColumn = sColumn || this._lastSort.column;
	sSortType = sSortType || this._lastSort.type;
	
	var sOrderBy;

	// disable datagrid's internal sort IMPORTANT!
	this._skipsort = true;

	switch(sColumn)
	{
		//Contacts
		case 'CONTACT_EMAIL':
			sOrderBy = '';
			var aContactEmailParts = ['LCTEMAIL1','LCTEMAIL2','LCTEMAIL3'];

			for (var n in aContactEmailParts)
			{
				if (sOrderBy)
					sOrderBy += ',';

				sOrderBy += aContactEmailParts[n] + ' ' + sSortType;
			}
			break;

		case 'CONTACT_FULLNAME':
			sOrderBy = '';
			var aFullNameParts = ['ITMTITLE','ITMFIRSTNAME','ITMMIDDLENAME','ITMSURNAME','ITMSUFFIX'];

			for (var n in aFullNameParts)
			{
				if (sOrderBy)
					sOrderBy += ',';

				sOrderBy += aFullNameParts[n] + ' ' + sSortType;
			}
			break;

		//Events
		case 'EVENT_ENDDATE':
			sOrderBy = 'EVNENDDATE ' + sSortType + ',EVNENDTIME ' + sSortType;
			break;

		case 'EVENT_STARTDATE':
			sOrderBy = 'EVNSTARTDATE ' + sSortType + ',EVNSTARTTIME ' + sSortType;
			break;

		case 'EVNFILESIZE':
			sOrderBy = 'EVNCOMPLETE ' + sSortType;
		    break;

        case 'EVNFILEMODIFIED':
            sOrderBy = 'EVN_MODIFIED ' + sSortType;
			break;
            
		case 'EVNFILENAME':
            sOrderBy = 'EVNLOCATION ' + sSortType;
            break;

		//Mails
		case 'FROM':
			sOrderBy = 'HEADER_FROM ' + sSortType;
			break;

		case 'TO':
			sOrderBy = 'HEADER_TO ' + sSortType;
			break;
		//Tasks
		case 'TASK_ENDDATE':
			sOrderBy = 'EVNSTARTDATE ' + sSortType;
			break;

		case 'RECCURENCE':
			sOrderBy = 'EVNRCR_ID ' + sSortType;
			break;

		default:
			sOrderBy = sColumn + ' ' + sSortType;
	}

	var sFolType = dataSet.get('folders',[oFolder['aid'],oFolder['fid'],'TYPE']);
	var aValues = WMItems.default_values(sFolType);

	var aFilter = {'order_by':sOrderBy};
	if (this.lister){
		aFilter['offset'] = this.lister._value();
		aFilter['limit'] = this.lister._list()
	}
	if (this._SQLfilter)
		aFilter['sql'] = this._SQLfilter;

	if (this._SQLfulltext)
		aFilter['fulltext'] = this._SQLfulltext;

	WMItems.list({'aid':oFolder['aid'],'fid':oFolder['fid'],'values':aValues,'filter':aFilter},this._dataSet,'','',aHandler);
};

_me._getFolder = function(){
	var sDataSet = dataSet.get(this._dataSet);

	for(var sAccId in sDataSet)
		for(var sFolId in sDataSet[sAccId])

	return {'aid':sAccId,'fid':sFolId};
};