_me = obj_form_restrict.prototype;
function obj_form_restrict(){};

  /**
   * @brief  : activate value restrictions
   * @example:
   *           _restrict('regExp','error string',...)
   *           "error string" is optional parametr
   *
   * @result : ._checkError [...]
   * @date   : 25.4.2006 15:59:31
   **/
_me._restrict = function(){
	if (!arguments.length) {
		this._disobeyEvent('onkeyup',[this,'__check']);

		//this.__eIN.onkeyup = null;
		this.__restrictions  = null;
		return;
	}
	this.__restrictions = arguments;
	this._obeyEvent('onkeyup',[this,'__check']);
	this.__check();
};

  /**
   * @brief: value check function
   * @date : 15.2.2007 16:09:57
   * @note : if expression starts with "!" than result is inverted
   **/
_me.__check = function(){

	if (!this.__restrictions || !this.__restrictions.length){
		/* Error -> Ok */
		if (this._checkError.length && this._onerror){
			this._checkError = [];
			removecss(this._main,'error');
			this._onerror(false);
		}
		return true;
	}

	var r = this.__restrictions, v = this._value(), x,re,invert,ok;
	var checkError = [];

	for (var i = 0;i<r.length;i+=2){

		re = r[i];

		//alert(re+"\n"+re.substr(1,re.length-2));
		
		ok = false;

		if (re.indexOf('!')===0){
			invert = true;
			re = re.substr(1);
		}
		else
			invert = false;

		if (re.charAt(0)==">"){
			var number;

			if (re.charAt(re.length-1) == 'i') {
				if (v.match(/^[0-9]+$/) != null && (number = parseInt(v)) != NaN && number > re.substr(1,re.length-2))
					ok = true;
			}
			else
			if (v.match(/^[0-9.]+$/) != null && (number = parseFloat(v)) != NaN && number > re.substr(1))
				ok = true;
		}
		else
		if (re.charAt(0)=="<"){
			var number;
			if (re.charAt(re.length-1) == 'i') {
				if (v.match(/^[0-9]+i?$/) && (number = parseInt(v)) != NaN && number < re.substr(1,re.length-2))
					ok = true;
			}
			else
			if (v.match(/^[0-9.]+i?$/) && (number = parseFloat(v)) != NaN && number < re.substr(1))
				ok = true;
		}
		else{
			x = new RegExp(re,'gi');
			if (v.match(x)) ok = true;
		}

		if ((ok && invert) || (!ok && !invert))
			checkError.push(r[i+1]);
	}
	
	/* OK -> Error */
	if (checkError.length){
		addcss(this._main,'error');

		if (this._onerror && !this._checkError.length){
			this._checkError = checkError;
			this._onerror(true);
		}
		else
			this._checkError = checkError;

		return false;
	}

	/* Error -> Ok */
	if (this._checkError.length){
		this._checkError = [];
		if (this._onerror) this._onerror(false);
		removecss(this._main,'error');
	}

	return true;
};