/**************************************************************************
 * XMLFORM object
 * converts xmlform XML documents which are stored in \forms into HTML form
 **************************************************************************/
 
_me = obj_xform.prototype;
function obj_xform(){};

/**
 * @brief: retrieve xmlform document as array and pass it to the _exe method
 * @scope: PUBLIC
 * @date : 11.5.2006 10:24:31
 **/
_me._xml = function(sName, aParams){
   /* retrieve xml from server thru cache */
   this._exe(storage.form(sName), aParams);
};

/**
 * @brief: convert array into html form structure
 * @scope: PUBLIC
 * @date : 11.5.2006 10:19:29
 **/
_me._exe = function(aXML, aParams){

   if (aXML)
      this.__aXml = aXML;
   else{
      throw new Error('xform - blank input document');
      return false;
   }

   /* with <pages> */
   var aTab,oTab;
   if (aXML['PAGE']){
      var cn1,cn2;

      cn1 = this._create(aXML['ATTRIBUTES'] && aXML['ATTRIBUTES']['NAME']?aXML['ATTRIBUTES']['NAME']:'frm_form','obj_tabs');
      cn1 = cn1._name;

      for (var i in aXML['PAGE']){
          aTab = aXML['PAGE'][i];
          
          cn2 = this[cn1]._create(aTab['ATTRIBUTES'] && aTab['ATTRIBUTES']['NAME']?aTab['ATTRIBUTES']['NAME']:'obj_tab','obj_tab');
          cn2 = cn2._name;
          
          oTab = this[cn1][cn2];
          if (aTab['CAPTION']) oTab._value(aTab['CAPTION'][0]['VALUE']);
          
          this.__block(oTab,aTab,aParams);
      }
   }
   /* without <page> */
   else{
      oTab = this._create(aXML['ATTRIBUTES'] && aXML['ATTRIBUTES']['NAME']?aXML['ATTRIBUTES']['NAME']:'frm_form','obj_form');
      aTab = aXML;
      this.__block(oTab,aTab,aParams);
   }
};

_me.__createWithParams = function(oTab, sName, sType, aDynamicParams) {

   if (aDynamicParams) {
         
      if (Is.Object(aDynamicParams[sName]) || Is.Array(aDynamicParams[sName])) {
         var sArg = [];
         var aArg = [];
         var i = 0;
   		for (var sParam in aDynamicParams[sName]) {
            aArg.push(aDynamicParams[sName][sParam]);
            sArg.push('aArg['+i+']');
            i++;
   		}
   		sArg = sArg.join(',');
   		
        return eval('oTab._create(sName, sType, sName,"", '+sArg+');');
   	} else {
   	  return oTab._create(sName, sType, sName);
   	}
	} else {
	  return oTab._create(sName, sType, sName);
	}
};

/**
 * @brief: parse rows from xform XML
 * @scope: PRIVATE
 * @date : 11.5.2006 10:15:01
 **/
_me.__block = function(oTab,aTab,aParams){
   /* prepare data array for xform template */
   aTab['_ins'] = oTab._pathName;

   /* prepare achors and delete <obj> without NAME attr.*/
   var name,o,aObj=[];
   for (var i in aTab['ROW']){

        if (!aTab['ROW'][i]['OBJ']) continue;
        o = aTab['ROW'][i]['OBJ'][0];

        if (o){
           try{
             name = o['ATTRIBUTES']['NAME'];
             if(!name || !o['ATTRIBUTES']['TYPE']) throw true;
             oTab._anchors[name] = aTab['_ins']+name;
             aObj.push(o);
           }
           catch(e){
             delete aTab['ROW'][i]['OBJ'];
           }
        }
   }

   /* execute xform template */
   var e = document.getElementById(oTab._anchors['main']);
       e.innerHTML = template.tmp('xform',aTab);

   /* create objects into anchors */
   var tmp;
   for (var i in aObj){
        o = aObj[i];
        /* create obj instacnce */
        var onew = this.__createWithParams(oTab, o['ATTRIBUTES']['NAME'], o['ATTRIBUTES']['TYPE'], aParams);
        
        /* convert option tags to object's properties */
        if(o['OPTION']){
           var opt,tmp = {};
           for (var i in o['OPTION']){
               opt = o['OPTION'][i];
               if (opt['ATTRIBUTES'] && opt['ATTRIBUTES']['VALUE'])
                   tmp[opt['ATTRIBUTES']['VALUE']] = opt['VALUE'];
               else
                   tmp[opt['VALUE']] = opt['VALUE'];
           }
           onew._fill(tmp);
        }
        if(o['LISTENERDATA']){
           tmp = o['LISTENERDATA'][0];
           onew._listen(tmp['VALUE'],(tmp['ATTRIBUTES'] && tmp['ATTRIBUTES']['PATH']?tmp['ATTRIBUTES']['PATH']:''));
        }
        if(o['LISTENER']){
           tmp = o['LISTENER'][0];
           onew._listen(tmp['VALUE'],(tmp['ATTRIBUTES'] && tmp['ATTRIBUTES']['PATH']?tmp['ATTRIBUTES']['PATH']:''));
        }
        if(o['SAVER']){
           tmp = o['SAVER'][0];
           onew._save(tmp['VALUE'],(tmp['ATTRIBUTES'] && tmp['ATTRIBUTES']['PATH']?tmp['ATTRIBUTES']['PATH']:''));
        }
        if(o['RESTRICTIONS']){
           var a = [];
           for (var r in o['RESTRICTIONS'][0]['RESTRICT']){
               tmp = o['RESTRICTIONS'][0]['RESTRICT'][r];
               a.push(tmp['VALUE'],(tmp['ATTRIBUTES'] && tmp['ATTRIBUTES']['TEXT']?tmp['ATTRIBUTES']['TEXT']:''));
           }
           if (a.length) eval('onew._restrict("'+ a.join('","') +'");');
        }
   }
};
