/**
 * @brief copy methods and properties from one class to another one
 * @date  4.4.2006 9:56:24
 */
function objConcat(obj1,obj2){
	for (var i in obj2){
		switch(typeof obj2[i]) {
			case 'object'	: break;
			case 'function'	: break;
			default			: obj1[i] = obj2[i];
		}
	}
	for(var i in obj2.prototype)
		obj1.prototype[i] = obj2.prototype[i];

	return obj1;
};

/**
 * @brief   inherits only selected method from parent obj
 * @syntax  this.swiss(obj,'methodname','methodname');
 */
Function.prototype.swiss = function (parent) {

	if (arguments.length == 1){
		for(var i in parent.prototype)
			this.prototype[i] = parent.prototype[i]
	}

	for(var i = 1; i < arguments.length; i += 1) {
		var name = arguments[i];
		this.prototype[name] = parent.prototype[name];
	}

	return this;
};

/* orig metody hodi do _uber */
Function.prototype.inherit = function (parent) {

	var d = 0, p = (this.prototype = new parent());

	this.prototype.__uber = function (name) {
		var f, r, t = d, v = parent.prototype;
		if (t) {
			while (t) {
				v = v.constructor.prototype;
				t -= 1;
			}
			f = v[name];
		}
		else {
			f = p[name];
			if (f == this[name]) {
				f = v[name];
			}
		}
		d += 1;
		r = f.apply(this, Array.prototype.slice.apply(arguments, [1]));
		d -= 1;
		return r;
	};

	return this;
};

/**
 * @brief  : return clone of given class
 * @date   : 30.3.2006 15:38:54
 * NOT USED
 */
function cloneClass(obj){
	var x = obj.toString();
	var args = x.slice(x.indexOf('(')+1,x.indexOf(')')),body = x.slice(x.indexOf('{')+1,x.lastIndexOf('}'));

	pubEval('clon = function('+args+'){'+body+'};');

	for (var i in obj){
		switch(typeof obj[i]) {
			case 'object'  : break;
			case 'function': break;
			default        : clon[i] = obj[i];
		}
	}

	for (var i in obj.prototype)
		clon.prototype[i] = obj.prototype[i];

	return clon;
};

/**
 * @brief: inherits methods & properties of classes into given object (class instance)
 * @att. : main - instance, obj[,obj,...] classes
 * @date : 10.4.2006 21:17:15           PREDELAT na inherits METHODS
 **/
function inherits(main){
	for (var ii=1; ii<arguments.length; ii++){
		obj = arguments[ii];
		for(var i in obj){
			switch(typeof obj[i]) {
				case 'object'	: break;
				case 'function'	: break;
				default			: main[i] = obj[i];
			}
		}
		for (var i in obj.prototype)
			main[i] = obj.prototype[i];
	}
};

/**
 * @brief  : clone object
 *           "deep" switch for deep clone mode
 * @author : DRZ 10.03.2005
 * @date   : 29.3.2006 10:18:37
 */
function clone (obj, deep){

	//if (Is.Array(obj)) return [].concat(obj);  prestane bezet horni menu
	if (typeof(obj) != 'object') return obj;

	var objectClone = new obj.constructor();
	for (var property in obj){
		if (!deep)
			objectClone[property] = obj[property];
		else
		if (typeof obj[property] == 'object')
			objectClone[property] = clone(obj[property],deep);
		else
			objectClone[property] = obj[property];
	}
	return objectClone;
};

/**
 * @brief: deep object comparsion (for asociative arrays)
 * FALSE if aold != anew
 **/
function compareObj(aold,anew,keepOld){

	var a2 = anew;
	var a1 = keepOld?clone(aold,true):aold;

	if (typeof a1 == 'undefined')
		if (typeof a2 == 'undefined')
			return true;
		else
			return false;

	if (typeof a2 == 'undefined' || a1.constructor !== a2.constructor) return false;

	if (typeof a1 != 'object')
		if (a1 == a2)
			return true;
		else
			return false;

	var t;
	for (var i in a2){
		if (typeof a1[i] == 'undefined')
			if (typeof a2[i] == 'undefined')
				return true;
			else
				return false;

		t = typeof a2[i];

		if (t != typeof a1[i]) return false;

		if (t == 'object'){
			if (!compareObj(a1[i],a2[i],keepOld)) return false;
		}
		else
		if (a1[i] != a2[i]) return false;

		delete a1[i];
	}

	for (var i in a1) return false;

	return true;
};

function compareObj(aold,anew,keepOld){

	var a1 = keepOld?clone(aold,true):aold;
	var a2 = anew;

	if (typeof a1 == 'undefined')
		if (typeof a2 == 'undefined')
			return true;
		else
			return false;

	if (typeof a2 == 'undefined' || a1.constructor !== a2.constructor) return false;

	if (typeof a1 != 'object')
		if (a1 == a2)
			return true;
		else
			return false;

	var t;
	for (var i in a2){
		if (typeof a1[i] == 'undefined')
			if (typeof a2[i] == 'undefined')
				return true;
			else
				return false;

		t = typeof a2[i];

		if (t != typeof a1[i]) return false;

		if (t == 'object'){
			if (!compareObj(a1[i],a2[i],keepOld)) return false;
		}
		else
		if (a1[i] != a2[i]) return false;

		delete a1[i];
	}

	for (var i in a1) return false;

	return true;
};