function wm_items(){
  this.xmlns = 'items';
};

wm_items.inherit(wm_generic);
var _me = wm_items.prototype;

//********************************************************************************
//Základní SET funkce pro pro přidávání a update položek
//********************************************************************************
// Vstup: 
// id	[aid, fid(, iid)] 
//		povinné:   aid: account_id, fid: folder_id
//		nepovinné: iid: item_id (není-li zadané, položka se přidá, jinak se edituje)
//********************************************************************************
_me.add = function(id,aItemInfo,sDataSet,aDataPath,sFolderDataSet,aHandler)
{
	//Pomocná rekurzivní funkce
	function parse_addons(sAddOns,aFrom,aTo){
		if (typeof aFrom == 'object'){
			var aFrame = aTo[sAddOns] = [{}];
			var sAddOn = sAddOns.substr(0,sAddOns.length-1);
			aFrame = aFrame[0][sAddOn] = [{}];
			var aValues,n;
		}

		n = 0;
		for(var sId in aFrom){
			aFrame[n] = {};

			for(var sValues in aFrom[sId]){
				aValues = aFrom[sId][sValues];

				if (sValues == 'uid')
					aFrame[n]['ATTRIBUTES'] = {'UID':aValues};
				else
					if (sValues == 'values'){
						aValuesFrame = aFrame[n]['VALUES'] = [{}];
						parse_values(aValues,aValuesFrame[0]);
					}
					else
						parse_addons(sValues,aValues,aFrame[n]);
			}
			n++;
		}
	};

	function parse_values(aFrom,aTo){
		for(var sValue in aFrom)
			if(typeof aFrom[sValue] == 'object')
				aTo[sValue] = [{'VALUE':aFrom[sValue].pop()}];
			else
				aTo[sValue] = [{'VALUE':aFrom[sValue]}];
	};

	//Máme definovaná account_id a folder_id?
	if (!id[0] || !id[1])
		return false;

	//Chceme aktualizovat datasety při změně flags?
	if (id[2] && aItemInfo['values'] && (typeof aItemInfo['values']['flags'] != 'undefined') && sDataSet){
		var nFlag = aItemInfo['values']['flags'];
		dataSet.add(sDataSet,id.concat(['FLAGS']),nFlag);

		if (sFolderDataSet){
			var nRecent = dataSet.get(sFolderDataSet,[id[0],id[1],'RECENT']);
			if (typeof nRecent == 'undefined')
				nRecent = 0;

			if (this.hasFlag(nFlag,'SEEN')){
				if (nRecent)
					nRecent--;
			}
			else
				nRecent++;
			
			if (parseInt(dataSet.get(sFolderDataSet,[id[0],id[1],'RECENT']) || 0) != nRecent)
				dataSet.add(sFolderDataSet,[id[0],id[1],'RECENT'],nRecent.toString());
		}
	}

	var aRequest;

	//Vytvoříme základní strukturu XML dotazu
	if (id[2])
		aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"UID":id[0]},"FOLDER":[{"ATTRIBUTES":{"UID":id[1]},"ITEM":[{"ATTRIBUTES":{"UID":id[2],"ACTION":"edit"}}]}]}]};
	else
		aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"UID":id[0]},"FOLDER":[{"ATTRIBUTES":{"UID":id[1]},"ITEM":[{"ATTRIBUTES":{"ACTION":"add"}}]}]}]};

	var aFrame = aRequest["ACCOUNT"][0]["FOLDER"][0]["ITEM"][0];

	for(var sValues in aItemInfo)
		if (sValues != 'aid' && sValues != 'fid' && sValues != 'iid')
			if (sValues == 'values'){
				aFrame['VALUES'] = [{}];
				parse_values(aItemInfo['values'],aFrame['VALUES'][0]);
			}
			else
				parse_addons(sValues,aItemInfo[sValues],aFrame);

	//ClientTimeZone
	if (!aFrame['VALUES']) aFrame['VALUES'] = [];
	aFrame['VALUES'][0]['CTZ'] = [{VALUE:(new Date).getTimezoneOffset()*-1}];

	//Pracujeme synchronně či asynchronně?
	if (!sDataSet)
		return this.parse(this.create_iq(aRequest,'','set'));
	else{
		//AJAX...
		this.create_iq(aRequest,[this,'response',['add',sDataSet,aDataPath,sFolderDataSet,{'aid':id[0]},aHandler]],'set');
		return true;
	}
};

_me.copy = function(aItemsInfo, sDataSet, aDataPath, sFolderDataSet, aHandler)
{
	//Máme definovaná account_id, folder_id a jméno folderu, kam položky kopírujeme?
	if (!aItemsInfo['aid'] || !aItemsInfo['fid'] || !aItemsInfo['folder'])
		return false;

	//Vytvoříme základní strukturu XML dotazu
	// <ACCOUNT UID='aid'><FOLDER UID='fid'><ITEM...></FOLDER></ACCOUNT>
	var aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"UID":aItemsInfo['aid']},"FOLDER":[{"ATTRIBUTES":{"UID":aItemsInfo['fid']},"ITEM":[]}]}]};

	var aFrame = aRequest["ACCOUNT"][0]["FOLDER"][0]["ITEM"];
	var bItems;

	//Vytvoření atributů tagu(ů) <ITEM>
	// <ITEM UID='iid' ACTION='copy'><ACCOUNT>account</ACCOUNT><FOLDER>folder</FOLDER></ITEM>
	for(var nItem in aItemsInfo['iid']){
		if (aItemsInfo['account'])
			aFrame[nItem] = {"ATTRIBUTES":{"UID":aItemsInfo['iid'][nItem],"ACTION":"copy"},"ACCOUNT":[{"VALUE":aItemsInfo['account']}],"FOLDER":[{"VALUE":aItemsInfo['folder']}]};
		else
			aFrame[nItem] = {"ATTRIBUTES":{"UID":aItemsInfo['iid'][nItem],"ACTION":"copy"},"FOLDER":[{"VALUE":aItemsInfo['folder']}]};

		bItems = 1;
	}

	//Nebylo subpole 'iid' prázdné?
	if (!bItems) return false;

	//Pracujeme synchronně či asynchronně?
	if (!sDataSet){
		var aResponse = this.create_iq(aRequest,'','set');

		try{
			if (aResponse['IQ'][0]['ATTRIBUTES']['TYPE'] == 'result')
			return true;
		}
		catch(e){}

		return false;
	}
	else{
		//AJAX...
		this.create_iq(aRequest,[this,'response',['copy',sDataSet,aDataPath,sFolderDataSet,{'aid':aItemsInfo['aid'],'fid':aItemsInfo['fid'],'account':aItemsInfo['account']},aHandler]],'set');
		return true;
	}
};

_me.getFlag = function(id, sFlagName, sDataSet){
	var nFlag = this._getFlagValue(id, sDataSet, 'FLAGS');
	if (!Is.Defined(nFlag)) return false;
	return this.hasFlag(nFlag, sFlagName);
};

/**
 * Check whether some bit in number representing flags is set or not.
 * @param	nFlag		E.g. number 65 represents 'ANSWERED' + 'FORWARDED'  (1 + 64)
 * @param	sFlagName	'ANSWERED'|'DELETED'|'DRAFT'|'FLAGGED'|'RECENT'|'SEEN'|'FORWARDED'
 * @return	0 if the specified flag is not set, nonzero value otherwise
 */  
_me.hasFlag = function(nFlag, sFlagName)
{
	switch(sFlagName) {
		case 'ANSWERED' : nFlag &= 1; break;
		case 'DELETED'  : nFlag &= 2; break;
		case 'DRAFT'    : nFlag &= 4; break;
		case 'FLAGGED'  : nFlag &= 8; break;
		case 'RECENT'   : nFlag &= 16; break;
		case 'SEEN'     : nFlag &= 32; break;
		case 'FORWARDED': nFlag &= 64; break;
		default         : return false;
	}
	return (nFlag) ? true : false;
};

_me.setFlag = function(aItemsInfo,aFlagsSet,sDataSet,sFolderDataSet)
{
	function _setFlag(nFlag,sFlagName,bValue){
		switch(sFlagName){
			case 'ANSWERED'	: return (bValue ? nFlag | 33 : nFlag & ~1); // ANSWERED + SEEN
			case 'DELETED'	: return (bValue ? nFlag | 2 : nFlag & ~2);
			case 'DRAFT'	: return (bValue ? nFlag | 4 : nFlag & ~4);
			case 'FLAGGED'	: return (bValue ? nFlag | 8 : nFlag & ~8);
			case 'RECENT'	: return (bValue ? nFlag | 16 : nFlag & ~16);
			case 'SEEN'		: return (bValue ? nFlag | 32 : nFlag & ~32);
			case 'FORWARDED': return (bValue ? nFlag | 96 : nFlag & ~64); // FORWARDED + SEEN
		}
		return nFlag;
	}

	//Máme definovaná account_id, folder_id a alspoň jedno item_id?
	if (!aItemsInfo['aid'] || !aItemsInfo['fid'] || !aItemsInfo['iid'] || typeof aItemsInfo['iid'] != 'object' || !count(aItemsInfo['iid']))
		return false;

	//Vytvoříme základní strukturu XML dotazu
	var aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"UID":aItemsInfo['aid']},"FOLDER":[{"ATTRIBUTES":{"UID":aItemsInfo['fid']},"ITEM":[]}]}]};

	var aItemFrame = aRequest["ACCOUNT"][0]["FOLDER"][0]["ITEM"];
	var nFlag,nNewFlag;
	var nCounter = 0;
	var bUpdate = false;
	
	for(var n in aItemsInfo['iid'])
	{
		nFlag = this._getFlagValue([aItemsInfo['aid'], aItemsInfo['fid'], aItemsInfo['iid'][n]], sDataSet, 'FLAGS');
		if (typeof nFlag == 'undefined')
			nFlag = 0;

		nNewFlag = nFlag;
	
		for(var sFlagName in aFlagsSet)
			nNewFlag = _setFlag(nNewFlag,sFlagName,aFlagsSet[sFlagName]);
		
		if (nNewFlag != nFlag)
		{
			dataSet.add(sDataSet,[aItemsInfo['aid'],aItemsInfo['fid'],aItemsInfo['iid'][n],'FLAGS'],nNewFlag,true);
			aItemFrame.push({"ATTRIBUTES":{"UID":aItemsInfo['iid'][n],"ACTION":"edit"},"VALUES":[{"FLAGS":[{"VALUE":nNewFlag}]}]});
			nCounter++;
			bUpdate = true;
		}
	}
	if (bUpdate) {
		if (aItemsInfo['iid'].length == 1)
			dataSet.update(sDataSet, [aItemsInfo['aid'], aItemsInfo['fid'], aItemsInfo['iid'][0], 'FLAGS']);
		else
			dataSet.update(sDataSet);
	}

	//Chceme aktualizovat datasety při změně flags?
	if (sFolderDataSet && nCounter>0)
	{
		var nRecent = parseInt(dataSet.get(sFolderDataSet,[aItemsInfo['aid'],aItemsInfo['fid'],'RECENT']) || 0);

		if (this.hasFlag(nNewFlag,'SEEN'))
			dataSet.add(sFolderDataSet,[aItemsInfo['aid'],aItemsInfo['fid'],'RECENT'],(nRecent - nCounter > 0?nRecent - nCounter:0).toString());
		else
			dataSet.add(sFolderDataSet,[aItemsInfo['aid'],aItemsInfo['fid'],'RECENT'],(nRecent + nCounter).toString());
	}

	if (!nCounter)
		return false;

	//Pracujeme synchronně či asynchronně?
	if (!sDataSet)
		return this.parse(this.create_iq(aRequest,'','set'));
	else
	{
		//AJAX...
		this.create_iq(aRequest,[this,'response',['edit',sDataSet,'',sFolderDataSet,{'aid':aItemsInfo['aid']}]],'set');
		return true;
	}
};

_me.getStaticFlag = function(id, sFlagName, sDataSet)
{
	var nFlag = this._getFlagValue(id, sDataSet, 'STATIC_FLAGS');
	if (typeof nFlag != 'undefined')
		return false;
	
	switch(sFlagName)
	{
		case 'HTMLBODY'   : return nFlag & 1;
		case 'CACHED'     : return nFlag & 2;
	}
	return false;
};

_me._getFlagValue = function(id, sDataSet, sFlagType)
{
	if (!sDataSet || !sFlagType)
		return false;

	return dataSet.get(sDataSet, id.concat([sFlagType]));
}

_me.move = function(aItemsInfo,sDataSet,aDataPath,sFolderDataSet,aHandler)
{
	//Máme definovaná account_id, folder_id a jméno folderu, kam položky přesouváme?
	if (!aItemsInfo['aid'] || !aItemsInfo['fid'] || !aItemsInfo['folder'])
		return false;

	//Vytvoříme základní strukturu XML dotazu
	// <ACCOUNT UID='aid'><FOLDER UID='fid'><ITEM...></FOLDER></ACCOUNT>
	var aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"UID":aItemsInfo['aid']},"FOLDER":[{"ATTRIBUTES":{"UID":aItemsInfo['fid']},"ITEM":[]}]}]};

	var aFrame = aRequest["ACCOUNT"][0]["FOLDER"][0]["ITEM"];
	var bItems;

	//Vytvoření atributů tagu(ů) <ITEM>
	// <ITEM UID='iid' ACTION='move'><ACCOUNT>account</ACCOUNT><FOLDER>folder</FOLDER></ITEM>
	for(var n in aItemsInfo['iid'])
	{
		if (aItemsInfo['account'])
			aFrame[n] = {"ATTRIBUTES":{"UID":aItemsInfo['iid'][n],"ACTION":"move"},"ACCOUNT":[{"VALUE":aItemsInfo['account']}],"FOLDER":[{"VALUE":aItemsInfo['folder']}]};
		else
			aFrame[n] = {"ATTRIBUTES":{"UID":aItemsInfo['iid'][n],"ACTION":"move"},"FOLDER":[{"VALUE":aItemsInfo['folder']}]};

		bItems = 1;
	}

	//Nebylo subpole 'iid' prázdné?
	if (!bItems) return false;

	//Natvrdo synchronne
    var aResponse = this.create_iq(aRequest,'','set');

    try{
        if (sDataSet)
			this.response({"Array":aResponse},'move',sDataSet,aDataPath,sFolderDataSet,{'aid':aItemsInfo['aid'],'fid':aItemsInfo['fid'],'account':aItemsInfo['account']},aHandler);
		else
		if (aResponse['IQ'][0]['ATTRIBUTES']['TYPE'] == 'result') return true;
    }
    catch(e){}
	return false;

	/*
	//Pracujeme synchronně či asynchronně?
	if (!sDataSet)
	{
		var aResponse = this.create_iq(aRequest,'','set');

		try
		{
			if (aResponse['IQ'][0]['ATTRIBUTES']['TYPE'] == 'result')

			if (sDataSet)
				this.create_iq(aRequest,[this,'response',['move',sDataSet,aDataPath,sFolderDataSet,{'aid':aItemsInfo['aid'],'fid':aItemsInfo['fid'],'account':aItemsInfo['account']},aHandler]],'set');

			return true;
		}
		catch(e){}
		return false;
	}
	else{
		//AJAX...
		this.create_iq(aRequest,[this,'response',['move',sDataSet,aDataPath,sFolderDataSet,{'aid':aItemsInfo['aid'],'fid':aItemsInfo['fid'],'account':aItemsInfo['account']},aHandler]],'set');
		return true;
	}
	*/
};
    
_me.quarantine = function(aItemsInfo,sDataSet,aDataPath,sFolderDataSet)
{
	//Máme definovaná account_id, folder_id a akci, kterou máme vyvolat?
  if (!aItemsInfo['aid'] || !aItemsInfo['fid'] || !aItemsInfo['action'])
    return false;

  //Vytvoříme základní strukturu XML dotazu
  // <ACCOUNT UID='aid'><FOLDER UID='fid'><ITEM...></FOLDER></ACCOUNT>
  var aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"UID":aItemsInfo['aid']},"FOLDER":[{"ATTRIBUTES":{"UID":aItemsInfo['fid']},"ITEM":[]}]}]};

  var aFrame = aRequest["ACCOUNT"][0]["FOLDER"][0]["ITEM"];
  var bItems;

  //Vytvoření atributů tagu(ů) <ITEM>
  // <ITEM UID='iid' ACTION='action'/>
  for(var n in aItemsInfo['iid'])
  {
    aFrame[n] = {"ATTRIBUTES":{"UID":aItemsInfo['iid'][n],"ACTION":aItemsInfo['action']}};

    bItems = 1;
  }
  //Nebylo subpole 'iid' prázdné?
  if (!bItems)
    return false;

	var aResponse = this.create_iq(aRequest,'','set');
    try{
        if (sDataSet)
			this.response({"Array":aResponse},'quarantine',sDataSet,aDataPath,sFolderDataSet,{'aid':aItemsInfo['aid'],'fid':aItemsInfo['fid']});
		else
		if (aResponse['IQ'][0]['ATTRIBUTES']['TYPE'] == 'result') return true;
    }
    catch(e){}
	return false;

	
/*
  //Pracujeme synchronně či asynchronně?
  if (!sDataSet)
  {
    var aResponse = this.create_iq(aRequest,'','set');

    try
    {
      if (aResponse['IQ'][0]['ATTRIBUTES']['TYPE'] == 'result')
        return true;
    }
    catch(e){}
    return false;
  }
  else
  {
    //AJAX...
    this.create_iq(aRequest,[this,'response',['quarantine',sDataSet,aDataPath,sFolderDataSet,{'aid':aItemsInfo['aid'],'fid':aItemsInfo['fid']}]],'set');
    return true;
  }
*/
};

/*

<iq sid="8028cf831e365b49a98abdfdaded298e" type="set">
<query xmlns="webmail:iq:items">
<account uid="domain@icewarpdemo.com">
<folder uid="INBOX">
<item uid="72" action="accept">
<folder>Events</folder><partid>1</partid>
</item></folder></account></query>
</iq>

*/
_me.imip = function(aItemInfo,sAction,aHandler)
{
	//Máme definovaná account_id a folder_id?
	if (!aItemInfo['aid'] || !aItemInfo['fid'] || !aItemInfo['iid'])
		return false;

	//Vytvoříme základní strukturu XML dotazu
	// <ACCOUNT UID='aid'><FOLDER UID='fid'><ITEM UID='iid'>...</ITEM></FOLDER></ACCOUNT>
	var aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"UID":aItemInfo['aid']},"FOLDER":[{"ATTRIBUTES":{"UID":aItemInfo['fid']},"ITEM":[{"ATTRIBUTES":{"UID":aItemInfo['iid'],"ACTION":sAction}}]}]}]};

	var aItemRequest = aRequest["ACCOUNT"][0]["FOLDER"][0]["ITEM"][0];

	if (!aItemInfo['destination'])
		switch(aItemInfo['imip_type']){
		case 'VEVENT':
            aItemInfo['destination'] = 'Events';
			break;
		case 'VTODO':
			aItemInfo['destination'] = 'Tasks';
		    break;
		case 'VJOURNAL':
			aItemInfo['destination'] = 'Journal';
			break;
		}
		
	aItemRequest["FOLDER"] = [{"VALUE":aItemInfo['destination']}];

	if (aItemInfo['partid'])
		aItemRequest["PARTID"] = [{"VALUE":aItemInfo['partid']}];

	//Pracujeme synchronně či asynchronně?
	if (!aHandler){
		var aResponse = this.create_iq(aRequest,'','set');
		try{
			if (aResponse['IQ'][0]['ATTRIBUTES']['TYPE'] == 'result')
				return true;
		}
		catch(e){}
		return false;
	}
	else{
		//AJAX...
		this.create_iq(aRequest,[this,'response',[sAction,'','','',{'aid':aItemInfo['aid'],'fid':aItemInfo['fid']},aHandler]],'set');
		return true;
	}
};


//********************************************************************************
//Základní SET funkce pro pro přesměrování mailové položky
//********************************************************************************
//Vstup: aItemInfo ... asociativní pole klíčů:
//  povinné: 'aid':account_id, 'fid':folder_id, 'iid':item_id,
//					 'to': seznam příjemců, 'distrib': asociativní pole polí
//            	account_id -> folder_id -> pole aliasů
//********************************************************************************

_me.redirect = function(aItemInfo,sDataSet,aDataPath,aHandler)
{
	//Máme definovaná account_id a folder_id?
	if (!aItemInfo['aid'] || !aItemInfo['fid'] || !aItemInfo['iid'] || (!aItemInfo['to'] && !aItemInfo['distrib']))
		return false;

	//Vytvoříme základní strukturu XML dotazu
	// <ACCOUNT UID='aid'><FOLDER UID='fid'><ITEM UID='iid'>...</ITEM></FOLDER></ACCOUNT>
	var aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"UID":aItemInfo['aid']},"FOLDER":[{"ATTRIBUTES":{"UID":aItemInfo['fid']},"ITEM":[{"ATTRIBUTES":{"UID":aItemInfo['iid'],"ACTION":"redirect"}}]}]}]};

	var aItemRequest = aRequest["ACCOUNT"][0]["FOLDER"][0]["ITEM"][0];

	if (aItemInfo['to'])
		aItemRequest["TO"] = [{"VALUE":aItemInfo['to']}];

	if (aItemInfo['distrib'])
	{
		aItemRequest["ACCOUNT"] = [];
		var aAccRequest = aItemRequest["ACCOUNT"];
	  var aFolRequest,aToRequest;
	  
	  var aDistribFrame = aItemInfo['distrib'];
	  var aAccFrame,FolFrame;
	  
	  for(var sAccId in aDistribFrame)
		{
			aAccFrame = aDistribFrame[sAccId];
			aFolRequest = [];

			for(var sFolId in aAccFrame)
			{
			  aFolFrame = aAccFrame[sFolId];
				aToRequest = [];
				
			  for(var n in aFolFrame)
					aToRequest.push({"VALUE":aFolFrame[n]});

			  aFolRequest.push({"ATTRIBUTES":{"UID":sFolId},"TO":aToRequest});
			}
			aAccRequest.push({"ATTRIBUTES":{"UID":sAccId},"FOLDER":aFolRequest});
	  }
	}

	//Pracujeme synchronně či asynchronně?
  if (!sDataSet)
  {
    var aResponse = this.create_iq(aRequest,'','set');

    try
    {
      if (aResponse['IQ'][0]['ATTRIBUTES']['TYPE'] == 'result')
        return true;
    }
    catch(e){}
    return false;
  }
  else
  {
    //AJAX...
    this.create_iq(aRequest,[this,'response',['redirect',sDataSet,aDataPath,'',{'aid':aItemInfo['aid'],'fid':aItemInfo['fid']},aHandler]],'set');
    return true;
  }
};

//********************************************************************************
//Základní SET funkce pro pro mazání položek
//********************************************************************************
//Vstup: aItemsInfo ... asociativní pole klíčů:
//  povinné:   'aid':account_id, 'fid':folder_id, 'iid':pole hodnot item_id
//********************************************************************************

_me.remove = function(aItemsInfo,sDataSet,aDataPath,sFolderDataSet,aHandler){
	function parse_values(aFrom,aTo){
		for(var sValue in aFrom)
			if(typeof aFrom[sValue] == 'object')
				aTo[sValue] = [{'VALUE':aFrom[sValue].pop()}];
			else
				aTo[sValue] = [{'VALUE':aFrom[sValue]}];
	};
	
	//Máme definovaná account_id a folder_id?
	if (!aItemsInfo['aid'] || !aItemsInfo['fid']) return false;

	//Vytvoříme základní strukturu XML dotazu
	// <ACCOUNT UID='aid'><FOLDER UID='fid'><ITEM.../></FOLDER></ACCOUNT>
	var aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"UID":aItemsInfo['aid']},"FOLDER":[{"ATTRIBUTES":{"UID":aItemsInfo['fid']},"ITEM":[]}]}]};

	var aFrame = aRequest["ACCOUNT"][0]["FOLDER"][0]["ITEM"];
	var bItems = 0;
	var bValue = Is.Object(aItemsInfo['values']);

	//Vytvoření atributů tagu(ů) <ITEM>
	// <ITEM UID='iid' ACTION='delete'/>
	for(var n in aItemsInfo['iid']){
		aFrame[n] = {"ATTRIBUTES":{"UID":aItemsInfo['iid'][n],"ACTION":"delete"}};
		bItems++;

		// byly pro polozku nastaveny nepovinne parametry 'VALUES'?
		if (bValue && Is.Object(aItemsInfo['values'][n])){
			aFrame[n]['VALUES'] = [{}];
			parse_values(aItemsInfo['values'][n],aFrame[n]['VALUES'][0]);
		}
	}

	//Nebylo subpole 'iid' prázdné?
	if (!bItems)
		return false;

	//Natvrdo synchronne
    var aResponse = this.create_iq(aRequest,'','set');

    try{
        if (sDataSet)
			this.response({'Array':aResponse},'remove',sDataSet,aDataPath,sFolderDataSet,{'aid':aItemsInfo['aid'],'fid':aItemsInfo['fid']},aHandler);
		else
		if (aResponse['IQ'][0]['ATTRIBUTES']['TYPE'] == 'result') return true;
    }
    catch(e){}
	return false;
	
	/*
	//Pracujeme synchronně či asynchronně?
	if (!sDataSet){
		var aResponse = this.create_iq(aRequest,'','set');

		try{
			if (aResponse['IQ'][0]['ATTRIBUTES']['TYPE'] == 'result')
			return true;
		}
		catch(e){}
		return false;
	}
	else{
		//AJAX...
		this.create_iq(aRequest,[this,'response',['remove',sDataSet,aDataPath,sFolderDataSet,{'aid':aItemsInfo['aid'],'fid':aItemsInfo['fid']},aHandler]],'set');
		return true;
	}
	*/
};

//********************************************************************************
//Základní GET funkce pro získání položek
//********************************************************************************
//Vstup: aItemsInfo ... asociativní pole klíčů:
//  povinné:   'aid':account_id, 'fid':folder_id
//  nepovinné: 'iid':item_id, 'values':pole hodnot kontextových subtagů,
//             'filter':asociativní pole nepovinných klíčů:
//                'eventinterval':unixfrom-unixto, 
//                'sql':(evntitle like '%webmail%') and/or (evn...)
//********************************************************************************

_me.list = function(aItemsInfo,sDataSet,aDataPath,sFolderDataSet,aHandler)
{
	//Máme definovaná account_id a folder_id?
	if (!aItemsInfo['aid'] || !aItemsInfo['fid'])
		return false;

	var aRequest;
	//Vytvoříme základní strukturu XML dotazu
	// <ACCOUNT UID='aid'><FOLDER UID='fid'><ITEM UID='iid'>...</ITEM></FOLDER></ACCOUNT> pro definované 'iid' nebo
	// <ACCOUNT UID='aid'><FOLDER UID='fid'>...</FOLDER></ACCOUNT> pro nedefinované
	if (aItemsInfo['iid']){
		if (aItemsInfo['atid'])
			aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"UID":aItemsInfo['aid']},"FOLDER":[{"ATTRIBUTES":{"UID":aItemsInfo['fid']},"ITEM":[{"ATTRIBUTES":{"UID":aItemsInfo['iid'],"ATID":aItemsInfo['atid']}}]}]}]};
		else
			aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"UID":aItemsInfo['aid']},"FOLDER":[{"ATTRIBUTES":{"UID":aItemsInfo['fid']},"ITEM":[{"ATTRIBUTES":{"UID":aItemsInfo['iid']}}]}]}]};
	}
	else{
		aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"UID":aItemsInfo['aid']},"FOLDER":[{"ATTRIBUTES":{"UID":aItemsInfo['fid']}}]}]};

		//Trash auto-cleanup
		if (!window.gui.frm_main.__trash_cleaned){
			var aTrashFolder = Path.split(GWOthers.getItem('DEFAULT_FOLDERS', 'trash'));
			if (typeof aTrashFolder == 'object' && aItemsInfo['aid'] == aTrashFolder[0] && aItemsInfo['fid'] == aTrashFolder[1]){
				var iDay = 0;
				if (GWOthers.getItem('MAIL_SETTINGS_GENERAL','autoclear_trash')>0 && (iDay = GWOthers.getItem('MAIL_SETTINGS_GENERAL','autoclear_trash_days'))>0){
					aRequest.ACCOUNT[0].FOLDER[0].CLEANUP = [{VALUE:parseInt(iDay)}];

					//trash is cleaned once per login
					window.gui.frm_main.__trash_cleaned = true;
				}
			}
		}
	}
    
	var aFrame; 
	var bValues;
	var bSort,bBody;

	//Máme definované subpole "values"?
	if (aItemsInfo['values'])
	{
		var aValFrame = {};
		
		//Vytvoříme podstrukturu tagu <VALUES>
		// <TAG1/><TAG2/>...    
		for(var nIndex in aItemsInfo['values'])
		{
			aValFrame[aItemsInfo['values'][nIndex]] = [{"VALUE":' '}];
		
			//Chceme explicitně tělo mailu?
			if (aItemsInfo['values'][nIndex] == 'HTML' || aItemsInfo['values'][nIndex] == 'TEXT')
				bBody = true;
		
			bValues = true;
		}


		//Chceme aktualizovat datasety při změně flags?
		if (bBody && aItemsInfo['iid'] && sDataSet && aItemsInfo['iid'].indexOf('|')<0){
			if (this.getFlag([aItemsInfo['aid'], aItemsInfo['fid'], aItemsInfo['iid']], 'SEEN', 'items') == false)
			{
				var nFlags = dataSet.get('items',[aItemsInfo['aid'],aItemsInfo['fid'],aItemsInfo['iid'],'FLAGS']);

				if (typeof nFlags != 'undefined')
				{
					dataSet.add(sDataSet,[aItemsInfo['aid'],aItemsInfo['fid'],aItemsInfo['iid'],'FLAGS'],nFlags | 32);

					if (sFolderDataSet){
						var nRecent = parseInt(dataSet.get(sFolderDataSet,[aItemsInfo['aid'],aItemsInfo['fid'],'RECENT']) || 0);
						if (nRecent > 0)
							dataSet.add(sFolderDataSet,[aItemsInfo['aid'],aItemsInfo['fid'],'RECENT'],(--nRecent).toString());
					}
				}
			}
		}

		//Nebylo subpole "values" prázdné?
		if (bValues)
		{
			//Pokud nebylo zadáno item_id, přidáme tag <ITEM> pod tag <FOLDER>
			if (!aItemsInfo['iid'])
				aRequest["ACCOUNT"][0]["FOLDER"][0]["ITEM"]=[{}];



			//Přidáme celou strukturu tagu <VALUES> pod tag <ITEM>
			aFrame = aRequest["ACCOUNT"][0]["FOLDER"][0]["ITEM"][0];

			//ClientTimeZone
			aValFrame['CTZ'] = [{VALUE:(new Date).getTimezoneOffset()*-1}];
			aFrame["VALUES"] = [aValFrame];
		}
	}

	var bFilter = 0;
	//Máme definované subpole "filter" a nedefinované item_id?
	if (aItemsInfo['filter'] && !aItemsInfo['iid']){
		var aFilFrame = {};

		//Vytvoříme podstrukturu tagu <FILTER>
		// <TAG1/><TAG2/>...
		for(var sFilter in aItemsInfo['filter']){

			aFilFrame[sFilter] = [{"VALUE":aItemsInfo['filter'][sFilter]}];

			if (sFilter == 'order_by' || sFilter == 'limit')
				bSort = true;

			bFilter = 1;
		}

		//Nebylo subpole "filter" prázdné?
		if (bFilter){
			//Pokud nebylo definováno subpole "filter", či bylo prázdné, přidáme tag <ITEM> pod tag <FOLDER>
			if (!bValues){
				aRequest["ACCOUNT"][0]["FOLDER"][0]["ITEM"]=[{}];
				aFrame = aRequest["ACCOUNT"][0]["FOLDER"][0]["ITEM"][0];
			}
			//Přidáme celou strukturu tagu <FILTER> pod tag <ITEM>
			aFrame["FILTER"] = [aFilFrame];
		}
	}
	

	//Pracujeme synchronně či asynchronně?
	if (!sDataSet){
		return this.parse(this.create_iq(aRequest),(typeof aItemsInfo.iid == 'undefined'?true:false));
	}
	else{
		//AJAX...
		this.__lastListId = (new Date()).getTime();   //debug seems that it can be removed
		this.create_iq(aRequest,[this,'response',['list',sDataSet,aDataPath,sFolderDataSet,{'aid':aItemsInfo['aid'],'fid':aItemsInfo['fid'],'iid':aItemsInfo['iid'],'filter':bFilter},aHandler,bSort]],'',this.__lastListId);
		return true;
	}
};

//********************************************************************************
//Pomocná funkce realizující asynchronní obsluhu odpovědi
//********************************************************************************

_me.response = function(aData,sMethodName,sDataSet,aDataPath,sFolderDataSet,aArgs,aHandler,bSort)
{
	var aXMLResponse = aData['Array'];
	var aIQAttribute = aXMLResponse['IQ'][0]['ATTRIBUTES'];

	switch(sMethodName){
		// IMIP
		case 'accept':
		case 'decline':

			if (aIQAttribute['TYPE'] == 'result')
				executeCallbackFunction(aHandler);

			break;
		    
		case 'edit':
			if (aIQAttribute['TYPE'] != 'result'){
				return;
			}
			
		case 'add':
		case 'list':
			var bOk = false;

			//debug seems that it can be removed
			//if (aIQAttribute['UID'] && aIQAttribute['UID']!=this.__lastListId) return;

			if (aIQAttribute['TYPE'] != 'result'){

				var str, att;
				try{
					att = aXMLResponse.IQ[0].ERROR[0].ATTRIBUTES.UID;
					str = aXMLResponse.IQ[0].ERROR[0].VALUE;
				}
				catch(e){
					str = att = '';
				}

				switch(att.toLowerCase()){
				case 'smtp_recipients_failed':
					alert(getLang('ALERTS::SMTP_RECIPIENTS_FAILED')+(str?"\n"+str.unescapeHTML():''));
					bOk = true;
					break;

				case 'imap_internal':
					alert(str.unescapeHTML());

				default:
					if (sFolderDataSet){
						var folders = new wm_folders;
						folders.list({'aid':aArgs['aid']},sFolderDataSet);
					}
					else{
						//stops datagrid2 "Loading"
						dataSet.remove(sDataSet,aDataPath);
						//dataSet.update(sDataSet,aDataPath);
					}
					//HOT FIX, we dont have any error handling here (class_old_message)
					return false;
				}
			}
			else
			{
				if (sMethodName == 'list'){

					if (bSort)
						dataSet.remove(sDataSet,aDataPath,true);

					var parsedXMLResponse = this.parse(aXMLResponse,(typeof aArgs['iid'] == 'undefined'?true:false));

					dataSet.add(sDataSet,aDataPath,parsedXMLResponse,true);
					dataSet.update(sDataSet);
				}
				bOk = true;
			}

			if (typeof aHandler == 'object')
				if (sMethodName == 'list'){
					// pěkná čunina :)
					// TODO unless executeCallbackFunction reorders the parameters
					// this hack wouldn't be nedeed
					pushParameterToCallback(aHandler, parsedXMLResponse);
					executeCallbackFunction(aHandler);
				}
				else
					executeCallbackFunction(aHandler,[bOk]);

			return true;

		case 'copy':
		case 'move':
		case 'remove':
			try{
				if (sFolderDataSet)
					if (aIQAttribute['TYPE'] == 'result'){
						//Specialita pro delete Events
						if (sMethodName == 'remove'){
							var aItems = dataSet.get(sDataSet);

							for(var sAccId in aItems)
								for(var sFolId in aItems[sAccId]);

							var oType = dataSet.get(sFolderDataSet,[sAccId,sFolId,'TYPE']);
							if (oType == 'E' || oType == '0') dataSet.update(sDataSet);
						}
					}
					else{
						if (sMethodName != 'copy'){
							var aItems = dataSet.get(sDataSet);

							for(var sAccId in aItems)
							for(var sFolId in aItems[sAccId]);

							//Nekliknul uživatel na jiný folder?
							if (sAccId == aArgs['aid'] && sFolId == aArgs['fid']){
								var aValues = this.default_values(dataSet.get(sFolderDataSet,[sAccId,sFolId,'TYPE']));
								if (aValues)
									this.list({'aid':sAccId,'fid':sFolId,'values':aValues},sDataSet,aDataPath);
							}
						}

						var folders = new wm_folders;

						//Probíhaly metody copy, move do jiného account?
						if (aArgs['account'] && aArgs['account'] != aArgs['aid'])
							folders.list({'aid':aArgs['account']},sFolderDataSet);

						folders.list({'aid':aArgs['aid']},sFolderDataSet);
						
						/*
                        if (typeof aHandler == 'object'){
							//pridat error do aHandler

							pushParameterToCallback()
							
						}
						*/
					}

				if (typeof aHandler == 'object')
					executeCallbackFunction(aHandler);

				return true;
			}
			catch(e)
			{
				return false;
			}
			
		case 'quarantine':
			try{
				if (aIQAttribute['TYPE'] == 'result'){
					//Chceme synchronizovat folder tree?
					if (sFolderDataSet){
						var folders = new wm_folders;
						folders.list({'aid':aArgs['aid']},sFolderDataSet);
					}
					return true;
				}
			}
			catch(e){}

			return false;
			
		case 'redirect':
			if (typeof aHandler == 'object'){
				if (aIQAttribute['TYPE'] != 'result'){
					var str,att;
					try{
						str = aXMLResponse.IQ[0].ERROR[0].VALUE;
						att = aXMLResponse.IQ[0].ERROR[0].ATTRIBUTES.UID;
					}
					catch(e){
						att = '';
						str = 'unknown error';
					}

					pushParameterToCallback(aHandler,[att,str.unescapeHTML()]);
				}
				executeCallbackFunction(aHandler);
			}
	}
};

_me.default_values = function(sFolType)
{
	var aValues;

	switch(sFolType){
		case 'C':
			aValues  = ['ITMCLASSIFYAS','ITMTITLE','ITMFIRSTNAME','ITMMIDDLENAME','ITMSURNAME','ITMCLASS','ITMSUFFIX','ITMCOMPANY','ITMDEPARTMENT','LCTEMAIL1','LCTEMAIL2','LCTEMAIL3','ITMCATEGORY'];
			break;

		case 'E':
			aValues  = ['EVNTITLE','EVNLOCATION','EVNSTARTDATE','EVNSTARTTIME','EVNENDDATE','EVNENDTIME','EVNRCR_ID','EVNTYPE','EVNCLASS','EVNCOLOR'];
			break;
		case 'EI':
			aValues  = ['EVNTITLE','EVNLOCATION','EVNSTARTDATE','EVNSTARTTIME','EVNENDDATE','EVNENDTIME','OSD','OED','EVNRCR_ID','EVNTYPE','EVNCLASS','EVNCOLOR'];
			break;

		case 'J':
			aValues  = ['EVNTITLE','EVNLOCATION','EVNSTARTDATE','EVNSTARTTIME','EVNENDDATE','EVNENDTIME','EVNCONTACT','EVNTYPE','EVNCOLOR'];
			break;

		case 'F':
			aValues  = ['EVNTITLE','EVNNOTE','EVNLOCATION','EVNSTARTDATE','EVNSTARTTIME','EVNTYPE','EVNCOLOR','EVNCOMPLETE'];
			break;

		case 'R':
		case 'M':
			aValues  = ['SUBJECT','TO','FROM','DATE','SIZE','FLAGS','HAS_ATTACHMENT','COLOR','PRIORITY','SMIME_STATUS'];
			break;

		case 'N':
			aValues  = ['EVNTITLE','EVNTYPE','EVNCOLOR'];
			break;

		case 'T':
			aValues  = ['EVNTITLE','EVNSTATUS','EVNSTARTDATE','EVNRCR_ID','EVNTYPE','EVNCOLOR'];
			break;
	}
	return aValues;
};

/**
 * bCount - bool - set TOTAL = count for proper folder
 **/
_me.parse = function(aData,bCount)
{
	try{
		function parse_addons(sAddOns,aAddOns)
		{
			var sAddOnId,aAddOnFrame,aValuesFrame;
			var aResult = {};
			var aResultValueFrame;
			
			var sAddOn = sAddOns.substr(0,sAddOns.length-1);
			
			for(var n in aAddOns[sAddOn])
			{
				aAddOnFrame = aAddOns[sAddOn][n]

				if (aAddOnFrame['ATTRIBUTES'] && aAddOnFrame['ATTRIBUTES']['UID'])
				{
					sAddOnId = aAddOnFrame['ATTRIBUTES']['UID'];
					aResult[sAddOnId] = {};
				}
				else{
					sAddOnId = '';
					aResult[n] = {};
				}

				for(var sValues in aAddOnFrame)
					if (sValues =='VALUES'){
						aValuesFrame = aAddOnFrame['VALUES'][0];

						if (sAddOnId)
							aResultValueFrame = aResult[sAddOnId]['values'] = {};
						else
							aResultValueFrame = aResult[n]['values'] = {};

						for (var sValue in aValuesFrame)
							aResultValueFrame[sValue] = aValuesFrame[sValue][0]['VALUE'];
					}
					else
						if (sValues != 'ATTRIBUTES')
							if (sAddOnId)
								aResult[sAddOnId][sValues] = parse_addons(sValues,aAddOnFrame[sValues][0]);
							else
								aResult[n][sValues] = parse_addons(sValues,aAddOnFrame[sValues][0]);
			}
			return aResult;
		};

		var aAccFrame = aData['IQ'][0]['QUERY'][0]['ACCOUNT'][0];
		var sAccId = aAccFrame['ATTRIBUTES']['UID'];
		var aFolFrame = aAccFrame['FOLDER'][0];
		var sFolId = aFolFrame['ATTRIBUTES']['UID'];

		if (typeof aFolFrame['ATTRIBUTES']['RECENT'] != 'undefined' && parseInt(dataSet.get("folders",[sAccId,sFolId,'RECENT']) || 0) != parseInt(aFolFrame['ATTRIBUTES']['RECENT'] || 0))
			dataSet.add("folders",[sAccId,sFolId,'RECENT'],(aFolFrame['ATTRIBUTES']['RECENT']).toString());

//save folder COUNT to dataset TOTAL
/*
if (bCount && typeof aFolFrame['ATTRIBUTES']['COUNT'] != 'undefined')
	dataSet.add("folders",[sAccId,sFolId,'TOTAL'],aFolFrame['ATTRIBUTES']['COUNT'],true);
*/
		var aItmFrame,sItemId,aValFrame;

		var aResult = {};
		var aResultFrame = aResult[sAccId] = {};
			aResultFrame = aResultFrame[sFolId] = {};

		if (bCount && typeof aFolFrame['ATTRIBUTES']['COUNT'] != 'undefined' && aFolFrame['ATTRIBUTES']['COUNT']){
			aResultFrame['/'] = aFolFrame['ATTRIBUTES']['COUNT'];
			aResultFrame['#'] = aFolFrame.ITEM?aFolFrame.ITEM.length:0;
		}

		if (typeof aFolFrame['ATTRIBUTES']['OFFSET'] != 'undefined' && aFolFrame['ATTRIBUTES']['OFFSET'])
			aResultFrame['$'] = aFolFrame['ATTRIBUTES']['OFFSET'];

		var aItemIds = {};

		for(var n in aFolFrame['ITEM'])
		{
			aItmFrame = aFolFrame['ITEM'][n];
			sItemId = aItmFrame['ATTRIBUTES']['UID'];

			if (typeof aItemIds[sItemId] == 'undefined')
				aItemIds[sItemId] = 0;
			else
				aItemIds[sItemId]++;

			if (aItemIds[sItemId])
				sItemId += '|' + aItemIds[sItemId];

			aResultFrame[sItemId] = {'aid':sAccId,'fid':sFolId};

			for (sAddOns in aItmFrame)
				if (sAddOns == 'VALUES'){
					aValFrame = aItmFrame['VALUES'][0];
					for(var sValue in aValFrame)
						aResultFrame[sItemId][sValue] = aValFrame[sValue][0]['VALUE'];
				}
				else
				if (sAddOns == 'NOTE' || sAddOns == 'CERIFICATE')
					aResultFrame[sItemId][sAddOns] = aItmFrame[sAddOns][0]['VALUE'];
				else
				if (sAddOns != 'ATTRIBUTES')
					aResultFrame[sItemId][sAddOns] = parse_addons(sAddOns,aItmFrame[sAddOns][0],aResultFrame[sItemId][sAddOns]);
		}
		return aResult;
	}
	catch(e){
		return false;
	}
};


_me.getColorTag = function(sType) {
	switch (sType) {
		case 'M':
		case 'R':
			return 'COLOR';
		case 'E':
		case 'J':
		case 'N':
		case 'T':
		case 'F':
			return 'EVNCOLOR'; 
		default:
			return;
	}
};

//var item = new wm_items;	// For backward compatibility
var WMItems = new wm_items;			// TODO: create real static functions in wm_items instead of simulating it.