function wm_spellchecker(){
  this.xmlns = 'spellchecker';
};

wm_spellchecker.inherit(wm_generic);
var _me = wm_spellchecker.prototype;

//********************************************************************************
//Zkladn GET funkce pro zskn dat ze spellchecker                           
//********************************************************************************
//Vstup: aSpellcheckerInfo ... asociativn pole kl:
//  povinn: 'type' :typ pkazu get (check,suggest,dictionary)
//					 'lang' :kd jazyka
//           'input':text (check,suggest) nebo pole jednotlivch slov (dictionary)
//********************************************************************************
_me.get = function(aSpellcheckerInfo,sDataSet,aDataPath,aHandler)
{
	if (!aSpellcheckerInfo['type'] || !aSpellcheckerInfo['lang'] || !aSpellcheckerInfo['input'])
	  return false;
	  
	var aRequest;

	switch(aSpellcheckerInfo['type'])
	{
		case 'check':
		  if (typeof aSpellcheckerInfo['input'] != 'string')
		    return false;
		
      aRequest = {'CHECK':[{'ATTRIBUTES':{'UID':aSpellcheckerInfo['lang']},'TEXT':[{'VALUE':aSpellcheckerInfo['input']}]}]};
      break;
      
		case 'suggest':
		  if (typeof aSpellcheckerInfo['input'] != 'string')
		    return false;
		    
		  aRequest = {'CHECK':[{'ATTRIBUTES':{'UID':aSpellcheckerInfo['lang']},'TEXT':[{'VALUE':aSpellcheckerInfo['input']}],'SUGGEST':[{}]}]};
			break;
			
		case 'dictionary':
		  if (typeof aSpellcheckerInfo['input'] != 'object')
		    return false;
		    
      aRequest = {'DICTIONARY':[{'ATTRIBUTES':{'UID':aSpellcheckerInfo['lang']},'SUGGEST':[{}]}]};
      var aSuggestFrame = aRequest['DICTIONARY'][0]['SUGGEST'];

			for(var n in aSpellcheckerInfo['input'])
				aSuggestFrame.push({'ATTRIBUTES':{'WORD':aSpellcheckerInfo['input'][n]}});
	}

	//Pracujeme synchronn i asynchronn?
  if (!sDataSet)
  	return this.parse(this.create_iq(aRequest));
	else
  {
    //AJAX...
    this.create_iq(aRequest,[this,'response',['get',sDataSet,aDataPath,aHandler]]);
    return true;
  }
};

//********************************************************************************
//Zkladn SET funkce pro pidvan slov do spellchecker
//********************************************************************************
//Vstup: aSpellcheckerInfo ... asociativn pole kl:
//  povinn:   'lang' :kd jazyka
//						 'input':pole jednotlivych slov
//********************************************************************************

_me.set = function(aSpellcheckerInfo,sDataSet,aDataPath)
{
	if (!aSpellcheckerInfo['lang'] || !aSpellcheckerInfo['input'] || typeof aSpellcheckerWords != 'object')
	  return false;

	var aRequest = {'DICTIONARY':[{'ATTRIBUTES':{'UID':aSpellcheckerInfo['lang']},'ADD':[]}]};
	var aAddFrame = aRequest['DICTIONARY'][0]['ADD'];
	
	for(var n in aSpellcheckerInfo['input'])
	  aAddFrame.push({'VALUE':aSpellcheckerInfo['input'][n]});

	//Pracujeme synchronn i asynchronn?
  if (!sDataSet)
  {
    var aResponse = this.create_iq(aRequest,'','set');

    try
    {
      if (aResponse['IQ'][0]['ATTRIBUTES']['TYPE'] == 'result')
        return true;
    }
    catch(e){}

    return false;
  }
  else
  {
		//AJAX...
    this.create_iq(aRequest,[this,'response',['set',sDataSet,aDataPath]],'set');
    return true;
  }
};

//********************************************************************************
//Pomocn funkce realizujc asynchronn obsluhu odpovdi
//********************************************************************************

_me.response = function(aResponse,sMethodName,sDataSet,aDataPath,aHandler){
	try{
		var aXMLResponse = aResponse['Array'];
		var aIQAttribute = aXMLResponse['IQ'][0]['ATTRIBUTES'];

		switch(sMethodName){
			case 'set':
		  	if (aIQAttribute['TYPE'] == 'result')
				return true;
			case 'get':
				if (aIQAttribute['TYPE'] == 'result'){
					dataSet.add(sDataSet,[aDataPath],this.parse(aXMLResponse));

					if (typeof aHandler == 'object')
						executeCallbackFunction(aHandler);

					return true;
				}
		}
	}
	catch(e){}
	return false;
};

//********************************************************************************
//Pomocn funkce realizujc pevod z "XML" pole do Dataset struktur
//********************************************************************************

_me.parse = function(aData){

	try{
		var aQuery = aData['IQ'][0]['QUERY'][0];
		var sType;

		if (aQuery['CHECK'])
			sType = 'CHECK';
		else
			sType = 'DICTIONARY';

		var aQueryType = aQuery[sType][0];
		var aResult = [];

		for(var sTag in aQueryType)
			switch(sTag){
				case 'WORD':
					for(var n in aQueryType['WORD'])
						aResult.push(aQueryType['WORD'][n]['VALUE']);

					break;

				case 'SUGGEST':
					var aSuggest = aQueryType['SUGGEST'];
					var sOrigWord,aOrigWordFrame;

					for(var n in aSuggest){
						sOrigWord = aSuggest[n]['ATTRIBUTES']['WORD'];
						aOrigWordFrame = aSuggest[n]['WORD'];

						aResult[sOrigWord] = [];

						for(var m in aOrigWordFrame)
							aResult[sOrigWord].push(aOrigWordFrame[m]['VALUE']);
					}
			}
		return aResult;
	}
	catch(e){
		return false;
	}
};
