testFile('browser_ext');

/**************** Test 1 **************
 * Try Is.<type>() functions
 */ 
var booleanValue = true;
var numericalValue = 354;
var stringValue = "This is a String";
var arrayValue = [1, 2, 3];
var emptyObject = {};
var emptyArray = {};
var nullValue = null;

function testFunction() {};

assert('Test1',
   Is.Boolean(booleanValue) &&
   Is.Number(numericalValue) &&
   Is.String(stringValue) &&
   Is.Array(arrayValue) &&
   Is.Empty(emptyObject) &&
   Is.Empty(emptyArray) &&
   Is.Function(testFunction) &&
   Is.Null(nullValue) &&
   Is.Object(emptyObject) &&
   Is.Undefined(emptyObject.undefinedVariable) &&
   Is.Defined(numericalValue) &&
   Is.Email('dlouhy_siroky@atlas.cz') &&
   !Is.Email('dlouhy@siroky@atlas.cz') &&
   !Is.Date(2004, 2) &&
   !Is.Date('er34', 5, 5) &&
   Is.Date(2004, 2, 29) &&
   !Is.Date(2100, 2, 29) &&
   !Is.Date(2006, -2, 3) &&
   '&<>'.entityify() == '&amp;&lt;&gt;' &&
   '\\\b\f\n\r\t'.quote() == '"\\\\\\b\\f\\n\\r\\t"' &&
   ' test   '.trim() == 'test' &&
   'bbaaabba'.remove('a*') == 'bbbb' &&
   '<b>test<i>test</i>test</b>'.removeTags() == 'testtesttest' &&
   'žščř'.quoteMeta() == '\\ž\\š\\č\\ř'   
);

/**************** Test 2 **************
 * Array tests
 */
var arrayValue = ['ahoj', 'nazdar'];
var objectValue = {1: 'ahoj', 2: 'nazdar'};
var reversedArrayValue = reverse(arrayValue);
var reversedObjectValue = reverse(objectValue);
var gappyArray = ['ahoj', 'nazdar', 'cau'];
delete gappyArray[1];

var i = 0;
var isReversedObjectValueCorrect = true;
for (var property in reversedObjectValue) {
   if (reversedObjectValue[property] != reversedArrayValue[i++]) {
      isReversedObjectValueCorrect = false;
      break;
   }   
}
var arrayPath = {'ahoj': {'nazdar': true}};
arrayPath['ahoj'] = mkArrayPath(['cau'], arrayPath['ahoj']);

cookieManager.set('test_language', 'english', 1);

assert('Test2',
   arrayCompare(['ahoj', 'nazdar'], {1: 'nazdar', 0: 'ahoj'}) &&
   arrayCompare({'ahoj': 'nazdar', 'nazdar': 'ahoj'}, {'nazdar': 'ahoj', 'ahoj': 'nazdar'}) &&
   !arrayCompare(['ahoj', 'nazdar'], {1: 'nazdar', 0: 'ahoj', 2: 'cau'}) &&
   arrayKeys({'ahoj': 'nazdar'})[0] == 'ahoj' &&
   inArray(['ahoj', 'nazdar'], 'nazdar') &&
   inArray({1: 'ahoj', 2: 'nazdar'}, 'nazdar') &&
   arrayCompare(reverse(['ahoj', 'nazdar']), ['nazdar', 'ahoj']) &&
   isReversedObjectValueCorrect &&
   arrayCompare(arrConcat({'modra': true, 'cervena': false}, {'bila': true}), {'cervena': false, 'modra': true, 'bila': true}) && 
   typeof arrayPath['ahoj']['cau'] != 'undefined' &&
   arrayCompare(arraySearch(['ahojaaa', 'daad', 'ccaaabb'], 'AAA', true), ['ahojaaa', 'ccaaabb']) &&
   substract(['cervena', 'modra', 'bila'], ['cervena', 'bila'])[1] == 'modra' &&
   getFreeKey(gappyArray) == 1 &&
   arrayCompare(arrKeySlice({'modra': true, 'cervena': false}, ['cervena']), {'cervena': false}) &&
   arrayCompare(compact([1, 0, 3, '']), {0: 1, 2: 3}) &&
   count({'modra': true, 'cervena': false}) == 2 &&
   count([1, 2, 4]) == 3
);

/**************** Test 3 **************
 * URL tools
 */
assert('Test3',
   buildURL({'cervena': 2, 'bila': 1}) == 'cervena=2&bila=1' &&
   arrayCompare(parseURL('cervena=2&bila=1'), {'cervena': 2, 'bila': 1})
);

/**************** Test 4 **************
 * URL tools
 */
assert('Test4',
   cookieManager.get('test_language').valueOf() == 'english'
);

