<?
/* It is a parent class for cache class
 * Provides function to get correct 
 * IMAP folders and files
 */
class Paths
{
  /** The cache directory. */
	private $cacheDir;
	
	public function __construct($directory,$cache)
  {
    $this->cacheDir = $directory;
    $this->cache = &$cache;
  }
  
  public function getCacheDir()
  {
      return $this->cacheDir;
  }
  
	/**
	  @brief Get the name of the message file.
	  @return The name.
	 */
	public function getMessageFile($dir, $itemID)
	{
		return $dir . '/' . $itemID . '.msg';
	}

	/**
	  @brief Get the name of the message directory.
	  @return The name.
	 */
	public function getMessageDir($accountID, $folderID)
	{
		return $this->cacheDir . '~'.$accountID . '/' . $folderID;
		//return $_SESSION['INSTALLPATH'].'cache/' .$_SESSION['EMAIL'].'/'. $accountID . '/' . $folderID;
	}
	
	/**
	  @brief Get the path to the message file.
	  @return The path.
	 */
	public function getMessagePath($accountID, $folderName, $itemID)
	{
		$this->cache->transaction();
		$stmt = $this->cache->prepare('SELECT folder_id
								FROM folder
								WHERE account_id = ? AND name = ?');
		$stmt->execute(array($accountID, $folderName));
		
		$row = $stmt->fetch();
    //$this->cache->commit();
		
		if (!$row) {
			return false;
		}
			
		$folderID = $row['folder_id'];

		return $this->getMessageFile($this->getMessageDir($accountID, $folderID), $itemID);
	}
}
?>
