<?php

/**
  @file
  @brief Collection of functions providing character safe output.
 */

/**
  @brief Encode given string to be safe in HTML.
  @param $str String to be encoded.
  @return Encoded string.
 */
function encodeHTML($str)
{
	return htmlspecialchars($str, ENT_COMPAT, 'UTF-8');
}

/**
  @brief Encode given string to be safe in URL.
  @param $str String to be encoded.
  @return Encoded string.
 */
function encodeURL($str)
{
	return urlencode($str);
}

/**
  @brief Decode given string that is safe in URL.
  @param $str String to be decoded.
  @return Decoded string.
 */
function decodeURL($str)
{
	return urldecode($str);
}

?>
