<?
require_once 'inc/localpop/localpop.php';
/**
  @class LocalPOPAccount
  @brief Class representing an LocalPOP account.
  @author Pavel Perna
  @date 08-08-2006
 */
class LocalPOPAccount extends CacheAccount {

	/**
	  @brief Create a new LocalPOPAccount object.
	  @param $user Parent user object of the account.
	  @param $accountID ID of the account.
	  @param $server Name of the server where the account is located.
	  @param $port Port where connect to on the server.
	  @param $username Account logging username.
	  @param $password Account logging password.
	 */
	 
  public function __construct($user, $accountID, $primary, $properties = false)
  {

        $apos = strpos($accountID,"@");
        $username = substr($accountID,0,$apos);
        $password = '';
        
        $this->folderClassName = 'LocalPOPFolder';
        
        parent::__construct($user, $accountID,
  							$_SERVER['SERVER_NAME'], 25, $username, $password, false,'local',$properties);
  			$this->primary = $primary;
  			
  }
  
	/**
	  @brief Create a new folder.
	  @param $name Name of the folder.
	 */  
  public function createFolder($name,$type='')
  {
        // Check for folder existence
        parent::createFolder($name);
               
        // Create LocalPOP folder object 
  		  $this->folders['main'][$name] = LocalPOPFolder::create($this, $name);
  }

  	/**
	  @brief Synchronize the folder cache with the POP server.
	 */
	public function sync()
	{

		$lpop = LocalPOP::instance($this);

		$folders = $lpop->getMailboxes();
		parent::sync($folders);
		return true;
	}
	
	public function test()
	{
    $mAccount = new MerakAccount();
    return $mAccount->AuthenticateUserHash($this->username, $this->password, $_SERVER['SERVER_NAME'],'',$_SESSION['LOGGING_TYPE']);
    
	}

}
?>
