<?php
require_once('inc/webmailiqitems.php');
function fdrCompare($a,$b)
{
	return strcasecmp($a['name'],$b['name']);
}
class PDA{
	public function __construct()
	{
		if($_SESSION['user']){
			$this->oUser = &$_SESSION['user'];
		}
		if($this->oUser){
			$this->sSID = $_SESSION['SID'];
			$this->oAccount = &$this->oUser->getAccount($_SESSION['EMAIL']); 
		}
		//Init PDA classes
		$this->oSettings = PDASettings::load($this);
		$aLoginSettings = $this->oSettings->getPublic('login_settings');
		$aLayoutSettings = $this->oSettings->getPublic('layout_settings');
		//Language & Version
		$this->sWMVersion = $aLoginSettings['@childnodes']['item'][0]['@childnodes']['version'][0]['@value'];
		$this->sWMLanguage = $aLayoutSettings['@childnodes']['item'][0]['@childnodes']['language'][0]['@value'];
		$this->oLanguage = PDALanguage::load($this->sWMLanguage);
	}
	public function mailList($sFolder){
		//Get the primary account
		$oAccount = &$this->oAccount;
		$oFolder = $oAccount->getFolder($sFolder?$sFolder:'INBOX');
		//FOLDERS
		$aFdr = $this->folderList($sFolder);
		//ITEMS
		$aFilter['tag'] = 'header_from,header_to,subject,date,size,flags';
		$aFilter['orderby'] = 'date DESC';
		$oItems = $oFolder->getItems($aFilter);
		$aItm['items']['num'] = WebmailIqItems::cnvItems($oItems,$aFilter,false,1,$a,$f,"%d.%b %y");
		$aItm['folder'] = rawurlencode($oFolder->name);
		$aItm['sid'] = $this->sSID; 
		//Labels
		$aItm['subjectl'] = $this->oLanguage->get('datagrid_items_view','subject'); 
		$aItm['froml'] = $this->oLanguage->get('datagrid_items_view','from'); 
		$aItm['datel'] = $this->oLanguage->get('datagrid_items_view','date');    
		//Menu
		$aItm['menu'] = self::makeMenu('mail_list');
		return array('folders'=>$aFdr,'items'=>$aItm); 
	}
	public function mailView($sFolder,$sItemID){
		$oAccount = &$this->oAccount;
		$oFolder = $oAccount->getFolder($sFolder);
		//FOLDERS
		$aFdr = $this->folderList($sFolder,false);
		//Items
		$oItem = $oFolder->getItem($sItemID);
		if ($oItem->wmclass=="M" || $oItem->wmclass=="R") {
			$oItem->markAsRead();
		}
		$aFilter['tag'] = '*';
		$aItm = WebmailIqItems::cnvItems(array(0=>$oItem),$aFilter,true,1,$a,$f,"%d.%B %Y %H:%I:%S");
		$aItm = reset($aItm);
		$aItm['html'] = Tools::unhtmlspecialchars($aItm['html']);
		foreach($aItm['attachments']['num'] as $sAttKey => $aAttVal){
			$aItm['attachments']['num'][$sAttKey]['fullpath'] = $oAccount->accountID.'/'.urlencode($oFolder->name).'/'.$oItem->itemID.'/'.$aAttVal['part_id'];
			$aItm['attachments']['num'][$sAttKey]['size'] = (string) round($aItm['attachments']['num'][$sAttKey]['size']/1024,2)."";
		}
		$aItm['froml'] = $this->oLanguage->get('datagrid_items_view','from'); 
		$aItm['tol'] = $this->oLanguage->get('datagrid_items_view','to'); 
		$aItm['subjectl'] = $this->oLanguage->get('datagrid_items_view','subject'); 
		$aItm['datel'] = $this->oLanguage->get('datagrid_items_view','date'); 
		$aItm['attachmentl'] = $this->oLanguage->get('datagrid_items_view','attachment'); 
		$aItm['sid'] = $this->sSID;
		//Menu
		$aItm['menu'] = self::makeMenu('mail_view');
		//Replace url for embedded images
		$sHTTP = (strtoupper($_SERVER['HTTPS'])=='ON'?'https://':'http://');
		$sDownload = $sHTTP.$_SERVER['HTTP_HOST'].'/server/download.php';
		$sURI = $sHTTP.$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_NAME'];
		$aItm['html'] = str_replace($sURI,$sDownload,$aItm['html']);
		return array('folders'=>$aFdr,'items'=>$aItm); 
	}
	public function makeMenu($sType)
	{ 
		switch($sType){
			case 'mail_view':
				$aMenu['replyl'] = $this->oLanguage->get('popup_items','reply_to_sender');
				$aMenu['replyalll'] = $this->oLanguage->get('popup_items','reply_to_all');
				$aMenu['forwardl'] = $this->oLanguage->get('popup_items','forward');
				$aMenu['deletel'] = $this->oLanguage->get('popup_items','delete_selected');
				$aMenu['confirmdeletel'] = $this->oLanguage->get('confirmation','delete_item');
				$aMenu['markunreadl'] = $this->oLanguage->get('popup_items','mark_as_unread');
				$aMenu['movetrashl'] = $this->oLanguage->get('settings','move_to_trash');
				$aMenu['action_processl'] = $this->oLanguage->get('login_screen','send');
				$aMenu['choosel'] = $this->oLanguage->get('insert_item','insert_item');
				$sTemplate = 'menu_mail_view.tpl';          
				break;
			case 'mail_list':
				$aMenu['mark_spaml'] = $this->oLanguage->get('popup_items','blacklist_sender');
				$aMenu['deletel'] = $this->oLanguage->get('popup_items','delete_selected');
				$aMenu['confirmdeletel'] = $this->oLanguage->get('confirmation','delete_item');
				$aMenu['markreadl'] = $this->oLanguage->get('popup_items','mark_as_read');
				$aMenu['markunreadl'] = $this->oLanguage->get('popup_items','mark_as_unread');
				$aMenu['movetrashl'] = $this->oLanguage->get('settings','move_to_trash');
				$aMenu['action_processl'] = $this->oLanguage->get('login_screen','send');
				$aMenu['choosel'] = $this->oLanguage->get('input_item','input_item');
				$sTemplate = 'menu_mail_list.tpl';
				break;
			case 'mail_compose':
				break;
		}
		return template(PDA_TEMPLATE_PATH.$sTemplate,$aMenu);
	}
	//Actions
	public function mailDelete($sFolder,$aItemsID,&$sMessage = '')
	{
		//Get the primary account
		$oAccount = &$this->oAccount;
		//Get the folder
		$oFolder = $oAccount->getFolder($sFolder?$sFolder:'INBOX');
		//Inititalize cache object for quick get in foreach
		$cache['cache'] = Cache::instance($this->oUser);
		//Delete items
		if($aItemsID){
			foreach($aItemsID as $sID){
				$aItemsList[] = $oFolder->getItem($sID,$cache);
			}
			$oFolder->deleteItems($aItemsList);
		}          
	}
	public function mailMark($sFolder,$aItemsID,$sState = 'read',&$sMessage = '')
	{
		//Get the primary account
		$oAccount = &$this->oAccount;
		//Get the folder
		$oFolder = $oAccount->getFolder($sFolder?$sFolder:'INBOX');
		$cache['cache'] = Cache::instance($this->oUser);
		if($aItemsID){
			foreach($aItemsID as $sID){
				$oItem = $oFolder->getItem($sID,$cache);
				if($sState == 'read') {
					$oItem->markAsRead();
				} else {
					$oItem->markAsUnread();
				}
			}
		}     
	}
	//List of folders
	public function folderList($sFolder,$bParent = true){    
		$sFolder = urldecode($_REQUEST['folder']);
		$oAccount = &$this->oAccount;
		$oFolder = $oAccount->getFolder($sFolder?$sFolder:'INBOX');
		//FOLDERS
		$oFolders = $oAccount->getFolders();
		$aFolders = WebmailIqFolders::cnvFolders($oFolders);
		//Get parent folder
		if($sFolder && $bParent){
			$oParent = $oFolder->getParent();
			if(!$oParent){
				$aParent['name'] = '..';
				$aParent['id'] = '';
			} else{
				$aParent = WebmailIqFolders::cnvFolders(array(0=>$oParent));
				$aParent = $aParent[0];
				$aParent['name'] = '..';
			}
			$aFdr['folders']['num'][] = $aParent;
		} elseif($sFolder) {
			$aFolder = WebmailIqFolders::cnvFolders(array(0=>$oFolder));
			$aFolder = $aFolder[0];
			$aFolder['name'] = $this->localizeFolder($aFolder['name']);
			$aFdr['folders']['num'][] = $aFolder;
		}
		//Get only folders in ROOT or current subfolder level
		$iLevel = substr_count($sFolder,'/');
		if(!$sFolder) {
			$iLevel = -1;
		}
		if($aFolders) foreach($aFolders as $aFolder) {
			if( 
				( 
					( 
						(
							$sFolder 
						&& 
							strpos($aFolder['id'],$sFolder)===0
						) 
					|| 
						!$sFolder
					) //Subfolder 
				&& 
					substr_count($aFolder['id'],'/') == ($iLevel+1) //Direct subfolder
				) 
			) {
				//Filter folder types
				if ($aFolder['type']!='M' && $aFolder['type']!='C') {
					continue;
				}
				if(strtolower($aFolder['name'])=='inbox') {
					$aFolder['name'] = $this->localizeFolder($aFolder['name']);
					$aBackup[] = $aFolder;  
					continue;      
				}
				$aFolder['name'] = $this->localizeFolder($aFolder['name']);
				$aFolder['id'] = rawurlencode($aFolder['id']);
				$aFdr['folders']['num'][] = $aFolder;
			}
		}
		//Sort folders 
		uasort($aFdr['folders']['num'],"fdrCompare");
		//Place inbox to the top
		if ($aBackup) {
			$aFdr['folders']['num'] = $aBackup + $aFdr['folders']['num']; 
		}
		$aFdr['sid'] = $this->sSID;  
		return $aFdr;
	}
	//Localize names  
	public function localizeFolder($sName){    
		$sIndex = $sName;
		$aIndex = explode('/',$sIndex,2);
		if (is_array($aIndex)) {
			$sIndex = strtolower($aIndex[0]);
		} else {                  
			$sIndex = strtolower($sIndex);
		}
		if($this->oLanguage->get('common_folders',$sIndex)) {
			$sName = $this->oLanguage->get('common_folders',$sIndex);
			if ($aIndex[1]) {
				$sName.='/'.$aIndex[1];
			} else {
				$sName.=$aIndex[1];
			}
			// ????????????????!!!!!!!!!!!!!!!
			// $sName.= ($aIndex[1]?'/':'').$aIndex[1];
		}
		return $sName;  
	}
}
class PDARequest
{
	public function __construct($aRequest)
	{
		$this->aRequest = $aRequest;
	}
	//Check the actions from request object and 
	//prepare the input data
	public function getInput()
	{
		foreach($this->aRequest as $key => $val){
			switch($key){ 
				//Actions
				case 'multiple_action_button':
					$this->aData['action'] = $_REQUEST['multiple_action'];
					if(!$this->aData['action']) {
						$this->aData['action'] = 'mail_list';
					}
					break;
				case 'multiple_delete':
					break;
				case 'multiple_spam':
					break;
				case 'mail_reply':
				case 'mail_reply_all':
					break;
				case 'mail_compose':
				//Data
				case 'mails':
					break;
				case 'folder':
					break; 
				//Contoller
				case 'sid':
				case 'action':
				case 'folder':
				case 'view':
					$this->aData[$key] = $val;
					break;
			}
		}
		return $this->aData;  
	}
	public function get($sVar){
		return $this->aRequest[$sVar];
	}
}
class PDALanguage
{
	static private $base;
	private function __construct($lang = 'en')
	{
		$this->sLanguageFile =  '../client/languages/' . $lang . '/data.xml';
		$this->oData = simplexml_load_file( $this->sLanguageFile );
	}
	static public function load($lang = 'en')
	{
		if(!is_object(self::$base[$lang])){
			self::$base[$lang] = new PDALanguage($lang);
		}
		return self::$base[$lang];
	}
	public function get($group,$label)
	{
		return strval($this->oData->$group->$label);
	}
}
class PDASettings
{
	static private $base;
	private function __construct(&$oPDA = false)
	{
		if($oPDA->oUser){
			$this->oUser = &$oPDA->oUser;
			$this->oAccount = &$oPDA->oAccount;
			$this->bLogged = true;
		} else {
			$this->bLogged = false;
		}
		if(($pos = strpos($_SERVER['HTTP_HOST'],':'))!==false) {
			$this->sDomain = substr($_SERVER['HTTP_HOST'],0,$pos);
		}
	}
	static public function load(&$oPDA = false)
	{
		if(!is_object(self::$base)) {
			self::$base = new PDASettings($oPDA);
		}
		return self::$base;
	}
	public function getPublic($sResourceName)
	{
		$aSettings = $this->get('public',$sResourceName);
		return $aSettings; 
	}
	public function getPrivate($sResourceName)
	{
		$aSettings = $this->get('private',$sResourceName);
		return $aSettings;     
	}
	private function get($sType,$sResourceName)
	{
		switch($sResourceName) {
			//Get well known resources(special syntax)
			case 'login_settings':
				$aSettings = Storage::getLoginSettings();
				break;
			//Get not-well known resources(default syntax)
			default:
				$aData['aGlobal'] = Storage::getDefaults($sResourceName);
				$aData['aDomain'] = Storage::getDomainDefaults($sResourceName,$this->sDomain);
				if($this->oUser) {
					$aData['aUser'] = Storage::getUserData($sResourceName,$this->sDomain);
				} else {
					$aData['aUser'] = false;
				}
				if($sType=='private') {
					$aSettings = WebmailIqPrivate::get($aData['aGlobal'],$aData['aDomain'],$aData['aUser']); 
				} else {
					$aSettings = WebmailIqPublic::get($aData['aGlobal'],$aData['aDomain'],$aData['aUser']); 
				}
				break;
		}
		return $aSettings;    
	}
}
?>