<?php
class PHPMailer
{
    //MAIL
    var $Priority          = "";
    var $charSet           = "UTF-8";
    var $ContentType        = "text/plain";
    var $Encoding          = "8bit";
    var $ErrorInfo         = "";
    var $From               = "root@localhost";
    var $FromName           = "Root User";
    var $Sender            = "";
    var $Subject           = "";
    var $Body               = "";
    var $AltBody           = "";
    var $WordWrap          = 0;
    var $Mailer            = "mail";
    var $Sendmail          = "/usr/sbin/sendmail";
    var $PluginDir         = "";
    var $Version           = "1.73";
    var $XMailer           = "";
    var $ConfirmReadingTo  = "";
    var $Hostname          = "";
    var $SignMessage       = false;
    var $EncryptMessage    = false;
    
    //SMTP
    var $Host        = "127.0.0.1";
    var $Port        = 25;
    
    var $Helo        = "";
    var $SMTPAuth     = false;
    var $Username     = "";
    var $Password     = "";
    var $Timeout      = 10;
    var $SMTPDebug    = false;
    var $SMTPKeepAlive = false;

    //PRIVATE
    var $smtp            = NULL;
    var $to              = array();
    var $cc              = array();
    var $bcc             = array();
    var $ReplyTo         = array();
    var $attachment      = array();
    var $CustomHeader    = array();
    var $message_type    = "";
    var $boundary        = array();
    var $language        = array();
    var $error_count     = 0;
    var $LE              = "\r\n";

    function PHPMailer($charset){
	     $this->charSet = $charset; 

    }

    function IsHTML($bool) {
        if($bool == true)
            $this->ContentType = "text/html";
        else
            $this->ContentType = "text/plain";
    }

    function IsSMTP() {
        $this->Mailer = "smtp";
    }

    function IsMail() {
        $this->Mailer = "mail";
    }

    function IsSendmail() {
        $this->Mailer = "sendmail";
    }

    function IsQmail() {
        $this->Sendmail = "/var/qmail/bin/sendmail";
        $this->Mailer = "sendmail";
    }

    //Address
    function AddAddress($address, $name = "") {
        $cur = count($this->to);
        $this->to[$cur][0] = trim($address);
        $this->to[$cur][1] = $name;
    }

    function AddCC($address, $name = "") {
        $cur = count($this->cc);
        $this->cc[$cur][0] = trim($address);
        $this->cc[$cur][1] = $name;
    }

    function AddBCC($address, $name = "") {
        $cur = count($this->bcc);
        $this->bcc[$cur][0] = trim($address);
        $this->bcc[$cur][1] = $name;
    }

    function AddReplyTo($address, $name = "") {
        $cur = count($this->ReplyTo);
        $this->ReplyTo[$cur][0] = trim($address);
        $this->ReplyTo[$cur][1] = $name;
    }


    //Send
    function Send($header = false,$body = false,$charset = 'UTF-8',$relay = false,&$filename = false) {

				$result = true;

        if($charset) $this->charSet = $charset;
        if((count($this->to) + count($this->cc) + count($this->bcc)) < 1)
        {
            $this->SetError('no_rcpt',$this->Lang("provide_address"));
            return false;
        }

        if(!empty($this->AltBody))
            $this->ContentType = "multipart/alternative";

        $this->error_count = 0;

        $this->SetMessageType();

        if($filename) $messageFile = $filename;
        else{
         $messageFile = Tools::randomFileName();
         $filename = $messageFile;
        }
          
        if(!is_dir(dirname($messageFile)))
          System::mkdir_r(dirname($messageFile));
        
				$fp = fopen($messageFile,'wb+');

        if (!$header) $this->CreateHeader($fp);
        else fwrite($fp,$header . "\r\n");

        if ($body) fwrite($fp,$body);
        else $this->CreateBody($fp,$messageFile);

				@fclose($fp);
        switch($this->Mailer)
        {
            case "sendmail":
                $result = $this->SendmailSend($header, $body);
                break;
            case "mail":
                $result = $this->MailSend($header, $body);
                break;
            case "smtp":
                $result = $this->SmtpSend($filename,$fp);
                break;
            default:
            $this->SetError('mailer_support',$this->Mailer . $this->Lang("mailer_not_supported"));
                $result = false;
                break;
        }

        return $result;
    }

    function SendmailSend($fp) {
        if ($this->Sender != "")
            $sendmail = sprintf("%s -oi -f %s -t", $this->Sendmail, $this->Sender);
        else
            $sendmail = sprintf("%s -oi -t", $this->Sendmail);

        if(!@$mail = popen($sendmail, "w"))
        {
            $this->SetError('sendmail_open',$this->Lang("execute") . $this->Sendmail);
            return false;
        }

        $message = $header . $body;

        if ($this->SignMessage || $this->EncryptMessage)
          $this->encryptAndSign($message);
        
        fputs($mail, $message);
        
        $result = pclose($mail) >> 8 & 0xFF;
        if($result != 0)
        {
            $this->SetError('sendmail_send',$this->Lang("execute") . $this->Sendmail);
            return false;
        }

        return true;
    }

    function MailSend($header, $body) {
        $to = "";
        for($i = 0; $i < count($this->to); $i++)
        {
            if($i != 0) { $to .= ", "; }
            $to .= $this->to[$i][0];
        }

        if ($this->SignMessage || $this->EncryptMessage) {
          $message = $header . $body;
          $this->encryptAndSign($message);
          $delimiter = strpos($message, "\r\n");
					$header = substr($message, 0, $delimiter);
					$body = substr($message, $delimiter);
        }

        if ($this->Sender != "" && strlen(ini_get("safe_mode"))< 1)
        {
            $old_from = ini_get("sendmail_from");
            ini_set("sendmail_from", $this->Sender);
            $params = sprintf("-oi -f %s", $this->Sender);
            $rt = @mail($to, $this->EncodeHeader($this->Subject), $body, 
                        $header, $params);
        }
        else
            $rt = @mail($to, $this->EncodeHeader($this->Subject), $body, $header);

        if (isset($old_from))
            ini_set("sendmail_from", $old_from);

        if(!$rt)
        {
            $this->SetError('mail_send',$this->Lang("instantiate"));
            return false;
        }

        return true;
    }

		function SenderDomain() {
			return substr($this->From, strrpos($this->From, '@') + 1);
		}

    function SmtpSend(&$filename,&$fp) {
        include_once($this->PluginDir . "class.smtp.php");
        $error = "";
        $bad_rcpt = array();

        if(!$this->SmtpConnect())
            return false;

        $smtp_from = ($this->Sender == "") ? $this->From : $this->Sender;

        if(!$this->smtp->Mail($smtp_from))
        {
            $error = $this->Lang("from_failed") . $smtp_from;
            $this->SetSMTPError("from_failed", $smtp_from);
            $this->smtp->Reset();
            return false;
        }
        
        if (count($this->to)+count($this->cc)+count($this->bcc) > 1)
          $prefix = $this->relay?("@".$this->Host.":"):"";
        else
          $prefix = "";

        for($i = 0; $i < count($this->to); $i++)
        {
            if(!$this->smtp->Recipient($prefix.$this->to[$i][0])){
                $bad_rcpt[] = $this->to[$i][0];
                $aErrorMsg[] = htmlspecialchars($this->smtp->error['smtp_msg']);
            }
        }
        for($i = 0; $i < count($this->cc); $i++)
        {
            if(!$this->smtp->Recipient($prefix.$this->cc[$i][0])){
                $bad_rcpt[] = $prefix.$this->cc[$i][0];
                $aErrorMsg[] = htmlspecialchars($this->smtp->error['smtp_msg']);
            }
        }
        
        for($i = 0; $i < count($this->bcc); $i++)
        {
            if(!$this->smtp->Recipient($prefix.$this->bcc[$i][0])){
                $bad_rcpt[] = $prefix.$this->bcc[$i][0];
                $aErrorMsg[] = htmlspecialchars($this->smtp->error['smtp_msg']);
            }
        }
        
        if(count($bad_rcpt) > 0)
        {
            for($i = 0; $i < count($bad_rcpt); $i++)
            {
                if($i != 0) { $error .= ", "; }
                $error .= $bad_rcpt[$i];
            }

            $errormsg = implode(CRLF,$aErrorMsg);
            $this->SetSMTPError("recipients_failed", $errormsg);
            $this->smtp->Reset();
            return false;
        }

        

        if ($this->SignMessage || $this->EncryptMessage)
          $this->encryptAndSign($fp,$filename);

        if(!$this->smtp->Data($filename)){
            $error_msg = htmlspecialchars($this->smtp->error['smtp_msg']);
            $this->SetSMTPError("data_not_accepted", $error_msg);
            $this->smtp->Reset();
            return false;
        }

        if($this->SMTPKeepAlive == true)
            $this->smtp->Reset();
        else            
            $this->SmtpClose();

        return true;
    }

    function SmtpConnect() {
        if($this->smtp == NULL)  $this->smtp = new SMTP(); 

        $this->smtp->do_debug = $this->SMTPDebug;
        $hosts = explode(";", $this->Host);
        $index = 0;
        $connection = ($this->smtp->Connected()); 

        while($index < count($hosts) && $connection == false){
            if(strstr($hosts[$index], ":"))
                list($host, $port) = explode(":", $hosts[$index]);
            else {
                $host = $hosts[$index];
                $port = $this->Port;
            }

            if($this->smtp->Connect($host, $port, $this->Timeout)){
                $this->smtp->Hello($this->ServerHostname());
        
                if($this->SMTPAuth){
                    if(!$this->smtp->Authenticate($this->Username, 
                                                  $this->Password)){
                        $this->SetError('smtp_auth',$this->Lang("authenticate"));
                        $this->smtp->Reset();
                        $connection = false;
                    }
                }
                $connection = true;
            }
            $index++;
        }
        if(!$connection)
            $this->SetError('smtp_connect',$this->Lang("connect_host"));

        return $connection;
    }

    /**
     * Closes the active SMTP session if one exists.
     * @return void
     */
    function SmtpClose() {
        if($this->smtp != NULL){
            if($this->smtp->Connected()){
                $this->smtp->Quit();
                $this->smtp->Close();
            }
        }
    }

    function SetLanguage($lang_type, $lang_path = "language/") {
        if(file_exists($lang_path.'phpmailer.lang-'.$lang_type.'.php'))
            include($lang_path.'phpmailer.lang-'.$lang_type.'.php');
        else if(file_exists($lang_path.'phpmailer.lang-en.php'))
            include($lang_path.'phpmailer.lang-en.php');
        else {
            $this->SetError('language',"Could not load language file");
            return false;
        }
        $this->language = $PHPMAILER_LANG;
    
        return true;
    }

    function setRelay($relay)
    {
      $this->relay = $relay;
    }

    function AddrAppend($type, $addr) {
        $addr_str = $type . ": ";
        $addr_str .= $this->AddrFormat($addr[0]);

        if(count($addr) > 1){
            for($i = 1; $i < count($addr); $i++){
                $addr_str .= ", " . $this->AddrFormat($addr[$i]);
            }
        }
        $addr_str .= $this->LE;

        return $addr_str;
    }

    function AddrFormat($addr,$charset = false) {
        if(empty($addr[1]))
            $formatted = $addr[0];
        else
            $formatted = $this->putheader('"' . $addr[1] . '"',$this->charSet,true) . " <" . 
                         $addr[0] . ">";
        
        return $formatted;
    }

    function WrapText($message, $length, $qp_mode = false) {
        $soft_break = ($qp_mode) ? sprintf(" =%s", $this->LE) : $this->LE;

        $message = $this->FixEOL($message);
        if (substr($message, -1) == $this->LE)
            $message = substr($message, 0, -1);

        $line = explode($this->LE, $message);
        $message = "";
        for ($i=0 ;$i < count($line); $i++){
          $line_part = explode(" ", $line[$i]);
          $buf = "";
          for ($e = 0; $e<count($line_part); $e++){
              $word = $line_part[$e];
              if ($qp_mode and (strlen($word) > $length)){
                $space_left = $length - strlen($buf) - 1;
                if ($e != 0){
                    if ($space_left > 20){
                        $len = $space_left;
                        if (substr($word, $len - 1, 1) == "=")
                          $len--;
                        elseif (substr($word, $len - 2, 1) == "=")
                          $len -= 2;
                        $part = substr($word, 0, $len);
                        $word = substr($word, $len);
                        $buf .= " " . $part;
                        $message .= $buf . sprintf("=%s", $this->LE);
                    }
                    else
                        $message .= $buf . $soft_break;
                    $buf = "";
                }
                while (strlen($word) > 0){
                    $len = $length;
                    if (substr($word, $len - 1, 1) == "=")
                        $len--;
                    elseif (substr($word, $len - 2, 1) == "=")
                        $len -= 2;
                    $part = substr($word, 0, $len);
                    $word = substr($word, $len);

                    if (strlen($word) > 0)
                        $message .= $part . sprintf("=%s", $this->LE);
                    else
                        $buf = $part;
                }
              }
              else {
                $buf_o = $buf;
                $buf .= ($e == 0) ? $word : (" " . $word); 

                if (strlen($buf) > $length and $buf_o != "") {
                    $message .= $buf_o . $soft_break;
                    $buf = $word;
                }
              }
          }
          $message .= $buf . $this->LE;
        }

        return $message;
    }

    function SetWordWrap() 
    {
        if($this->WordWrap < 1)
            return;
            
        switch($this->message_type)
        {
           case "alt":
              // fall through
           case "alt_attachments":
              $this->AltBody = $this->WrapText($this->AltBody, $this->WordWrap);
              break;
           default:
              $this->Body = $this->WrapText($this->Body, $this->WordWrap);
              break;
        }
    }

    function CreateHeader(&$fp = false) {
        $result = "";

        $uniq_id = md5(uniqid(time()));
        $this->boundary[1] = "b1_" . $uniq_id;
        $this->boundary[2] = "b2_" . $uniq_id;

        $bSingleAttachmentOnly = false;

        fwrite($fp,$this->HeaderLine("Date", $this->RFCDate()));
        if($this->Sender == "")
            fwrite($fp,$this->HeaderLine("Return-Path", trim($this->From)));
        else
            fwrite($fp,$this->HeaderLine("Return-Path", trim($this->Sender)));

        if($this->Mailer != "mail"){
            if(count($this->to) > 0){
                fwrite($fp,$this->AddrAppend("To", $this->to));
            }
            else if (count($this->cc) == 0){
                //FIX for drafts (not necessary when only saving)
                if(!$this->bAllowEmptyReceipient)
                  fwrite($fp,$this->HeaderLine("To", "undisclosed-recipients:;"));
            
            }if(count($this->cc) > 0)
                fwrite($fp,$this->AddrAppend("Cc", $this->cc));
 
        }

        $from = array();
        $from[0][0] = trim($this->From);
        $from[0][1] = $this->FromName;
        fwrite($fp,$this->AddrAppend('From', $from,$this->charSet));

        if((($this->Mailer == "sendmail") || ($this->Mailer == "mail")) && (count($this->bcc) > 0))
            fwrite($fp,$this->AddrAppend("Bcc", $this->bcc));

        if(count($this->ReplyTo) > 0)
            fwrite($fp,$this->AddrAppend("Reply-to", $this->ReplyTo));

       fwrite($fp,"Subject: ".$this->putheader($this->Subject,$this->charSet)."\r\n");

        if ($this->XMailer)
					$XMailer = $this->XMailer;
				else
					$XMailer = "PHPMailer [version " . $this->Version . "]";
				
				fwrite($fp,sprintf("Message-ID: <%s@%s>%s", $uniq_id, $this->SenderDomain(), $this->LE));

	if ($this->Priority) fwrite($fp,$this->HeaderLine("X-Priority", $this->Priority));
        fwrite($fp,$this->HeaderLine("X-Mailer", $XMailer));
        
        if($this->ConfirmReadingTo != "")
            fwrite($fp,$this->HeaderLine("Disposition-Notification-To", 
                       "<" . trim($this->ConfirmReadingTo) . ">"));

        for($index = 0; $index < count($this->CustomHeader); $index++)
            fwrite($fp,$this->HeaderLine(trim($this->CustomHeader[$index][0]), 
                       trim($this->CustomHeader[$index][1])));
        
        fwrite($fp,$this->HeaderLine("MIME-Version", "1.0"));

        switch($this->message_type)
        {
            case "plain":
                fwrite($fp,$this->HeaderLine("Content-Transfer-Encoding", $this->Encoding));
                fwrite($fp, sprintf("Content-Type: %s; charset=%s",
                                    $this->ContentType, $this->charSet));
                break;
            case "attachments":
                // fall through
            case "alt_attachments":
                if($this->InlineImageExists()){
                    fwrite($fp,sprintf("Content-Type: %s;%s\ttype=\"text/html\";%s\tboundary=\"%s\"%s", 
                                    "multipart/related", $this->LE, $this->LE, 
                                    $this->boundary[1], $this->LE));
                }
                else {
                    if($this->Body){
                      fwrite($fp,$this->HeaderLine("Content-Type", "multipart/mixed;"));
                      fwrite($fp,$this->TextLine("\tboundary=\"" . $this->boundary[1] . '"'));
                    }else{
                      if(count($this->attachment)==1){
                        $aAttachment = reset($this->attachment);
                        if($aAttachment[4]=='text/calendar'){
                          $bSingleAttachmentOnly = true;
                        } else{
                          fwrite($fp,$this->HeaderLine("Content-Type", "multipart/mixed;"));
                          fwrite($fp,$this->TextLine("\tboundary=\"" . $this->boundary[1] . '"'));
                        }
                      }else{
                        fwrite($fp,$this->HeaderLine("Content-Type", "multipart/mixed;"));
                        fwrite($fp,$this->TextLine("\tboundary=\"" . $this->boundary[1] . '"'));
                      }
                    }
                }
                break;
            case "alt":
                fwrite($fp,$this->HeaderLine("Content-Type", "multipart/alternative;"));
                fwrite($fp,$this->TextLine("\tboundary=\"" . $this->boundary[1] . '"'));
                break;
        }

        if($this->Mailer != "mail" && !$bSingleAttachmentOnly)
            fwrite($fp,$this->LE.$this->LE);

        return true;
    }
    
    function CreateBody(&$fp = false,$filename = false) {
        $result = "";

        $this->SetWordWrap();
        
        if ($this->charSet!='UTF-8')
          $localBody = iconv('UTF-8',$this->charSet.'//IGNORE',$this->Body);
	      else
	        $localBody = $this->Body;
          
        switch($this->message_type)
        {
            case "alt":
                /* $result.= instead of fwrite */
                fwrite($fp,$this->GetBoundary($this->boundary[1], "", 
                                              "text/plain", ""));
                fwrite($fp,$this->EncodeString($this->AltBody, $this->Encoding));
                fwrite($fp,$this->LE.$this->LE);
                fwrite($fp,$this->GetBoundary($this->boundary[1], "", 
                                              "text/html", ""));
                
                fwrite($fp,$this->EncodeString($localBody, $this->Encoding));
                fwrite($fp,$this->LE.$this->LE);
    
                fwrite($fp,$this->EndBoundary($this->boundary[1]));
                break;
            case "plain":
                fwrite($fp,$this->EncodeString($localBody, $this->Encoding));
                break;
            case "attachments":
                if($localBody){
                  fwrite($fp,$this->GetBoundary($this->boundary[1], "", "", ""));
                  fwrite($fp,$this->EncodeString($localBody, $this->Encoding));
                  fwrite($fp,$this->LE);
                }
                
                $this->AttachAll($fp,$filename);

                break;
            case "alt_attachments":

                fwrite($fp,sprintf("--%s%s", $this->boundary[1], $this->LE));
                fwrite($fp,sprintf("Content-Type: %s;%s" .
                                   "\tboundary=\"%s\"%s",
                                   "multipart/alternative", $this->LE, 
                                   $this->boundary[2], $this->LE.$this->LE));
    
                // Create text body
                fwrite($fp,$this->GetBoundary($this->boundary[2], "", 
                                              "text/plain", "") . $this->LE);

                fwrite($fp,$this->EncodeString($this->AltBody, $this->Encoding));
                fwrite($fp,$this->LE.$this->LE);
    
                // Create the HTML body
                fwrite($fp,$this->GetBoundary($this->boundary[2], "", 
                                              "text/html", "") . $this->LE);
    
                fwrite($fp,$this->EncodeString($localBody, $this->Encoding));
                fwrite($fp,$this->LE.$this->LE);

                fwrite($fp,$this->EndBoundary($this->boundary[2]));
                
                $this->AttachAll($fp,$filename);
                break;
        }
        if($this->IsError())
            return false;

        return true;
    }

    function GetBoundary($boundary, $charSet, $contentType, $encoding) {
        $result = "";
        if($charSet == "") { $charSet = $this->charSet; }
        if($contentType == "") { $contentType = $this->ContentType; }
        if($encoding == "") { $encoding = $this->Encoding; }

        $result .= $this->TextLine("--" . $boundary);
        $result .= sprintf("Content-Type: %s; charset=%s", 
                            $contentType, $charSet);
        $result .= $this->LE;
        $result .= $this->HeaderLine("Content-Transfer-Encoding", $encoding);
        $result .= $this->LE;
       
        return $result;
    }

    function EndBoundary($boundary) 
    {
        return $this->LE . "--" . $boundary . "--" . $this->LE; 
    }

    function SetMessageType() 
    {
        if(count($this->attachment) < 1 && strlen($this->AltBody) < 1)
            $this->message_type = "plain";
        else {
            if(count($this->attachment) > 0)
                $this->message_type = "attachments";
            if(strlen($this->AltBody) > 0 && count($this->attachment) < 1)
                $this->message_type = "alt";
            if(strlen($this->AltBody) > 0 && count($this->attachment) > 0)
                $this->message_type = "alt_attachments";
        }
    }

    function HeaderLine($name, $value) {
        return $name . ": " . $value . $this->LE;
    }

    function TextLine($value) {
        return $value . $this->LE;
    }

    function AddAttachment($path, $name = "", $encoding = "base64", 
                           $type = "application/octet-stream",$encode = true,
                           $method = false) {

        if(!@is_file($path)){
            $this->SetError('add_attachment',$this->Lang("file_access") . $path);
            return false;
        }
        
        $filename = basename($path);
    
        if($name == "")
            $name = $filename;

        $cur = count($this->attachment);
        $this->attachment[$cur][0] = $path;
        $this->attachment[$cur][1] = $filename;
        $this->attachment[$cur][2] = $name;
        $this->attachment[$cur][3] = $encoding;
        $this->attachment[$cur][4] = $type;
        $this->attachment[$cur][5] = false; // isStringAttachment
        $this->attachment[$cur][6] = "attachment";
        $this->attachment[$cur][7] = 0;
        $this->attachment[$cur][8] = $encode;
        $this->attachment[$cur][9] = $method;
        
        return true;
    }

    function AttachAll(&$fp = false,$messageFile = false) 
    {
        $mime = array();

        for($i = 0; $i < count($this->attachment); $i++)
        {
            $bString = $this->attachment[$i][5];
            if ($bString)
                $string = $this->attachment[$i][0];
            else
                $path = $this->attachment[$i][0];

            $filename    = $this->attachment[$i][1];
            $name        = $this->attachment[$i][2];
            $encoding    = $this->attachment[$i][3];
            $type        = $this->attachment[$i][4];
            $disposition = $this->attachment[$i][6];
            $cid         = $this->attachment[$i][7];
            $encode      = $this->attachment[$i][8];
            $method      = $this->attachment[$i][9];
            $charset      = "UTF-8";
            
	          // Encode filename               
            if ($this->isabovechar($name))
              $name = "=?" . strtoupper($this->charSet) . "?Q?" .$this->converttoquoted(iconv('UTF-8', $this->charSet . '//IGNORE', $name)) . "?=";
           
            //$mime[] = * instead of fwrite($fp,*
            if(count($this->attachment)!=1 || $this->attachment[$i][4]!="text/calendar")
              fwrite($fp,sprintf("--%s%s", $this->boundary[1], $this->LE));
            
            $sHead = "Content-Type: %s; name=\"%s\"";
            if($charset) $sHead.= "; charset=\"".$charset."\"";
            if($method) $sHead.= "; method=".$method;
            $sHead.="%s";
            
            fwrite($fp,sprintf($sHead, $type, $name, $this->LE, $this->LE));
            if($encode) fwrite($fp,sprintf("Content-Transfer-Encoding: %s%s", $encoding, $this->LE));

            if($disposition == "inline")
                fwrite($fp,sprintf("Content-ID: <%s>%s", $cid, $this->LE));
             
            fwrite($fp,sprintf("Content-Disposition: %s; filename=\"%s\"%s", 
                              $disposition, $name, $this->LE.$this->LE));

            if($bString){
                if ($encode) fwrite($fp,$this->EncodeString($string, $encoding));
                else         fwrite($fp,$string);
                
                if($this->IsError()) { return ""; }
                fwrite($fp,$this->LE.$this->LE);
            } else {                             
                $this->EncodeFile(&$fp,$messageFile, $path, $encoding,$encode);  
                if($this->IsError()) { return ""; }
                fwrite($fp,$this->LE.$this->LE);
            }
        }
        if(count($this->attachment)!=1 || $this->attachment[$i][4]!="text/calendar")
          fwrite($fp,sprintf("--%s--%s", $this->boundary[1], $this->LE));
        
        return true;
    }

    function EncodeFile (&$fp,$filename, $path, $encoding = "base64",$encode = true) 
    {

        if($encode){
          
          $t = time();
          $m = microtime();
          
          $newFile = Tools::randomFilename();
          
          fclose($fp);
          
          icewarp_base64_encode_file($path,$newFile);

          $fp = fopen($filename,"ab");
          
          if(!$fd = fopen($newFile, "rb")){
            $this->SetError('encode_file',$this->Lang("file_open") . $path);
            return "";
          }
          while($buffer = fread($fd,4096))
            fwrite($fp,$buffer);
          
          fclose($fd);
          unlink($newFile);
        }else{
          $fd = fopen($path, "rb");
          while($buffer = fread($fd,4096))
            fwrite($fp,$buffer);
          fclose($fd);
        }

        return true;
    }

    function EncodeString ($str, $encoding = "base64") 
    {
        switch(strtolower($encoding)) {
          case "base64":
              // chunk_split is found in PHP >= 3.0.6
              $str = chunk_split(base64_encode($str), 76, $this->LE);
              break;
          case "7bit":
          case "8bit":
              $str = $this->FixEOL($str);
              if (substr($str, -(strlen($this->LE))) != $this->LE)
                $str .= $this->LE;
              break;
          case "binary":
              $encoded = $str;
              break;
          case "quoted-printable":
              $str = $this->EncodeQP($str);
              break;
          default:
              $this->SetError('encode_unknown',$this->Lang("encoding") . $encoding);
              break;
        }
        return $str;
    }

    function EncodeHeader ($str, $position = 'text') 
    {
      $x = 0;
      
      switch (strtolower($position)) {
        case 'phrase':
          if (!preg_match('/[\200-\377]/', $str)) {
            $encoded = addcslashes($str, "\0..\37\177\\\"");

            if (($str == $encoded) && !preg_match('/[^A-Za-z0-9!#$%&\'*+\/=?^_`{|}~ -]/', $str))
              return ($encoded);
            else
              return ("\"$encoded\"");
          }
          $x = preg_match_all('/[^\040\041\043-\133\135-\176]/', $str, $matches);
          break;
        case 'comment':
          $x = preg_match_all('/[()"]/', $str, $matches);
        case 'text':
        default:
          $x += preg_match_all('/[\000-\010\013\014\016-\037\177-\377]/', $str, $matches);
          break;
      }

      if ($x == 0)
        return ($str);

      $maxlen = 75 - 7 - strlen($this->charSet);

      if (strlen($str)/3 < $x) {
        $encoding = 'B';
        $encoded = base64_encode($str);
        $maxlen -= $maxlen % 4;
        $encoded = trim(chunk_split($encoded, $maxlen, "\r\n"));
      } else {
        $encoding = 'Q';
        $encoded = $this->EncodeQ($str, $position);
        $encoded = $this->WrapText($encoded, $maxlen, true);
        $encoded = str_replace("=".$this->LE, "\r\n", trim($encoded));
      }

      $encoded = preg_replace('/^(.*)$/m', " =?".$this->charSet."?$encoding?\\1?=", $encoded);
      $encoded = trim(str_replace("\r\n", $this->LE, $encoded));
      
      return $encoded;
    }

    function EncodeQP ($str) 
    {
        $encoded = $this->FixEOL($str);
        if (substr($encoded, -(strlen($this->LE))) != $this->LE)
            $encoded .= $this->LE;

        $encoded = preg_replace('/([\000-\010\013\014\016-\037\075\177-\377])/e',
                  "'='.sprintf('%02X', ord('\\1'))", $encoded);

        $encoded = preg_replace("/([\011\040])".$this->LE."/e",
                  "'='.sprintf('%02X', ord('\\1')).'".$this->LE."'", $encoded);

        $encoded = $this->WrapText($encoded, 74, true);

        return $encoded;
    }

    function EncodeQ ($str, $position = "text") 
    {
        // There should not be any EOL in the string
        $encoded = preg_replace("[\r\n]", "", $str);

        switch (strtolower($position)) {
          case "phrase":
            $encoded = preg_replace("/([^A-Za-z0-9!*+\/ -])/e", "'='.sprintf('%02X', ord('\\1'))", $encoded);
            break;
          case "comment":
            $encoded = preg_replace("/([\(\)\"])/e", "'='.sprintf('%02X', ord('\\1'))", $encoded);
          case "text":
          default:
            $encoded = preg_replace('/([\000-\011\013\014\016-\037\075\077\137\177-\377])/e',
                  "'='.sprintf('%02X', ord('\\1'))", $encoded);
            break;
        }

        $encoded = str_replace(" ", "_", $encoded);

        return $encoded;
    }

    function AddStringAttachment($string, $filename, $encoding = "base64", 
                                 $type = "application/octet-stream",
                                 $encode = true,
																 $content_id = false) 
    {

        $cur = count($this->attachment);
        $this->attachment[$cur][0] = $string;
        $this->attachment[$cur][1] = $filename;
        $this->attachment[$cur][2] = $filename;
        $this->attachment[$cur][3] = $encoding;
        $this->attachment[$cur][4] = $type;
        $this->attachment[$cur][5] = true;
        $this->attachment[$cur][8] = $encode;
				if ($content_id){
					$this->attachment[$cur][6] = "inline";
	        $this->attachment[$cur][7] = $content_id;
				} else {
					$this->attachment[$cur][6] = "attachment";
	        $this->attachment[$cur][7] = 0;
				}
    }

    function AddEmbeddedImage($path, $cid, $name = "", $encoding = "base64", 
                              $type = "application/octet-stream") 
    {
    
        if(!@is_file($path)){
            $this->SetError('add_attachment',$this->Lang("file_access") . $path);
            return false;
        }

        $filename = basename($path);
        if($name == "")
            $name = $filename;

        $cur = count($this->attachment);
        $this->attachment[$cur][0] = $path;
        $this->attachment[$cur][1] = $filename;
        $this->attachment[$cur][2] = $name;
        $this->attachment[$cur][3] = $encoding;
        $this->attachment[$cur][4] = $type;
        $this->attachment[$cur][5] = true;
        $this->attachment[$cur][6] = "inline";
        $this->attachment[$cur][7] = $cid;
        
        return true;
    }

    function InlineImageExists() 
    {
        $result = false;
        for($i = 0; $i < count($this->attachment); $i++){
            if($this->attachment[$i][6] == "inline"){
                $result = true;
                break;
            }
        }
        
        return $result;
    }

    function ClearAddresses() 
    {
        $this->to = array();
    }

    function ClearCCs() 
    {
        $this->cc = array();
    }

    function ClearBCCs() 
    {
        $this->bcc = array();
    }

    function ClearReplyTos() 
    {
        $this->ReplyTo = array();
    }

    function ClearAllRecipients() 
    {
        $this->to = array();
        $this->cc = array();
        $this->bcc = array();
    }

    function ClearAttachments() 
    {
        $this->attachment = array();
    }

    function ClearCustomHeaders() 
    {
        $this->CustomHeader = array();
    }

    function SetError($type,$msg) 
    {   
        throw new Exc('phpmailer_',$msg);
				$this->ErrorInfo = $msg;
        $this->error_count++;
    }

    function SetSMTPError($type, $msg) 
    {
        throw new Exc('SMTP_'.$type, $msg, false);
    }

    function RFCDate() 
    {
        $tz = date("Z");
        $tzs = ($tz < 0) ? "-" : "+";
        $tz = abs($tz);
        $tz = ($tz/3600)*100 + ($tz%3600)/60;
        $result = sprintf("%s %s%04d", date("D, j M Y H:i:s"), $tzs, $tz);

        return $result;
    }

    function ServerVar($varName) 
    {
        global $HTTP_SERVER_VARS;
        global $HTTP_ENV_VARS;

        if(!isset($_SERVER))
        {
            $_SERVER = $HTTP_SERVER_VARS;
            if(!isset($_SERVER["REMOTE_ADDR"]))
                $_SERVER = $HTTP_ENV_VARS; // must be Apache
        }
        
        if(isset($_SERVER[$varName]))
            return $_SERVER[$varName];
        else
            return "";
    }

    function ServerHostname() 
    {
        if ($this->Hostname != "")
            $result = $this->Hostname;
        elseif ($this->ServerVar('SERVER_NAME') != "")
            $result = $this->ServerVar('SERVER_NAME');
        else
            $result = "localhost.localdomain";

        return $result;
    }

    function Lang($key) 
    {
        if(count($this->language) < 1)
            $this->SetLanguage("en");
    
        if(isset($this->language[$key]))
            return $this->language[$key];
        else
            return "Language string failed to load: " . $key;
    }

    function IsError() 
    {
        return ($this->error_count > 0);
    }

    function FixEOL($str) 
    {
//        $str = str_replace("\r", "", $str);
//        $str = str_replace("\n", $this->LE, $str);
        return $str;
    }

    function AddCustomHeader($custom_header) 
    {
        $this->CustomHeader[] = explode(":", $custom_header, 2);
    }
    
    //Functions from old webmail 
    function putheader($header,$mycharset="",$emails=false)
    {
    if ($mycharset!='UTF-8')
    {

      $fheader = iconv('UTF-8',$mycharset.'//IGNORE',trim($header));

    } else
      $fheader = trim($header);
    
    if ($this->isabovechar($fheader))
    {
      $i=1;
      if($emails && strpos($fheader,">"))
      {

         $arr = explode(">",$header);

         foreach($arr as $val)
         {
            if(!strlen($val)) continue;
            unset($val2);
            if(($spos = strpos($val,"<"))>-1) $val .='>';

            if (!eregi("(.*)(<.*[^>]*>)",$val,$val2))
                                $val2[1]=$val;

            $val2[1]=ereg_replace("^[,;]","",trim($val2[1]));

            if($this->isabovechar($val2[1]))
              $out2 .= "=?" . strtoupper($mycharset) . "?Q?" .$this->converttoquoted($val2[1]) . "?=";
            else
              $out2 .= $val2[1];

            if($val2[2]) $out2 .= ' '.$val2[2].";";
         }

         if(isset($out2)) $out = $val2[2]?substr($out2,0,-1):$out2;
      } else {

      $out = "=?" . strtoupper($mycharset) . "?Q?" .$this->converttoquoted($fheader) . "?=";
      }
    } else
      $out = $fheader;

    return $out;
  }

  static function converttoquoted($string)
  {

    $converted = "";
    $strlen = strlen($string);
    
    for ($i = 0; $i < $strlen; $i++) {
                if ((ord($string[$i]) > 127) || ($string[$i] == "_") || ($string[$i] == "=") || ($string[$i]=="?") || (ord($string[$i]) < 32))
                        $converted .= "=" .

self::fillstr(strtoupper(dechex(ord($string[$i]))), 2, "0");
                else
                        $converted .= $string[$i];
        }
    //Replace blank spaces by _    
    $converted = str_replace(" ","_",$converted);
    
    
    return $converted;
  }
  
  
  function isabovechar($string)
  {
    for ($i = 0; $i < strlen($string); $i++) if (ord($string[$i]) > 127) { return true; }
    return false;
  }
   
  
  static function fillstr($str, $size, $char)
{
    if (strlen($str) > $size) return substr($str, 0, $size);

    $value = $str;
    for ($i = strlen($str); $i < $size; $i++) {
        $value = $char . $value;
    }

    return $value;
}
}

?>
