<?php
require_once 'inc/pop3/pop3.php';
/**
  @class POP3Account
  @brief Class representing an POP3 account.
  @author Pavel Perna
  @date 07-08-2007
 */
class POP3Account extends CacheAccount {
	/**
	 * @brief Create a new POP3Account object.
	 * @param $user Parent user object of the account.
	 * @param $accountID ID of the account.
	 * @param $primary Account is primary?.
	 * @param OPTIONAL $properties other optional properties.
	 */
	 
  public function __construct($user, $accountID,$server ,$port = 110,$username,$password,$primary, $properties = false)
  {

        //$apos = strpos($accountID,"@");
        //$username = substr($accountID,0,$apos);
        $this->folderClassName = 'POP3Folder';
        parent::__construct($user, $accountID,$server, $port, 
                $username, $password, false,'pop3',$properties);
  			$this->primary = $primary;
  			
  }
  
  /**
	 * @brief Create a new folder.
	 * @param $name Name of the folder.
	 */  
  public function createFolder($name,$type='')
  {
        // Check for folder existence
        parent::createFolder($name);
        // Create LocalPOP folder object 
  		  $this->folders['main'][$name] = POP3Folder::create($this, $name);
  }
  
  /**
	 * @brief Synchronize the folder cache with the POP server.
	 */
	public function sync()
	{
		$pop3 = POP3::instance($this);

		$folders = $pop3->getMailboxes();
		parent::sync($folders);
		return true;
	}

	public function test()
	{
       $pop3 = POP3::instance($this);
       return $pop3->isLogged;
  }
}
?>
