<?php
  require_once('inc/cache/account.php');
  require_once('inc/rss/folder.php');
  require_once('inc/rss/rss.php');
  
  class RSSAccount extends CacheAccount{
  
    public function __construct(&$user,$accountID){
      $this->folderClassName = 'RSSFolder';
      parent::__construct($user, $accountID, false, false, false, false, false,'RSS');
      $this->acc_type = 'rss';
    }

    
    public function createFolder($name,$type='',$channel = ''){
      
      if($type!='R')
        throw new Exc('folder_create',$name);

  		// Check for folder existence
  		parent::createFolder($name);
  		
  		// Create imap folder object 
  		$folder = RSSFolder::create($this, $name, $channel);
      	if($folder->channel){
        	$folder->sync();
        	$this->aSyncedFolders[$folder->folderID] = true;
      	}
    }
    
	/**
	  @brief Synchronize the folder cache with the IMAP server.
	 */
	public function sync()
	{
		$rss = RSS::instance($this);
		  
		$folders = $rss->getChannels($this->accountID);

		parent::sync($folders);

		return true;
	}
    
}


?>
