<?php

class SMTP
{
	var $from;
	var $to;
	var $socket;
	var $line;
	var $status;
	
	function smtp($server, $port = 25, &$connected)
	{
		$connected = $this->open($server, $port);
	}
	
	function smtpmail($from, $to, $message)
	{
		$this->to = $to;
		$this->from = $from;
		
		if (($msg = $this->helo())) return $msg;
		if (($msg = $this->mailfrom($from))) return $msg;
		for ($i = 0; $i < count($to); $i++) { if ($this->rcptto($to[$i]) == false) return false; }
		if ($this->body($message) == false) return false;
		$this->quit();
	}
	
	
	function open($server, $port)
	{
		if (($this->socket = fsockopen($server, $port)) <= 0) return false;
		
		while (true)
		{
			$this->line = fgets($this->socket, 1024);
			
			$this->status["LASTRESULT"] = substr($this->line, 0, 1);
			$this->status["LASTRESULTTXT"] = substr($this->line, 0, 1024);
			
			if ($this->line[3] == " ") break;
			if (!($this->line)) break;
		}
		
		if ($this->status["LASTRESULT"] <> "2") return false;
		
		return true;
	}
	
	
	function helo()
	{
		if (!(fputs($this->socket, "HELO localhost\r\n"))) return 'HELO localhost: error';
		$this->line = fgets($this->socket, 1024);
		
		$this->status["LASTRESULT"] = substr($this->line, 0, 1);
		$this->status["LASTRESULTTXT"] = substr($this->line, 0, 1024);
		
		if ($this->status["LASTRESULT"] <> "2") return 'HELO localhost: error';
	}
	
	
	function mailfrom($from)
	{
		if (!(fputs($this->socket, "MAIL From:$from\r\n"))) return 'MAIL From: error';
		
		$this->line = fgets($this->socket, 1024);
		
		$this->status["LASTRESULT"] = substr($this->line, 0, 1);
		$this->status["LASTRESULTTXT"] = substr($this->line, 0, 1024);
		
		if ($this->status["LASTRESULT"] <> "2") return 'MAIL From: error';
	}
	
	function rcptto($to)
	{
		if (!(fputs($this->socket, "RCPT To:$to\r\n"))) return false;
		
		$this->line = fgets($this->socket, 1024);
		
		$this->status["LASTRESULT"] = substr($this->line, 0, 1);
		$this->status["LASTRESULTTXT"] = substr($this->line, 0, 1024);
		
		if ($this->status["LASTRESULT"] <> "2") return false;
		return true;
	}
	
	function body($message)
	{
		if (!(fputs($this->socket, "DATA\r\n"))) return false;
		$this->line = fgets($this->socket, 1024);
		
		$this->status["LASTRESULT"] = substr($this->line, 0, 1);
		$this->status["LASTRESULTTXT"] = substr($this->line, 0, 1024);
		
		if ($this->status["LASTRESULT"] <> "3") return false;
		
		$message .= "\r\n.\r\n";
		if (!(fputs($this->socket, $message, strlen($message)))) return false;
		
		$this->line = fgets($this->socket, 1024);
		
		$this->status["LASTRESULT"] = substr($this->line, 0, 1);
		$this->status["LASTRESULTTXT"] = substr($this->line, 0, 1024);
		
		if (substr($this->line, 0, 1) <> "2") return false;
		
		return true;
	}
	
	function quit()
	{
		fputs($this->socket, "QUIT\r\n");
		$this->line = fgets($this->socket, 1024);
		
		$this->status["LASTRESULT"] = substr($this->line, 0, 1);
		$this->status["LASTRESULTTXT"] = substr($this->line, 0, 1024);
		
		return true;
	}
	
	function close() { fclose($this->socket); }
}

?>
