<?
define('STORAGE_XML_MAX_LEVEL_DEPTH',4);

define('SETTINGS_ELM','settings');
define('RET_STRING',0x0);
define('RET_ARRAY',0x1);


/* @brief		Class Storage
 *			Handles all settings files, all cookies and
 *			takes care about groupware configuration
 * @revision		01.03.2007
 * @author		Pavel Perna
 */
class Storage
{
	public static $rightType = array(0=>'useraccess',1=>false,2=>'domainadminaccess');
        
   
	public static function mergeResource($data,$merge,$restriction,$set = false,$righttype = 'useraccess',$sPP = 'private')
	{		
		//Step over items
		if($merge['@childnodes']['item']) foreach($merge['@childnodes']['item'] as $item => $itemVal){   //Item name
			if (!$itemVal)	continue;
			//Use restriction - if array and current id(index) doesn't exists in
			//restriction file use restriction template for first item   
			if (is_array($restriction['@childnodes']['item'][$item]))
				$restriction = $restriction['@childnodes']['item'][$item];
			else 
				$restriction = $restriction['@childnodes']['item'][$item]; 

			$data['@childnodes']['item'][$item] = self::mergeItem($data['@childnodes']['item'][$item],
												$merge['@childnodes']['item'][$item],
												$restriction,
												$set,
												$righttype);
		}
        return $data;
	}
    
	public static function mergeItem($data,$merge,$restriction,$set = false,$righttype = 'useraccess')
	{
		//Step over keys of item

 		if ($merge['@childnodes']) foreach($merge['@childnodes'] as $keyIndex => $keyValue){
			$count = 0;

			if (count($data['@childnodes'][$keyIndex])>1) throw new Exc('settings_duplicity');
			
			if ($righttype && isset($restriction['@childnodes'][$keyIndex][0]['@attributes'][$righttype]))
				$keyRights = $restriction['@childnodes'][$keyIndex][0]['@attributes'][$righttype];
			else 
				$keyRights = 'full';

			switch($keyRights)
			{
				//Returns user's own settings and set view rigts
				case 'view':
					if ($set){
						unset($data['@childnodes'][$keyIndex][$count]);
					}else{

						$data['@childnodes'][$keyIndex][$count]['@value'] = $merge['@childnodes'][$keyIndex][$count]['@value'];
						$data['@childnodes'][$keyIndex][$count]['@attributes']['access'] = 'view';
						if ($merge['@childnodes'][$keyIndex][$count]['@attributes']['useraccess'])
							$data['@childnodes'][$keyIndex][$count]['@attributes']['useraccess'] = $merge['@childnodes'][$keyIndex][$count]['@attributes']['useraccess'];
						unset($data['@childnodes'][$keyIndex][$count]['@attributes'][$righttype]);
					}
					break;
				//Returns nothing
				case 'none':
					$data['@childnodes'][$keyIndex][$count]['@attributes']['access'] = 'none';
					if (!$set){

						unset($data['@childnodes'][$keyIndex][$count]['@attributes']['useraccess']);
						unset($data['@childnodes'][$keyIndex][$count]['@attributes']['domainadminaccess']);
					} else {
						unset($data['@childnodes'][$keyIndex][$count]);
					}
					break;
				//Return user's own settings
				default:
					if (!$set){
					 
						if (!isset($data['@childnodes'][$keyIndex][$count]['@value'])){
						  if($keyIndex=='disable_gw_types' 
                  && isset($data['@childnodes'][$keyIndex][$count])
                  )
						    continue;
							$data['@childnodes'][$keyIndex][$count]['@value'] = $merge['@childnodes'][$keyIndex][$count]['@value'];
						} 
						//Merge rights if it is possible
						if(isset($merge['@childnodes'][$keyIndex][$count]['@attributes']['useraccess']))
							if(($merge['@childnodes'][$keyIndex][$count]['@attributes']['domainadminaccess']!='full'
							|| !isset($merge['@childnodes'][$keyIndex][$count]['@attributes']['domainadminaccess']))
							||!isset($data['@childnodes'][$keyIndex][$count]['@attributes']['useraccess']))
								$data['@childnodes'][$keyIndex][$count]['@attributes']['useraccess'] = $merge['@childnodes'][$keyIndex][$count]['@attributes']['useraccess'];
						unset($data['@childnodes'][$keyIndex][$count]['@attributes'][$righttype]);
					}else{
						if ($righttype=='access'){
							unset($keyValue[0]['@attributes']);
							if (!isset($keyValue[0]['@value']))
								unset($data['@childnodes'][$keyIndex]);
							else
								$data['@childnodes'][$keyIndex][0] = $keyValue[0];
						}
					}
					break;          
			}
			if($set){
				switch($sPP){
					//Unset all access tags for private
					case 'private':
						unset($data['@childnodes'][$keyIndex][$count]['@attributes']);
						break;
					//Domain admin - unset 
					case 'domain':
						unset($data['@childnodes'][$keyIndex][$count]['@attributes']['domainadminaccess']);
						break;
				}
			}
			$count++; 
		}
		return $data;
	}
	
	public static function getDomainDefaults($resource = false,$domain = false)
	{
		if (!$domain) $domain = $_SESSION['DOMAIN'];
		$path = WM_CONFIGPATH.$domain.'/';
		$aArray = self::getArray($path,$resource);
		
		return $aArray;
	}
	
	public static function setDomainDefaultsStr($xmlString,$sResourceName,$domain = false)
	{
		if (!$domain) $domain = $_SESSION['DOMAIN'];
		$path = WM_CONFIGPATH.$domain.'/';
		$file = SETTINGS_FILE.storeageext;
		
		if (!file_exists($path)){
			if (!System::mkdir_r($path))
				throw new Exc('settings_get_domain_file',$path);
		//TODO
    }else{
    
    }
		if (!@file_put_contents($path.$file,$xmlString))
			throw new Exc('settings_domain_set',$path.$file);
	}

	public static function getUserData($resource = false)
	{
		if(isset($_SESSION)){
			$path = $_SESSION['USERDIR'];      
			$result = self::getArray($path,$resource);
		}else{
			$result = false;
		}
		return $result;
	}

	public static function setUserDataStr($xmlString,$sResourceName)
	{

		$path = $_SESSION['USERDIR'].SETTINGS_FOLDER;
		$file = SETTINGS_FILE.storeageext;

    if (!is_dir($_SESSION['USERDIR'].SETTINGS_FOLDER))
      System::mkdir_r($_SESSION['USERDIR'].SETTINGS_FOLDER);

		if($sResourceName=='cookie_settings')
			$file = COOKIE_FILE.storeageext;

   // $string = file_get_contents

    if(!@file_put_contents($path.$file,$xmlString))
			throw new Exc('settings_user_set',$path.$file);
	}

	public static function getDefaults($resource = false)
	{
		$path = $_SESSION['WMCONFIGPATH']?$_SESSION['WMCONFIGPATH']:WM_CONFIGPATH;
		
		$oDOM = self::getArray($path,$resource);

		return $oDOM;
	}

	public static function setDefaultsStr($xmlString,$sResourceName)
	{
		$path = $_SESSION['WMCONFIGPATH']?$_SESSION['WMCONFIGPATH']:WM_CONFIGPATH;
		$file = SETTINGS_FILE.storeageext;
		if ($sResourceName=='cookie_settings')
			$file = COOKIE_FILE.storeageext;
			
		if (!file_exists($path))
			if (!System::mkdir_r($path))
				throw new Exc('settings_public_set',$path);
				
		if (!@file_put_contents($path.$file,$xmlString))
			throw new Exc('settings_public_set',$path.$file);
}

	public static function saveSharedAccounts($xmlString)
	{
		$path = $_SESSION['USERDIR'];
		$file = 'shared_accounts'.storeageext;

		if (!@file_put_contents($path.$file,$xmlString))
			throw new Exc('settings_shared_set');
	}

	public static function getRestrictions($resource = false)
	{
		$path = $_SESSION['WMCONFIGPATH']?$_SESSION['WMCONFIGPATH']:WM_CONFIGPATH;
		$oDOM = self::getArray($path,$resource);

		return $oDOM;
	}

	private static function getDOM($path,$resource)
	{
		global $aError;

		$file = $resource.storeageext;

		if (!file_exists($path.$file))
			return false;

		$oDOM = XML::open($path.$file);

		return $oDOM;
	}

	public static function getArray($path,$resource = false,$sfile = SETTINGS_FILE)
			{
			global $aError;

			$aArray = false;

			$file = $sfile.storeageext;

			if ($resource=='cookie_settings')
				$file = COOKIE_FILE.storeageext;
				
			
      if ($resource=='global_settings')
				$file = GLOBAL_FILE.storeageext;
		  
     /* if ($resource=='login_settings')
				$file = LOGIN_FILE.storeageext;
		*/
      if ($resource=='spellchecker_languages')
				$file = SPELLCHECKER_FILE.storeageext;

		//USERDIR/~webmail folder if we are in user dir 
		//(in config dir it is CONFIGPATH/_webmail)
		if ($path == @$_SESSION['USERDIR'])
			$path.=SETTINGS_FOLDER;

		if (!file_exists($path.$file))
			return false;
    
		$oDOM = XML::open($path.$file);

		if ($resource){
		  $oDOMResource = $oDOM->query("//".$resource,$oDOM->documentElement);
			if ($oDOMResource->item(0)){
				$aArray = Tools::makeTreeFromXML($oDOMResource->item(0));
			}
		}else{
			$aArray = Tools::makeTreeFromXML($oDOM->documentElement);
		}

		if (!$aArray)
			if ($resource=='cookie_settings'
          || $resource=='global_settings')
				$aArray = Tools::makeTreeFromXML($oDOM->documentElement);
			else
				$aArray = array();

		return $aArray;
	}	


	public static function getCertificates($XMLencode = false)
	{
		$cert = self::getUserData('certificate');
		$data = array();
		if (isset($cert['@childnodes']['item'][0]['@childnodes']['passphrase'][0]['@value']))
			$data['passphrase'] = $cert['@childnodes']['item'][0]['@childnodes']['passphrase'][0]['@value'];
		else
			$data['passphrase'] = '';
		@$cert = file_get_contents($_SESSION['USERDIR'] . CERTIFICATE_FILE);
		if ($cert){
			$data['data'] = $XMLencode ? encodeHTML($cert) : $cert;
		  $data['info'] = Tools::text2html(self::getCertificateInfo($cert));
    }
    else 
    {
			$data['data'] = '';
			$data['info'] = '';
    }
		return $data;
	}
	
	public static function setCertificates($xmlArray)
	{
		if (isset($xmlArray['passphrase']))
			$return = array('@childnodes' => array('item' => array(0 => array('@childnodes' => array('passphrase' => array(0 => array('@value' => $xmlArray['passphrase'])))))));
		else
			$return = array();

		@$cert = file_put_contents($_SESSION['USERDIR'] . CERTIFICATE_FILE, $xmlArray['data']);

		return $return;
	}

  
  public static function getCertificateInfo($key)
  {
    if ($key)
    {
       // Get key info
      $array = openssl_x509_parse($key);
      // Parse cert array
      if (is_array($array))
      {
        $result .= $array["name"] . "\r\n\r\n";

        $result .= $array["subject"]["CN"] . "\r\n";
        $result .= $array["subject"]["emailAddress"] . "\r\n\r\n";

        $result .= $array["issuer"]["C"] . "\r\n";
        $result .= $array["issuer"]["ST"] . "\r\n";
        $result .= $array["issuer"]["L"] . "\r\n";
        $result .= $array["issuer"]["O"] . "\r\n";
        $result .= $array["issuer"]["OU"] . "\r\n";
        $result .= $array["issuer"]["CN"] . "\r\n";
        $result .= $array["issuer"]["emailAddress"] . "\r\n\r\n";

        $result .= $array["validFrom"] . "\r\n";
        $result .= $array["validTo"] . "\r\n\r\n";
      }
    }
    
    return trim($result);
  }

		public static function getAvailableLanguages()
		{
			$result = array();
			$langRoot = '../client/languages';
			if ($dh = opendir($langRoot)) {
				while (($lang = readdir($dh)) !== false) {
					if (($lang == '.') || ($lang == '..'))
						continue;

					$dir = $langRoot . '/' . $lang;
					if (is_dir($dir) && file_exists($dir . '/data.xml')) {
						@$aContent = explode(CRLF,file_get_contents($dir . '/name.dat'));
						$collation = isset($aContent[1])?$aContent[1]:false;
						$data = &$result[$lang];
						$data['lang'] = $lang;
						$data['name'] = $aContent[0];
						if($collation){
							$data['collation'] = $collation;
						}
					}
				}
				closedir($dh);
			}
			
			//Sort by description keys
			uasort($result,'lang_compare');
			return $result;
		}
		
		public static function getAvailableSkins()
		{
			$skinsRoot = '../client/skins/';
			$skinsFile = 'skins.xml';
			$result = file_get_contents($skinsRoot.$skinsFile);
			return $result;
		}
		
		public static function getAvailableHolidays($oGWAccount)
		{
				// Get Holidays depending on specified email
				$sHolidays = $oGWAccount->gwAPI->FunctionCall("GetHolidays",
																	$oGWAccount->gwAPI->sessid);
				// Parse holidays param line
				$aHolidays = $oGWAccount->gwAPI->ParseParamLine($sHolidays);

				foreach($aHolidays as $key => $aHoliday){
					$aHolidays[$key]['HOLSHORTDESCRIPTION'] = XML::encode($aHoliday['HOLSHORTDESCRIPTION']);
				}
				return $aHolidays;
		}

		
		public static function subscribeHolidays($oGWAccount,$aActions)
		{
      $aHolidays = self::getAvailableHolidays($oGWAccount);

      //Get selected holiday
      foreach($aHolidays as $aHoliday)
        if ($aHoliday['HOLSELECTED'])
          $aSelectedHolidays[$aHoliday['HOLHOLIDAYID']] = $aHoliday;

      //Clear all holidays
      $oGWAccount->gwAPI->FunctionCall("DeleteHolidays",$oGWAccount->gwAPI->sessid);
      
      //Resubscribe
      foreach($aActions as $aAction){
        $sHolidayID = $aAction['dataTree']['@attributes']['uid']; 
        $sSelected = strtolower($aAction['dataTree']['@childnodes']['subscribed'][0]['@value']);
        
        $aNewHoliday['HOLHOLIDAYID'] = strtoupper($sHolidayID);
        $aNewHoliday['HOLSELECTED'] = 1;
        
        if ($sSelected=='true')
          $aSelectedHolidays[$sHolidayID] = $aNewHoliday;
        
        if ($sSelected=='false' || !$sSelected)
          unset($aSelectedHolidays[$sHolidayID]);
          
      }

      foreach($aSelectedHolidays as $aNew){
        unset($aHoliday);
        $aHoliday['HOLHOLIDAYID'] = strtoupper($aNew['HOLHOLIDAYID']);
        $aHoliday['HOLSELECTED'] = 1;

        $sHoliday = $oGWAccount->gwAPI->CreateParamLine($aHoliday);
        $oGWAccount->gwAPI->FunctionCall("AddHoliday",$oGWAccount->gwAPI->sessid,$sHoliday);
      }
      return true;
    }
	public static function getSharedAccounts($oGWAccount,$rType = RET_STRING)
	{
		//Get Public groups and subscribed groups
		$gwgroups = self::getGwGroups($oGWAccount);
		$mygroups = self::getMyGroups($oGWAccount);

		//Remove user's own group
		@$myGroupID = reset(array_keys($mygroups));
		unset($mygroups[$myGroupID]);

		//Process subtraction of groups to get shared accounts
		if ($mygroups) foreach($mygroups as $groupid => $group)
			if (isset($gwgroups[$group['GRPLINK']]))
				unset($mygroups[$groupid]);

		//Pass data to template
		$tpl['saccounts']['num']= $mygroups;
		$return = trim(template('inc/templates/shared_accounts.tpl',$tpl));

	return $return; 
	}

	public static function setSharedAccounts($oGWAccount,$aActions)
    {
      foreach($aActions as $itemNum => $itemVal)
      {
        switch($itemVal['action'])
        {
          case 'add':
            self::addSharedAccount($oGWAccount,$itemVal);
          break;
          case 'edit':
            self::editSharedAccount($oGWAccount,$itemVal);
          break;
          case 'delete':
            self::deleteSharedAccount($oGWAccount,$itemVal['uid']);
          break;
        }
      } 
    }
    
    public static function addSharedAccount($oGWAccount,$action)
    {
      //Get shared account email address
      $sSharedEmail = $action['dataTree']['@childnodes']['email'][0]['@value'];

      //Get shared account's groups
      $sharedgroups = $oGWAccount->gwAPI->FunctionCall('GetGroupList',$oGWAccount->gwAPI->sessid,$sSharedEmail);
      if ($sharedgroups) $sharedgroups = $oGWAccount->gwAPI->ParseParamLine($sharedgroups);     
      if ($sharedgroups) {
        //Get shared account main group's id
        $sSharedGroupID = $sharedgroups[0]['GRP_ID'];
        //Add shared account using shared account's groupid
        return self::subscribe($oGWAccount,$sSharedGroupID,$sSharedEmail);
      }else
        return false;
    }
    
    //Later TODO
    public static function editSharedAccount($action)
    {
    }

    public static function deleteSharedAccount($oGWAccount,$uid)
    {

      self::deleteGroup($oGWAccount,$uid);
      $oGWAccount->gwAPI->cleanup();
      return true;
    }
            
    public static function getMyGroups($oGWAccount,&$subscribed = false)
		{
      $mygroups = $oGWAccount->gwAPI->FunctionCall('GetGroupList',$oGWAccount->gwAPI->sessid);
      $mygroups = $oGWAccount->gwAPI->ParseParamLine($mygroups);     

      foreach($mygroups as $mygroup)
      {
          $gSID = $oGWAccount->gwAPI->OpenGroup($mygroup['GRP_ID']);
    
          if (!$rights = $_SESSION['GW'][$oGWAccount->gwAPI->user]['rights'][$mygroup['GRP_ID']])
          $rights = $oGWAccount->gwAPI->FunctionCall('GetGroupAccessRights',
                                                    $oGWAccount->sGWSessionID);        

        $aRet = $mygroup;
        $aRet['RIGHTS'] = $rights;
        $aReturn[$mygroup['GRP_ID']] = $aRet;
      } 

      return $aReturn;  
            
    }
		
		public static function getGwGroups($oGWAccount)
		{
      
      $groups = $oGWAccount->gwAPI->FunctionCall('GetGlobalGroupList',$oGWAccount->gwAPI->sessid);
      $groups = $oGWAccount->gwAPI->ParseParamLine($groups);
      
      $mygroups = self::getMyGroups($oGWAccount);
      
      foreach($groups as $group){
        $aReturn[$group['GRP_ID']] = $group;
        $aReturn[$group['GRP_ID']]['SUBSCRIBED'] = 'false';
        $gSID = $oGWAccount->gwAPI->OpenGroup($group['GRP_ID']);
        
        if (!$rights = $_SESSION['GW'][$oGWAccount->gwAPI->user]['rights'][$group['GRP_ID']])
          $rights = $oGWAccount->gwAPI->FunctionCall('GetGroupAccessRights',
                                                   $gSID);
        //Do not close previously opened subscribed groups                                           
        if (!$mygroups[$group['GRP_ID']]) 
          $oGWAccount->gwAPI->CloseGroup($gSID);
          
        $aReturn[$group['GRP_ID']]['RIGHTS'] = $rights;
      }
      
      

      if ($mygroups) foreach($mygroups as $mygroup)
        if ($mygroup['GRPLINK'] && isset($aReturn[$mygroup['GRPLINK']])){ 
          $aReturn[$mygroup['GRPLINK']]['SUBSCRIBED'] = 'true';      
        } 
       return $aReturn;  
      
    }
    
    public static function getOwnerInfo($oGWAccount)
    {
      
      $owner = $oGWAccount->gwAPI->FunctionCall('GetOwnerInfo',$oGWAccount->gwAPI->sessid);
      $owner = $oGWAccount->gwAPI->ParseParamLine($owner);      
            
      return $owner[0];
    }
    
    public static function setOwnerInfo($oGWAccount,$owner)
    {
      $owner = $oGWAccount->gwAPI->CreateParamLine($owner);   

  		if($oGWAccount->gwAPI->FunctionCall("UpdateOwnerInfo",
																	         $oGWAccount->gwAPI->sessid,
																	         $owner)==-1)
	      throw new Exc('settings_owner_set',$owner);
    }
    
    public static function getGwFriends($oGWAccount)
    {
      $oGWAccount->gwAPI->OpenGroup("*");
              
      $friends = $oGWAccount->gwAPI->FunctionCall('GetGroupUsers', $oGWAccount->sGWSessionID);
      $friends = $oGWAccount->gwAPI->ParseParamLine($friends);      
    
      return $friends;
    }    

    public static function subscribe($oGWAccount,$groupid,$title = false)
    {
      global $aError;

      $parameters['GrpLink'] = $groupid;
      if ($title) $parameters['GrpTitle'] = $title;

      $parameters = $oGWAccount->gwAPI->CreateParamLine($parameters);

      

			if(!$oGWAccount->gwAPI->FunctionCall("AddGroup",
																	         $oGWAccount->gwAPI->sessid,
																	         $parameters))
	      throw new Exc('group_subscribe',$title);
            
    }
    
    public static function unsubscribe($oGWAccount,$groupid)
    {
      global $aError;
      
      //$oGWAccount->gwAPI->OpenGroup("*");
      
      $groups = self::GetMyGroups($oGWAccount);

      foreach($groups as $group)
      {
        if ($group['GRPLINK']==$groupid)
          $subcriptionGroup = $group['GRP_ID'];
      }

      self::deleteGroup($oGWAccount,$subcriptionGroup);  
    }
    
    public static function deleteGroup($oGWAccount,$id)
    {
      $oGWAccount->gwAPI->CloseGroup($aAction['uid']);

      $aReturn = $oGWAccount->gwAPI->FunctionCall('DeleteGroup',
                                                   $oGWAccount->gwAPI->sessid,
                                                   $id);   

      return $aReturn;      
    }
    
    public static function addGroup($oGWAccount,$group)
    {
       global $aError;

      $sParameters = $oGWAccount->gwAPI->CreateParamLine($group);
     
			if(!$oGWAccount->gwAPI->FunctionCall("AddGroup",
																	         $oGWAccount->gwAPI->sessid,
																	         $sParameters))  
        throw new Exc('group_add');    
               
    }
    
    public static function editGroup($oGWAccount,$group,$id='*')
    {
      global $aError;

      $sParameters = $oGWAccount->gwAPI->CreateParamLine($group);

      //Subscribe or unsubscribe group
      if (isset($group['subscribed'])){
        if ($group['subscribed']=='true')
          self::subscribe($oGWAccount,$group['grp_id'],$group['grptitle']);
        else{

          self::unsubscribe($oGWAccount,$group['grp_id']);
        }
      } else {
      

      //Edit group
      if(!$oGWAccount->gwAPI->FunctionCall("AddGroup",
																	         $oGWAccount->gwAPI->sessid,
																	         $sParameters,
                                           $id))  
        throw new Exc('group_edit'); 
      }
    }
    
    public static function processGroups($oGWAccount,$aActions)
    {
      foreach($aActions as $aAction)
        switch($aAction['action'])
        {
          case 'add':
            self::addGroup($oGWAccount,$aAction['data']);
            break;
          case 'edit':
            self::editGroup($oGWAccount,$aAction['data'],$aAction['uid']);
            break;
          case 'delete':
            self::deleteGroup($oGWAccount,$aAction['uid']);
            break;
        }
    }

    public static function processFriends($oGWAccount,$aActions)
    {
      foreach($aActions as $aAction)
        switch($aAction['action'])
        {
          case 'add':
            self::addFriend($oGWAccount,$aAction['data']);
            break;
          case 'edit':
            self::editFriend($oGWAccount,$aAction['data'],$aAction['uid']);
            break;
          case 'delete':
            self::deleteFriend($oGWAccount,$aAction['uid']);
            break;
        }
    }  
            
    public static function addFriend($oGWAccount,$friend,$group='*')
    {
      global $aError;
			
			
			if(isset($friend['usremail'])){
				$friend['usremail'] = strtolower($friend['usremail']);
			}
      $aParameters = $oGWAccount->gwAPI->CreateParamLine($friend);
      $gSID = $oGWAccount->gwAPI->OpenGroup($group);

			if(!$oGWAccount->gwAPI->FunctionCall("AddGroupUser",
																	         $gSID,
																	         $aParameters))  
        throw new Exc('group_user_add',$gSID);    
            
    }
    
    public static function editFriend($oGWAccount,$friend,$friendID,$group='*')
    {
      global $aError;
			if(isset($friend['usremail'])){
				$friend['usremail'] = strtolower($friend['usremail']);
			}
      $aParameters = $oGWAccount->gwAPI->CreateParamLine($friend);
      $gSID = $oGWAccount->gwAPI->OpenGroup($group);

			if($oGWAccount->gwAPI->FunctionCall("AddGroupUser",
																	         $gSID,
																	         $aParameters,
                                           $friendID)==-1)  
        throw new Exc('group_user_edit',$friendID);    
            
    }    
    
    public static function deleteFriend($oGWAccount,$friendID,$group='*')
    {
      global $aError;

      $gSID = $oGWAccount->gwAPI->OpenGroup($group);

			if($oGWAccount->gwAPI->FunctionCall("DeleteGroupUsers",
																	         $gSID,
																	         $friendID)==-1)  
        throw new Exc('group_user_delete',$friendID);         
    }

		private static function getPropertyItems($type,&$aAccess = array()) {
			switch (strtoupper($type)) {
				case 'AUTORESPONDER':
					return array('U_RESPOND','U_RESPONDPERIOD','U_REPLYFROM','U_RESPONDBETWEENFROM','U_RESPONDBETWEENTO','U_RESPONDONLYIFTOME','U_RESPONDERCONTENT');
				case 'FORWARDER':
					return array('U_FORWARDTO','U_FORWARDOLDER','U_FORWARDOLDERDAYS','U_FORWARDOLDERTO','U_NULL');
				case 'FILTER_RULES':
					return array('U_RULESCONTENTXML','U_BLACKWHITEFILTER');
				case 'ANTISPAM':
				$aAccess['U_AS']['NAME'] = 'C_AS_GENERAL_PROCESSINGMODE';
				$aAccess['U_AS']['VALUE'] = 9;
				
        $aAccess['U_CR']['NAME'] = 'C_AS_Challenge_ProcessingMode';
				$aAccess['U_CR']['VALUE'] = 9;
								
			    return array('U_AS','U_CR','U_QUARANTINEREPORTS','U_SPAMFOLDER');
        default:
					throw new Exc('api_property_get',strtoupper($type));
			}
		}

		public static function getUserProperties($type)
		{
			global $aError,$_iqdata;
			$result = array();
			
			$mAccount = new MerakAccount();      

			if ($mAccount->Open($_SESSION['user']->email)){
				$result['properties']['num'] = array();
				foreach (self::getPropertyItems($type,$aAccess) as $item) {
					$data = &$result['properties']['num'][];
					$data['name'] = strtolower($item);
          $data['value'] = XML::encode($mAccount->GetProperty($item));
          if ($aAccess && $aAccess[$item]){
            if(!$mAPI)
              $mAPI = new MerakAPI();
            $data['access'] = $mAPI->GetProperty($aAccess[$item]['NAME'])==$aAccess[$item]['VALUE']?'full':'view';
          }
        }
			}

			return $result;
		}

  /*  public static function processSpellcheckerLanguages($aActions)
    {

      $default = self::getDefaults();

      $aSettings = WebmailIqPrivate::get($default,false,false);
      $aItems = $aSettings['@childnodes']['spellchecker_languages'][0]['@childnodes']['item'];
  
      if (!$aItems){
      
       $aItems = array();
      }

      foreach($aActions as $aAction){
        $spellLangID = $aAction['dataTree']['@attributes']['uid'];

        switch($aAction['action'])
        {
          case 'add':
          case 'edit':
   
            $spellLabel =  $aAction['data']['label'];   

            $aItems[$spellLangID]['@attributes']['uid'] = $spellLangID;
            $aItems[$spellLangID]['@childnodes']['uid'][0]['@value'] = $spellLangID;
            $aItems[$spellLangID]['@childnodes']['label'][0]['@value'] = $spellLabel;
            break;
          case 'delete':
            unset($aItems[$spellLangID]);
            break;
        }
      }
      
      $aResult['spellchecker_languages']['@childnodes']['item'][] = $aItems;
      return $aResult;
    }   */
		
		public static function setUserProperties($type, $properties)
		{
			global $aError;

			$mAccount = new MerakAccount();
			if ($mAccount->Open($_SESSION['user']->email)){
				foreach (self::getPropertyItems($type,$aAccess) as $item) {
					$value = isset($properties[strtolower($item)]) ? $properties[strtolower($item)] : '';
					if ($aAccess && $aAccess[$item]){
            if(!$mAPI)
              $mAPI = new MerakAPI();

            if($mAPI->GetProperty($aAccess[$item]['NAME'])==$aAccess[$item]['VALUE'])
              $mAccount->SetProperty($item,$value);
          }else
					$mAccount->SetProperty($item,$value);
				}
				$mAccount->Save();
			}
		}
		
		public static function getAvailableDomains()
		{
			$list = self::getDomains();
			foreach($list as $dom){
				$ret = array();
				$ret['domain']=$dom;
				if (file_exists($_SESSION['WMCONFIGPATH'].$dom)){
					$ret['set'] = 'true'; 
				}
				$return[] = $ret;
			}
			return $return;
		}
		
		public static function getSignupDomains()
		{
			//Restrictions
			$domaindata = Storage::getDomainDefaults('restrictions');
			$defaultdata = Storage::getDefaults('restrictions');
			$data = WebmailIqPrivate::get($defaultdata,$domaindata,false,0);
			$bSignupEnabled = $data['@childnodes']['item'][0]['@childnodes']['disable_signup'][0]['@value']==1?false:true;

			$sSignupFile = WM_CONFIGPATH.'signup.dat';
			$bSignupFileExistence = file_exists($sSignupFile)?true:false;

			if($bSignupEnabled){
				if($bSignupFileExistence){
					$api = new MerakAPI();
			  	@$domains = rtrim(file_get_contents(WM_CONFIGPATH.'signup.dat'));
	      	$domains = explode("\r\n",$domains);
	      	foreach($domains as $key => $domain){
	      		$dom = trim($domain);
						if($api->GetDomainIndex($dom)!=-1){
							$return[$key]['domain'] = trim($dom);
						}
					}
				}else{
					$list = self::getDomains();
					foreach($list as $key => $dom){
						$return[$key]['domain'] = $dom;
					}
				}
			}
			return $return;
		}
		
		public static function getDomains(){
			$api = new MerakAPI();
			$list = $api->getDomainList();
			$list = Tools::explode_j(';',$list);

			return $list;
		}
		
		public static function removeAvailableDomains($aActions)
		{
			$domains = self::getAvailableDomains();
			
			foreach($aActions as $action)
				$arr[] = $action['data']['domain'];

			foreach($domains as $dom){
				if (!in_array($dom['domain'],$arr))
					System::rmdir($_SESSION['CONFIGPATH'].'_webmail/'.$dom['domain']);
				else
					System::mkdir($_SESSION['CONFIGPATH'].'_webmail/'.$dom['domain']);
				
			}
		}
		
	/*	public function getGlobalSettings($type)
		{
      $xml = simplexml_load_file(GLOBAL_SETTINGS_FILE);
      if ($type=='database'){
        if ($xml){
          foreach($xml->database->db as $db){
            unset($item);
            foreach($db as $key => $val)
              $item[$key] = strval($val);
            $items[] = $item;
          }        
        }
      }
      else
      if($xml){
        unset($item);
        foreach($xml->$type as $set){
            foreach($set as $key => $val)
              $item[$key] = strval($val);
            $items[] = $item;
        }
        
      }
      return $items;
    }*/
    
		public function getLoginSettings()
		{
			$mAPI = new MerakAPI();
			$result = self::getArray(WM_CONFIGPATH,'login_settings');
			if(!@$_SESSION['SETTINGS_GLOBAL']){
				@$data = file_get_contents(GLOBAL_SETTINGS_FILE);
				$xml = XML::openFromString(trim($data));
				$global_settings = Tools::makeTreeFromXML($xml);
				$set = $global_settings['@childnodes']['global_settings'][0]['@childnodes']['item'][0]['@childnodes'];
				$logging_type = $set['logging_type'][0]['@value'];
			}else{
				$logging_type = $_SESSION['LOGGING_TYPE'];
			}
			$result['@childnodes']['item'][0]['@childnodes']['version'][0]['@value'] = $mAPI->GetProperty('C_Version');
			$result['@childnodes']['item'][0]['@childnodes']['logging_type'][0]['@value'] = $logging_type;
			$result['@childnodes']['item'][0]['@childnodes']['logging_type'][0]['@attributes']['access'] = 'view';
			return $result;
		}

		public function getSpellcheckerLanguages($sResourceName)
		{
			if(!file_exists(SPELLCHECKER_SETTINGS_FILE)){
				$fp = @fopen(SPELLCHECKER_SETTINGS_FILE,"w+");
				@fwrite($fp,file_get_contents(SPELLCHECKER_SETTINGS_DEFAULT));
				@fclose($fp);
			}
			$result = simplexml_load_file(WM_CONFIGPATH.'spellchecker.xml');
			$result = (array) $result->item;
			asort($result);
			$result = '<'.$sResourceName.'><item>'.Tools::makeXMLTags($result).'</item></'.$sResourceName.'>';
			return $result;
		}
   /* public function setLoginSettings($login_settings)
		{
      if (!file_put_contents(WM_CONFIGPATH.LOGIN_FILE.storeageext,$login_settings))
        return false;
        
      return true;
    }
*/
		public function getGlobalSettings()
		{
		  $result = self::getArray(WM_CONFIGPATH,'global_settings');

		  foreach($result['@childnodes']['item'][0]['@childnodes'] as $key=>$child){
        if ($key=='database'){
          /*foreach($child[0]['@childnodes']['db'] as $db)
          $value .= Tools::MakeXMLStringFromTree($db,'db');
          $return['@childnodes']['item'][0]['@childnodes'][$key][0]['@value'] = htmlspecialchars($value); */ 
        }else
          $return['@childnodes']['item'][0]['@childnodes'][$key] = $child;
      }
      $return = Tools::makeXMLStringFromTree($return,'global_settings');

      return $return;
    }
    
		public function setGlobalSettings($settings)
		{
      if (!@file_put_contents(WM_CONFIGPATH.GLOBAL_FILE.storeageext,$settings))
        return false;
        
      return true;
    }		
    
    public function getSIPCallsHistory()
    {
      $oUser = $_SESSION['user'];
      $api = new MerakAPI();
            
      $sUserDir = $oUser->getDir(true);
      $sSipCallsDirectory = $sUserDir.'~sip/calls/';

      $time = time();
      
      $year = date('Y',$time);
      $month = date('m',$time);
        
      //Current log file
      $aLogFiles[] = date('Ym',$time).'.log';

      //Back to last year's logs
      if($month == 1){
        $month = 12;
        $year--;  
      }
      
      //Last log file
      $time = mktime(0,0,0,$month,0,$year);
      $aLogFiles[] = date('Ym',$time).'.log';

      $total=0;

      for ($fi=0;$fi<count($aLogFiles);$fi++){
        if($total>=100) break;

        $logfile=$aLogFiles[$fi];
        $date = array();

        @$log = file_get_contents($sSipCallsDirectory.$logfile);
        $aLogs = explode("\r\n",$log);

        for ($i=count($aLogs);$i>0;$i--){
          if($total>=100) break;
	  $logLine=$aLogs[$i-1];

          $aLog = array();
          eregi('([0-9]{4})-([0-9]{2})-([0-9]{2}) (([0-9]{2}):([0-9]{2}):([0-9]{2}))'.
                ' ([0-9]{2}):([0-9]{2}):([0-9]{2})'. 
                ' ([^ ]{0,}) ([^ ]{0,}) ([0-9]{3})'.
                ' (FAILED|ANSWERED|CANCELLED) (IN|OUT) ([^ ]{0,})'.
                ' ([^ ]{0,}) ([^ ]{0,}) (.*)$',$logLine,$aLog);

          if($aLog[11]){

	    // Skip Proxy Requires Authentication error response
	    if ($aLog[13]=='407') continue;

            $aItem['time'] = $aLog[4];
            $aItem['duration'] = $aLog[10]+$aLog[9]*60+$aLog[8]*3600;
            $aItem['from'] = $aLog[11];
            $aItem['to'] = $aLog[12];
            $aItem['inout'] = $aLog[15];
            $aItem['status'] = $aLog[14];
            $aItem['date'] = $date = mktime($aLog[5],$aLog[6],$aLog[7],$aLog[2],$aLog[3],$aLog[1]);

	    // Extra params
  	    $extra = explode(' ', $aLog[19]);
	    if ($extra[1]) $aItem['from'] = urldecode($extra[1]).' <'.$aItem['from'].'>';
	    if ($extra[2]) $aItem['to'] = urldecode($extra[2]).' <'.$aItem['to'].'>';

            $aResult[] = $aItem;

	    $total++;
          }          
        }
      }

      return $aResult;
    }

}
?>
