<?php

/**
  @class System
  @brief Various system methods.
  @author Martin Zlomek
  @date 22-03-2006
 */
class System {
	/**
	  @brief Create a directory including parent directories.
	  @param $dir The directory.
	 */
	public static function mkdir($dir) {
		if (!is_dir($dir)) {
			if (!mkdir($dir, 0755, true))
				return false;//throw new Exc('directory_create');
		}
	}
	
  public static function mkdir_r($dirName, $rights=0777){

     // Check if exists
     if (is_dir($dirName)) return true;

     // Convert win to php path
     $dirName = str_replace('\\','/',$dirName);

     $dirs = explode('/', $dirName);
     $dir='';
     foreach ($dirs as $part) {
         $dir.=$part.'/';

         if (!is_dir($dir) && strlen($dir)>0)
             @mkdir($dir, $rights);
     }

     return true;
  }
	/**
	  @brief Remove a directory including subdirectories.
	  @param $dir The directory.
	 */
	public static function rmdir($dir,$empty = false)
	{
		if (!is_dir($dir))
			return;

		if ($dh = @opendir($dir)) {
			while (($file = readdir($dh)) !== false) {
				if (($file == '.') || ($file == '..'))
					continue;

				$file = $dir . '/' . $file;

				if (is_dir($file))
					self::rmdir($file);
				else
					unlink($file);
			}
			closedir($dh);
		}
		if (!$empty) @rmdir($dir);
	}

}

?>
