<?php
require_once "privateandpublic.php";
require_once "webmailiqpublic.php";
/**
  * @brief		Class for handling webmailIqPrivate namespace
  * @revision		01.03.2007
  * @author		Pavel Perna
  */
class WebmailIqPrivate extends PrivateAndPublic
{
	protected $sPP; //Private or public flag
	/**
	 * @brief	Public: Constructor
	 * @param	aInputXML	Array that contains subrequest
	 * @param 	aAttrs		Array that contains IQ attributes
	 */
	public function __construct($oDOMQuery,&$oDOMDoc,&$attrs)
	{
		$this->oDOMQuery = $oDOMQuery;
		$this->oDOMDoc = &$oDOMDoc;
		$this->aAttrs = &$attrs;
		$this->aAttts['private'] = true;
		$this->sPP = 'private';
		$this->oResources = $this->oDOMDoc->query("private:resources/private:*",$this->oDOMQuery);
		if (!$this->oResources) {
			$this->oResources = $this->oDOMDoc->query("private:resources/*",$this->oDOMQuery);
		}
		$this->sDirectory = @$_SESSION['USERDIR'];
		// basic input check
		parent::checkInputXML();
		$this->exeInputXML();
	}
	public static function get($default,$domain,$user,$rights = false)
	{
		//Flags
		$settingsState = 0;
		$settingsState += $default?1:0;
		$settingsState += $domain?2:0;
		$settingsState += $user?4:0;
		switch($settingsState) {
			//All settings exists - merge them all
			//No user settings - merge server defaults & domain defaults - user setttings merge only due to access tags
			case 3:
				$data = Storage::mergeResource($domain,$default,$default,false,'domainadminaccess');
				$data = Storage::mergeResource($data,$data,$data,false,'useraccess');
				break;
			case 7:
				$tmp = WebmailIqPublic::get($default,$domain,$user,2);
				$data = Storage::mergeResource($user,$tmp,$tmp,false);
				break;
			//No server defaults - merge domain defaults & user settings
			case 6:
				$data = Storage::mergeResource($user,$domain,$domain,false);
				break;
			//No domain defaults - merge server defaults & user settings
			case 5:
				$data = Storage::mergeResource($user,$default,$default,false);
				break;
			//Only user settings - return as they are
			case 4:
				$data = $user;
				break;
			//Only domain defaults - proccess only access attributes
			case 2:
				$data = self::removeAttrs($domain,@$_SESSION['ACCOUNT']);
				break;
			//Only server setting - proccess only access attributes
			case 1:
				$data = self::removeAttrs($default,@$_SESSION['ACCOUNT']);
				break;
		}
		return $data;
	}
	public static function set($sResourceName,$aActions,$aAsD = false,$domain = false,$rewrite = false)
	{
		$default = Storage::getDefaults($sResourceName);
		$domain = Storage::getDomainDefaults($sResourceName);
		$user = Storage::getUserData($sResourceName);
		$data = self::get($default,$domain,$user);
		if ($aActions) {
			foreach($aActions as $action) {
				$newdata['@childnodes']['item'][] = $action['dataTree'];
			}
			//Save as it is - if there are no default data
			if (!$data || $rewrite){
				$items = $newdata;
			//Merge according to default's restrictions
			} else {
				$items = Storage::mergeResource($user,$newdata,$data,true,'access');
			}
		}
		return $items;
	}
}
?>
