<?php
require_once "privateandpublic.php";
/**
 * @brief		Class for handling webmailIqPublic namespace
 *			Only Administrs can change this files
 * @revision		01.03.2007
 * @author		Pavel Perna
 */
class WebmailIqPublic extends PrivateAndPublic
{
	protected $sPP = 'public';
	/**
	 * @brief		Public: Constructor
	 * @param		aInputXML		Array that contains subrequest
	 *			aAttrs			Array that contains IQ attributes
	 */
	public function __construct($oDOMQuery,&$oDOMDoc,&$attrs)
	{
		$this->oDOMQuery = $oDOMQuery;
		$this->oDOMDoc = &$oDOMDoc;
		$this->aAttrs = &$attrs;
		$this->aAttts['private'] = false;
		/* get filename */
		$this->oResources = $this->oDOMDoc->query("public:resources/public:*",$this->oDOMQuery);
		if (!$this->oResources) {
			$this->oResources = $this->oDOMDoc->query("private:resources/*",$this->oDOMQuery);
		}
		if (!is_object($this->oResources)) {
			throw new Exc('settings_missing_tag','resources');
		}
		/* check filename */
		Security::checkpath($this->sFile);
		/* check for filter existency (Filter is mandatory in Public mode) */
		$this->checkInputXML();
		/* execute input */
		$this->exeInputXML();
	}
	/**
	 * @brief	Private: input check
	 */
	private function checkInputXML()
	{
		parent::checkInputXML();
	}
	//This function gets non-well-known settings data
	public static function get($default,$domain,$user,$rights = false)
	{
		if (!$rights) {
			$rights = $_SESSION['ACCOUNT'];
		}
		switch($rights) {
			//Administrator
			case 1:
				$result = $default;
				break;
			//Domain administrator
			case 2:
			default:
				$result = Storage::mergeResource($domain,$default,$default,false,'domainadminaccess','domain');
				break;
		}
		//Create xml string and return
		return $result;
	}
	//This function sets non-well-known settings data
	public static function set($sResourceName,$aActions,$aAsD = false,$domain = false)
	{
		if ($sResourceName!='login_settings'){
			$default = Storage::getDefaults($sResourceName);
			$domain = Storage::getDomainDefaults($sResourceName,$domain);
			//Domain defaults (merged)
			$defaults = self::get($default,$domain,false,2);
			if ($aAsD || $_SESSION['ACCOUNT']==2) {
				$handler = $domain;
			} else {
				$handler = $default;
			}
		}
		$count=0;
		if ($aActions) {
			foreach($aActions as $action){
				$newdata['@childnodes']['item'][$count++] = $action['dataTree'];
				if (!$handler) {
					$handler = $newdata;
				} else {
					//Change newdata values in default resource
					foreach($newdata['@childnodes']['item'] as $ikey => $ival) {
						foreach($newdata['@childnodes']['item'][$ikey]['@childnodes'] as $key => $value) {
							//Administrator as admin
							if ($_SESSION['ACCOUNT']==1 && !$aAsD) {
								$handler['@childnodes']['item'][$ikey]['@childnodes'][$key] = $value;
							}
							//Domain administrator
							if ($_SESSION['ACCOUNT']==2 || $aAsD) {
								unset($value[0]['@attributes']['domainadminaccess']);
								unset($handler['@childnodes']['item'][$ikey]['@childnodes'][$key][0]['@attributes']['domainadminaccess']);
								if (
									$defaults['@childnodes']['item'][$ikey]['@childnodes'][$key][0]['@attributes']['access']=='full'
								||
									!isset($defaults['@childnodes']['item'][$ikey]['@childnodes'][$key][0]['@attributes']['access'])
								){
									$handler['@childnodes']['item'][$ikey]['@childnodes'][$key] = $value;
								}
							}
						}
					}
				}
			}
		}
		return $handler;
	}
}
?>
