<?php
require_once('inc/user.php');
require_once('inc/webmailiqauth.php');

class WMAuth
{
	public function check($sAction)
	{
		$oWMUserInterface = &Singleton::instance('WMUserInterface');
		$oWMRequest = &Singleton::instance('WMRequest');
		$oWMUserInterface->setView('login');
		switch($sAction){
			case 'login':
				
				if(!$this->sUsername = $oWMRequest->get('username')){
					throw new Exc('auth_missing_tag','username',false,true,'login');
				}
				if(!$this->sPassword = $oWMRequest->get('password')){
					throw new Exc('auth_missing_tag','password',false,true,'login');
				}
				$this->bCipher = $oWMRequest->get('cipher')?true:false;
				//RSA login ?
				if($this->bCipher){
					WebmailIqAuth::checkServerKeys();
					$privateData = file_get_contents(WM_CONFIGPATH.'private.key');
					$privateKey = openssl_pkey_get_private($privateData);
					openssl_private_decrypt(WebmailIqAuth::hexStringToBinary($this->sPassword), $this->sPassword, $privateKey);
				}
			break;
		} 
	}
	
	public function login()
	{
		$oWMUserInterface = &Singleton::instance('WMUserInterface');
		$oWMData = &Singleton::instance('WMData');
		$oWMRequest = &Singleton::instance('WMRequest');
		
		try{
			$sSID = User::login($this->sUsername,$this->sPassword);
			$oUser = &$_SESSION['user'];
			
			$oPrimaryAccount = $oUser->getAccount($_SESSION['EMAIL']);
			//Sync account & folders
			$oPrimaryAccount->sync();
			$oInbox = $oPrimaryAccount->getFolder('INBOX');
			$oInbox->sync();
			
			//Set view
			$oWMUserInterface->setView($oWMRequest->get('view'));
			$oWMData->store('general','sid',$sSID);
			
		}catch(Exc $e){
			$oWMRequest->bLogged = false;
			$oWMRequest->setException($e);
			throw $e;
		}
	}
	
	public function logout()
	{
		$oWMUserInterface = &Singleton::instance('WMUserInterface');
		$oWMData = &Singleton::instance('WMData');
		$oWMRequest = &Singleton::instance('WMRequest');
		if($_SESSION['user']) {
			unset($_SESSION['user']);
		}
		$_SESSION['PDA_LOGOUT'] = true;
		$oWMRequest->bLogged = false;
		$oWMRequest->setException($e);
	}
}

?>