<?php
require_once('inc/mail.php');


class WMMessage
{
	public function check($sAction)
	{
		$oWMUserInterface = &Singleton::instance('WMUserInterface');
		$oWMRequest = &Singleton::instance('WMRequest');
/*specific checks
		switch($sAction){
			case 'send':
			break;
		}*/ 
	}
	
	public function send()
	{
		$oWMUserInterface = &Singleton::instance('WMUserInterface');
		$oWMData = &Singleton::instance('WMData');
		$oWMRequest = &Singleton::instance('WMRequest');
		$oPrimaryAccount = $_SESSION['user']->getAccount($_SESSION['EMAIL']);
		$sFullname = $oPrimaryAccount->fullname?$oPrimaryAccount->fullname:'';
		$oMail = $this->mailInit($oPrimaryAccount->accountID,$sFullname);
		//store 2d item id if present for case of error
		try{
			$oMail->send();
		}catch(Exc $e){
			if(($sItemID = $oWMRequest->get('item'))!=false) {
				$sRID = $oWMRequest->get('rid');
				$oWMRequest->set('item',$sItemID,$sRID);
			}
			throw $e;
		}
		//TODO : save sent message to Sent ?
		
		//$oWMUserInterface->setView('mail_list');
		$oWMData->store('general','sid',$oWMRequest->get('sid'));
		try{
			$oFolder = $oPrimaryAccount->getFolder($oWMRequest->get('folder'));
			if(strtolower($oFolder->type)!='M'){
				throw new Exception('folder');
			}
		}catch(Exception $e){
			$oWMRequest->set('folder','INBOX',$oWMRequest->get('rid'));
		}
		$oWMData->store('general','sid',$oWMRequest->get('sid'));
	}
	
	public function save($sContinueAction = true)
	{
		
		$oWMUserInterface = &Singleton::instance('WMUserInterface');
		$oWMData = &Singleton::instance('WMData');
		$oWMRequest = &Singleton::instance('WMRequest');
		$oWMSettings = &Singleton::instance('WMSettings');
		$oUser = &$_SESSION['user'];
		$sAccount = $_SESSION['EMAIL'];
		
		//Get sent folder from settings
		$oDrafts = FolderExtension::getMappedFolder('drafts',true);
		$sFolder = $oDrafts->name;
		$oWMRequest->set('folder',$sFolder,$oWMRequest->get('rid'));
		$oAccount = $oUser->getAccount($sAccount);
		$sFullname = $oAccount->fullname?$oAccount->fullname:'';

		//Save to drafts
		$oMail = $this->mailInit($oAccount->accountID,$sFullname,'','','','','',false);
		//read message id

		if(!$sItemID = $oWMRequest->get('item')){
			$sItemID = false;
		}
		$sSavedID = $this->saveMessage($oMail,$sAccount,$sFolder,$sItemID);
		//Store saved ID
		$sRID = $oWMRequest->get('rid');
		$oWMRequest->set('item',$sSavedID,$sRID);
		//Set action to continue this email(only when clicked on save)
		if($sContinueAction){
			$oWMRequest->storeVariable($sRID,'mail_action','continue');
		}
		$oWMData->store('general','sid',$oWMRequest->get('sid'));
	}
	
	private function mailInit($sFrom,$sFromName = '',$sTo='',$sCC='',$sBCC='',$sSubject='',$sBody='',$bSend = true)
	{
		$oWMRequest = &Singleton::instance('WMRequest');
		
		$oMail = new Mail('UTF-8',false,true);
		$sMailTo = $sTo?$sTo:$oWMRequest->get('mail_to');
		$sMailCC = $sCC?$sCC:$oWMRequest->get('mail_cc');
		$sMailBCC = $sBCC?$sBCC:$oWMRequest->get('mail_bcc');
		$sMailSubject = $sSubject?$sSubject:$oWMRequest->get('mail_subject');
		$sMailBody = $sBody?$sBody:$oWMRequest->get('mail_body');

		$this->processRecipients($oMail,$sMailTo,$sMailCC,$sMailBCC,$bSend);
		$oMail->setFrom($sFrom,$sFromName);
		$oMail->setSubject($sMailSubject);
		$oMail->setBody($sMailBody);

		return $oMail;
	}
	
	public function fast_reply()
	{
		$oWMRequest = &Singleton::instance('WMRequest');
		$oWMData = &Singleton::instance('WMData');
		$aItems = $oWMRequest->get('items');
		$oPrimaryAccount = $_SESSION['user']->getAccount($_SESSION['EMAIL']);
		if($aItems){
			$aItem = $oWMData->getMessage($oPrimaryAccount,$oWMRequest->get('folder'),$aItems[0],array('tag'=>'*'));
			$sFastReplyBody .= $oWMRequest->get('mail_body')."\r\n";
			$sFastReplyBody .= $oWMData->addEnvelope
			(
				'------------Original message-----------',
				$aItem['subject'],
				$aItem['from'],
				$aItem['to'],
				$aItem['html']?br2nl($aItem['html']):$aItem['text']
			);
			$oMail = $this->mailInit
			(
				$oPrimaryAccount->accountID,
				$oPrimaryAccount->fullname,
				$aItem['from'],
				'',
				'',
				'RE: '.$aItem['subject'],
				$sFastReplyBody
			);
			try{
				$oMail->send();
			}catch(Exc $e){
				/*if(($sItemID = $oWMRequest->get('item'))!=false) {
					$sRID = $oWMRequest->get('rid');
					$oWMRequest->set('item',$aItems[0],$sRID);
				}*/
				throw $e;
			}
		}
	}
	
	private function saveMessage(&$oMail,$sSaveAccount,$sSaveFolder,$sSaveItem = false)
	{
		//Get folder
		$oUser = &$_SESSION['user'];
		
		$oAccount = $oUser->getAccount($sSaveAccount);
		if (!is_object($oAccount)) {
			throw new Exc('message_invalid_account',$sSaveAccount);
		}
		$oFolder = $oAccount->getFolderWithAutoCreate($sSaveFolder,'main');
		
		if (!is_object($oFolder)) {
			throw new Exc('message_invalid_folder',$sSaveFolder);
		}
		
		// store BCC headers for further usage
		if(!$filename){
			$filename = $oMail->getMessageTempFile($oMail->charSet);
		}
		//Save to folder
		if ($sSaveItem!==false) {
			//Item already exists?
			try{
				$oItem = $oFolder->getItem($sSaveItem);
				$oItem->edit(false,$filename);
				$oItem->setFlags(Item::FLAG_SEEN);
				//Create new item
			}catch (Exc $e){
				$itemID = $oFolder->createItem(false,$filename);
				$oItem = $oFolder->getItem($itemID);
				$oItem->setFlags(Item::FLAG_SEEN);
			}
			$sItemID = $oItem->itemID;
		} else {
			$sItemID = $oFolder->createItem(false,$filename);
			$oItem = $oFolder->getItem($sItemID);
			$oItem->markAsRead();
		}
		
		return $sItemID;
	}
	
	private function processRecipients(&$oMail,$sMailTo,$sMailCC='',$sMailBCC='',$bSend = true)
	{
		$aToArray = Mailparse::parseAddresses($sMailTo);
		$aCCArray = Mailparse::parseAddresses($sMailCC);
		$aBCCArray = Mailparse::parseAddresses($sMailBCC);
		if($aToArray){
			foreach($aToArray as $key => $aTo){
				//Add @primarydomain to email addresses without it 
				if(strpos($aTo['address'],'@')===false && $bSend){
					if($aToArray[$key]['address'])
						$aToArray[$key]['address'] .= '@'.$_SESSION['PRIMARY_DOMAIN'];
				}
				$oMail->addTo($aToArray[$key]['address'],$aTo['display']);
			}
		}
		if($aCCArray){
			foreach($aCCArray as $key => $aCC){
				//Add @primarydomain to email addresses without it 
				if(strpos($aCC['address'],'@')===false && $bSend){
					if($aCCArray[$key]['address'])
						$aCCArray[$key]['address'] .= '@'.$_SESSION['PRIMARY_DOMAIN'];
				}
				$oMail->addCC($aCCArray[$key]['address'],$aCC['display']);
			}
		}
		if($aToArray){
			foreach($aBCCArray as $aBCC){
				$oMail->addBCC($aBCC['address'],$aBCC['display']);
			}
		}
	}

}
?>
