<?
require_once('interface/inc/data/item.php');
require_once('interface/inc/data/folder.php');

class WMData extends Singleton
{
	static public $aViewToFolderType = array
	(
		'contact_list'=>'C',
		'contact_select'=>'C',
		'mail_list'=>'M',
		'contact_view'=>'C',
		'mail_view'=>'M'
	);
	static public $aViewToDefaultFolder = array
	(
		'contact_list'=>'Contacts',
		'contact_select'=>'Contacts',
		'mail_list'=>'INBOX',
		'contact_view'=>'Contacts',
		'mail_view'=>'INBOX'
	);
	
	protected function __construct()
	{
	}
	
	public function prepare()
	{
		$oWMRequest = &Singleton::instance('WMRequest');
		$sView = &Singleton::instance('WMUserInterface')->getView();
		if($oWMRequest->isLogged()){
			$oUser = &$_SESSION['user'];
			//FIXME : we will always use primary account in PDA
			$oPrimaryAccount = $oUser->getAccount($_SESSION['EMAIL']);
		}
		if(!$sFolder = $oWMRequest->get('folder')){
			$sFolder = self::$aViewToDefaultFolder[$sView];
		}
		$oWMLanguage = &Singleton::instance('WMLanguage');
		
		/*try{
			if($oPrimaryAccount){
				$oFolder = $oPrimaryAccount->getFolder($sFolder);
				if($oFolder->type!==self::$aViewToFolderType[$sView]){
					$sFolder = self::$aViewToDefaultFolder[$sView];
				}
			}
		}catch(Exc $e){
			$sFolder = self::$aViewToDefaultFolder[$sView];
		}*/

		switch($sView){
			case 'login':
				require_once('inc/webmailiqauth.php');
				WebmailIqAuth::checkServerKeys();
				$sHash = file_get_contents(WM_CONFIGPATH.'public.key');
				$this->store('login','hash',$sHash);
				break;
			case 'contact_select':
			case 'contact_list':
			case 'mail_list':

				
				if(!$oPrimaryAccount){
					throw new Exc('no_user_accounts');
				}
				
				//Load items and folders
				$oFolder = $oPrimaryAccount->getFolder($sFolder);
				
				$sType = self::$aViewToFolderType[$sView];
				
				ItemExtension::getFolderTypeFilter($oFolder->type,$oFolder->name,$aFilter);
				$iTotal = $oFolder->countItems(0,true,$aFilter['sql'],$aFilter['fulltext']);
				//TODO: Read from settings
				$iLimit = 10;
				//TODO : Move this to item extension
				
				$aPage = ItemExtension::listing($sType,$iTotal,$iLimit,$aFilter);
				$aSort = ItemExtension::sorting($sType,$aFilter);
				
				$aFilter['htmlspecialchars'] = false;
				$aItems = ItemExtension::itemList($oFolder,$aFilter);

				$this->store('lister','page',$aPage['page']);
				$this->store('lister','total',$aPage['total']);
				$this->store('item','list',$aItems);
				$this->attachFolders($oPrimaryAccount);
				break;
			case 'folder_list':
				$this->attachFolders($oPrimaryAccount);
			break;
			case 'mail_view':
				// kdysi jsem mel hodne rad news server na strahove, jedna se o protokol nntp a list zprav je tam realizovan jako stromecek, me by se libil stromecek vytvoreny z sent i recieved tedy jako nejaky dalsi seznam, ktery to vsechno namixuje podle toho, jak na sebe odpovedi navazuji, gmail to ma nejak naemulovane, tak bychom to mohli vyrobit taky
				//Get item ID
				$sItemID = $oWMRequest->get('item');
				//Get item details
				$aItem = ItemExtension::mailView($oPrimaryAccount,$sFolder,$sItemID);
				$this->store('item','details',$aItem);
				break;
			case 'mail_compose':
				$aMail = array();
				$sMailAction = $oWMRequest->get('mail_action');
				$sPostMailAction = $oWMRequest->get('action');
				//Override action (sMailAction - from main menu(GET),
				//sPostMailAction - from mail_view menu(POST)
				// - action over existing item
				if(!$sMailAction && $sPostMailAction){
					$sMailAction = $sPostMailAction;
					$oWMRequest = &Singleton::instance('WMRequest');
					$aItems = $oWMRequest->get('items');
					@$sItemID = reset($aItems);
				}
				
				$sSavedItemID = $oWMRequest->get('item');
				if($sSavedItemID || $sSavedItemID===0){
							$this->store('mail','id',$sSavedItemID);
							$sItemID = $sSavedItemID;
				}
				$sReplyHeader = $oWMLanguage->get('email','reply_message');
				//Action over existing email
				switch($sMailAction){
					case 'reply':
						$aFilter['tag'] = 'header_to,header_from,text,html,subject';
						$aItem = $this->getMessage($oPrimaryAccount,$sFolder,$sItemID,$aFilter);// plaintext je "default", html mail je nadstavba, strip_tags ma druhy parametr k dispozici pro vyber toho, co nechame s html markupem, ja navrhuju nechat markup u a, b, i, hX (s tim, ze u hX fallbackneme cssko tak, aby nam to nemrvilo layout) a po nejakych testech bychom se mozna mohli dobrat i k img
						$sTo = htmlspecialchars($aItem['from']);
						$sSubject = 'Re: '.htmlspecialchars($aItem['subject']);
						$sBody = $this->getTextBody($aItem);
						$sBody = $this->addEnvelope(
							$sReplyHeader,
							$aItem['subject'],
							$aItem['from'],
							$aItem['to'],
							$sBody
						);
						$sTo = htmlspecialchars($aItem['from']);
						$sSubject = 'Re: '.htmlspecialchars($aItem['subject']);
						$this->storeMessageData($sTo,$sSubject,$sBody);
						
					break;
					case 'reply_all':
						$aFilter['tag'] = 'header_to,header_from,cc,text,html,subject';
						$aItem = $this->getMessage($oPrimaryAccount,$sFolder,$sItemID,$aFilter);
						$sTo = $this->collectReplyAllAddresses($oPrimaryAccount,$aItem);
						$sSubject = 'Re: '.htmlspecialchars($aItem['subject']);
						$sBody = $this->getTextBody($aItem);
						$sBody = $this->addEnvelope(
							$sReplyHeader,
							$aItem['subject'],
							$aItem['from'],
							$aItem['to'],
							$sBody);
						$sSubject = 'Re: '.htmlspecialchars($aItem['subject']);
						$this->storeMessageData($sTo,$sSubject,$sBody);
					break;
					case 'forward':
						$aFilter['tag'] = 'header_to,header_from,cc,text,html,subject';
						$aItem = $this->getMessage($oPrimaryAccount,$sFolder,$sItemID,$aFilter);
						$sTo = '';
						$sSubject = 'Fw: '.htmlspecialchars($aItem['subject']);
						$sBody = $this->getTextBody($aItem);
						$sBody = $this->addEnvelope(
							$sReplyHeader,
							$aItem['subject'],
							$aItem['from'],
							$aItem['to'],
							$sBody);
						
						$this->storeMessageData($sTo,$sSubject,$sBody);
					break;
					case 'continue':
						$aFilter['tag'] = 'header_to,header_from,cc,bcc,text,html,subject';

						$aMessage = $this->getMessage($oPrimaryAccount,$sFolder,$sItemID,$aFilter);
						$this->storeMessageData(
							htmlspecialchars($aMessage['to']),
							htmlspecialchars($aMessage['subject']),
							htmlspecialchars($aMessage['text']),
							htmlspecialchars($aMessage['cc']),
							htmlspecialchars($aMessage['bcc'])
						);
					break;
					case 'new':
					default:
						if($sMailTo = htmlspecialchars($oWMRequest->get('mail_to'))){
							$this->store('mail','to',$sMailTo);
						}
						if($sMailCC = htmlspecialchars($oWMRequest->get('mail_cc'))){
							$this->store('mail','cc',$sMailCC);
						}
						if($sMailBCC = htmlspecialchars($oWMRequest->get('mail_bcc'))){
							$this->store('mail','bcc',$sMailBCC);
						}
						if($sMailSubject = htmlspecialchars($oWMRequest->get('mail_subject'))){
							$this->store('mail','subject',$sMailSubject);
						}
						if($sMailBody = htmlspecialchars($oWMRequest->get('mail_body'))){
							$this->store('mail','body',$sMailBody);
						}
					break;
				}
				$this->attachFolders($oPrimaryAccount);
				break;
			case 'contact_view':
				$sItemID = $oWMRequest->get('item');
				$oFolder = $oPrimaryAccount->getFolder($sFolder);
				$oItem = $oFolder->getItem($sItemID);
				if($oItem->aAddons['location']){
					$aLocation = $oItem->aAddons['location']->getData();
				}
				$this->store('item','details',$oItem->item);
				$this->store('contact','location',$aLocation);
				$this->attachFolders($oPrimaryAccount);
			break;
		}
		$this->store('general','folder',$sFolder);
		$this->store('general','sid',$oWMRequest->sSID);
		//$this->store('general','rid',$oWMRequest->get('rid'));
		$this->store('general','folder',$sFolder);
		$this->store('general','view',$oWMRequest->get('view'));
	}
	
	private function storeMessageData($sTo='',$sSubject='',$sBody='',$sCC='',$sBCC='')
	{
		$this->store('mail','to',$sTo);
		//FIXME : better Re[i]: handling ?
		$this->store('mail','subject',$sSubject);
		$this->store('mail','body',$sBody);
		$this->store('mail','cc',$sCC);
		$this->store('mail','bcc',$sBCC);
	}
	
	public function getMessage($oAccount,$sFolder,$sItemID,$aFilter = false)
	{

		$oFolder = $oAccount->getFolder($sFolder);
		
		$oItem = $oFolder->getItem($sItemID);

		$aItem = reset(
			ItemExtension::cnvItems(
				array(0=>$oItem),
				$aFilter,
				array('htmlspecialchars'=>false)
			)
		);
		return $aItem;
	}
	
	private function getTextBody($aItem)
	{
		if(isset($aItem['html']) && !empty($aItem['html'])){
			$sBody = Tools::removeHTML($aItem['html']);
		} else {
			$sBody = $aItem['text'];
		}
		return $sBody;
	}
	
	public function addEnvelope($envelope,$subject,$from,$to,$body)
	{
		$text = "\r\n".$envelope."\r\n".
			"Subject:".$subject."\r\n".
			"From:".$from."\r\n".
			"To:".$to."\r\n\r\n".
			$body;
		return $text;

	}
	
	private function attachFolders(&$oPrimaryAccount)
	{
		$aFolders = FolderExtension::definedFolderList($oPrimaryAccount);
		$this->store('folder','list',$aFolders);
	}
	
	private function collectReplyAllAddresses(&$oAccount,$aItem)
	{
		$aReceipients = array();
		$aFromArray = MailParse::parseAddresses($aItem['from']);
		$aToArray = MailParse::parseAddresses($aItem['to']);
		$aCCArray = MailParse::parseAddresses($aItem['cc']);

		$this->collectEmails($oAccount,$aFromArray,$aReceipients);
		$this->collectEmails($oAccount,$aToArray,$aReceipients);
		$this->collectEmails($oAccount,$aCCArray,$aReceipients);
		
		$sReceipients = implode(';',$aReceipients);
		return $sReceipients;
	}
	
	private function collectEmails(&$oAccount,$aAddressArray,&$aReceipients,$stripOwner = false)
	{
		foreach($aAddressArray as $aAddress){
			if($aAddress['address']){
				if(strpos($aAddress['address'],$oAccount->accountID)===false && $stripOwner){
					continue;
				}
				$aReceipients[$aAddress['address']] = ($aAddress['display']?('&quot;'.$aAddress['display'].'&quot; '):'').
					'&lt;'.$aAddress['address'].'&gt;';
			}
		}
	}
	
	public function store($namespace,$variable,$value)
	{
		//Autocreate namespace storage
		if(!$this->aData[$namespace]){
			$this->aData[$namespace] = array();
		}
		
		$this->aData[$namespace][$variable] = $value;
	}
	
	public function get($namespace,$variable)
	{
		return @$this->aData[$namespace][$variable];
	}
}
?>