<?php
require_once('inc/webmailiqitems.php');


class ItemExtension
{
	public function itemList(&$oFolder,$aFilter = array())
	{
		if($oFolder)
		{
			if(
				!$oFolder->gw
				&&	!$oFolder->sync
				&&	!$oAccount->aSyncedFolders[$oFolder->folderID]
			){
				$oAccount->aSyncedFolders[$oFolder->folderID] = true;
				if ($oFolder) {
					$oFolder->sync();
				}
			}
			
			self::getFolderTypeFilter($oFoldet->type,$oFolder->name,$aFilter);
			$oItems = $oFolder->getItems($aFilter);
		}
		
		$aItm['num'] = self::cnvItems($oItems,$aFilter,array('dateformat'=>"%m/%d/%y",
			'htmlspecialchars'=>$aFilter['htmlspecialchars']));

		return $aItm; 
	}
	
	public function getFolderTypeFilter($sType,&$sFolder,&$aFilter)
	{
			//TODO move to data.php
			switch($sType){
				case 'M':
					$sFolder = $sFolder?$sFolder:'INBOX';
					//ITEMS
					if(!$aFilter['tag']){
						$aFilter['tag'] = 'header_from,header_to,subject,date,size,flags';
					}
					if(!$aFilter['orderby']){
						$aFilter['orderby'] = 'date DESC';
					}
				break;
				case 'C':
					$sFolder = $sFolder?$sFolder:'Contacts';
					if(!$aFilter['tag']){
						$aFilter['tag'] = 'itmclassifyas,lctemail1,lctemail2,lctemail3,itmcompany,itmdepartment';
					}
					if(!$aFilter['orderby']){
						$aFilter['orderby'] = 'itmclassifyas ASC';
					}
					$oWMRequest = &Singleton::instance('WMRequest');
					$aFilter['sql'] = "((NOT LCTEMAIL1 = '') OR (NOT LCTEMAIL2 = '') OR (NOT LCTEMAIL3 = ''))";
				break;
			}
	}
	
	public function mailView(&$oAccount,$sFolder,$sItemID){

	//dmp($sFolder);echo 'safsdfdsa';
		$oFolder = $oAccount->getFolder($sFolder);

		$oItem = $oFolder->getItem($sItemID);
		if ($oItem->wmclass=="M" || $oItem->wmclass=="R") {
			$oItem->markAsRead();
		}
		$aFilter['tag'] = '*';
		$aItm = self::cnvItems(array(0=>$oItem),$aFilter,array('dateformat'=>"%d.%B %Y %H:%I:%S",'htmlspecialchars'=>true));
		$aItm = reset($aItm);
		$aItm['html'] = Tools::unhtmlspecialchars($aItm['html']);

		if($aItm['attachments']['num']){
			foreach($aItm['attachments']['num'] as $sAttKey => $aAttVal){
				$aItm['attachments']['num'][$sAttKey]['fullpath'] = $oAccount->accountID.'/'.urlencode($oFolder->name).'/'.$oItem->itemID.'/'.$aAttVal['part_id'];
				$aItm['attachments']['num'][$sAttKey]['size'] = (string) round($aItm['attachments']['num'][$sAttKey]['size']/1024,2)."";
			}
		}
		//Replace url for embedded images
		$sHTTP = (strtoupper($_SERVER['HTTPS'])=='ON'?'https://':'http://');
		$sDownload = $sHTTP.$_SERVER['HTTP_HOST'].'/server/download.php';

		$sURI = $sHTTP.$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_NAME'];
		$aItm['html'] = str_replace($sURI,$sDownload,$aItm['html']);
		return $aItm; 
	}
	
	static public function cnvItems($items,$aFilter,$aFormat)
	{
		$oWMLanguage = &Singleton::instance('WMLanguage');
		if (!is_array($items)) {
			return;
		}
		$rssDoc = false;
		foreach ($items as $oItem) {
			$aItem = array();
			$aItem['id'] = (string) $oItem->itemID;
			$aItem['item_id'] = (string) $oItem->itemID;
			switch($oItem->wmclass) {
				//Mail
				case 'M':
					$aItem = WebmailIqItems::cnvMailItem($oItem,$aFilter,1,$aFormat['htmlspecialchars']);
					switch(strtolower($oItem->folder->name)){
						case 'drafts':
							$aItem['heading'] = self::getListAddress($aItem['to']);
							$aItem['action'] = 'continue';
							$aItem['view'] = 'mail_compose';
						break;
						case 'sent':
							$aItem['heading'] = self::getListAddress($aItem['to']);
							$aItem['view'] = 'mail_view';
						break;
						default:
							$aItem['heading'] = self::getListAddress($aItem['from']);
							$aItem['view'] = 'mail_view';
						break;
					}
					if(!$aItem['subject']){
						$aItem['subject'] = $oWMLanguage->get('mail_view','nosubject');
					}
					$aItem['size'] = (string) round($aItem['size']/1024,2);
					$aItem["mail"] = 1;
					if (!($oItem->flags & Item::FLAG_SEEN)) {
						$aItem['unread'] = true;
					}
					$aItem['id'] = (string) $oItem->itemID;
					$aItem['item_id'] = (string) $oItem->itemID;
				break;
				case 'GW':
					$aItem['view'] = 'contact_view';
				/*Fixme : do not store sFields in GroupWareItem, call XML transformation in this method */
					$aItem["sFields"] = $oItem->sFields;
					$aItem = array_merge($aItem,array_change_key_case($oItem->item,CASE_LOWER));
					if(!$aItem['itmclassifyas']){
						$aItem['itmclassifyas'] = $oWMLanguage->get('event_view','notitle');
					}
					break;
				break;
			}

			/*if ($aFormat['dateformat']){
				$aItem['date'] = iconv("","UTF-8",strftime($aFormat['dateformat'],$aItem['timestamp']));
			}*/
			if(date("Y/m/d",$aItem['timestamp'])==date("Y/m/d",time())){
				$aItem['date_short'] = strftime("%H:%M:%S",$aItem['timestamp']);
			}else{
				$aItem['date_short'] = iconv("","UTF-8",strftime($aFormat['dateformat'],$aItem['timestamp']));
			}
			

			$aItems[] = $aItem;
		}
		return $aItems;
	}
	
static public function getListAddress($sAddress){
	$address = Mailparse::parseAddresses($sAddress);
	if($address[0]['display']){
		$result = $address[0]['display'];
	}else{
		$result = $address[0]['address'];
	}	
	return $result;
}
static public function listing($sGridID,$iTotal,$iLimit,&$aFilter)
	{
		$oWMRequest = &Singleton::instance('WMRequest');
		$sFolder = $oWMRequest->get('folder');
		$sPageNumber = $oWMRequest->get('pageNumber');
		if($sPageNumber<0){
			$sPageNumber = 0;
		}
		if((!$sPageNumber) && ($sPageNumber!==0) && ($_SESSION['COOKIE'][$sGridID]['page'][$sFolder])){
			$sPageNumber = $_SESSION['COOKIE'][$sGridID]['page'][$sFolder];
		}
		$sTotalPages = ceil($iTotal/$iLimit);
		$aFilter['limit'] = $iLimit;
		
		if($sPageNumber && $oWMRequest->get('__a_grid_previous')){
			$sPageNumber--;
		}
		if(($sPageNumber*$iLimit < $iTotal) && ($oWMRequest->get('__a_grid_next'))){
			$sPageNumber++;
		}
		if($oWMRequest->get('__a_grid_first')){
			$sPageNumber = 1;
		}
		if($oWMRequest->get('__a_grid_last')){
			$sPageNumber = $sTotalPages;
		}
		if(($sPageNumber-1) >= $sTotalPages){
			$sPageNumber = $sTotalPages;
		}
		if($sPageNumber){
			$aFilter['offset'] = ($sPageNumber-1)*$iLimit;
		}else{
			$aFilter['offset'] = 0;
			$sPageNumber = 1;
		}
		$_SESSION['COOKIE'][$sGridID]['page'][$sFolder] = $sPageNumber;
		$aResult['page'] = intval($sPageNumber);
		$aResult['total'] = intval($sTotalPages);
		return $aResult;
	}
	
	static public function sorting($sGridID,&$aFilter)
	{
		$oWMRequest = &Singleton::instance('WMRequest');
		$sFolder = $oWMRequest->get('folder');
		$aCurrentSort = $_SESSION['COOKIE'][$sGridID]['sort'][$sFolder];
		unset($_SESSION['COOKIE'][$sGridID]['sort'][$sFolder]);

		if(
				($sOrderBy = $oWMRequest->get('sortBy'))
				&& $oWMRequest->get('__a_grid_sort')
			){
			$aOrder = explode(',',$sOrderBy);
			foreach($aOrder as $orderBy){
				if(preg_match('#(.*)(asc|desc)#i',$orderBy,$matches)){
					$orderBy = $matches[1];
					$sOrder = $matches[2];
				}else{
					//Read stored data from session 
					$sOrder = $aCurrentSort[$orderBy];
					
					if($sOrder){
						$sOrder = ($sOrder!='ASC'?'ASC':'DESC');
					}else{
						$sOrder = 'ASC';
					}
				}
			
				if($orderBy && $sOrder){
					$_SESSION['COOKIE'][$sGridID]['sort'][$sFolder][$orderBy] = $sOrder;
					$aOrderBy[] = $orderBy.' '.$sOrder;
				}
			}
			$aFilter['orderby'] = implode(',',$aOrderBy);
			
			//Read stored data from session 
		/*	$sOrder = $_SESSION['COOKIE'][$sGridID]['sort'][$sFolder][$sOrderBy];
			//Clear sorting info
			unset($_SESSION['COOKIE'][$sGridID]['sort'][$sFolder]);
			if($sOrder){
				$sOrder = ($sOrder!='ASC'?'ASC':'DESC');
			}else{
				$sOrder = 'ASC';
			}*/
		}else{
			if($aCurrentSort){
				$sOrderBy = reset(array_keys($aCurrentSort));
				
				$sOrder = reset($aCurrentSort);
			}
			if($sOrderBy && $sOrder){
				$_SESSION['COOKIE'][$sGridID]['sort'][$sFolder][$sOrderBy] = $sOrder;
				$aFilter['orderby'] = $sOrderBy.' '.$sOrder;
			}
		}
	}
}

?>