<?
require_once('inc/user.php');

class WMRequest extends Singleton
{
	public $bLogged;
	protected function __construct()
	{
		if($_REQUEST['sid']){
			try{
				$oUser = User::load($_REQUEST['sid']);
			}catch(Exc $e){

				$this->set('view','login',$_REQUEST['rid']);
				$this->bViewFinal = true;
				if(!$_SESSION['PDA_LOGOUT']){
					$oWMUserInterface = Singleton::instance('WMUserInterface');
					$oWMUserInterface->setView('login');
					$oWMUserInterface->setError($e->XHTMLMessage($oWMLanguage,$oWMUserInterface->getSkin()));
				}else{
					@session_destroy();
				}
				$this->bLogged = false;
				
			}
			if($oUser){
				//FIXME : we will always use primary account in PDA
				$this->bLogged = true;
				$this->sSID = $_REQUEST['sid'];
				$oWMData = Singleton::instance('WMData');
				$oWMData->store('general','sid',$tpohis->sSID);
				$this->aData['view'] = $_REQUEST['view'];
			}
		}
		if($_REQUEST['rid']){
			$this->set('rid',$_REQUEST['rid']);
		}
	}
	
	public function store()
	{
		//Store this request to session
		$key = str_replace('.','',Tools::my_uniqid('',true));
		$_SESSION['WMREQUEST'][$key] = $_REQUEST;
		$this->set('rid',$key);
		//Prepare this request to be used by UserInterface
		$this->prepare();
		return $key;
	}
	public function appendGetData($id)
	{
		foreach($_GET as $key => $val){
			$_SESSION['WMREQUEST'][$id][$key] = $val;
		}
	}
	public function setError($sRequestID,$error)
	{
		$_SESSION['WMREQUEST'][$sRequestID]['__error'] = $error;
	}
	public function getError($sRequestID)
	{
		return $_SESSION['WMREQUEST'][$sRequestID]['__error'];
	}	
	public function retrieve($id)
	{
		if($_SESSION['WMREQUEST'][$id]){
			foreach($_SESSION['WMREQUEST'][$id] as $key => $val){
				$this->set($key,$val);
			}
		}
		unset($_SESSION['WMREQUEST'][$id]['sortBy']);
	}
	public function set($var,$val,$appendToRequest = false)
	{

		switch($var){
			//Do actions , navigate to view, other required stuff to handle single request value
			case '__a_logout':
				$aAction['namespace'] = 'wmauth';
				$aAction['action'] = 'logout';
				$aAction['view'] = 'login';
				
			break;
			case '__a_get_new':
				$aAction['namespace'] = 'wmaccount';
				$aAction['action'] = 'sync';
				
				if(!$_REQUEST['folder']){
					$aAction['folder'] = 'INBOX';
					$aAction['view'] = 'mail_list';
				}else{
					$aAction['folder'] = $_REQUEST['folder'];
					$aAction['view'] = $_REQUEST['view'];
				}
				
			break;
			case '__a_message_send':
				$aAction['namespace'] = 'wmmessage';
				$aAction['action'] = 'send';

			break;
			case '__a_message_save':
				$aAction['namespace'] = 'wmmessage';
				$aAction['action'] = 'save';
				$aAction['view'] = 'mail_compose';
			break;
			case '__a_fast_reply':
				$aAction['namespace'] = 'wmmessage';
				$aAction['action'] = 'fast_reply';
				$aAction['view'] = 'mail_list';
			break;
			case '__a_mark_read':
				$aAction['namespace'] = 'wmitem';
				$aAction['action'] = 'mark_read';
				$aAction['view'] = 'mail_list';
			break;
			case '__a_mark_unread':
				$aAction['namespace'] = 'wmitem';
				$aAction['action'] = 'mark_unread';
				$aAction['view'] = 'mail_list';
			break;
			case '__a_whitelist':
				$aAction['namespace'] = 'wmitem';
				$aAction['action'] = 'whitelist';
				$aAction['view'] = 'mail_list';
			break;
			case '__a_blacklist':
				$aAction['namespace'] = 'wmitem';
				$aAction['action'] = 'blacklist';
				$aAction['view'] = 'mail_list';
			break;
			case '__a_reply':
				$aAction['namespace'] = 'wmitem';
				$aAction['action'] = 'reply';
				$aAction['view'] = 'mail_compose';
			break;
			case '__a_reply_all':
				$aAction['namespace'] = 'wmitem';
				$aAction['action'] = 'reply_all';
				$aAction['view'] = 'mail_compose';
			break;
			case '__a_forward':
				$aAction['namespace'] = 'wmitem';
				$aAction['action'] = 'forward';
				$aAction['view'] = 'mail_compose';
			break;
			case '__a_delete':
				$aAction['namespace'] = 'wmitem';
				$aAction['action'] = 'delete';
				$aAction['view'] = 'mail_list';
			break;
			case '__a_mail_compose':
				$aAction['namespace'] = 'none';
				$aAction['action'] = 'none';
				$aAction['view'] = 'mail_compose';
			break;
			case '__a_mail_list':
				$aAction['namespace'] = 'none';
				$aAction['action'] = 'none';
				$aAction['view'] = 'mail_list';
			break;
			case '__a_settings':
				$aAction['namespace'] = 'none';
				$aAction['action'] = 'none';
				$aAction['view'] = 'settings';
			break;
			case '__a_addto':
				$aAction['namespace'] = 'wmsession';
				$aAction['action'] = 'store_data';
				$aAction['data_id'] = 'mail_compose';
				$aAction['target'] = 'mail_to';
				$aAction['view'] = 'contact_select';
				$aAction['folder'] = 'Contacts';
			break;
			case '__a_addcc':
				$aAction['namespace'] = 'wmsession';
				$aAction['action'] = 'store_data';
				$aAction['data_id'] = 'mail_compose';
				$aAction['target'] = 'mail_cc';
				$aAction['view'] = 'contact_select';
				$aAction['folder'] = 'Contacts';
			break;
			case '__a_addbcc':
				$aAction['namespace'] = 'wmsession';
				$aAction['action'] = 'store_data';
				$aAction['data_id'] = 'mail_compose';
				$aAction['target'] = 'mail_bcc';
				$aAction['view'] = 'contact_select';
				$aAction['folder'] = 'Contacts';
			break;
			case '_a_insert_contact_mail':
				$aAction['namespace'] = 'wmsession';
				$aAction['action'] = 'add_contacts';
				$aAction['data_id'] = 'mail_compose';
				$aAction['view'] = 'mail_compose';
				$aAction['folder'] = 'Contacts';
			break;
			case '_a_insert_contact_mail_cancel':
				$aAction['namespace'] = 'wmsession';
				$aAction['action'] = 'retrieve_data';
				$aAction['data_id'] = 'mail_compose';
				$aAction['view'] = 'mail_compose';
				$aAction['folder'] = 'Contacts';
			break;
			case '__a_action_select':
				$this->set($_REQUEST['action_select'],true);
			break;
			case '__sent':
			break;
			case '__a_grid_sort':
				$this->aData[$var] = 1;
			break;
			
			case 'view':
				if(!$this->bViewFinal){
					$this->aData[$var] = $val;
				}
			break;
			default:
				$this->aData[$var] = $val;
			break;
		}
		if($appendToRequest){
			$_SESSION['WMREQUEST'][$appendToRequest][$var] = $val;
		}
		if($aAction){
			$this->setAction($aAction);
		}
	}

	private function setAction($aAction)
	{
		$this->aAction = $aAction;
	}
	
	private function performAction()
	{
		if($this->aAction){
			foreach($this->aAction as $key=>$val)
				switch($key){
					case 'view':
						$oWMUserInterface = &Singleton::instance('WMUserInterface');
						$oWMUserInterface->setView($val);
					default:
						$this->set($key,$val,$this->get('rid'));
					break;
				}
		}
	}
	
	public function prepare()
	{
		foreach($_REQUEST as $key => $val){
			$this->set($key,$val);
		}
		$this->performAction();
		$this->aPostData = $_POST;
	}
	public function get($key){
		return $this->aData[$key];
	}
	public function isLogged()
	{
		return $this->bLogged;
	}
	
	public function storeVariable($sRID,$sVar,$sValue)
	{
		$_SESSION['WMREQUEST'][$sRID][$sVar] = $sValue;
	}
	
	public function setException($oException)
	{
		$oWMUserInterface = &Singleton::instance('WMUserInterface');
		switch($oException->sView){
			case 'login':
				$oWMUserInterface->setView('login');
				$this->set('view','login');
				$this->bViewFinal = true;
			break;
			default:
				$sView = $oException->sView;
				$oWMUserInterface->setView($sView);
				$this->set('view',$sView);
				$this->bViewFinal = true;
			break;
		}
	}
	
	public function getPostVar($var)
	{
		return $this->aPostData[$var];
	}
}
?>