<?
require_once('inc/storage/storage.php');

//TODO : use current wm settigns
class WMSettings extends Singleton
{
	protected function __construct()
	{
		$this->sDomain = Tools::getDomainName();

		if($_SESSION['user']){
			$this->oUser = &$_SESSION['user'];
			$this->oAccount = $this->oUser->getAccount($_SESSION['EMAIL']);
			$this->bLogged = true;
			$aLayoutSettings = $this->getPrivate('layout_settings');
			$aLoginSettings = $this->getPrivate('login_settings');

		} else {
			$aLoginSettings = $this->getPublic('login_settings');
			$aLayoutSettings = $this->getPublic('layout_settings');
			$this->bLogged = false;
		}

		//Language & Version
		$this->sWMVersion = $aLoginSettings['@childnodes']['item'][0]['@childnodes']['version'][0]['@value'];
		$this->sWMLanguage = $aLayoutSettings['@childnodes']['item'][0]['@childnodes']['language'][0]['@value'];
		if(!$this->sWMLanguage){
			$this->sWMLanguage = 'en';
		}
	}
	public function getPublic($sResourceName)
	{
		$aSettings = $this->get('public',$sResourceName);
		return $aSettings;
	}
	public function getPrivate($sResourceName)
	{
		$aSettings = $this->get('private',$sResourceName);
		return $aSettings;
	}
	private function get($sType,$sResourceName)
	{
		if(!$this->oUser){
			if($_SESSION['user']){
				$this->oUser = $_SESSION['user'];
			}
		}
		switch($sResourceName) {
			//Get well known resources(special syntax)
			case 'login_settings':
				$aSettings = Storage::getLoginSettings();
				break;
			//Get not-well known resources(default syntax)
			default:
				$aData['aGlobal'] = Storage::getDefaults($sResourceName);
				$aData['aDomain'] = Storage::getDomainDefaults($sResourceName,$this->sDomain);

				if($this->oUser) {
					
					$aData['aUser'] = Storage::getUserData($sResourceName);
				} else {
					$aData['aUser'] = false;
				}

				if($sType=='private') {
					$aSettings = WebmailIqPrivate::get($aData['aGlobal'],$aData['aDomain'],$aData['aUser'],false);
				} else {
					$aSettings = WebmailIqPublic::get($aData['aGlobal'],$aData['aDomain'],$aData['aUser'],false);
				}
				break;
		}
		return $aSettings;
	}
}
?>