#!/bin/bash
#
# IceWarp Merak Mail Server
# (c) IceWarp Ltd. 2008
#
#       All rights reserved.
#
# http://www.icewarp.com
#
# file: service.sh - Merak server internal script
# version: 1.0
#

# init working dir
pushd `pwd` &> /dev/null
WORK_DIR=$(dirname $0)
cd $WORK_DIR &> /dev/null
if [ $? -ne 0 ]
    then
	echo "Can not change directory to ${WORK_DIR}"
	exit 1
fi

# include functions
if [ -z "$FUNCTIONS_INCLUDED" ]
    then
	source ./inc/functions.sh
fi

# include daemon functions
source ./inc/daemonlib.sh

case "$1" in
    "start")
	startdaemon "$2"
	;;
    "stop")
	stopdaemon "$2"
	;;
    *)
	;;
esac

# restore working dir
popd &> /dev/null
exit 0

