#!/bin/bash
#
# IceWarp Merak Mail Server
# (c) IceWarp Ltd. 2008
#
#       All rights reserved.
#
# http://www.icewarp.com
#
# file: wizard.sh - Merak maintanance wizard script
# version: 1.0
#

# init working dir
pushd `pwd` &> /dev/null
WORK_DIR=$(dirname $0)
cd $WORK_DIR &> /dev/null
if [ $? -ne 0 ]
    then
	echo "Can not change directory to ${WORK_DIR}"
	exit 1
fi

# include functions
if [ -z "$FUNCTIONS_INCLUDED" ]
    then
	source ./inc/functions.sh
fi

copyright()
{
    good ""
    hilite "Merak Mail Server"
    hilite "(c) 1999-2008 IceWarp Ltd."
    good ""
    good "Wizard configuration assistant"
    good ""
    good "Logging is enabled to the following file for future reference:"
    good "Commands: $WIZARDCMDLOG"
    good ""
    good "Press [ENTER] to continue, CTRL-C to quit."
}

getscriptparams()
{
    case $1 in
	*)
	    MENUROOT="ROOT"
	    MENULIST="${SCRIPTDIR}/wizard/menu.lst"
	    menu "Root menu" "$MENUROOT" "$MENULIST" "wizard"
	    ;;
    esac
}

# Init command log
rm -f $WIZARDCMDLOG
touch $WIZARDCMDLOG

# Display copyright and wait for [Enter]
clear
copyright
read -s

# Run wizard
clear
getscriptparams $*

# restore working dir
popd &> /dev/null
exit 0
