#!/bin/bash
#
# IceWarp Merak Mail Server
# (c) IceWarp Ltd. 2008
#
#       All rights reserved.
#
# http://www.icewarp.com
#
# file: domain_add.sh - wizard menu script
# version: 1.0
#

# include functions
if [ -z "$SCRIPTDIR" ]
    then
	echo "This wizard script requires to have \$SCRIPTDIR variable set."
	exit 1
fi

if [ -z "$FUNCTIONS_INCLUDED" ]
    then
	source ${SCRIPTDIR}/inc/functions.sh
fi

adddomain()
{
    good ""
    hilite "Create new domain:"
    good ""

    getparam "Domain name:"
    DOMAINNAME=$PARAM

    getparam "Domain description:"
    DOMAINDESC=$DOMAINNAME
    if [ "$PARAM" != "" ]
	then
	    DOMAINDESC=$PARAM
    fi

    getparam "Administrator email address:"
    DOMAINADMIN="postmaster@${DOMAINNAME}"
    if [ "$PARAM" != "" ]
	then
	    DOMAINADMIN=$PARAM
    fi

    good ""
    ask_with_confirmation "OK?" "Y" "n"
    if [ $? -eq 1 ]
	then
	    run_cmd_log "${MERAKDIR}/tool" create domain "${DOMAINNAME}" d_description "${DOMAINDESC}" d_adminemail "${DOMAINADMIN}"
	    if [ $? -eq 0 ]
		then
		    good "Domain created"
		else
	    	    bad "Domain save problem!"
	    fi
	else
	    warn "Domain cancelled"
    fi

    ask_with_confirmation "Add another domain?" "Y" "n"
    if [ $? -eq 1 ]
	then
	    adddomain
    fi
    return 0
}

adddomain
exit 0
