#!/bin/bash
#
# IceWarp Merak Mail Server
# (c) IceWarp Ltd. 2008
#
#       All rights reserved.
#
# http://www.icewarp.com
#
# file: domain_del.sh - wizard menu script
# version: 1.0
#

# include functions
if [ -z "$SCRIPTDIR" ]
    then
	echo "This wizard script requires to have \$SCRIPTDIR variable set."
	exit 1
fi

if [ -z "$FUNCTIONS_INCLUDED" ]
    then
	source ${SCRIPTDIR}/inc/functions.sh
fi

deldomain()
{
    good ""
    bad "${BAD}Delete domain:${NORMAL}"
    good ""

    getparam "Domain name:"
    DOMAINNAME=$PARAM
    good ""

    ask_with_confirmation "OK?" "N" "y"
    if [ $? -eq 2 ]
	then
	    run_cmd_log "${MERAKDIR}/tool" delete domain "${DOMAINNAME}"
	    if [ $? -eq 0 ]
		then
		    good "Domain deleted"
		else
		     bad "Domain deletion problem!"
	    fi
	else
	    warn "User cancelled"
    fi

    ask_with_confirmation "Delete another domain?" "N" "y"
    if [ $? -eq 2 ]
	then
	    deldomain
    fi
    return 0
}

deldomain
exit 0
