#!/bin/bash
#
# IceWarp Merak Mail Server
# (c) IceWarp Ltd. 2008
#
#       All rights reserved.
#
# http://www.icewarp.com
#
# file: ssl_gen_cert.sh - wizard menu script
# version: 1.0
#

# include functions
if [ -z "$SCRIPTDIR" ]
    then
	echo "This wizard script requires to have \$SCRIPTDIR variable set."
	exit 1
fi

if [ -z "$FUNCTIONS_INCLUDED" ]
    then
	source ${SCRIPTDIR}/inc/functions.sh
fi

gensslcert()
{
    pushd $MERAKDIR > /dev/null
    run_cmd_log "openssl req -x509 -nodes -newkey rsa:1024 -keyout config/cert.pem -out config/cert.pem"
    popd > /dev/null
}

good ""
ask_with_confirmation "Create a new SSL/TLS Certificate?" "Y" "n"
if [ $? -eq 1 ]
    then
	gensslcert
    else
	warn "User cancelled"
fi

exit 0
