#!/bin/bash
#
# IceWarp Merak Mail Server
# (c) IceWarp Ltd. 2008
#
#       All rights reserved.
#
# http://www.icewarp.com
#
# file: user_add.sh - wizard menu script
# version: 1.0
#

# include functions
if [ -z "$SCRIPTDIR" ]
    then
	echo "This wizard script requires to have \$SCRIPTDIR variable set."
	exit 1
fi

if [ -z "$FUNCTIONS_INCLUDED" ]
    then
	source ${SCRIPTDIR}/inc/functions.sh
fi

adduser()
{
    good ""
    hilite "Create new account:"
    good ""

    getparam "Email address:"
    EMAIL=$PARAM

    getpassword "Password:"
    PASSWORD=$PASSWORD_PARAM

    getparam "Full name:"
    FULLNAME=$EMAIL
    if [ "$PARAM" != "" ]
	then
	    FULLNAME=$PARAM
    fi

    ask_with_confirmation "Account is system administrator?" "Y" "n"
    if [ $? -eq 1 ]
	then
	    ADMIN="1"
	else
	    ADMIN="0"
    fi

    good ""
    ask_with_confirmation "OK?" "Y" "n"
    if [ $? -eq 1 ]
	then
	    run_cmd_log "${MERAKDIR}/tool" create account "${EMAIL}" u_name "${FULLNAME}" u_password "${PASSWORD}" u_admin "${ADMIN}"
	    if [ $? -eq 0 ]
		then
		    good "Account created"
		else
		    bad "Account save problem!"
	    fi
	else
	    warn "User cancelled"
    fi

    ask_with_confirmation "Add another user?" "Y" "n"
    if [ $? -eq 1 ]
	then
	    adduser
    fi
    return 0
}

adduser
exit 0
