#!/bin/bash
#
# IceWarp Merak Mail Server
# (c) IceWarp Ltd. 2008
#
#       All rights reserved.
#
# http://www.icewarp.com
#
# file: user_del.sh - wizard menu script
# version: 1.0
#

# include functions
if [ -z "$SCRIPTDIR" ]
    then
	echo "This wizard script requires to have \$SCRIPTDIR variable set."
	exit 1
fi

if [ -z "$FUNCTIONS_INCLUDED" ]
    then
	source ${SCRIPTDIR}/inc/functions.sh
fi

deluser()
{
    good ""
    hilite "Delete account:"
    good ""

    getparam "Email address:"
    EMAIL=$PARAM

    good ""
    ask_with_confirmation "Delete this account?" "N" "y"
    if [ $? -eq 2 ]
	then
	    run_cmd_log "${MERAKDIR}/tool" delete account "${EMAIL}"
	    if [ $? -eq 0 ]
		then
		    good "Account deleted"
		else
		    bad "Account deletion problem!"
	    fi
	else
	    warn "User cancelled"
    fi

    ask_with_confirmation "Delete another account?" "N" "y"
    if [ $? -eq 2 ]
	then
	    deluser
    fi
    return 0
}

deluser
exit 0
